#include	"compiler.h"

#include	"np2.h"
#include	"np2pc98.h"
#include	"i286.h"
#include	"memory.h"
#include	"iobridge.h"
#include	"pic.h"
#include	"bios.h"
#include	"nevent.h"
#include	"pc_core.h"
#include	"sysport.h"
#include	"dosio.h"
#include	"itfrom.h"
#include	"lio.h"
#include	"fdfmt.h"
#include	"extmem.h"
#include	"gdc.h"
#include	"crtc.h"
#include	"dmac.h"
#include	"fdc.h"
#include	"fddfile.h"
#include	"fdd_mtr.h"
#include	"trace.h"

static	BOOL	biosrom = FALSE;

static	BYTE	neccheck[] = "Copyright (C) 1983 by NEC Corporation";

						// 00/05/18 MS-DOS6.2 on PC-9801VX calling proc
static	BYTE	printmain[] = {0x5a, 0x1f, 0xb4, 0x00, 0xcf};

static	BYTE	nosyscode[] = {
			0xeb,0x05,0xbe,0x6f,0x00,0xeb,0x03,0xbe,0x47,0x00,0xb8,0x00,
			0x10,0xbb,0x00,0x80,0x8e,0xd0,0x8b,0xe3,0x8c,0xc8,0x8e,0xd8,
			0xb8,0x00,0xa0,0x8e,0xc0,0xb9,0x00,0x10,0xb8,0x20,0x00,0x33,
			0xff,0xfc,0xf3,0xab,0xb0,0xe1,0xb9,0xe0,0x1f,0xaa,0x47,0xe2,
			0xfc,0x2e,0xad,0x8b,0xf8,0x2e,0xad,0x85,0xc0,0x74,0x0a,0xab,
			0x0a,0xe4,0x74,0xf5,0x83,0xc7,0x02,0xeb,0xf0,0xeb,0xfe,0xac,
			0x07,0x05,0x37,0x05,0x39,0x05,0x46,0x05,0x60,0x05,0x47,0x05,
			0x23,0x05,0x39,0x05,0x2f,0x04,0x72,0x05,0x3b,0x05,0x43,0x05,
			0x48,0x04,0x37,0x04,0x46,0x04,0x2f,0x04,0x40,0x04,0x35,0x04,
			0x24,0x00,0x00,0xae,0x07,0x42,0x00,0x41,0x00,0x53,0x00,0x49,
			0x00,0x43,0x00,0x04,0x4e,0x15,0x2f,0x26,0x30,0x04,0x4b,0x04,
			0x4f,0x20,0x00,0x42,0x00,0x49,0x00,0x4f,0x00,0x53,0x00,0x2e,
			0x00,0x52,0x00,0x4f,0x00,0x4d,0x00,0x04,0x2c,0x29,0x2c,0x2d,
			0x57,0x04,0x47,0x04,0x39,0x00,0x00};

#ifdef __cplusplus
extern "C" {
#endif
	BYTE	itf_bank = 0;
#ifdef __cplusplus
}
#endif

static void bios_reinitbyswitch(void) {

	BYTE	extmem;
	BYTE	prxcrt;
	BYTE	prxdupd;
	BYTE	biosflag;

	prxcrt = 0xc8;
	if (gdc.display & 2) {
		prxcrt |= 0x04;							// color16
	}
	if (!(np2cfg.dipsw[0] & 0x80)) {			// dipsw1-8 on
		prxcrt |= 0x01;
	}
	if (grcg.chip) {
		prxcrt |= 0x02;
	}
	MEM_SETB(MEMB_PRXCRT, prxcrt);

	prxdupd = 0x18;
	if (grcg.chip >= 3) {
		prxdupd |= 0x40;
	}
	if (!(np2cfg.dipsw[1] & 0x80)) {			// dipsw2-8 on
		prxdupd |= 0x20;
	}
	MEM_SETB(MEMB_PRXDUPD, prxdupd);

	biosflag = 0x20;
	if (pc.cpumode & CPUMODE_8MHz) {
		biosflag |= 0x80;
	}
	biosflag |= MEM_GETB(MEMB_MSW3) & 7;
	CPUTYPE = 0;
	if (np2cfg.dipsw[2] & 0x80) {
		CPUTYPE = CPUTYPE_V30;
		biosflag |= 0x40;
	}
	MEM_SETB(MEMB_BIOS_FLAG, biosflag);

	extmem = 0;
	if (!(np2cfg.dipsw[2] & 0x80)) {
		extmem = np2cfg.EXTMEM;										// ver0.28
	}
	if (extmem_init(extmem)) {										// ver0.28
		extmem = 0;								// ݤ˼
	}
	MEM_SETB(MEMB_EXPMMSZ, (extmem << 3));

	MEM_SETB(MEMB_CRT_RASTER, 0x0f);

	gdc.display &= ~4;
	if (!(np2cfg.dipsw[0] & 0x04)) {			// dipsw1-3 on
		gdc.display |= 4;
	}
	gdcs.textdisp |= GDCSCRN_EXT;
}

static void bios_vectorset(void) {									// ver0.29

	int		i;

	for (i=0; i<0x100; i++) {
		MEM_SETW(i*4+0, ((BIOS_OFF) + 0x003e));
		MEM_SETW(i*4+2, BIOS_SEG);
	}
	for (i=0; i<0x20; i++) {
		MEM_SETW(i*4, MEM_GETW(0xfd868 + i*2));
	}
	MEM_SETD(0x1e*4, 0xe8000000);
}



void bios_init(void) {

	int		i;
	FILEH	fh;

	biosrom = FALSE;

	// ޤDISK BASICư褦ˤʤ뤫餤󤸤ʤǤ
	// BASIC BIOS 8086ɤΤ褦˸뤱ɡ
	fh = file_open_c("bios.rom");
	if (fh != (FILEH)-1) {
		if (file_lread(fh, mem + 0x0e8000, 0x18000) == 0x18000) {
			biosrom = TRUE;
		}
		file_close(fh);
	}
	if (!biosrom) {
		CopyMemory(mem + 0x0e8000, nosyscode, sizeof(nosyscode));
	}

	itf_bank = 0;
	for (i=0; i<0x20; i++) {
		MEM_SETW(0xfd868 + i*2, ((BIOS_OFF) + (i << 1)));				// ver0.29
		MEM_SETW(BIOS_ADR + i*2, 0xcf90);							// ver0.29
	}
	MEM_SETW(BIOS_ADR + 0x40, 0xcf90);								// ver0.29
	MEM_SETW(BIOS_ADR + 0x42, 0xcf90);								// ver0.29

	CopyMemory(mem + BIOS_ADR + 0x4d, printmain, sizeof(printmain));// ver0.29

	bios_vectorset();												// ver0.29

	if (!biosrom) {
		lio_init();
	}

	MEM_SETW(0xfd800, 0xcb90);
	MEM_SETW(0xfd802, 0xcb90);

	for (i=0; i<4; i++) {
		MEM_SETW(0xfd800 + 0x1aaf + i*2, 0x1ab7);
		MEM_SETW(0xfd800 + 0x1ad7 + i*2, 0x1adf);
	}
	CopyMemory(mem + 0xfd800 + 0x1ab7, fdfmt2hd, sizeof(fdfmt2hd));
	CopyMemory(mem + 0xfd800 + 0x1adf, fdfmt2dd, sizeof(fdfmt2dd));

	MEM_SETW(0xfffe8, 0xcb90);
	MEM_SETW(0xfffec, 0xcb90);

	MEM_SETB(0xffff0, 0xea);
	MEM_SETD(0xffff1, 0xfd800000);

	CopyMemory(mem + ITF_ADRS, itfrom, sizeof(itfrom));
	MEM_SETB(ITF_ADRS + 0x7ff0, 0xea);
	MEM_SETD(ITF_ADRS + 0x7ff1, 0xf8000000);

	if (!biosrom) {
		CopyMemory(mem + 0xe8dd8, neccheck, 0x25);
		CopyMemory(mem + 0xf538e, itfrom + GETWORD(itfrom + 2), 0x27);
	}

	bios_reinitbyswitch();
	MEM_SETB(MEMB_CRT_STS_FLAG, 0x84);
	MEM_SETB(MEMB_BIOS_FLAG0, 0x03);
 	MEM_SETW(MEMW_DISK_EQUIP, 0x03);
	MEM_SETB(MEMB_F2DD_MODE, 0xff);									// ver0.29
	MEM_SETD(MEMD_F2DD_POINTER, 0xfd801ad7);
	MEM_SETD(MEMD_F2HD_POINTER, 0xfd801aaf);

	CopyMemory(mem + 0x0fde00, keytable[0], 0x300);
	bios0x09_init();
}

static void bios_reset(void) {

	if (systemport.c & 0x80) {
		if (!(systemport.c & 0x20)) {
			bios_reinitbyswitch();
		}
		I286_CS = 0x0000;
		I286_IP = 0x04f8;
		I286_DS = 0x0000;
		I286_DX = 0x43d;
		I286_AL = 0x10;
		MEM_SETB(0x004f8, 0xee);				// out  dx, al
		MEM_SETB(0x004f9, 0xea);				// call far
		MEM_SETD(0x004fa, 0xffff0000);
	}
	else {
		I286_SP = MEM_GETW(0x00404);
		I286_SS = MEM_GETW(0x00406);
	}
}


WORD BIOS_CALL biosfunc(DWORD adrs) {

	if ((itf_bank) && (adrs >= 0xf8000) && (adrs < 0x100000)) {
		I286_IP--;
		nevent.remainclock = -1;
		return(1);
	}
	if ((adrs >= BIOS_ADR) && (adrs < (BIOS_ADR + 0x42))) {			// ver0.29
		if (adrs & 1) {
			return(0);
		}
		nevent.remainclock -= 300;
		switch((adrs - BIOS_ADR) >> 1) {							// ver0.29
			case 0x08:
				bios0x08();
				break;

			case 0x09:
				bios0x09();
				break;

			case 0x12:
				bios0x13(0xc8);
				break;

			case 0x13:
				bios0x13(0x90);
				break;

			case 0x0a:
			case 0x0b:
			case 0x0c:
			case 0x0d:
			case 0x0e:
			case 0x0f:
				pic_w(0, 0x20);
				break;

			case 0x10:
			case 0x11:
			case 0x14:
			case 0x15:
			case 0x16:
			case 0x17:
				pic_w(8, 0x20);
				if (!pic[1].isr) {
					pic_w(0, 0x20);
				}
				break;

			case 0x18:
				bios0x18();
				break;

			case 0x1b:
				bios0x1b();
				break;

			case 0x1c:
				bios0x1c();
				break;

			case 0x20:
				I286_STI;
				if (fddmtr_biosbusy) {						// ver0.26
					I286_IP--;
					nevent.remainclock = -1;
				}
				else {
					switch(CTRL_FDMEDIA) {
						case DISKTYPE_2HD:
							if (pic[1].isr & PIC_INT42) {
								I286_IP--;
								nevent.remainclock -= 1000;
							}
							break;
						case DISKTYPE_2DD:
							if (pic[1].isr & PIC_INT41) {
								I286_IP--;
								nevent.remainclock -= 1000;
							}
							break;
					}
				}
				break;
		}
		return(1);
	}
	if ((adrs >= 0xf9a00) && (adrs < 0x0f9a24)) {
		if (!(adrs & 1)) {
			bios_lio((BYTE)((adrs - 0xf9a00) >> 1));
		}
		return(0);
	}

	// ꥻå
	if (adrs == 0xfd800) {
		bios_reset();
		return(1);
	}
	// ֡
	if (adrs == 0xfd802) {
		bios_reinitbyswitch();										// ver0.27
		bios_vectorset();											// ver0.29
		I286_CS = bootstrapload();									// ver0.27
		if (!I286_CS) {
			I286_CS = 0xe800;
		}
		I286_STI;
		I286_SS = 0x0030;
		I286_SP = 0x00e6;
		I286_IP = 0x0000;
		return(1);
	}
	// ֡ȥȥåץ
	if (adrs == 0xfffe8) {											// ver0.29
		WORD codseg;
		nevent.remainclock -= 2000;
		codseg = bootstrapload();
		if (codseg) {
			I286_STI;
			I286_CS = codseg;
			I286_IP = 0x0000;
			I286_SS = 0x0030;
			I286_SP = 0x00e6;
			return(1);
		}
		return(0);
	}
	if (adrs == 0xfffec) {											// ver0.29
		nevent.remainclock -= 2000;
		bootstrapload();
		return(0);
	}
	if (biosrom) {
		return(0);
	}
	I286_IP--;
	nevent.remainclock = -1;
	return(1);
}


I286_OUT itf_ctrl(WORD port, BYTE value) {

	switch(value) {
		case 0x10:
			itf_bank = 1;
			break;
		case 0x12:
			itf_bank = 0;
			break;
	}
}


