#include	"compiler.h"

#include	"pc_core.h"
#include	"i286.h"
#include	"iobridge.h"
#include	"memory.h"
#include	"bios.h"
#include	"dmac.h"
#include	"fdc.h"
#include	"pic.h"
#include	"trace.h"

void bios0x13(WORD baseport) {

	BYTE	stat;
	BYTE	result;
	BYTE	*p;
	BYTE	drv;
	BYTE	drvbit;

//	TRACE_("BIOS", 0x13);
	pic_w(8, 0x20);
	if (!pic[1].isr) {
		pic_w(0, 0x20);
	}

	stat = fdc_r(baseport);
	while(1) {
		if (!(stat & FDCSTAT_CB)) {
			if ((stat & (FDCSTAT_RQM | FDCSTAT_DIO)) != FDCSTAT_RQM) {
				break;
			}
			fdc_w(baseport+2, 0x08);
			stat = fdc_r(baseport);
		}
		if ((stat & (FDCSTAT_RQM | FDCSTAT_DIO | FDCSTAT_CB))
							!= (FDCSTAT_RQM | FDCSTAT_DIO | FDCSTAT_CB)) {
			break;
		}
		result = fdc_r(baseport+2);
		if (result == FDCRLT_IC1) {
			break;
		}
		drv = result & 3;
		drvbit = 1 << drv;
#if 0
		if (result & FDCRLT_IC1) {
			if (mem[0x0055e] & drvbit) {
				continue;
			}
			drvbit = 0;
		}
#endif
		p = &mem[0x00564 + (drv * 8)];
		while(1) {
			*p++ = result;
			stat = fdc_r(baseport);
			if ((stat & (FDCSTAT_RQM | FDCSTAT_DIO | FDCSTAT_CB))
							!= (FDCSTAT_RQM | FDCSTAT_DIO | FDCSTAT_CB)) {
				break;
			}
			result = fdc_r(baseport+2);
		}
		mem[0x0055e] |= drvbit;
	}
	if (mem[0x00480] & 0x10) {
		if (mem[0x00485]) {
			if (!(--mem[0x00485])) {
				mem[0x005a4] |= 0x0f;
			}
		}
	}
}
