

#ifdef NP2_LITTLEENDIAN
#define	GETWORD(p)		(*(WORD *)(p))
#define	GETWORDx(p, a)	(*(WORD *)(p+a))
#define	SETWORD(p, i)	*(WORD *)(p) = (i)
#define	GETDWORD(p)		(*(DWORD *)(p))
#define	SETDWORD(p, i)	*(DWORD *)(p) = (i)
#define	MOVWORD(d, s)	*(WORD *)(d) = *(WORD *)(s)
#endif

#ifdef NP2_BIGENDIAN
#define	GETWORD(p)		((WORD)(*((p)+1) << 8) | (BYTE)(*(p)))
#define	GETWORDx(p, a)	((WORD)(p[a+1] << 8) | (BYTE)(p[a]))
#define	SETWORD(p, i)	*(p)=(BYTE)(i); *((p)+1)=(BYTE)((i)>>8);
#define	GETDWORD(p)		(((DWORD)(*((p) + 3)) << 24) |					\
						 ((DWORD)(*((p) + 2)) << 16) |					\
						  ((WORD)(*((p) + 1)) <<  8) | (*(p)))
#define	SETDWORD(p, i)	*(p)=(BYTE)(i); *((p)+1)=(BYTE)((i)>>8);		\
						*((p)+2)=(BYTE)((i)>>16); *((p)+3)=(BYTE)((i)>>24);
#define	MOVWORD(d, s)	*(BYTE *)(d) = *(BYTE *)(s);					\
						*(((BYTE *)(d)) + 1) = *(((BYTE *)(s)) + 1);
#endif



#ifdef NP2_LITTLEENDIAN
typedef unsigned char	XSTR;

#define	XSTR_SETW(itm, data)	*(WORD *)(itm) = (data)
#define	XSTR_SETD(itm, data)	*(DWORD *)(itm) = (data)
#define	XSTR_GETW(itm)			(*(WORD *)(itm))
#define	XSTR_GETD(itm)			(*(DWORD *)(itm))
#endif

#ifdef NP2_BIGENDIAN
typedef unsigned char	XSTR;

#define	XSTR_SETW(itm, data)											\
			*(itm) = (XSTR)((data) & 0x00ff);							\
			*((itm) + 1) = (XSTR)(((data) >> 8) & 0x00ff);
#define	XSTR_SETD(itm, data)											\
			*(itm) = (XSTR)((data) & 0x00ff);							\
			*((itm) + 1) = (XSTR)(((data) >> 8) & 0x00ff);				\
			*((itm) + 2) = (XSTR)(((data) >> 16) & 0x00ff);				\
			*((itm) + 3) = (XSTR)(((data) >> 24) & 0x00ff);
#define	XSTR_GETW(itm)													\
			(((WORD)(*((itm) + 1)) << 8) | (*(itm)))
#define	XSTR_GETD(itm)													\
			(((DWORD)(*((itm) + 3)) << 24) |							\
			 ((DWORD)(*((itm) + 2)) << 16) |							\
			  ((WORD)(*((itm) + 1)) <<  8) | (*(itm)))
#endif

#define	XSTR_SETB(itm, data)	*(itm) = data
#define	XSTR_GETB(itm, data)	(*(itm))





typedef union {
	BYTE	b[2];
	WORD	w;
} XWORD;

typedef union {
	XWORD	x[2];
	DWORD	d;
} XDWORD;


#define	X_HIGH		1
#define	X_LOW		0


#ifdef NP2_LITTLEENDIAN

#define C4_DWORD(a, b, c, d)	(((DWORD)(d) << 24) |					\
								 ((DWORD)(c) << 16) |					\
								 ((WORD)(b) << 8) | (a))

#define	XWORD_BYTE(itm, hl)		((itm).b[(hl)])
#define	XWORD_WORD(itm)			((itm).w)

#define	XDWORD_BYTE(itm, h, l)	((itm).x[(h)].b[(l)])
#define	XDWORD_WORD(itm, hl)	((itm).x[(hl)].w)
#define	XDWORD_DWORD(itm)		((itm).d)

#endif

#ifdef NP2_BIGENDIAN									// !!!!!! ToDo

#ifndef NP2_TESTBIGENDIAN

#define C4_DWORD(a, b, c, d)	(((DWORD)(a) << 24) |					\
								 ((DWORD)(b) << 16) |					\
								 ((WORD)(c) << 8) | (d))

#define	XWORD_BYTE(itm, hl)		((itm).b[(hl) ^ 1])
#define	XWORD_WORD(itm)			((itm).w)

#define	XDWORD_BYTE(itm, h, l)	((itm).x[(h) ^ 1].b[(l) ^ 1])
#define	XDWORD_WORD(itm, hl)	((itm).x[(hl) ^ 1].w)
#define	XDWORD_DWORD(itm)		((itm).d)

#else

#define C4_DWORD(a, b, c, d)	(((DWORD)(d) << 24) |					\
								 ((DWORD)(c) << 16) |					\
								 ((WORD)(b) << 8) | (a))

#define	XWORD_BYTE(itm, hl)		((itm).b[(hl)])
#define	XWORD_WORD(itm)			((itm).w)

#define	XDWORD_BYTE(itm, h, l)	((itm).x[(h)].b[(l)])
#define	XDWORD_WORD(itm, hl)	((itm).x[(hl)].w)
#define	XDWORD_DWORD(itm)		((itm).d)

#endif

#endif

