;
; i286.mcr
;

%macro	I286CLOCK	1
	sub	dword [nevent + nevent_t.remainclock], %1
%endmacro

%macro	I286CLOCKDEC	0
	dec	dword [nevent + nevent_t.remainclock]
%endmacro

%macro	FLAG_LOAD	0
	mov	ah, byte [I286_FLAGL]
	sahf
%endmacro

%macro	CFLAG_LOAD	0
	bt	word [I286_FLAG], 0
%endmacro

%macro	FLAG_STORE	0
	lahf
	mov	byte [I286_FLAGL], ah
%endmacro

%macro	FLAG_STORE0	0
	lahf
	mov	byte [I286_FLAGL], ah
	and	word [I286_FLAG], ~O_FLAG
%endmacro

%macro	FLAG_STORE_OF	0
	lahf
	mov	byte [I286_FLAGL], ah
	seto	ah
	shl	ah, 3
	and	word [I286_FLAG], ~O_FLAG
	or	byte [I286_FLAGH], ah
%endmacro

%macro	FLAG_STORE_NC	0
	clc
	lahf
	seto	bl
	shl	bl, 3
	and	word [I286_FLAG], 0f701h
	or	byte [I286_FLAGL], ah
	or	byte [I286_FLAGH], bl
%endmacro

%macro	FLAG_STORE_OC	0
	seto	bh
	setc	bl
	shl	bh, 3
	and	word [I286_FLAG], ~(O_FLAG | C_FLAG)
	or	word [I286_FLAG], bx
%endmacro

%macro	GET_PCBYTE	0
	lea	ecx, [ebp + esi]
	inc	si
	call	@i286_memoryread@4
%endmacro

%macro	GET_PCWORD	0
	lea	ecx, [ebp + esi]
	add	si, 2
	call	@i286_memoryread_w@4
%endmacro

%macro	REGPUSH1	1
	mov	dx, %1
	sub	word [I286_SP], 2
	movzx	ecx, word [I286_SP]
	add	ecx, dword [SS_BASE]
	jmp	@i286_memorywrite_w@8
%endmacro

%macro	REGPOP		1
	movzx	ecx, word [I286_SP]
	add	ecx, dword [SS_BASE]
	call	@i286_memoryread_w@4
	mov	%1, ax
	add	word [I286_SP], 2
%endmacro

%macro	INT_NUM		1
	mov	edi, dword [SS_BASE]
	movzx	ebx, word [I286_SP]
	sub	bx, 2
	lea	ecx, [edi + ebx]
	mov	dx, word [I286_FLAG]
	and	word [I286_FLAG], ~(T_FLAG | I_FLAG)
	mov	dword [I286_TRAP], 0
	call	@i286_memorywrite_w@8
	sub	bx, 2
	lea	ecx, [edi + ebx]
	mov	dx, word [I286_CS]
	call	@i286_memorywrite_w@8
	sub	bx, 2
	mov	word [I286_SP], bx
	lea	ecx, [edi + ebx]
	mov	dx, si
	mov	eax, dword [I286_MEM + %1 * 4]
	mov	si, ax
	shr	eax, 16
	mov	word [I286_CS], ax
	shl	eax, 4
	mov	dword [CS_BASE], eax
	mov	ebp, eax
	jmp	@i286_memorywrite_w@8
%endmacro

%macro	V30INT_NUM	1
	mov	edi, dword [SS_BASE]
	movzx	ebx, word [I286_SP]
	sub	bx, 2
	lea	ecx, [edi + ebx]
	mov	dx, word [I286_FLAG]
	or	dx, 0f000h
	and	word [I286_FLAG], ~(T_FLAG | I_FLAG)
	mov	dword [I286_TRAP], 0
	call	@i286_memorywrite_w@8
	sub	bx, 2
	lea	ecx, [edi + ebx]
	mov	dx, word [I286_CS]
	call	@i286_memorywrite_w@8
	sub	bx, 2
	mov	word [I286_SP], bx
	lea	ecx, [edi + ebx]
	mov	dx, si
	mov	eax, dword [I286_MEM + %1 * 4]
	mov	si, ax
	shr	eax, 16
	mov	word [I286_CS], ax
	shl	eax, 4
	mov	dword [CS_BASE], eax
	mov	ebp, eax
	jmp	@i286_memorywrite_w@8
%endmacro

%macro	STRING_DIR	0
	xor	ax, ax
	test	word [I286_FLAG], D_FLAG
	setz	al
	add	al, al
	dec	ax
%endmacro

%macro	STRING_DIRx2	0
	xor	ax, ax
	test	word [I286_FLAG], D_FLAG
	setz	al
	shl	ax, 2
	sub	ax, 2
%endmacro

%macro	GET_PCBYTEEX	0
	lea	ecx, [ebp + esi]
	inc	si
	call	@i286_memoryread_w@4
	movzx	ebx, al
%endmacro

%macro	INC_PCBYTE	0
	inc	si
%endmacro

%macro	GET_PCBYTE_C	0
	inc	si
	mov	al, ah
%endmacro


;
; i286_ea.mcr
;

%macro	GET_PREFIX_DS		0
	mov	edi, dword [DS_FIX]
%endmacro

%macro	GET_PREFIX_SS		0
	mov	edi, dword [SS_FIX]
%endmacro

; dest: I286_REG[eax] src: dl
%macro	PREPART_EA_REG8		1
	GET_PCBYTE
	mov	ebx, eax
	shr	ebx, 3
	bt	ebx, 2
	rcl	ebx, 1
	and	ebx, 7
	cmp	al, 0c0h
	jc	.memory_eareg8
	bt	eax, 2
	rcl	eax, 1
	and	eax, 7
	mov	dl, byte [I286_REG + ebx]
	I286CLOCK %1
%endmacro

; dest: MAIN_MEM[ecx] src: dl
%macro	MEMORY_EA_REG8		1
.memory_eareg8:
	I286CLOCK %1
	rol	al, 2
	and	eax, 31
	call	[calc_ea_dst + eax * 4]
	cmp	ecx, I286_MEMWRITEMAX
	jae	.extmem_eareg8
	mov	dl, byte [I286_REG + ebx]
%endmacro

; dest: al,ecx src: I286_REG[ebx]
%macro EXTMEM_EA_REG8		0
.extmem_eareg8:
	call	@i286_memoryread@4
%endmacro

; dest: I286_REG[eax*2] src: dx
%macro	PREPART_EA_REG16	1
	GET_PCBYTE
	mov	ebx, eax
	shr	ebx, 3
	and	ebx, 7
	cmp	al, 0c0h
	jc	.memory_eareg16
	and	eax, 7
	mov	dx, word [I286_REG + ebx * 2]
	I286CLOCK %1
%endmacro

; dest: MAIN_MEM[ecx] src: dx
%macro	MEMORY_EA_REG16		1
.memory_eareg16:
	I286CLOCK %1
	rol	al, 2
	and	eax, 1fh
	call	[calc_ea_dst + eax * 4]
	cmp	ecx, (I286_MEMWRITEMAX - 1)
	jae	.extmem_eareg16
	mov	dx, word [I286_REG + ebx * 2]
%endmacro

; dest: ax,ecx src: I286_REG[ebx*2]
%macro EXTMEM_EA_REG16		0
.extmem_eareg16:
	call	@i286_memoryread_w@4
%endmacro

; dest: I286_REG[ebx]  src: al
%macro	PREPART_REG8_EA		2
	GET_PCBYTE
	mov	ebx, eax
	shr	ebx, 3
	bt	ebx, 2
	rcl	ebx, 1
	and	ebx, 7
	cmp	al, 0c0h
	jnc	.src_register

	I286CLOCK %2
	rol	al, 2
	and	eax, 1fh
	call	[calc_ea_dst + eax * 4]
	call	@i286_memoryread@4
	jmp	.reg8_ea_ready

.src_register:
	bt	ax, 2
	rcl	eax, 1
	and	eax, 7
	mov	al, byte [I286_REG + eax]
	I286CLOCK %1
.reg8_ea_ready:
%endmacro

; dest: I286_REG[ebx*2]  src: ax
%macro	PREPART_REG16_EA	2
	GET_PCBYTE
	mov	ebx, eax
	shr	ebx, 3
	and	ebx, 7
	cmp	al, 0c0h
	jnc	.src_register

	I286CLOCK %2
	rol	al, 2
	and	eax, 1fh
	call	[calc_ea_dst + eax * 4]
	call	@i286_memoryread_w@4
	jmp	.reg16_ea_ready

.src_register:
	and	eax, 7
	mov	ax, word [I286_REG + eax * 2]
	I286CLOCK %1
.reg16_ea_ready:
%endmacro

; dest: I286_REG[eax]
%macro	PREPART_EA8		1
	cmp	al, 0c0h
	jc	.memory_eareg8

	I286CLOCK %1
	bt	eax, 2
	rcl	eax, 1
	and	eax, 7
%endmacro

; dest: MAIN_MEM[ecx]
%macro	MEMORY_EA8		1
.memory_eareg8:
	I286CLOCK %1
	rol	al, 2
	and	eax, 1fh
	call	[calc_ea_dst + eax * 4]
	cmp	ecx, I286_MEMWRITEMAX
	jae	.extmem_eareg8
%endmacro

; dest: ecx
%macro EXTMEM_EA8		0
.extmem_eareg8:
	call	@i286_memoryread@4
%endmacro

; dest: I286_REG[eax*2]
%macro	PREPART_EA16		1
	cmp	al, 0c0h
	jc	.memory_eareg16
	I286CLOCK %1
	and	eax, 7
%endmacro

; dest: MAIN_MEM[ecx]
%macro	MEMORY_EA16		1
.memory_eareg16:
	I286CLOCK %1
	rol	al, 2
	and	eax, 1fh
	call	[calc_ea_dst + eax * 4]
	cmp	ecx, (I286_MEMWRITEMAX-1)
	jae	.extmem_eareg16
%endmacro

; dest: ecx
%macro EXTMEM_EA16		0
.extmem_eareg16:
	call	@i286_memoryread_w@4
%endmacro

extern	@i286_memoryread@4
extern	@i286_memoryread_w@4
extern	@i286_memorywrite@8
extern	@i286_memorywrite_w@8
extern	@i286_in@4
extern	@i286_in_w@4
extern	@i286_out@8
extern	@i286_out_w@8
