
;
;	Intel Architecture 32-bit Processor Interpreter Engine for Pentium
;
;							Copyright by Yui/Studio Milmake 1999-2000
;							Copyright by Norio HATTORI 2000
;

CPU_VENDOR_1		equ		'_Ayu'
CPU_VENDOR_2		equ		'Ayu_'
CPU_VENDOR_3		equ		'    '
CPU_FAMILY			equ		6
CPU_MODEL			equ		1
CPU_STEPPING		equ		3
_SUPPORT_FPU		equ		(1 << 0)
_SUPPORT_CX8		equ		(1 << 8)
_SUPPORT_CMOV		equ		(1 << 15)
_SUPPORT_MMX		equ		(1 << 23)
_SUPPORT_SSE		equ		(1 << 25)
%ifdef USE_FPU
 CPU_FEATURES		equ		(_SUPPORT_FPU | _SUPPORT_CX8 | _SUPPORT_CMOV)
%else
 CPU_FEATURES		equ		(_SUPPORT_CX8 | _SUPPORT_CMOV)
%endif

MAINMEM_READMAX		equ		0xa4000
MAINMEM_WRITEMAX	equ		0xa0000

%macro REG 4
  %1:
  %2:
  %3:	resb	1
  %4:	resb	1
		resw	1
%endmacro

%macro REG_1 1
	REG .e%1x, .%1x, .%1l, .%1h
%endmacro
%macro REG_2 1
	REG .e%1, .%1, %%dummy1, %%dummy2
%endmacro
%macro REG_3 3
	REG .e%1, .%1, .%2, .%3
%endmacro

	struc	CPU_REGS
		REG_1 a
		REG_1 c
		REG_1 d
		REG_1 b
		REG_2 sp
		REG_2 bp
		REG_2 si
		REG_2 di

.sregs
.es		resw	1
.cs		resw	1
.ss		resw	1
.ds		resw	1
.fs		resw	1
.gs		resw	1

		REG_3 flags, flags_l, flags_h

		REG_2 ip
	endstruc

	struc	CPU_SYSREGS
.gdtr
	.gdtr_limit	resw	1
	.gdtr_base	resd	1
.idtr
	.idtr_limit	resw	1
	.idtr_base	resd	1
.ldtr			resw	1
.tr				resw	1

.ctrlreg
.cr0			resd	1
.cr1			resd	1
.cr2			resd	1
.cr3			resd	1
.cr4			resd	1
.mxcsr			resd	1
	endstruc

	struc	CPU_STAT
.seg_bases
.es_base	resd	1
.cs_base	resd	1
.ss_base	resd	1
.ds_base	resd	1
.fs_base	resd	1
.gs_base	resd	1

.trap		resb	1
.padding	resb	1
.inport		resd	1
.cpu_type	resb	1
._dummy		resb	1
.ovflag		resd	1
	endstruc

	struc	CPU_INST
.op_32		resb	1
.as_32		resb	1
.rep_used	resb	1
.seg_used	resb	1
.seg_base	resd	1
	endstruc

%define MAIN_MEM	_mem
%define CPU_REG		_cpu_regs
%define CPU_SEGREG	(_cpu_regs + CPU_REGS.sregs)

%define CPU_AL		(_cpu_regs + CPU_REGS.al)
%define CPU_BL		(_cpu_regs + CPU_REGS.bl)
%define CPU_CL		(_cpu_regs + CPU_REGS.cl)
%define CPU_DL		(_cpu_regs + CPU_REGS.dl)
%define CPU_AH		(_cpu_regs + CPU_REGS.ah)
%define CPU_BH		(_cpu_regs + CPU_REGS.bh)
%define CPU_CH		(_cpu_regs + CPU_REGS.ch)
%define CPU_DH		(_cpu_regs + CPU_REGS.dh)

%define CPU_AX		(_cpu_regs + CPU_REGS.ax)
%define CPU_BX		(_cpu_regs + CPU_REGS.bx)
%define CPU_CX		(_cpu_regs + CPU_REGS.cx)
%define CPU_DX		(_cpu_regs + CPU_REGS.dx)
%define CPU_SI		(_cpu_regs + CPU_REGS.si)
%define CPU_DI		(_cpu_regs + CPU_REGS.di)
%define CPU_BP		(_cpu_regs + CPU_REGS.bp)
%define CPU_SP		(_cpu_regs + CPU_REGS.sp)
%define CPU_IP		(_cpu_regs + CPU_REGS.ip)

%define CPU_EAX		(_cpu_regs + CPU_REGS.eax)
%define CPU_EBX		(_cpu_regs + CPU_REGS.ebx)
%define CPU_ECX		(_cpu_regs + CPU_REGS.ecx)
%define CPU_EDX		(_cpu_regs + CPU_REGS.edx)
%define CPU_ESI		(_cpu_regs + CPU_REGS.esi)
%define CPU_EDI		(_cpu_regs + CPU_REGS.edi)
%define CPU_EBP		(_cpu_regs + CPU_REGS.ebp)
%define CPU_ESP		(_cpu_regs + CPU_REGS.esp)
%define CPU_EIP		(_cpu_regs + CPU_REGS.eip)

%define CPU_CS		(_cpu_regs + CPU_REGS.cs)
%define CPU_DS		(_cpu_regs + CPU_REGS.ds)
%define CPU_ES		(_cpu_regs + CPU_REGS.es)
%define CPU_FS		(_cpu_regs + CPU_REGS.fs)
%define CPU_GS		(_cpu_regs + CPU_REGS.gs)
%define CPU_SS		(_cpu_regs + CPU_REGS.ss)

%define SEG_BASE	(_cpu_stat + CPU_STAT.seg_bases)
%define ES_BASE		(_cpu_stat + CPU_STAT.es_base)
%define CS_BASE		(_cpu_stat + CPU_STAT.cs_base)
%define SS_BASE		(_cpu_stat + CPU_STAT.ss_base)
%define DS_BASE		(_cpu_stat + CPU_STAT.ds_base)
%define FS_BASE		(_cpu_stat + CPU_STAT.fs_base)
%define GS_BASE		(_cpu_stat + CPU_STAT.gs_base)

%define CPU_EFLAG	(_cpu_regs + CPU_REGS.eflags)
%define CPU_FLAG	(_cpu_regs + CPU_REGS.flags)
%define CPU_FLAGL	(_cpu_regs + CPU_REGS.flags_l)
%define CPU_FLAGH	(_cpu_regs + CPU_REGS.flags_h)
%define CPU_TRAP	(_cpu_stat + CPU_STAT.trap)
;%define CPU_INPORT	(_cpu_stat + CPU_STAT.inport)

C_FLAG		equ		(1 << 0)
P_FLAG		equ		(1 << 2)
A_FLAG		equ		(1 << 4)
Z_FLAG		equ		(1 << 6)
S_FLAG		equ		(1 << 7)
T_FLAG		equ		(1 << 8)
I_FLAG		equ		(1 << 9)
D_FLAG		equ		(1 << 10)
O_FLAG		equ		(1 << 11)

IOPL_FLAG	equ		(3 << 12)
NT_FLAG		equ		(1 << 14)
RF_FLAG		equ		(1 << 16)
VM_FLAG		equ		(1 << 17)
AC_FLAG		equ		(1 << 18)
VIF_FLAG	equ		(1 << 19)
VIP_FLAG	equ		(1 << 20)
ID_FLAG		equ		(1 << 21)

%define CPU_INST_OP32		(cpu_inst + CPU_INST.op_32)
%define CPU_INST_AS32		(cpu_inst + CPU_INST.as_32)
%define CPU_INST_REPUSE		(cpu_inst + CPU_INST.rep_used)
%define CPU_INST_SEGUSE		(cpu_inst + CPU_INST.seg_used)
%define CPU_INST_SEGBASE	(cpu_inst + CPU_INST.seg_base)

INST_PREFIX		equ		(1 << 0)
INST_STRING		equ		(1 << 1)
REP_CHECKZF		equ		(1 << 7)

%define CPU_GDTR		(_cpu_sysregs + CPU_SYSREGS.gdtr)
%define CPU_GDTR_LIMIT	(_cpu_sysregs + CPU_SYSREGS.gdtr_limit)
%define CPU_GDTR_BASE	(_cpu_sysregs + CPU_SYSREGS.gdtr_base)
%define CPU_IDTR		(_cpu_sysregs + CPU_SYSREGS.idtr)
%define CPU_IDTR_LIMIT	(_cpu_sysregs + CPU_SYSREGS.idtr_limit)
%define CPU_IDTR_BASE	(_cpu_sysregs + CPU_SYSREGS.idtr_base)
%define CPU_LDTR		(_cpu_sysregs + CPU_SYSREGS.ldtr)
%define CPU_TR			(_cpu_sysregs + CPU_SYSREGS.tr)

%define CPU_CTRLREG		(_cpu_sysregs + CPU_SYSREGS.ctrlreg)
%define CPU_CR0			(_cpu_sysregs + CPU_SYSREGS.cr0)
%define CPU_CR1			(_cpu_sysregs + CPU_SYSREGS.cr1)
%define CPU_CR2			(_cpu_sysregs + CPU_SYSREGS.cr2)
%define CPU_CR3			(_cpu_sysregs + CPU_SYSREGS.cr3)
%define CPU_CR4			(_cpu_sysregs + CPU_SYSREGS.cr4)
%define CPU_MXCSR		(_cpu_sysregs + CPU_SYSREGS.mxcsr)

CR0_PE		equ		(1 << 0)
CR0_MP		equ		(1 << 1)
CR0_EM		equ		(1 << 2)
CR0_TS		equ		(1 << 3)
CR0_ET		equ		(1 << 4)
CR0_NE		equ		(1 << 5)
CR0_WP		equ		(1 << 16)
CR0_AM		equ		(1 << 18)
CR0_NW		equ		(1 << 29)
CR0_CD		equ		(1 << 30)
CR0_PG		equ		(1 << 31)

%define	_cpu_regs	cpu_regs
%define	_cpu_sysregs	cpu_sysregs
%define	_cpu_stat	cpu_stat
%define	_cpu_inst	cpu_inst
%define	_iflags		iflags
extern cpu_regs
extern cpu_sysregs
extern cpu_stat
extern cpu_inst
extern iflags
