
; BINARY ARITHMETIC INSTRUCTIONS

%include "cpu.inc"
%include "cpu.mcr"
%include "misc.inc"
%include "resolve.inc"

extern	_cpu_regs
extern	_cpu_stat
extern	cpu_inst

section .text

; add
	align	32
	global	ADD_EbGb
ADD_EbGb:
				PREPART_EA_REG8 2
					add		[CPU_REG + eax], dl
					FLAG_STORE_OF
					ret
				MEMORY_EA_REG8 7
					add		[MAIN_MEM + ecx], dl
					FLAG_STORE_OF
					ret
				EXTMEM_EA_REG8
					add		al, [CPU_REG + ebx]
					mov		dl, al
					FLAG_STORE_OF
					jmp		__f_i286_memorywrite@8

	align	32
	global	ADD_EwGw
ADD_EwGw:
				PREPART_EA_REG16 2
					add		[CPU_REG + eax * 4], dx
					FLAG_STORE_OF
					ret
				MEMORY_EA_REG16 7
					add		[MAIN_MEM + ecx], dx
					FLAG_STORE_OF
					ret
				EXTMEM_EA_REG16
					add		ax, [CPU_REG + ebx * 4]
					mov		dx, ax
					FLAG_STORE_OF
					jmp		__f_i286_memorywrite_w@8

	align	32
	global	ADD_EdGd
ADD_EdGd:
				PREPART_EA_REG32 2
					add		[CPU_REG + eax * 4], edx
					FLAG_STORE_OF
					ret
				MEMORY_EA_REG32 7
					add		[MAIN_MEM + ecx], edx
					FLAG_STORE_OF
					ret
				EXTMEM_EA_REG32
					add		eax, [CPU_REG + ebx * 4]
					mov		edx, eax
					FLAG_STORE_OF
					jmp		__f_i286_memorywrite_d@8

	align	32
	global	ADD_GbEb
ADD_GbEb:
				PREPART_REG8_EA 2, 7
					add		[CPU_REG + ebx], al
					FLAG_STORE_OF
					ret

	align	32
	global	ADD_GwEw
ADD_GwEw:
				PREPART_REG16_EA 2, 7
					add		[CPU_REG + ebx * 4], ax
					FLAG_STORE_OF
					ret

	align	32
	global	ADD_GdEd
ADD_GdEd:
				PREPART_REG32_EA 2, 7
					add		[CPU_REG + ebx * 4], eax
					FLAG_STORE_OF
					ret

	align	32
	global	ADD_ALIb
ADD_ALIb:
				CPUCLOCK 3
				GET_PCBYTE
				add		[CPU_AL], al
				FLAG_STORE_OF
				ret

	align	32
	global	ADD_AXIw
ADD_AXIw:
				CPUCLOCK 3
				GET_PCWORD
				add		[CPU_AX], ax
				FLAG_STORE_OF
				ret

	align	32
	global	ADD_EAXId
ADD_EAXId:
				CPUCLOCK 3
				GET_PCDWORD
				add		[CPU_EAX], eax
				FLAG_STORE_OF
				ret

	align	32
	global	ADD_EbIb
ADD_EbIb:
				PREPART_EA8 3
					mov		ebx, eax
					GET_PCBYTE
					add		[CPU_REG + ebx], al
					FLAG_STORE_OF
					ret
				MEMORY_EA8 7
					mov		ebx, ecx
					GET_PCBYTE
					add		[MAIN_MEM + ebx], al
					FLAG_STORE_OF
					ret
				EXTMEM_EA8
					mov		dl, al
					mov		ebx, ecx
					GET_PCBYTE
					mov		ecx, ebx
					add		dl, al
					FLAG_STORE_OF
					jmp		__f_i286_memorywrite@8

	align	32
	global	ADD_EwIb
ADD_EwIb:
				PREPART_EA16 3
					mov		ebx, eax
					GET_PCBYTE
					cbw
					add		[CPU_REG + ebx * 4], ax
					FLAG_STORE_OF
					ret
				MEMORY_EA16 7
					mov		ebx, ecx
					GET_PCBYTE
					cbw
					add		[MAIN_MEM + ebx], ax
					FLAG_STORE_OF
					ret
				EXTMEM_EA16
					mov		dx, ax
					mov		ebx, ecx
					GET_PCBYTE
					cbw
					mov		ecx, ebx
					add		dx, ax
					FLAG_STORE_OF
					jmp		__f_i286_memorywrite_w@8

	align	32
	global	ADD_EdIb
ADD_EdIb:
				PREPART_EA32 3
					mov		ebx, eax
					GET_PCBYTE
					cbw
					cwde
					add		[CPU_REG + ebx * 4], eax
					FLAG_STORE_OF
					ret
				MEMORY_EA32 7
					mov		ebx, ecx
					GET_PCBYTE
					cbw
					cwde
					add		[MAIN_MEM + ebx], eax
					FLAG_STORE_OF
					ret
				EXTMEM_EA32
					mov		edx, eax
					mov		ebx, ecx
					GET_PCBYTE
					cbw
					cwde
					mov		ecx, ebx
					add		edx, eax
					FLAG_STORE_OF
					jmp		__f_i286_memorywrite_d@8

	align	32
	global	ADD_EwIw
ADD_EwIw:
				PREPART_EA16 3
					mov		ebx, eax
					GET_PCWORD
					add		[CPU_REG + ebx * 4], ax
					FLAG_STORE_OF
					ret
				MEMORY_EA16 7
					mov		ebx, ecx
					GET_PCWORD
					add		[MAIN_MEM + ebx], ax
					FLAG_STORE_OF
					ret
				EXTMEM_EA16
					mov		dx, ax
					mov		ebx, ecx
					GET_PCWORD
					mov		ecx, ebx
					add		dx, ax
					FLAG_STORE_OF
					jmp		__f_i286_memorywrite_w@8

	align	32
	global	ADD_EdId
ADD_EdId:
				PREPART_EA32 3
					mov		ebx, eax
					GET_PCDWORD
					add		[CPU_REG + ebx * 4], eax
					FLAG_STORE_OF
					ret
				MEMORY_EA32 7
					mov		ebx, ecx
					GET_PCDWORD
					add		[MAIN_MEM + ebx], eax
					FLAG_STORE_OF
					ret
				EXTMEM_EA32
					mov		edx, eax
					mov		ebx, ecx
					GET_PCDWORD
					mov		ecx, ebx
					add		edx, eax
					FLAG_STORE_OF
					jmp		__f_i286_memorywrite_d@8

; adc
	align	32
	global	ADC_EbGb
ADC_EbGb:
				PREPART_EA_REG8 2
					CFLAG_LOAD
					adc		[CPU_REG + eax], dl
					FLAG_STORE_OF
					ret
				MEMORY_EA_REG8 7
					CFLAG_LOAD
					adc		[MAIN_MEM + ecx], dl
					FLAG_STORE_OF
					ret
				EXTMEM_EA_REG8
					CFLAG_LOAD
					adc		al, [CPU_REG + ebx]
					mov		dl, al
					FLAG_STORE_OF
					jmp		__f_i286_memorywrite@8

	align	32
	global	ADC_EwGw
ADC_EwGw:
				PREPART_EA_REG16 2
					CFLAG_LOAD
					adc		[CPU_REG + eax * 4], dx
					FLAG_STORE_OF
					ret
				MEMORY_EA_REG16 7
					CFLAG_LOAD
					adc		[MAIN_MEM + ecx], dx
					FLAG_STORE_OF
					ret
				EXTMEM_EA_REG16
					CFLAG_LOAD
					adc		ax, [CPU_REG + ebx * 4]
					mov		dx, ax
					FLAG_STORE_OF
					jmp		__f_i286_memorywrite_w@8

	align	32
	global	ADC_EdGd
ADC_EdGd:
				PREPART_EA_REG32 2
					CFLAG_LOAD
					adc		[CPU_REG + eax * 4], edx
					FLAG_STORE_OF
					ret
				MEMORY_EA_REG32 7
					CFLAG_LOAD
					adc		[MAIN_MEM + ecx], edx
					FLAG_STORE_OF
					ret
				EXTMEM_EA_REG32
					CFLAG_LOAD
					adc		eax, [CPU_REG + ebx * 4]
					mov		edx, eax
					FLAG_STORE_OF
					jmp		__f_i286_memorywrite_d@8

	align	32
	global	ADC_GbEb
ADC_GbEb:
				PREPART_REG8_EA 2, 7
					CFLAG_LOAD
					adc		[CPU_REG + ebx], al
					FLAG_STORE_OF
					ret

	align	32
	global	ADC_GwEw
ADC_GwEw:
				PREPART_REG16_EA 2, 7
					CFLAG_LOAD
					adc		[CPU_REG + ebx * 4], ax
					FLAG_STORE_OF
					ret

	align	32
	global	ADC_GdEd
ADC_GdEd:
				PREPART_REG32_EA 2, 7
					CFLAG_LOAD
					adc		[CPU_REG + ebx * 4], eax
					FLAG_STORE_OF
					ret

	align	32
	global	ADC_ALIb
ADC_ALIb:
				CPUCLOCK 3
				GET_PCBYTE
				CFLAG_LOAD
				adc		[CPU_AL], al
				FLAG_STORE_OF
				ret

	align	32
	global	ADC_AXIw
ADC_AXIw:
				CPUCLOCK 3
				GET_PCWORD
				CFLAG_LOAD
				adc		[CPU_AX], ax
				FLAG_STORE_OF
				ret

	align	32
	global	ADC_EAXId
ADC_EAXId:
				CPUCLOCK 3
				GET_PCDWORD
				CFLAG_LOAD
				adc		[CPU_EAX], eax
				FLAG_STORE_OF
				ret

	align	32
	global	ADC_EbIb
ADC_EbIb:
				PREPART_EA8 3
					mov		ebx, eax
					GET_PCBYTE
					CFLAG_LOAD
					adc		[CPU_REG + ebx], al
					FLAG_STORE_OF
					ret
				MEMORY_EA8 7
					mov		ebx, ecx
					GET_PCBYTE
					CFLAG_LOAD
					adc		[MAIN_MEM + ebx], al
					FLAG_STORE_OF
					ret
				EXTMEM_EA8
					mov		dl, al
					mov		ebx, ecx
					GET_PCBYTE
					mov		ecx, ebx
					CFLAG_LOAD
					adc		dl, al
					FLAG_STORE_OF
					jmp		__f_i286_memorywrite@8

	align	32
	global	ADC_EwIb
ADC_EwIb:
				PREPART_EA16 3
					mov		ebx, eax
					GET_PCBYTE
					cbw
					CFLAG_LOAD
					adc		[CPU_REG + ebx * 4], ax
					FLAG_STORE_OF
					ret
				MEMORY_EA16 7
					mov		ebx, ecx
					GET_PCBYTE
					cbw
					CFLAG_LOAD
					adc		[MAIN_MEM + ebx], ax
					FLAG_STORE_OF
					ret
				EXTMEM_EA16
					mov		dx, ax
					mov		ebx, ecx
					GET_PCBYTE
					cbw
					mov		ecx, ebx
					CFLAG_LOAD
					adc		dx, ax
					FLAG_STORE_OF
					jmp		__f_i286_memorywrite_w@8

	align	32
	global	ADC_EdIb
ADC_EdIb:
				PREPART_EA32 3
					mov		ebx, eax
					GET_PCBYTE
					cbw
					cwde
					CFLAG_LOAD
					adc		[CPU_REG + ebx * 4], eax
					FLAG_STORE_OF
					ret
				MEMORY_EA32 7
					mov		ebx, ecx
					GET_PCBYTE
					cbw
					cwde
					CFLAG_LOAD
					adc		[MAIN_MEM + ebx], eax
					FLAG_STORE_OF
					ret
				EXTMEM_EA32
					mov		edx, eax
					mov		ebx, ecx
					GET_PCBYTE
					cbw
					cwde
					mov		ecx, ebx
					CFLAG_LOAD
					adc		edx, eax
					FLAG_STORE_OF
					jmp		__f_i286_memorywrite_d@8

	align	32
	global	ADC_EwIw
ADC_EwIw:
				PREPART_EA16 3
					mov		ebx, eax
					GET_PCWORD
					CFLAG_LOAD
					adc		[CPU_REG + ebx * 4], ax
					FLAG_STORE_OF
					ret
				MEMORY_EA16 7
					mov		ebx, ecx
					GET_PCWORD
					CFLAG_LOAD
					adc		[MAIN_MEM + ebx], ax
					FLAG_STORE_OF
					ret
				EXTMEM_EA16
					mov		dx, ax
					mov		ebx, ecx
					GET_PCWORD
					mov		ecx, ebx
					CFLAG_LOAD
					adc		dx, ax
					FLAG_STORE_OF
					jmp		__f_i286_memorywrite_w@8

	align	32
	global	ADC_EdId
ADC_EdId:
				PREPART_EA32 3
					mov		ebx, eax
					GET_PCDWORD
					CFLAG_LOAD
					adc		[CPU_REG + ebx * 4], eax
					FLAG_STORE_OF
					ret
				MEMORY_EA32 7
					mov		ebx, ecx
					GET_PCDWORD
					CFLAG_LOAD
					adc		[MAIN_MEM + ebx], eax
					FLAG_STORE_OF
					ret
				EXTMEM_EA32
					mov		edx, eax
					mov		ebx, ecx
					GET_PCDWORD
					mov		ecx, ebx
					CFLAG_LOAD
					adc		edx, eax
					FLAG_STORE_OF
					jmp		__f_i286_memorywrite_d@8

; sub
	align	32
	global	SUB_EbGb
SUB_EbGb:
				PREPART_EA_REG8 2
					sub		[CPU_REG + eax], dl
					FLAG_STORE_OF
					ret
				MEMORY_EA_REG8 7
					sub		[MAIN_MEM + ecx], dl
					FLAG_STORE_OF
					ret
				EXTMEM_EA_REG8
					sub		al, [CPU_REG + ebx]
					mov		dl, al
					FLAG_STORE_OF
					jmp		__f_i286_memorywrite@8

	align	32
	global	SUB_EwGw
SUB_EwGw:
				PREPART_EA_REG16 2
					sub		[CPU_REG + eax * 4], dx
					FLAG_STORE_OF
					ret
				MEMORY_EA_REG16 7
					sub		[MAIN_MEM + ecx], dx
					FLAG_STORE_OF
					ret
				EXTMEM_EA_REG16
					sub		ax, [CPU_REG + ebx * 4]
					mov		dx, ax
					FLAG_STORE_OF
					jmp		__f_i286_memorywrite_w@8

	align	32
	global	SUB_EdGd
SUB_EdGd:
				PREPART_EA_REG32 2
					sub		[CPU_REG + eax * 4], edx
					FLAG_STORE_OF
					ret
				MEMORY_EA_REG32 7
					sub		[MAIN_MEM + ecx], edx
					FLAG_STORE_OF
					ret
				EXTMEM_EA_REG32
					sub		eax, [CPU_REG + ebx * 4]
					mov		edx, eax
					FLAG_STORE_OF
					jmp		__f_i286_memorywrite_d@8

	align	32
	global	SUB_GbEb
SUB_GbEb:
				PREPART_REG8_EA 2, 7
					sub		[CPU_REG + ebx], al
					FLAG_STORE_OF
					ret

	align	32
	global	SUB_GwEw
SUB_GwEw:
				PREPART_REG16_EA 2, 7
					sub		[CPU_REG + ebx * 4], ax
					FLAG_STORE_OF
					ret

	align	32
	global	SUB_GdEd
SUB_GdEd:
				PREPART_REG32_EA 2, 7
					sub		[CPU_REG + ebx * 4], eax
					FLAG_STORE_OF
					ret

	align	32
	global	SUB_ALIb
SUB_ALIb:
				CPUCLOCK 3
				GET_PCBYTE
				sub		[CPU_AL], al
				FLAG_STORE_OF
				ret

	align	32
	global	SUB_AXIw
SUB_AXIw:
				CPUCLOCK 3
				GET_PCWORD
				sub		[CPU_AX], ax
				FLAG_STORE_OF
				ret

	align	32
	global	SUB_EAXId
SUB_EAXId:
				CPUCLOCK 3
				GET_PCDWORD
				sub		[CPU_EAX], eax
				FLAG_STORE_OF
				ret

	align	32
	global	SUB_EbIb
SUB_EbIb:
				PREPART_EA8 3
					mov		ebx, eax
					GET_PCBYTE
					sub		[CPU_REG + ebx], al
					FLAG_STORE_OF
					ret
				MEMORY_EA8 7
					mov		ebx, ecx
					GET_PCBYTE
					sub		[MAIN_MEM + ebx], al
					FLAG_STORE_OF
					ret
				EXTMEM_EA8
					mov		dl, al
					mov		ebx, ecx
					GET_PCBYTE
					mov		ecx, ebx
					sub		dl, al
					FLAG_STORE_OF
					jmp		__f_i286_memorywrite@8

	align	32
	global	SUB_EwIb
SUB_EwIb:
				PREPART_EA16 3
					mov		ebx, eax
					GET_PCBYTE
					cbw
					sub		[CPU_REG + ebx * 4], ax
					FLAG_STORE_OF
					ret
				MEMORY_EA16 7
					mov		ebx, ecx
					GET_PCBYTE
					cbw
					sub		[MAIN_MEM + ebx], ax
					FLAG_STORE_OF
					ret
				EXTMEM_EA16
					mov		dx, ax
					mov		ebx, ecx
					GET_PCBYTE
					cbw
					mov		ecx, ebx
					sub		dx, ax
					FLAG_STORE_OF
					jmp		__f_i286_memorywrite_w@8

	align	32
	global	SUB_EdIb
SUB_EdIb:
				PREPART_EA32 3
					mov		ebx, eax
					GET_PCBYTE
					cbw
					cwde
					sub		[CPU_REG + ebx * 4], eax
					FLAG_STORE_OF
					ret
				MEMORY_EA32 7
					mov		ebx, ecx
					GET_PCBYTE
					cbw
					cwde
					sub		[MAIN_MEM + ebx], eax
					FLAG_STORE_OF
					ret
				EXTMEM_EA32
					mov		edx, eax
					mov		ebx, ecx
					GET_PCBYTE
					cbw
					cwde
					mov		ecx, ebx
					sub		edx, eax
					FLAG_STORE_OF
					jmp		__f_i286_memorywrite_d@8

	align	32
	global	SUB_EwIw
SUB_EwIw:
				PREPART_EA16 3
					mov		ebx, eax
					GET_PCWORD
					sub		[CPU_REG + ebx * 4], ax
					FLAG_STORE_OF
					ret
				MEMORY_EA16 7
					mov		ebx, ecx
					GET_PCWORD
					sub		[MAIN_MEM + ebx], ax
					FLAG_STORE_OF
					ret
				EXTMEM_EA16
					mov		dx, ax
					mov		ebx, ecx
					GET_PCWORD
					mov		ecx, ebx
					sub		dx, ax
					FLAG_STORE_OF
					jmp		__f_i286_memorywrite_w@8

	align	32
	global	SUB_EdId
SUB_EdId:
				PREPART_EA32 3
					mov		ebx, eax
					GET_PCDWORD
					sub		[CPU_REG + ebx * 4], eax
					FLAG_STORE_OF
					ret
				MEMORY_EA32 7
					mov		ebx, ecx
					GET_PCDWORD
					sub		[MAIN_MEM + ebx], eax
					FLAG_STORE_OF
					ret
				EXTMEM_EA32
					mov		edx, eax
					mov		ebx, ecx
					GET_PCDWORD
					mov		ecx, ebx
					sub		edx, eax
					FLAG_STORE_OF
					jmp		__f_i286_memorywrite_d@8

; sbb
	align	32
	global	SBB_EbGb
SBB_EbGb:
				PREPART_EA_REG8 2
					CFLAG_LOAD
					sbb		[CPU_REG + eax], dl
					FLAG_STORE_OF
					ret
				MEMORY_EA_REG8 7
					CFLAG_LOAD
					sbb		[MAIN_MEM + ecx], dl
					FLAG_STORE_OF
					ret
				EXTMEM_EA_REG8
					CFLAG_LOAD
					sbb		al, [CPU_REG + ebx]
					mov		dl, al
					FLAG_STORE_OF
					jmp		__f_i286_memorywrite@8

	align	32
	global	SBB_EwGw
SBB_EwGw:
				PREPART_EA_REG16 2
					CFLAG_LOAD
					sbb		[CPU_REG + eax * 4], dx
					FLAG_STORE_OF
					ret
				MEMORY_EA_REG16 7
					CFLAG_LOAD
					sbb		[MAIN_MEM + ecx], dx
					FLAG_STORE_OF
					ret
				EXTMEM_EA_REG16
					CFLAG_LOAD
					sbb		ax, [CPU_REG + ebx * 4]
					mov		dx, ax
					FLAG_STORE_OF
					jmp		__f_i286_memorywrite_w@8

	align	32
	global	SBB_EdGd
SBB_EdGd:
				PREPART_EA_REG32 2
					CFLAG_LOAD
					sbb		[CPU_REG + eax * 4], edx
					FLAG_STORE_OF
					ret
				MEMORY_EA_REG32 7
					CFLAG_LOAD
					sbb		[MAIN_MEM + ecx], edx
					FLAG_STORE_OF
					ret
				EXTMEM_EA_REG32
					CFLAG_LOAD
					sbb		eax, [CPU_REG + ebx * 4]
					mov		edx, eax
					FLAG_STORE_OF
					jmp		__f_i286_memorywrite_d@8

	align	32
	global	SBB_GbEb
SBB_GbEb:
				PREPART_REG8_EA 2, 7
					CFLAG_LOAD
					sbb		[CPU_REG + ebx], al
					FLAG_STORE_OF
					ret

	align	32
	global	SBB_GwEw
SBB_GwEw:
				PREPART_REG16_EA 2, 7
					CFLAG_LOAD
					sbb		[CPU_REG + ebx * 4], ax
					FLAG_STORE_OF
					ret

	align	32
	global	SBB_GdEd
SBB_GdEd:
				PREPART_REG32_EA 2, 7
					CFLAG_LOAD
					sbb		[CPU_REG + ebx * 4], eax
					FLAG_STORE_OF
					ret

	align	32
	global	SBB_ALIb
SBB_ALIb:
				CPUCLOCK 3
				GET_PCBYTE
				CFLAG_LOAD
				sbb		[CPU_AL], al
				FLAG_STORE_OF
				ret

	align	32
	global	SBB_AXIw
SBB_AXIw:
				CPUCLOCK 3
				GET_PCWORD
				CFLAG_LOAD
				sbb		[CPU_AX], ax
				FLAG_STORE_OF
				ret

	align	32
	global	SBB_EAXId
SBB_EAXId:
				CPUCLOCK 3
				GET_PCDWORD
				CFLAG_LOAD
				sbb		[CPU_EAX], eax
				FLAG_STORE_OF
				ret

	align	32
	global	SBB_EbIb
SBB_EbIb:
				PREPART_EA8 3
					mov		ebx, eax
					GET_PCBYTE
					CFLAG_LOAD
					sbb		[CPU_REG + ebx], al
					FLAG_STORE_OF
					ret
				MEMORY_EA8 7
					mov		ebx, ecx
					GET_PCBYTE
					CFLAG_LOAD
					sbb		[MAIN_MEM + ebx], al
					FLAG_STORE_OF
					ret
				EXTMEM_EA8
					mov		dl, al
					mov		ebx, ecx
					GET_PCBYTE
					mov		ecx, ebx
					CFLAG_LOAD
					sbb		dl, al
					FLAG_STORE_OF
					jmp		__f_i286_memorywrite@8

	align	32
	global	SBB_EwIb
SBB_EwIb:
				PREPART_EA16 3
					mov		ebx, eax
					GET_PCBYTE
					cbw
					CFLAG_LOAD
					sbb		[CPU_REG + ebx * 4], ax
					FLAG_STORE_OF
					ret
				MEMORY_EA16 7
					mov		ebx, ecx
					GET_PCBYTE
					cbw
					CFLAG_LOAD
					sbb		[MAIN_MEM + ebx], ax
					FLAG_STORE_OF
					ret
				EXTMEM_EA16
					mov		dx, ax
					mov		ebx, ecx
					GET_PCBYTE
					cbw
					mov		ecx, ebx
					CFLAG_LOAD
					sbb		dx, ax
					FLAG_STORE_OF
					jmp		__f_i286_memorywrite_w@8

	align	32
	global	SBB_EdIb
SBB_EdIb:
				PREPART_EA32 3
					mov		ebx, eax
					GET_PCBYTE
					cbw
					cwde
					CFLAG_LOAD
					sbb		[CPU_REG + ebx * 4], eax
					FLAG_STORE_OF
					ret
				MEMORY_EA32 7
					mov		ebx, ecx
					GET_PCBYTE
					cbw
					cwde
					CFLAG_LOAD
					sbb		[MAIN_MEM + ebx], eax
					FLAG_STORE_OF
					ret
				EXTMEM_EA32
					mov		edx, eax
					mov		ebx, ecx
					GET_PCBYTE
					cbw
					cwde
					mov		ecx, ebx
					CFLAG_LOAD
					sbb		edx, eax
					FLAG_STORE_OF
					jmp		__f_i286_memorywrite_d@8

	align	32
	global	SBB_EwIw
SBB_EwIw:
				PREPART_EA16 3
					mov		ebx, eax
					GET_PCWORD
					CFLAG_LOAD
					sbb		[CPU_REG + ebx * 4], ax
					FLAG_STORE_OF
					ret
				MEMORY_EA16 7
					mov		ebx, ecx
					GET_PCWORD
					CFLAG_LOAD
					sbb		[MAIN_MEM + ebx], ax
					FLAG_STORE_OF
					ret
				EXTMEM_EA16
					mov		dx, ax
					mov		ebx, ecx
					GET_PCWORD
					mov		ecx, ebx
					CFLAG_LOAD
					sbb		dx, ax
					FLAG_STORE_OF
					jmp		__f_i286_memorywrite_w@8

	align	32
	global	SBB_EdId
SBB_EdId:
				PREPART_EA32 3
					mov		ebx, eax
					GET_PCDWORD
					CFLAG_LOAD
					sbb		[CPU_REG + ebx * 4], eax
					FLAG_STORE_OF
					ret
				MEMORY_EA32 7
					mov		ebx, ecx
					GET_PCDWORD
					CFLAG_LOAD
					sbb		[MAIN_MEM + ebx], eax
					FLAG_STORE_OF
					ret
				EXTMEM_EA32
					mov		edx, eax
					mov		ebx, ecx
					GET_PCDWORD
					mov		ecx, ebx
					CFLAG_LOAD
					sbb		edx, eax
					FLAG_STORE_OF
					jmp		__f_i286_memorywrite_d@8

; imul
	align	32
	global	IMUL_ALEb
IMUL_ALEb:
				PREPART_EA8 13
					mov		al, [CPU_REG + eax]
					imul	byte [CPU_AL]
					mov		[CPU_AX], ax
					FLAG_STORE_OC
					ret
				MEMORY_EA8 16
					mov		al, [MAIN_MEM + ecx]
					imul	byte [CPU_AL]
					mov		[CPU_AX], ax
					FLAG_STORE_OC
					ret
				EXTMEM_EA8
					imul	byte [CPU_AL]
					mov		[CPU_AX], ax
					FLAG_STORE_OC
					ret

	align	32
	global	IMUL_AXEw
IMUL_AXEw:
				PREPART_EA16 21
					mov		ax, [CPU_REG + eax * 4]
					imul	word [CPU_AX]
					mov		[CPU_AX], ax
					mov		[CPU_DX], dx
					FLAG_STORE_OC
					ret
				MEMORY_EA16 24
					mov		ax, [MAIN_MEM + ecx]
					imul	word [CPU_AX]
					mov		[CPU_AX], ax
					mov		[CPU_DX], dx
					FLAG_STORE_OC
					ret
				EXTMEM_EA16
					imul	word [CPU_AX]
					mov		[CPU_AX], ax
					mov		[CPU_DX], dx
					FLAG_STORE_OC
					ret

	align	32
	global	IMUL_EAXEd
IMUL_EAXEd:
				PREPART_EA32 21
					mov		eax, [CPU_REG + eax * 4]
					imul	dword [CPU_EAX]
					mov		[CPU_EAX], eax
					mov		[CPU_EDX], edx
					FLAG_STORE_OC
					ret
				MEMORY_EA32 24
					mov		eax, [MAIN_MEM + ecx]
					imul	dword [CPU_EAX]
					mov		[CPU_EAX], eax
					mov		[CPU_EDX], edx
					FLAG_STORE_OC
					ret
				EXTMEM_EA32
					imul	dword [CPU_EAX]
					mov		[CPU_EAX], eax
					mov		[CPU_EDX], edx
					FLAG_STORE_OC
					ret

	align	32
	global	IMUL_GwEw
IMUL_GwEw:
				PREPART_REG16_EA 21, 24
					imul	ax, [CPU_REG + ebx * 4]
					mov		[CPU_REG + ebx * 4], ax
					FLAG_STORE_OC
					ret

	align	32
	global	IMUL_GdEd
IMUL_GdEd:
				PREPART_REG32_EA 21, 24
					imul	eax, [CPU_REG + ebx * 4]
					mov		[CPU_REG + ebx * 4], eax
					FLAG_STORE_OC
					ret

	align	32
	global	IMUL_GwEwIb
IMUL_GwEwIb:
				PREPART_REG16_EA 21, 24
					mov		dx, ax
					GET_PCBYTE
					cbw
					imul	dx, ax
					mov		[CPU_REG + ebx * 4], dx
					FLAG_STORE_OC
					ret

	align	32
	global	IMUL_GdEdIb
IMUL_GdEdIb:
				PREPART_REG32_EA 21, 24
					mov		edx, eax
					GET_PCBYTE
					cbw
					cwde
					imul	edx, eax
					mov		[CPU_REG + ebx * 4], edx
					FLAG_STORE_OC
					ret

	align	32
	global	IMUL_GwEwIw
IMUL_GwEwIw:
				PREPART_REG16_EA 21, 24
					mov		dx, ax
					GET_PCWORD
					imul	dx, ax
					mov		[CPU_REG + ebx * 4], dx
					FLAG_STORE_OC
					ret

	align	32
	global	IMUL_GdEdId
IMUL_GdEdId:
				PREPART_REG32_EA 21, 24
					mov		edx, eax
					GET_PCDWORD
					imul	edx, eax
					mov		[CPU_REG + ebx * 4], edx
					FLAG_STORE_OC
					ret

; mul
	align	32
	global	MUL_ALEb
MUL_ALEb:
				PREPART_EA8 13
					mov		al, [CPU_REG + eax]
					mul		byte [CPU_AL]
					mov		[CPU_AX], ax
					FLAG_STORE_OC
					ret
				MEMORY_EA8 16
					mov		al, [MAIN_MEM + ecx]
					mul		byte [CPU_AL]
					mov		[CPU_AX], ax
					FLAG_STORE_OC
					ret
				EXTMEM_EA8
					mul		byte [CPU_AL]
					mov		[CPU_AX], ax
					FLAG_STORE_OC
					ret

	align	32
	global	MUL_AXEw
MUL_AXEw:
				PREPART_EA16 21
					mov		ax, [CPU_REG + eax * 4]
					mul		word [CPU_AX]
					mov		[CPU_AX], ax
					mov		[CPU_DX], dx
					FLAG_STORE_OC
					ret
				MEMORY_EA16 24
					mov		ax, [MAIN_MEM + ecx]
					mul		word [CPU_AX]
					mov		[CPU_AX], ax
					mov		[CPU_DX], dx
					FLAG_STORE_OC
					ret
				EXTMEM_EA16
					mul		word [CPU_AX]
					mov		[CPU_AX], ax
					mov		[CPU_DX], dx
					FLAG_STORE_OC
					ret

	align	32
	global	MUL_EAXEd
MUL_EAXEd:
				PREPART_EA32 21
					mov		eax, [CPU_REG + eax * 4]
					mul		dword [CPU_EAX]
					mov		[CPU_EAX], eax
					mov		[CPU_EDX], edx
					FLAG_STORE_OC
					ret
				MEMORY_EA32 24
					mov		eax, [MAIN_MEM + ecx]
					mul		dword [CPU_EAX]
					mov		[CPU_EAX], eax
					mov		[CPU_EDX], edx
					FLAG_STORE_OC
					ret
				EXTMEM_EA32
					mul		dword [CPU_EAX]
					mov		[CPU_EAX], eax
					mov		[CPU_EDX], edx
					FLAG_STORE_OC
					ret

; idiv
	align	32
	global	IDIV_ALEb
IDIV_ALEb:
				PREPART_EA8 17
					movsx	cx, byte [CPU_REG + eax]
					jmp		short .idivcheck
				MEMORY_EA8 25
					movsx	cx, byte [MAIN_MEM + ecx]
					jmp		short .idivcheck
				EXTMEM_EA8
					movsx	cx, al
		.idivcheck:
					jcxz	.idivovf
					mov		ax, [CPU_AX]
					cwd
					idiv	cx
					bt		ax, 7
					adc		ah, 0
					jne		.idivovf
					mov		[CPU_AL], al
					mov		[CPU_AH], dl
					ret
		.idivovf:
					INT_NUM 0

	align	32
	global	IDIV_AXEw
IDIV_AXEw:
				PREPART_EA16 20
					movsx	ecx, word [CPU_REG + eax * 4]
					jmp		short .idivcheck
				MEMORY_EA16 28
					movsx	ecx, word [MAIN_MEM + ecx]
					jmp		short .idivcheck
				EXTMEM_EA16
					movsx	ecx, ax
		.idivcheck:
					jecxz	.idivovf
					mov		ax, [CPU_DX]
					shl		eax, 16
					mov		ax, [CPU_AX]
					cdq
					idiv	ecx
					mov		ecx, eax
					shr		ecx, 16
					adc		cx, 0
					jne		.idivovf
					mov		[CPU_AX], ax
					mov		[CPU_DX], dx
					ret
		.idivovf:
					INT_NUM 0

	align	32
	global	IDIV_EAXEd
IDIV_EAXEd:
				PREPART_EA32 20
					mov		ecx, [CPU_REG + eax * 4]
					jmp		short .idivcheck
				MEMORY_EA32 28
					mov		ecx, [MAIN_MEM + ecx]
					jmp		short .idivcheck
				EXTMEM_EA32
					mov		ecx, eax
		.idivcheck:
					jecxz	.idivovf
					mov		eax, 80000000h
					imul	ecx
					cmp		[CPU_EDX], edx
					jl		.idivovf
					jg		.nextchk
					cmp		[CPU_EAX], eax
					jb		.idivovf
		.nextchk:
					mov		eax, 7fffffffh
					imul	ecx
					cmp		[CPU_EDX], edx
					jg		.idivovf
					jl		.ok
					cmp		[CPU_EAX], eax
					ja		.idivovf
		.ok:
					mov		edx, [CPU_EDX]
					mov		eax, [CPU_EAX]
					idiv	ecx
					mov		[CPU_EAX], eax
					mov		[CPU_EDX], edx
					ret
		.idivovf:
					INT_NUM 0

; div
	align	32
	global	DIV_ALEb
DIV_ALEb:
				PREPART_EA8 14
					movzx	cx, byte [CPU_REG + eax]
					jmp		short .divcheck
				MEMORY_EA8 22
					movzx	cx, byte [MAIN_MEM + ecx]
					jmp		short .divcheck
				EXTMEM_EA8
					movzx	cx, al
		.divcheck:
					jcxz	.divovf
					mov		ax, [CPU_AX]
					xor		dx, dx
					div		cx
					or		ah, ah
					jnz		.divovf
					mov		[CPU_AL], al
					mov		[CPU_AH], dl
					ret
		.divovf:
					INT_NUM 0

	align	32
	global	DIV_AXEw
DIV_AXEw:
				PREPART_EA16 17
					movzx	ecx, word [CPU_REG + eax * 4]
					jmp		short .divcheck
				MEMORY_EA16 25
					movzx	ecx, word [MAIN_MEM + ecx]
					jmp		short .divcheck
				EXTMEM_EA16
					movzx	ecx, ax
		.divcheck:
					jecxz	.divovf
					mov		ax, [CPU_DX]
					shl		eax, 16
					mov		ax, [CPU_AX]
					xor		edx, edx
					div		ecx
					cmp		eax, 10000h
					jae		.divovf
					mov		[CPU_AX], ax
					mov		[CPU_DX], dx
					ret
		.divovf:
					INT_NUM 0

	align	32
	global	DIV_EAXEd
DIV_EAXEd:
				PREPART_EA32 17
					mov		ecx, [CPU_REG + eax * 4]
					jmp		short .divcheck
				MEMORY_EA32 25
					mov		ecx, [MAIN_MEM + ecx]
					jmp		short .divcheck
				EXTMEM_EA32
					mov		ecx, eax
		.divcheck:
					jecxz	.divovf
					mov		eax, 0ffffffffh
					mul		ecx
					cmp		[CPU_EDX], edx
					ja		.divovf
					jb		.ok
					cmp		[CPU_EAX], eax
					ja		.divovf
		.ok:
					mov		edx, [CPU_EDX]
					mov		eax, [CPU_EAX]
					div		ecx
					mov		[CPU_EAX], eax
					mov		[CPU_EDX], edx
					ret
		.divovf:
					INT_NUM 0

; inc
	align	32
	global	INC_Eb
INC_Eb:
				PREPART_EA8 2
					inc		byte [CPU_REG + eax]
					FLAG_STORE_NC
					ret
				MEMORY_EA8 7
					inc		byte [MAIN_MEM + ecx]
					FLAG_STORE_NC
					ret
				EXTMEM_EA8
					mov		dl, al
					inc		dl
					FLAG_STORE_NC
					jmp		__f_i286_memorywrite@8

	align	32
	global	INC_Ew
INC_Ew:
				PREPART_EA16 2
					inc		word [CPU_REG + eax * 4]
					FLAG_STORE_NC
					ret
				MEMORY_EA16 7
					inc		word [MAIN_MEM + ecx]
					FLAG_STORE_NC
					ret
				EXTMEM_EA16
					mov		dx, ax
					inc		dx
					FLAG_STORE_NC
					jmp		__f_i286_memorywrite_w@8

	align	32
	global	INC_Ed
INC_Ed:
				PREPART_EA32 2
					inc		dword [CPU_REG + eax * 4]
					FLAG_STORE_NC
					ret
				MEMORY_EA32 7
					inc		dword [MAIN_MEM + ecx]
					FLAG_STORE_NC
					ret
				EXTMEM_EA32
					mov		edx, eax
					inc		edx
					FLAG_STORE_NC
					jmp		__f_i286_memorywrite_d@8

	align	32
	global	INC_RX
INC_RX:
				CPUCLOCK 2
				and		eax, 7
				inc		word [CPU_REG + eax * 4]
				FLAG_STORE_NC
				ret

	align	32
	global	INC_ERX
INC_ERX:
				CPUCLOCK 2
				and		eax, 7
				inc		dword [CPU_REG + eax * 4]
				FLAG_STORE_NC
				ret

; dec
	align	32
	global	DEC_Eb
DEC_Eb:
				PREPART_EA8 2
					dec		byte [CPU_REG + eax]
					FLAG_STORE_NC
					ret
				MEMORY_EA8 7
					dec		byte [MAIN_MEM + ecx]
					FLAG_STORE_NC
					ret
				EXTMEM_EA8
					mov		dl, al
					dec		dl
					FLAG_STORE_NC
					jmp		__f_i286_memorywrite@8

	align	32
	global	DEC_Ew
DEC_Ew:
				PREPART_EA16 2
					dec		word [CPU_REG + eax * 4]
					FLAG_STORE_NC
					ret
				MEMORY_EA16 7
					dec		word [MAIN_MEM + ecx]
					FLAG_STORE_NC
					ret
				EXTMEM_EA16
					mov		dx, ax
					dec		dx
					FLAG_STORE_NC
					jmp		__f_i286_memorywrite_w@8

	align	32
	global	DEC_Ed
DEC_Ed:
				PREPART_EA32 2
					dec		dword [CPU_REG + eax * 4]
					FLAG_STORE_NC
					ret
				MEMORY_EA32 7
					dec		dword [MAIN_MEM + ecx]
					FLAG_STORE_NC
					ret
				EXTMEM_EA32
					mov		edx, eax
					dec		edx
					FLAG_STORE_NC
					jmp		__f_i286_memorywrite_d@8

	align	32
	global	DEC_RX
DEC_RX:
				CPUCLOCK 2
				and		eax, 7
				dec		word [CPU_REG + eax * 4]
				FLAG_STORE_NC
				ret

	align	32
	global	DEC_ERX
DEC_ERX:
				CPUCLOCK 2
				and		eax, 7
				dec		dword [CPU_REG + eax * 4]
				FLAG_STORE_NC
				ret

; neg
	align	32
	global	NEG_Eb
NEG_Eb:
				PREPART_EA8 2
					neg		byte [CPU_REG + eax]
					FLAG_STORE_OF
					ret
				MEMORY_EA8 7
					neg		byte [MAIN_MEM + ecx]
					FLAG_STORE_OF
					ret
				EXTMEM_EA8
					mov		dl, al
					neg		dl
					FLAG_STORE_OF
					jmp		__f_i286_memorywrite@8

	align	32
	global	NEG_Ew
NEG_Ew:
				PREPART_EA16 2
					neg		word [CPU_REG + eax * 4]
					FLAG_STORE_OF
					ret
				MEMORY_EA16 7
					neg		word [MAIN_MEM + ecx]
					FLAG_STORE_OF
					ret
				EXTMEM_EA16
					mov		dx, ax
					neg		dx
					FLAG_STORE_OF
					jmp		__f_i286_memorywrite_w@8

	align	32
	global	NEG_Ed
NEG_Ed:
				PREPART_EA32 2
					neg		dword [CPU_REG + eax * 4]
					FLAG_STORE_OF
					ret
				MEMORY_EA32 7
					neg		dword [MAIN_MEM + ecx]
					FLAG_STORE_OF
					ret
				EXTMEM_EA32
					mov		edx, eax
					neg		edx
					FLAG_STORE_OF
					jmp		__f_i286_memorywrite_d@8

; cmp
	align	32
	global	CMP_EbGb
CMP_EbGb:
				PREPART_EA_REG8 2
					cmp		[CPU_REG + eax], dl
					FLAG_STORE_OF
					ret
				MEMORY_EA_REG8 6
					cmp		[MAIN_MEM + ecx], dl
					FLAG_STORE_OF
					ret
				EXTMEM_EA_REG8
					cmp		al, [CPU_REG + ebx]
					FLAG_STORE_OF
					ret

	align	32
	global	CMP_EwGw
CMP_EwGw:
				PREPART_EA_REG16 2
					cmp		[CPU_REG + eax * 4], dx
					FLAG_STORE_OF
					ret
				MEMORY_EA_REG16 6
					cmp		[MAIN_MEM + ecx], dx
					FLAG_STORE_OF
					ret
				EXTMEM_EA_REG16
					cmp		ax, [CPU_REG + ebx * 4]
					FLAG_STORE_OF
					ret

	align	32
	global	CMP_EdGd
CMP_EdGd:
				PREPART_EA_REG32 2
					cmp		[CPU_REG + eax * 4], edx
					FLAG_STORE_OF
					ret
				MEMORY_EA_REG32 6
					cmp		[MAIN_MEM + ecx], edx
					FLAG_STORE_OF
					ret
				EXTMEM_EA_REG32
					cmp		eax, [CPU_REG + ebx * 4]
					FLAG_STORE_OF
					ret

	align	32
	global	CMP_GbEb
CMP_GbEb:
				PREPART_REG8_EA 2, 6
					cmp		[CPU_REG + ebx], al
					FLAG_STORE_OF
					ret

	align	32
	global	CMP_GwEw
CMP_GwEw:
				PREPART_REG16_EA 2, 6
					cmp		[CPU_REG + ebx * 4], ax
					FLAG_STORE_OF
					ret

	align	32
	global	CMP_GdEd
CMP_GdEd:
				PREPART_REG32_EA 2, 6
					cmp		[CPU_REG + ebx * 4], eax
					FLAG_STORE_OF
					ret

	align	32
	global	CMP_ALIb
CMP_ALIb:
				CPUCLOCK 3
				GET_PCBYTE
				cmp		[CPU_AL], al
				FLAG_STORE_OF
				ret

	align	32
	global	CMP_AXIw
CMP_AXIw:
				CPUCLOCK 3
				GET_PCWORD
				cmp		[CPU_AX], ax
				FLAG_STORE_OF
				ret

	align	32
	global	CMP_EAXId
CMP_EAXId:
				CPUCLOCK 3
				GET_PCDWORD
				cmp		[CPU_EAX], eax
				FLAG_STORE_OF
				ret

	align	32
	global	CMP_EbIb
CMP_EbIb:
				PREPART_EA8 2
					mov		ebx, eax
					GET_PCBYTE
					cmp		[CPU_REG + ebx], al
					FLAG_STORE_OF
					ret
				MEMORY_EA8 6
					mov		ebx, ecx
					GET_PCBYTE
					cmp		[MAIN_MEM + ebx], al
					FLAG_STORE_OF
					ret
				EXTMEM_EA8
					mov		dl, al
					GET_PCBYTE
					cmp		dl, al
					FLAG_STORE_OF
					ret

	align	32
	global	CMP_EwIb
CMP_EwIb:
				PREPART_EA16 2
					mov		ebx, eax
					GET_PCBYTE
					cbw
					cmp		[CPU_REG + ebx * 4], ax
					FLAG_STORE_OF
					ret
				MEMORY_EA16 6
					mov		ebx, ecx
					GET_PCBYTE
					cbw
					cmp		[MAIN_MEM + ebx], ax
					FLAG_STORE_OF
					ret
				EXTMEM_EA16
					mov		dx, ax
					GET_PCBYTE
					cbw
					cmp		dx, ax
					FLAG_STORE_OF
					ret

	align	32
	global	CMP_EdIb
CMP_EdIb:
				PREPART_EA32 2
					mov		ebx, eax
					GET_PCBYTE
					cbw
					cwde
					cmp		[CPU_REG + ebx * 4], eax
					FLAG_STORE_OF
					ret
				MEMORY_EA32 6
					mov		ebx, ecx
					GET_PCBYTE
					cbw
					cwde
					cmp		[MAIN_MEM + ebx], eax
					FLAG_STORE_OF
					ret
				EXTMEM_EA32
					mov		edx, eax
					GET_PCBYTE
					cbw
					cwde
					cmp		edx, eax
					FLAG_STORE_OF
					ret

	align	32
	global	CMP_EwIw
CMP_EwIw:
				PREPART_EA16 2
					mov		ebx, eax
					GET_PCWORD
					cmp		[CPU_REG + ebx * 4], ax
					FLAG_STORE_OF
					ret
				MEMORY_EA16 6
					mov		ebx, ecx
					GET_PCWORD
					cmp		[MAIN_MEM + ebx], ax
					FLAG_STORE_OF
					ret
				EXTMEM_EA16
					mov		dx, ax
					GET_PCWORD
					cmp		dx, ax
					FLAG_STORE_OF
					ret

	align	32
	global	CMP_EdId
CMP_EdId:
				PREPART_EA32 2
					mov		ebx, eax
					GET_PCDWORD
					cmp		[CPU_REG + ebx * 4], eax
					FLAG_STORE_OF
					ret
				MEMORY_EA32 6
					mov		ebx, ecx
					GET_PCDWORD
					cmp		[MAIN_MEM + ebx], eax
					FLAG_STORE_OF
					ret
				EXTMEM_EA32
					mov		edx, eax
					GET_PCDWORD
					cmp		edx, eax
					FLAG_STORE_OF
					ret

