
; MISCELLANEOUS INSTRUCTIONS

%include "cpu.inc"
%include "cpu.mcr"
%include "resolve.inc"
%include "inst_table.inc"

%include "debug.inc"

extern	_cpu_regs
extern	_cpu_stat
extern	cpu_inst

section .text

; load add
	align	32
	global	LEA_GwM
LEA_GwM:
				GET_PCBYTE
				cmp		al, 0c0h
				jnc		.src_register
				CPUCLOCK 3
				movzx	ebx, al
				shr		ebx, 1
				and		ebx, 1ch
				rol		al, 2
				and		eax, 1fh
				call	calc_lea
				mov		[CPU_REG + ebx], ax
				ret

		.src_register:
				INT_NUM 6

	align	32
	global	LEA_GdM
LEA_GdM:
				GET_PCBYTE
				cmp		al, 0c0h
				jnc		.src_register
				CPUCLOCK 3
				movzx	ebx, al
				shr		ebx, 1
				and		ebx, 1ch
				rol		al, 2
				and		eax, 1fh
				call	calc_lea
				mov		[CPU_REG + ebx], eax
				ret

		.src_register:
				INT_NUM 6

;
	align	32
	global	_NOP
_NOP:
				CPUCLOCK 3
%if 1
				lea		ecx, [ebp + esi - 1]
				cmp		ecx, 0f8000h
				jc		near .biosend
				cmp		ecx, 100000h
				jnc		.biosend

				mov		[CPU_EIP], esi
;;
				pushad
				push	ecx
				call	biosfunc
				pop		ecx
				mov		[esp + 28], eax
				popad
;;
				or		al, al
				jz		.biosend
				mov		esi, [CPU_EIP]
				movzx	eax, word [CPU_ES]
				shl		eax, 4
				mov		[ES_BASE], eax
				movzx	ebp, word [CPU_CS]
				shl		ebp, 4
				mov		[CS_BASE], ebp
				movzx	eax, word [CPU_SS]
				shl		eax, 4
				mov		[SS_BASE], eax
				movzx	eax, word [CPU_DS]
				shl		eax, 4
				mov		[DS_BASE], eax
				movzx	eax, word [CPU_FS]
				shl		eax, 4
				mov		[FS_BASE], eax
				movzx	eax, word [CPU_GS]
				shl		eax, 4
				mov		[GS_BASE], eax
		.biosend:
%endif
				ret

	align	32
	global	_UD2
_UD2:
				INT_NUM 6

; table lookup
	align	32
	global	_XLAT
_XLAT:
				CPUCLOCK 5
				cmp		byte [CPU_INST_AS32], 0
				jne		.as32

				movzx	ecx, byte [CPU_AL]
				add		cx, [CPU_BX]
				ADD_SEGBASE [DS_BASE]
				call	__f_i286_memoryread@4
				mov		[CPU_AL], al
				ret

	.as32:		movzx	ecx, byte [CPU_AL]
				add		ecx, [CPU_EBX]
				ADD_SEGBASE [DS_BASE]
				call	__f_i286_memoryread@4
				mov		[CPU_AL], al
				ret

; cpuid
	align	32
	global	_CPUID
_CPUID:
				mov		eax, [CPU_EAX]
				cmp		eax, 2
				ja		.reserved
				jmp		[cpuid_func_table + eax * 4]
		.reserved:
				ret

	cpuid_func_id:
				mov		dword [CPU_EAX], 1
				mov		dword [CPU_EBX], CPU_VENDOR_1
				mov		dword [CPU_EDX], CPU_VENDOR_2
				mov		dword [CPU_ECX], CPU_VENDOR_3
				ret

	cpuid_func_ver:
				mov		dword [CPU_EAX], (CPU_FAMILY << 8) | (CPU_MODEL << 4) | CPU_STEPPING
				mov		dword [CPU_EBX], 0		; reserved
				mov		dword [CPU_ECX], 0		; reserved
				mov		dword [CPU_EDX], CPU_FEATURES
				ret

	cpuid_func_cache:
				mov		dword [CPU_EAX], 0
				mov		dword [CPU_EBX], 0
				mov		dword [CPU_ECX], 0
				mov		dword [CPU_EDX], 0
				ret

section .data

	align	16, db 0
cpuid_func_table:
		dd		cpuid_func_id
		dd		cpuid_func_ver
		dd		cpuid_func_cache

section .text

;
; undoc(8086)
	align	32
	global	_SALC
_SALC:
				test	byte [CPU_FLAGL], C_FLAG
				setz	al
				dec		al
				mov		[CPU_AL], al
				ret

;
; undoc(286)
	align	32
	global	_LOADALL286
_LOADALL286:
				jmp		undef_op

;
; undoc(386)
	align	32
	global	_LOADALL
_LOADALL:
				jmp		undef_op

;
	align	32
	global	OpSize
OpSize:
				mov		byte [CPU_INST_OP32], 1
				ret

	align	32
	global	AddrSize
AddrSize:
				mov		byte [CPU_INST_AS32], 1
				ret

	align	32
	global	_2byte_ESC16
_2byte_ESC16:
				GET_PCBYTE
				jmp		[insttable_2byte16 + eax * 4]

	align	32
	global	_2byte_ESC32
_2byte_ESC32:
				GET_PCBYTE
				jmp		[insttable_2byte32 + eax * 4]

;
	align	32
	global	Prefix_ES
Prefix_ES:
				mov		byte [CPU_INST_SEGUSE], 1
				mov		eax, [ES_BASE]
				mov		[CPU_INST_SEGBASE], eax
				ret

	align	32
	global	Prefix_CS
Prefix_CS:
				mov		byte [CPU_INST_SEGUSE], 1
				mov		eax, [CS_BASE]
				mov		[CPU_INST_SEGBASE], eax
				ret

	align	32
	global	Prefix_SS
Prefix_SS:
				mov		byte [CPU_INST_SEGUSE], 1
				mov		eax, [SS_BASE]
				mov		[CPU_INST_SEGBASE], eax
				ret

	align	32
	global	Prefix_DS
Prefix_DS:
				mov		byte [CPU_INST_SEGUSE], 1
				mov		eax, [DS_BASE]
				mov		[CPU_INST_SEGBASE], eax
				ret

	align	32
	global	Prefix_FS
Prefix_FS:
				mov		byte [CPU_INST_SEGUSE], 1
				mov		eax, [FS_BASE]
				mov		[CPU_INST_SEGBASE], eax
				ret

	align	32
	global	Prefix_GS
Prefix_GS:
				mov		byte [CPU_INST_SEGUSE], 1
				mov		eax, [GS_BASE]
				mov		[CPU_INST_SEGBASE], eax
				ret

;%define DEBUG
; undef opcode
	align	32
	global	undef_op
undef_op:
%ifdef DEBUG
				mov		[CPU_IP], si
				mov		ecx, eax
				jmp		__f_msgbox_mem@4
%else
				INT_NUM 6
%endif

