
; SEGMENT REGISTER INSTRUCTIONS

%include "cpu.inc"
%include "cpu.mcr"
%include "misc.inc"
%include "resolve.inc"

extern	_cpu_regs
extern	_cpu_stat

%macro LOAD_FAR_PTR_16 1
				GET_PCBYTE
				cmp		al, 0c0h
				jnc		%%src_register
				CPUCLOCK 3
				push	eax
				rol		al, 2
				and		eax, 1fh
				call	get_ea
				lea		ecx, [edi + ebx]
				call	__f_i286_memoryread_w@4
				pop		edx
				shr		edx, 1
				and		edx, 1ch
				mov		[CPU_REG + edx], ax
				add		bx, 2
				lea		ecx, [edi + ebx]
				call	__f_i286_memoryread_w@4
				mov		[CPU_%1], ax
				and		eax, 0000ffffh
				shl		eax, 4					; make segreg
				mov		[%1_BASE], eax
				ret

		%%src_register:
				INT_NUM 6
%endmacro

%macro LOAD_FAR_PTR_32 1
				GET_PCBYTE
				cmp		al, 0c0h
				jnc		%%src_register
				CPUCLOCK 3
				push	eax
				rol		al, 2
				and		eax, 1fh
				call	get_ea
				lea		ecx, [edi + ebx]
				call	__f_i286_memoryread_d@4
				pop		edx
				shr		edx, 1
				and		edx, 1ch
				mov		[CPU_REG + edx], eax
				add		bx, 4
				lea		ecx, [edi + ebx]
				call	__f_i286_memoryread_w@4
				mov		[CPU_%1], ax
				and		eax, 0000ffffh
				shl		eax, 4					; make segreg
				mov		[%1_BASE], eax
				ret

		%%src_register:
				INT_NUM 6
%endmacro

section .text

; load far ptr
	align	32
	global	LDS_GwMp
LDS_GwMp:
				LOAD_FAR_PTR_16 DS

	align	32
	global	LDS_GdMp
LDS_GdMp:
				LOAD_FAR_PTR_32 DS

	align	32
	global	LES_GwMp
LES_GwMp:
				LOAD_FAR_PTR_16 ES

	align	32
	global	LES_GdMp
LES_GdMp:
				LOAD_FAR_PTR_32 ES

	align	32
	global	LFS_GwMp
LFS_GwMp:
				LOAD_FAR_PTR_16 FS

	align	32
	global	LFS_GdMp
LFS_GdMp:
				LOAD_FAR_PTR_32 FS

	align	32
	global	LGS_GwMp
LGS_GwMp:
				LOAD_FAR_PTR_16 GS

	align	32
	global	LGS_GdMp
LGS_GdMp:
				LOAD_FAR_PTR_32 GS

	align	32
	global	LSS_GwMp
LSS_GwMp:
				LOAD_FAR_PTR_16 SS

	align	32
	global	LSS_GdMp
LSS_GdMp:
				LOAD_FAR_PTR_32 SS

