
; STRING INSTRUCTIONS

%include "cpu.inc"
%include "cpu.mcr"
%include "misc.inc"

extern	_cpu_regs
extern	_cpu_stat
extern	cpu_inst

section .text

; movs
	align	32
	global	MOVSB_XbYb
MOVSB_XbYb:
				CPUCLOCK 5
				cmp		byte [CPU_INST_AS32], 0
				jne		.as32

				movzx	ecx, word [CPU_SI]
				ADD_SEGBASE [DS_BASE]
				call	__f_i286_memoryread@4
				mov		dl, al
				movzx	ecx, word [CPU_DI]
				add		ecx, [ES_BASE]
				STRING_DIR
				add		[CPU_SI], ax
				add		[CPU_DI], ax
				jmp		__f_i286_memorywrite@8

	.as32:		mov		ecx, [CPU_ESI]
				ADD_SEGBASE [DS_BASE]
				call	__f_i286_memoryread@4
				mov		dl, al
				mov		ecx, [CPU_EDI]
				add		ecx, [ES_BASE]
				STRING_DIR
				add		[CPU_ESI], eax
				add		[CPU_EDI], eax
				jmp		__f_i286_memorywrite@8

	align	32
	global	MOVSW_XwYw
MOVSW_XwYw:
				CPUCLOCK 5
				cmp		byte [CPU_INST_AS32], 0
				jne		.as32

				movzx	ecx, word [CPU_SI]
				ADD_SEGBASE [DS_BASE]
				call	__f_i286_memoryread_w@4
				mov		dx, ax
				movzx	ecx, word [CPU_DI]
				add		ecx, [ES_BASE]
				STRING_DIRx2
				add		[CPU_SI], ax
				add		[CPU_DI], ax
				jmp		__f_i286_memorywrite_w@8

	.as32:		mov		ecx, [CPU_ESI]
				ADD_SEGBASE [DS_BASE]
				call	__f_i286_memoryread_w@4
				mov		dx, ax
				mov		ecx, [CPU_EDI]
				add		ecx, [ES_BASE]
				STRING_DIRx2
				add		[CPU_ESI], eax
				add		[CPU_EDI], eax
				jmp		__f_i286_memorywrite_w@8

	align	32
	global	MOVSD_XdYd
MOVSD_XdYd:
				CPUCLOCK 5
				cmp		byte [CPU_INST_AS32], 0
				jne		.as32

				movzx	ecx, word [CPU_SI]
				ADD_SEGBASE [DS_BASE]
				call	__f_i286_memoryread_d@4
				mov		edx, eax
				movzx	ecx, word [CPU_DI]
				add		ecx, [ES_BASE]
				STRING_DIRx4
				add		[CPU_SI], ax
				add		[CPU_DI], ax
				jmp		__f_i286_memorywrite_d@8

	.as32:		mov		ecx, [CPU_ESI]
				ADD_SEGBASE [DS_BASE]
				call	__f_i286_memoryread_d@4
				mov		edx, eax
				mov		ecx, [CPU_EDI]
				add		ecx, [ES_BASE]
				STRING_DIRx4
				add		[CPU_ESI], eax
				add		[CPU_EDI], eax
				jmp		__f_i286_memorywrite_d@8

; cmps
	align	32
	global	CMPSB_XbYb
CMPSB_XbYb:
				CPUCLOCK 8
				cmp		byte [CPU_INST_AS32], 0
				jne		.as32

				movzx	ecx, word [CPU_SI]
				ADD_SEGBASE [DS_BASE]
				call	__f_i286_memoryread@4
				mov		bl, al
				movzx	ecx, word [CPU_DI]
				add		ecx, [ES_BASE]
				call	__f_i286_memoryread@4
				cmp		bl, al
				FLAG_STORE_OF
				STRING_DIR
				add		[CPU_SI], ax
				add		[CPU_DI], ax
				ret

	.as32:		mov		ecx, [CPU_ESI]
				ADD_SEGBASE [DS_BASE]
				call	__f_i286_memoryread@4
				mov		bl, al
				mov		ecx, [CPU_EDI]
				add		ecx, [ES_BASE]
				call	__f_i286_memoryread@4
				cmp		bl, al
				FLAG_STORE_OF
				STRING_DIR
				add		[CPU_ESI], eax
				add		[CPU_EDI], eax
				ret

	align	32
	global	CMPSW_XwYw
CMPSW_XwYw:
				CPUCLOCK 8
				cmp		byte [CPU_INST_AS32], 0
				jne		.as32

				movzx	ecx, word [CPU_SI]
				ADD_SEGBASE [DS_BASE]
				call	__f_i286_memoryread_w@4
				mov		bx, ax
				movzx	ecx, word [CPU_DI]
				add		ecx, [ES_BASE]
				call	__f_i286_memoryread_w@4
				cmp		bx, ax
				FLAG_STORE_OF
				STRING_DIRx2
				add		[CPU_SI], ax
				add		[CPU_DI], ax
				ret

	.as32:		mov		ecx, [CPU_ESI]
				ADD_SEGBASE [DS_BASE]
				call	__f_i286_memoryread_w@4
				mov		bx, ax
				mov		ecx, [CPU_EDI]
				add		ecx, [ES_BASE]
				call	__f_i286_memoryread_w@4
				cmp		bx, ax
				FLAG_STORE_OF
				STRING_DIRx2
				add		[CPU_ESI], eax
				add		[CPU_EDI], eax
				ret

	align	32
	global	CMPSD_XdYd
CMPSD_XdYd:
				CPUCLOCK 8
				cmp		byte [CPU_INST_AS32], 0
				jne		.as32

				movzx	ecx, word [CPU_SI]
				ADD_SEGBASE [DS_BASE]
				call	__f_i286_memoryread_d@4
				mov		ebx, eax
				movzx	ecx, word [CPU_DI]
				add		ecx, [ES_BASE]
				call	__f_i286_memoryread_d@4
				cmp		ebx, eax
				FLAG_STORE_OF
				STRING_DIRx4
				add		[CPU_SI], ax
				add		[CPU_DI], ax
				ret

	.as32:		mov		ecx, [CPU_ESI]
				ADD_SEGBASE [DS_BASE]
				call	__f_i286_memoryread_d@4
				mov		ebx, eax
				mov		ecx, [CPU_EDI]
				add		ecx, [ES_BASE]
				call	__f_i286_memoryread_d@4
				cmp		ebx, eax
				FLAG_STORE_OF
				STRING_DIRx4
				add		[CPU_ESI], eax
				add		[CPU_EDI], eax
				ret

; scas
	align	32
	global	SCASB_ALXb
SCASB_ALXb:
				CPUCLOCK 7
				cmp		byte [CPU_INST_AS32], 0
				jne		.as32

				movzx	ecx, word [CPU_DI]
				add		ecx, [ES_BASE]
				call	__f_i286_memoryread@4
				cmp		[CPU_AL], al
				FLAG_STORE_OF
				STRING_DIR
				add		[CPU_DI], ax
				ret

	.as32:		mov		ecx, [CPU_EDI]
				add		ecx, [ES_BASE]
				call	__f_i286_memoryread@4
				cmp		[CPU_AL], al
				FLAG_STORE_OF
				STRING_DIR
				add		[CPU_EDI], eax
				ret

	align	32
	global	SCASW_AXXw
SCASW_AXXw:
				CPUCLOCK 7
				cmp		byte [CPU_INST_AS32], 0
				jne		.as32

				movzx	ecx, word [CPU_DI]
				add		ecx, [ES_BASE]
				call	__f_i286_memoryread_w@4
				cmp		[CPU_AX], ax
				FLAG_STORE_OF
				STRING_DIRx2
				add		[CPU_DI], ax
				ret

	.as32:		mov		ecx, [CPU_EDI]
				add		ecx, [ES_BASE]
				call	__f_i286_memoryread_w@4
				cmp		[CPU_AX], ax
				FLAG_STORE_OF
				STRING_DIRx2
				add		[CPU_EDI], eax
				ret

	align	32
	global	SCASD_EAXXd
SCASD_EAXXd:
				CPUCLOCK 7
				cmp		byte [CPU_INST_AS32], 0
				jne		.as32

				movzx	ecx, word [CPU_DI]
				add		ecx, [ES_BASE]
				call	__f_i286_memoryread_d@4
				cmp		[CPU_EAX], eax
				FLAG_STORE_OF
				STRING_DIRx4
				add		[CPU_DI], ax
				ret

	.as32:		mov		ecx, [CPU_EDI]
				add		ecx, [ES_BASE]
				call	__f_i286_memoryread_d@4
				cmp		[CPU_EAX], eax
				FLAG_STORE_OF
				STRING_DIRx4
				add		[CPU_EDI], eax
				ret

; lods
	align	32
	global	LODSB_ALXb
LODSB_ALXb:
				CPUCLOCK 5
				cmp		byte [CPU_INST_AS32], 0
				jne		.as32

				movzx	ecx, word [CPU_SI]
				ADD_SEGBASE [DS_BASE]
				call	__f_i286_memoryread@4
				mov		[CPU_AL], al
				STRING_DIR
				add		[CPU_SI], ax
				ret

	.as32:		mov		ecx, [CPU_ESI]
				ADD_SEGBASE [DS_BASE]
				call	__f_i286_memoryread@4
				mov		[CPU_AL], al
				STRING_DIR
				add		[CPU_ESI], eax
				ret

	align	32
	global	LODSW_AXXw
LODSW_AXXw:
				CPUCLOCK 5
				cmp		byte [CPU_INST_AS32], 0
				jne		.as32

				movzx	ecx, word [CPU_SI]
				ADD_SEGBASE [DS_BASE]
				call	__f_i286_memoryread_w@4
				mov		[CPU_AX], ax
				STRING_DIRx2
				add		[CPU_SI], ax
				ret

	.as32:		mov		ecx, [CPU_ESI]
				ADD_SEGBASE [DS_BASE]
				call	__f_i286_memoryread_w@4
				mov		[CPU_AX], ax
				STRING_DIRx2
				add		[CPU_ESI], eax
				ret

	align	32
	global	LODSD_EAXXd
LODSD_EAXXd:
				CPUCLOCK 5
				cmp		byte [CPU_INST_AS32], 0
				jne		.as32

				movzx	ecx, word [CPU_SI]
				ADD_SEGBASE [DS_BASE]
				call	__f_i286_memoryread_d@4
				mov		[CPU_EAX], eax
				STRING_DIRx4
				add		[CPU_SI], ax
				ret

	.as32:		mov		ecx, [CPU_ESI]
				ADD_SEGBASE [DS_BASE]
				call	__f_i286_memoryread_d@4
				mov		[CPU_EAX], eax
				STRING_DIRx4
				add		[CPU_ESI], eax
				ret

; stos
	align	32
	global	STOSB_YbAL
STOSB_YbAL:
				CPUCLOCK 3
				cmp		byte [CPU_INST_AS32], 0
				jne		.as32

				movzx	ecx, word [CPU_DI]
				add		ecx, [ES_BASE]
				STRING_DIR
				add		[CPU_DI], ax
				mov		dl, [CPU_AL]
				jmp		__f_i286_memorywrite@8

	.as32:		mov		ecx, [CPU_EDI]
				add		ecx, [ES_BASE]
				STRING_DIR
				add		[CPU_EDI], eax
				mov		dl, [CPU_AL]
				jmp		__f_i286_memorywrite@8

	align	32
	global	STOSW_YwAX
STOSW_YwAX:
				CPUCLOCK 3
				cmp		byte [CPU_INST_AS32], 0
				jne		.as32

				movzx	ecx, word [CPU_DI]
				add		ecx, [ES_BASE]
				STRING_DIRx2
				add		[CPU_DI], ax
				mov		dx, [CPU_AX]
				jmp		__f_i286_memorywrite_w@8

	.as32:		mov		ecx, [CPU_EDI]
				add		ecx, [ES_BASE]
				STRING_DIRx2
				add		[CPU_EDI], eax
				mov		dx, [CPU_AX]
				jmp		__f_i286_memorywrite_w@8

	align	32
	global	STOSD_YdEAX
STOSD_YdEAX:
				CPUCLOCK 3
				cmp		byte [CPU_INST_AS32], 0
				jne		.as32

				movzx	ecx, word [CPU_DI]
				add		ecx, [ES_BASE]
				STRING_DIRx4
				add		[CPU_DI], ax
				mov		edx, [CPU_EAX]
				jmp		__f_i286_memorywrite_d@8

	.as32:		mov		ecx, [CPU_EDI]
				add		ecx, [ES_BASE]
				STRING_DIRx4
				add		[CPU_EDI], eax
				mov		edx, [CPU_EAX]
				jmp		__f_i286_memorywrite_d@8

; repeat
	align	32
	global	_REPNE
_REPNE:
	global	_REPE
_REPE:
				mov		[CPU_INST_REPUSE], al
				ret

; ins
	align	32
	global	INSB_YbDX
INSB_YbDX:
				CPUCLOCK 5
				mov		cx, [CPU_DX]
				call	__f_i286_in@4
				mov		dl, al
				cmp		byte [CPU_INST_AS32], 0
				jne		.as32

				movzx	ecx, word [CPU_DI]
				add		ecx, [ES_BASE]
				STRING_DIR
				add		[CPU_DI], ax
				jmp		__f_i286_memorywrite@8

	.as32:		mov		ecx, [CPU_EDI]
				add		ecx, [ES_BASE]
				STRING_DIR
				add		[CPU_EDI], eax
				jmp		__f_i286_memorywrite@8

	align	32
	global	INSW_YwDX
INSW_YwDX:
				CPUCLOCK 5
				mov		cx, [CPU_DX]
				call	__f_i286_in_w@4
				mov		dx, ax
				cmp		byte [CPU_INST_AS32], 0
				jne		.as32

				movzx	ecx, word [CPU_DI]
				add		ecx, [ES_BASE]
				STRING_DIRx2
				add		[CPU_DI], ax
				jmp		__f_i286_memorywrite_w@8

	.as32:		mov		ecx, [CPU_EDI]
				add		ecx, [ES_BASE]
				STRING_DIRx2
				add		[CPU_EDI], eax
				jmp		__f_i286_memorywrite_w@8

	align	32
	global	INSD_YdDX
INSD_YdDX:
				CPUCLOCK 5
				mov		cx, [CPU_DX]
				call	__f_i286_in_d@4
				mov		edx, eax
				cmp		byte [CPU_INST_AS32], 0
				jne		.as32

				movzx	ecx, word [CPU_DI]
				add		ecx, [ES_BASE]
				STRING_DIRx4
				add		[CPU_DI], ax
				jmp		__f_i286_memorywrite_d@8

	.as32:		mov		ecx, [CPU_EDI]
				add		ecx, [ES_BASE]
				STRING_DIRx4
				add		[CPU_EDI], eax
				jmp		__f_i286_memorywrite_d@8

; outs
	align	32
	global	OUTSB_DXXb
OUTSB_DXXb:
				CPUCLOCK 3
				cmp		byte [CPU_INST_AS32], 0
				jne		.as32

				movzx	ecx, word [CPU_SI]
				ADD_SEGBASE [DS_BASE]
				call	__f_i286_memoryread@4
				mov		dl, al
				STRING_DIR
				add		[CPU_SI], ax
				mov		cx, [CPU_DX]
				jmp		__f_i286_out@8

	.as32:		mov		ecx, [CPU_ESI]
				ADD_SEGBASE [DS_BASE]
				call	__f_i286_memoryread@4
				mov		dl, al
				STRING_DIR
				add		[CPU_ESI], eax
				mov		cx, [CPU_DX]
				jmp		__f_i286_out@8

	align	32
	global	OUTSW_DXXw
OUTSW_DXXw:
				CPUCLOCK 3
				cmp		byte [CPU_INST_AS32], 0
				jne		.as32

				movzx	ecx, word [CPU_SI]
				ADD_SEGBASE [DS_BASE]
				call	__f_i286_memoryread_w@4
				mov		dx, ax
				STRING_DIRx2
				add		[CPU_SI], ax
				mov		cx, [CPU_DX]
				jmp		__f_i286_out_w@8

	.as32:		mov		ecx, [CPU_ESI]
				ADD_SEGBASE [DS_BASE]
				call	__f_i286_memoryread_w@4
				mov		dx, ax
				STRING_DIRx2
				add		[CPU_ESI], eax
				mov		cx, [CPU_DX]
				jmp		__f_i286_out_w@8

	align	32
	global	OUTSD_DXXd
OUTSD_DXXd:
				CPUCLOCK 3
				cmp		byte [CPU_INST_AS32], 0
				jne		.as32

				movzx	ecx, word [CPU_SI]
				ADD_SEGBASE [DS_BASE]
				call	__f_i286_memoryread_d@4
				mov		edx, eax
				STRING_DIRx4
				add		[CPU_SI], ax
				mov		cx, [CPU_DX]
				jmp		__f_i286_out_d@8

	.as32:		mov		ecx, [CPU_ESI]
				ADD_SEGBASE [DS_BASE]
				call	__f_i286_memoryread_d@4
				mov		edx, eax
				STRING_DIRx4
				add		[CPU_ESI], eax
				mov		cx, [CPU_DX]
				jmp		__f_i286_out_d@8

