
%include "cpu.inc"
%include "cpu.mcr"

extern	cpu_init
%ifdef USE_FPU
 extern	fpu_init
%endif
extern	exec_1step
extern	dma_proc

section .text

	align	32
	global	ia32reset
ia32reset:
				pushad
				call	cpu_init
%ifdef USE_FPU
				call	fpu_init
%endif
				mov		word [CPU_CS], 1fc0h
				mov		dword [CS_BASE], 1fc00h
				popad
				ret

	align	32
	global	ia32
ia32:
				pushad
				mov		ebp, [CS_BASE]
				movzx	esi, word [CPU_IP]
.mnlp:	
				call	exec_1step
				cmp		dword [_nevent + NEVENT_TABLE.remainclock], 0
				jg		.mnlp
				mov		[CPU_IP], si
				popad
				ret

	align	32
	global	ia32withtrap
ia32withtrap:
				pushad
				mov		ebp, [CS_BASE]
				movzx	esi, word [CPU_IP]
				call	exec_1step
				mov		[CPU_IP], si
				cmp		byte [CPU_TRAP], 0
				je		.notrap
				mov		ecx, 1
				call	__f_i286_interrupt@4
.notrap:
				popad
				ret

	align	32
	global	ia32withdma
ia32withdma:
				pushad
				mov		ebp, [CS_BASE]
				movzx	esi, word [CPU_IP]
.mnlp:
				call	exec_1step
				pushad
				call	dma_proc
				popad
				cmp		dword [_nevent + NEVENT_TABLE.remainclock], 0
				jg		.mnlp
				mov		[CPU_IP], si
				popad
				ret

	align	32
	global	ia32_step
ia32_step:
				pushad
				mov		ebp, [CS_BASE]
				movzx	esi, word [CPU_IP]
				call	exec_1step
				mov		[CPU_IP], si
				cmp		byte [CPU_TRAP], 0
				je		.nexts
				mov		ecx, 1
				call	__f_i286_interrupt@4
.nexts:
				call	dma_proc
				popad
				ret

	align	32
	global	__f_i286_interrupt@4
__f_i286_interrupt@4:
				push	ebx
				push	ecx
				push	edi

				; hlt..
				movzx	ecx, word [CPU_IP]
				add		ecx, [CS_BASE]
				call	__f_i286_memoryread@4
				cmp		al, 0f4h			; hlt
				jne		.nonhlt
				inc		word [CPU_IP]
	.nonhlt:	mov		edi, [SS_BASE]
				movzx	ebx, word [CPU_SP]
				sub		bx, 2
				lea		ecx, [edi + ebx]
				mov		dx, [CPU_FLAG]
				and		word [CPU_FLAG], ~ (T_FLAG | I_FLAG)
				mov		byte [CPU_TRAP], 0
				call	__f_i286_memorywrite_w@8
				sub		bx, 2
				lea		ecx, [edi + ebx]
				mov		dx, [CPU_CS]
				call	__f_i286_memorywrite_w@8
				sub		bx, 2
				mov		[CPU_SP], bx
				lea		ecx, [edi + ebx]
				mov		dx, [CPU_IP]
				call	__f_i286_memorywrite_w@8
				pop		edi
				pop		ecx
				pop		ebx

				sub		dword [_nevent + NEVENT_TABLE.remainclock], 20

				movzx	eax, cl
				mov		eax, [MAIN_MEM + eax * 4]
				mov		[CPU_IP], ax
				shr		eax, 16
				mov		[CPU_CS], ax
				shl		eax, 4					; make segreg
				mov		[CS_BASE], eax
				ret

