
%include "cpu.inc"
%include "cpu.mcr"

extern	cpu_inst
extern	resolve_table16
extern	resolve_table32

section	.text

; resolve addr
; eax: mod-rm
;  ret: ecx: addr
	align	32
	global	calc_ea_dst
calc_ea_dst:
				cmp		byte [CPU_INST_AS32], 0
				jne		.as32

				push	ebx
				call	[resolve_table16 + eax * 4]
				mov		ecx, edi
				add		ecx, ebx
				pop		ebx
				ret

	.as32:		push	ebx
				push	edx
				call	[resolve_table32 + eax * 4]
				mov		ecx, edi
				add		ecx, ebx
				pop		edx
				pop		ebx
				ret

; calc addr for LEA
;  ret: eax: offset
	align	32
	global	calc_lea
calc_lea:
				cmp		byte [CPU_INST_AS32], 0
				jne		.as32

				push	ebx
				call	[resolve_table16 + eax * 4]
				mov		eax, ebx
				pop		ebx
				ret

	.as32:		push	ebx
				call	[resolve_table32 + eax * 4]
				mov		eax, ebx
				pop		ebx
				ret

; get addr
;  ret: edi: segbase
;       ebx: offset
	align	32
	global	get_ea
get_ea:
				cmp		byte [CPU_INST_AS32], 0
				jne		.as32

				jmp		[resolve_table16 + eax * 4]

	.as32:		push	edx
				call	[resolve_table32 + eax * 4]
				pop		edx
				ret

