/*	$Id: cpu.c,v 1.1 2002/12/15 02:57:59 nonaka Exp $	*/

#include "cpu.h"
#include "ia32.mcr"
#include "inst_table.h"

#include "nevent.h"

void
exec_1step(void)
{
	BYTE op;

	bzero(&cpu_inst, sizeof(cpu_inst));

	do {
		GET_PCBYTE(op);

		// prefix
		if (insttable_info[op] & INST_PREFIX) {
			(*insttable_1byte[0][op])();
			continue;
		}
		break;
	} while (/*CONSTCOND*/ 1);

	// normal
	if (!(insttable_info[op] & INST_STRING)) {
		(*insttable_1byte[CPU_INST_OP32][op])();
		return;
	}

	// rep, but not use
	if (CPU_INST_REPUSE == 0) {
		(*insttable_1byte[CPU_INST_OP32][op])();
		return;
	}

	// rep
	CPU_CLOCK(5);
	if (!(CPU_INST_AS32)) {
		// 16bit
		if (CPU_CX != 0) {
			if (!(insttable_info[op] & REP_CHECKZF)) {
				// rep
				do {
					(*insttable_1byte[CPU_INST_OP32][op])();
				} while (CPU_CX > 0);
			} else if (CPU_INST_REPUSE != 0xf2) {
				// repz
				do {
					(*insttable_1byte[CPU_INST_OP32][op])();
				} while (CPU_CX > 0 && !(CPU_FLAGL & Z_FLAG));
			} else {
				// repnz
				do {
					(*insttable_1byte[CPU_INST_OP32][op])();
				} while (CPU_CX > 0 && (CPU_FLAGL & Z_FLAG));
			}
		}
	} else {
		// 32bit
		if (CPU_ECX != 0) {
			if (!(insttable_info[op] & REP_CHECKZF)) {
				// rep
				do {
					(*insttable_1byte[CPU_INST_OP32][op])();
				} while (CPU_ECX > 0);
			} else if (CPU_INST_REPUSE != 0xf2) {
				// repz
				do {
					(*insttable_1byte[CPU_INST_OP32][op])();
				} while (CPU_ECX > 0 && !(CPU_FLAGL & Z_FLAG));
			} else {
				// repnz
				do {
					(*insttable_1byte[CPU_INST_OP32][op])();
				} while (CPU_ECX > 0 && (CPU_FLAGL & Z_FLAG));
			}
		}
	}
}
