/*	$Id: groups.c,v 1.1 2002/12/15 02:57:59 nonaka Exp $	*/

#include "compiler.h"

#include "cpu.h"
#include "ia32.mcr"
#include "groups.h"
#include "inst_table.h"
#include "resolve.h"

#include "memory.h"
#include "nevent.h"


// group 1
void
Grp1_EbIb(void)
{
	BYTE *out;
	DWORD op, madr;

	GET_PCBYTE(op);
	if (op >= 0xc0) {
		CPU_CLOCK(3);
		out = reg8_b20[op];
	} else {
		CPU_CLOCK(7);
		madr = calc_ea_dst(op);
		if (madr >= MAINMEM_WRITEMAX) {
			(*insttable_G1EbIb_ext[(op >> 3) & 7])(madr);
			return;
		}
		out = mem + madr;
	}
	(*insttable_G1EbIb[(op >> 3) & 7])(out);
}

void
Grp1_EwIb(void)
{
	WORD *out;
	DWORD op, madr, src;

	GET_PCBYTE(op);
	if (op >= 0xc0) {
		CPU_CLOCK(3);
		out = reg16_b20[op];
	} else {
		CPU_CLOCK(7);
		madr = calc_ea_dst(op);
		if (INHIBIT_WORDP(madr)) {
			GET_PCBYTES(src);
			(*insttable_G1EwIx_ext[(op >> 3) & 7])(madr, src);
			return;
		}
		out = (WORD *)(mem + madr);
	}
	GET_PCBYTES(src);
	(*insttable_G1EwIx[(op >> 3) & 7])(out, src);
}

void
Grp1_EdIb(void)
{
	DWORD *out;
	DWORD op, madr, src;

	GET_PCBYTE(op);
	if (op >= 0xc0) {
		CPU_CLOCK(3);
		out = reg32_b20[op];
	} else {
		CPU_CLOCK(7);
		madr = calc_ea_dst(op);
		if (INHIBIT_WORDP(madr)) {
			GET_PCBYTESD(src);
			(*insttable_G1EdIx_ext[(op >> 3) & 7])(madr, src);
			return;
		}
		out = (DWORD *)(mem + madr);
	}
	GET_PCBYTESD(src);
	(*insttable_G1EdIx[(op >> 3) & 7])(out, src);
}

void
Grp1_EwIw(void)
{
	WORD *out;
	DWORD op, madr, src;

	GET_PCBYTE(op);
	if (op >= 0xc0) {
		CPU_CLOCK(3);
		out = reg16_b20[op];
	} else {
		CPU_CLOCK(7);
		madr = calc_ea_dst(op);
		if (INHIBIT_WORDP(madr)) {
			GET_PCWORD(src);
			(*insttable_G1EwIx_ext[(op >> 3) & 7])(madr, src);
			return;
		}
		out = (WORD *)(mem + madr);
	}
	GET_PCWORD(src);
	(*insttable_G1EwIx[(op >> 3) & 7])(out, src);
}

void
Grp1_EdId(void)
{
	DWORD *out;
	DWORD op, madr, src;

	GET_PCBYTE(op);
	if (op >= 0xc0) {
		CPU_CLOCK(3);
		out = reg32_b20[op];
	} else {
		CPU_CLOCK(7);
		madr = calc_ea_dst(op);
		if (INHIBIT_DWORDP(madr)) {
			GET_PCDWORD(src);
			(*insttable_G1EdIx_ext[(op >> 3) & 7])(madr, src);
			return;
		}
		out = (DWORD *)(mem + madr);
	}
	GET_PCDWORD(src);
	(*insttable_G1EdIx[(op >> 3) & 7])(out, src);
}


// group 2
void
Grp2_EbIb(void)
{
	BYTE *out;
	DWORD op, madr;
	BYTE  cl;

	GET_PCBYTE(op);
	if (op >= 0xc0) {
		CPU_CLOCK(5);
		out = reg8_b20[op];
	} else {
		CPU_CLOCK(8);
		madr = calc_ea_dst(op);
		if (madr >= MAINMEM_WRITEMAX) {
			GET_PCBYTE(cl);
			CPU_CLOCK(cl);
			(*insttable_G2EbCL_ext[(op >> 3) & 7])(madr, cl);
			return;
		}
		out = mem + madr;
	}
	GET_PCBYTE(cl);
	CPU_CLOCK(cl);
	(*insttable_G2EbCL[(op >> 3) & 7])(out, cl);
}

void
Grp2_EwIb(void)
{
	WORD *out;
	DWORD op, madr;
	BYTE  cl;

	GET_PCBYTE(op);
	if (op >= 0xc0) {
		CPU_CLOCK(5);
		out = reg16_b20[op];
	} else {
		CPU_CLOCK(8);
		madr = calc_ea_dst(op);
		if (INHIBIT_WORDP(madr)) {
			GET_PCBYTE(cl);
			CPU_CLOCK(cl);
			(*insttable_G2EwCL_ext[(op >> 3) & 7])(madr, cl);
			return;
		}
		out = (WORD *)(mem + madr);
	}
	GET_PCBYTE(cl);
	CPU_CLOCK(cl);
	(*insttable_G2EwCL[(op >> 3) & 7])(out, cl);
}

void
Grp2_EdIb(void)
{
	DWORD *out;
	DWORD op, madr;
	BYTE  cl;

	GET_PCBYTE(op);
	if (op >= 0xc0) {
		CPU_CLOCK(5);
		out = reg32_b20[op];
	} else {
		CPU_CLOCK(8);
		madr = calc_ea_dst(op);
		if (INHIBIT_DWORDP(madr)) {
			GET_PCBYTE(cl);
			CPU_CLOCK(cl);
			(*insttable_G2EdCL_ext[(op >> 3) & 7])(madr, cl);
			return;
		}
		out = (DWORD *)(mem + madr);
	}
	GET_PCBYTE(cl);
	CPU_CLOCK(cl);
	(*insttable_G2EdCL[(op >> 3) & 7])(out, cl);
}

void
Grp2_Eb(void)
{
	BYTE *out;
	DWORD op, madr;

	GET_PCBYTE(op);
	if (op >= 0xc0) {
		CPU_CLOCK(2);
		out = reg8_b20[op];
	} else {
		CPU_CLOCK(7);
		madr = calc_ea_dst(op);
		if (madr >= MAINMEM_WRITEMAX) {
			(*insttable_G2Eb_ext[(op >> 3) & 7])(madr);
			return;
		}
		out = mem + madr;
	}
	(*insttable_G2Eb[(op >> 3) & 7])(out);
}

void
Grp2_Ew(void)
{
	WORD *out;
	DWORD op, madr;

	GET_PCBYTE(op);
	if (op >= 0xc0) {
		CPU_CLOCK(2);
		out = reg16_b20[op];
	} else {
		CPU_CLOCK(7);
		madr = calc_ea_dst(op);
		if (INHIBIT_WORDP(madr)) {
			(*insttable_G2Ew_ext[(op >> 3) & 7])(madr);
			return;
		}
		out = (WORD *)(mem + madr);
	}
	(*insttable_G2Ew[(op >> 3) & 7])(out);
}

void
Grp2_Ed(void)
{
	DWORD *out;
	DWORD op, madr;

	GET_PCBYTE(op);
	if (op >= 0xc0) {
		CPU_CLOCK(2);
		out = reg32_b20[op];
	} else {
		CPU_CLOCK(7);
		madr = calc_ea_dst(op);
		if (INHIBIT_DWORDP(madr)) {
			(*insttable_G2Ed_ext[(op >> 3) & 7])(madr);
			return;
		}
		out = (DWORD *)(mem + madr);
	}
	(*insttable_G2Ed[(op >> 3) & 7])(out);
}

void
Grp2_EbCL(void)
{
	BYTE *out;
	DWORD op, madr;
	BYTE  cl;

	GET_PCBYTE(op);
	if (op >= 0xc0) {
		CPU_CLOCK(5);
		out = reg8_b20[op];
	} else {
		CPU_CLOCK(8);
		madr = calc_ea_dst(op);
		if (madr >= MAINMEM_WRITEMAX) {
			cl = CPU_CL;
			CPU_CLOCK(cl);
			(*insttable_G2EbCL_ext[(op >> 3) & 7])(madr, cl);
			return;
		}
		out = mem + madr;
	}
	cl = CPU_CL;
	CPU_CLOCK(cl);
	(*insttable_G2EbCL[(op >> 3) & 7])(out, cl);
}

void
Grp2_EwCL(void)
{
	WORD *out;
	DWORD op, madr;
	BYTE  cl;

	GET_PCBYTE(op);
	if (op >= 0xc0) {
		CPU_CLOCK(5);
		out = reg16_b20[op];
	} else {
		CPU_CLOCK(8);
		madr = calc_ea_dst(op);
		if (INHIBIT_WORDP(madr)) {
			cl = CPU_CL;
			CPU_CLOCK(cl);
			(*insttable_G2EwCL_ext[(op >> 3) & 7])(madr, cl);
			return;
		}
		out = (WORD *)(mem + madr);
	}
	cl = CPU_CL;
	CPU_CLOCK(cl);
	(*insttable_G2EwCL[(op >> 3) & 7])(out, cl);
}

void
Grp2_EdCL(void)
{
	DWORD *out;
	DWORD op, madr;
	BYTE  cl;

	GET_PCBYTE(op);
	if (op >= 0xc0) {
		CPU_CLOCK(5);
		out = reg32_b20[op];
	} else {
		CPU_CLOCK(8);
		madr = calc_ea_dst(op);
		if (INHIBIT_DWORDP(madr)) {
			cl = CPU_CL;
			CPU_CLOCK(cl);
			(*insttable_G2EdCL_ext[(op >> 3) & 7])(madr, cl);
			return;
		}
		out = (DWORD *)(mem + madr);
	}
	cl = CPU_CL;
	CPU_CLOCK(cl);
	(*insttable_G2EdCL[(op >> 3) & 7])(out, cl);
}


// group 3
void
Grp3_Eb(void)
{

	DWORD op;

	GET_PCBYTE(op);
	(*insttable_G3Eb[(op >> 3) & 7])(op);
}

void
Grp3_Ew(void)
{

	DWORD op;

	GET_PCBYTE(op);
	(*insttable_G3Ew[(op >> 3) & 7])(op);
}

void
Grp3_Ed(void)
{

	DWORD op;

	GET_PCBYTE(op);
	(*insttable_G3Ed[(op >> 3) & 7])(op);
}


// group 4
void
Grp4(void)
{
	DWORD op;

	GET_PCBYTE(op);
	(*insttable_G4[(op >> 3) & 7])(op);
}


// group 5
void
Grp5_Ew(void)
{
	DWORD op;

	GET_PCBYTE(op);
	(*insttable_G5Ew[(op >> 3) & 7])(op);
}

void
Grp5_Ed(void)
{
	DWORD op;

	GET_PCBYTE(op);
	(*insttable_G5Ed[(op >> 3) & 7])(op);
}


// group6
void
Grp6(void)
{
	DWORD op;

	GET_PCBYTE(op);
	(*insttable_G6[(op >> 3) & 7])(op);
}


// group 7
void
Grp7_16(void)
{
	DWORD op;

	GET_PCBYTE(op);
	(*insttable_G7_16[(op >> 3) & 7])(op);
}

void
Grp7_32(void)
{
	DWORD op;

	GET_PCBYTE(op);
	(*insttable_G7_32[(op >> 3) & 7])(op);
}


// group 8
void
Grp8_EwIb(void)
{
	DWORD op;

	GET_PCBYTE(op);
	(*insttable_G8EwIb[(op >> 3) & 7])(op);
}

void
Grp8_EdIb(void)
{
	DWORD op;

	GET_PCBYTE(op);
	(*insttable_G8EdIb[(op >> 3) & 7])(op);
}


// group 9
void
Grp9(void)
{
	DWORD op;

	GET_PCBYTE(op);
	(*insttable_G9[(op >> 3) & 7])(op);
}
