/*	$Id: ia32.mcr,v 1.1 2002/12/15 02:57:59 nonaka Exp $	*/

#ifndef	NP2_CPU_IA32_IA32_MCR__
#define	NP2_CPU_IA32_IA32_MCR__


#if defined(NP2_LITTLEENDIAN)
#define	INHIBIT_WORDP(m)	((m) >= (MAINMEM_WRITEMAX - 1))
#define	INHIBIT_DWORDP(m)	((m) >= (MAINMEM_WRITEMAX - 3))
#else	/* NP2_BIGENDIAN */
#define	INHIBIT_WORDP(m)	(1)
#define	INHIBIT_DWORDP(m)	(1)
#endif	/* NP2_LITTLEENDIAN */


#define	__CBW(src)	((WORD)((signed char)(src)))
#define	__CBD(src)	((signed char)(src))
#define	__CWDE(src)	((short)(src))


//
// clock
//
#define	CPU_CLOCK(clock) \
do { \
	nevent.remainclock -= (clock); \
} while (/*CONSTCOND*/ 0)


//
// read CPU_IP memory & inc CPU_IP
//
#define	GET_PCBYTE(v) \
do { \
	(v) = cpu_memoryread(CS_BASE + CPU_IP); \
	CPU_IP++; \
} while (/*CONSTCOND*/ 0)

#define	GET_PCBYTES(v) \
do { \
	(v) = __CBW(cpu_memoryread(CS_BASE + CPU_IP)); \
	CPU_IP++; \
} while (/*CONSTCOND*/ 0)

#define	GET_PCBYTESD(v) \
do { \
	(v) = __CBD(cpu_memoryread(CS_BASE + CPU_IP)); \
	CPU_IP++; \
} while (/*CONSTCOND*/ 0)

#define	GET_PCWORD(v) \
do { \
	(v) = cpu_memoryread_w(CS_BASE + CPU_IP); \
	CPU_IP += 2; \
} while (/*CONSTCOND*/ 0)

#define	GET_PCWORDS(v) \
do { \
	(v) = __CWDE(cpu_memoryread_w(CS_BASE + CPU_IP)); \
	CPU_IP += 2; \
} while (/*CONSTCOND*/ 0)

#define	GET_PCDWORD(v) \
do { \
	(v) = cpu_memoryread_d(CS_BASE + CPU_IP); \
	CPU_IP += 4; \
} while (/*CONSTCOND*/ 0)

#define	PREPART_EA_REG8(b, d_s) \
do { \
		GET_PCBYTE((b)); \
		(d_s) = *(reg8_b53[(b)]); \
} while (/*CONSTCOND*/ 0)

#define	PREPART_EA_REG8P(b, d_s) \
do { \
		GET_PCBYTE((b)); \
		(d_s) = reg8_b53[(b)]; \
} while (/*CONSTCOND*/ 0)

#define	PREPART_EA_REG16(b, d_s) \
do { \
		GET_PCBYTE((b)); \
		(d_s) = *(reg16_b53[(b)]); \
} while (/*CONSTCOND*/ 0)

#define	PREPART_EA_REG16P(b, d_s) \
do { \
		GET_PCBYTE((b)); \
		(d_s) = reg16_b53[(b)]; \
} while (/*CONSTCOND*/ 0)

#define	PREPART_EA_REG32(b, d_s) \
do { \
		GET_PCBYTE((b)); \
		(d_s) = *(reg32_b53[(b)]); \
} while (/*CONSTCOND*/ 0)

#define	PREPART_EA_REG32P(b, d_s) \
do { \
		GET_PCBYTE((b)); \
		(d_s) = reg32_b53[(b)]; \
} while (/*CONSTCOND*/ 0)

#define PREPART_REG8_EA(b, s, d, regclk, memclk) \
do { \
		GET_PCBYTE((b)); \
		if ((b) >= 0xc0) { \
			CPU_CLOCK(regclk); \
			(s) = *(reg8_b20[(b)]); \
		} else { \
			CPU_CLOCK(memclk); \
			(s) = cpu_memoryread(calc_ea_dst((b))); \
		} \
		(d) = reg8_b53[(b)]; \
} while (/*CONSTCOND*/ 0)

#define	PREPART_REG16_EA(b, s, d, regclk, memclk) \
do { \
		GET_PCBYTE((b)); \
		if (b >= 0xc0) { \
			CPU_CLOCK(regclk); \
			s = *(reg16_b20[(b)]); \
		} else { \
			CPU_CLOCK(memclk); \
			s = cpu_memoryread_w(calc_ea_dst((b))); \
		} \
		d = reg16_b53[(b)]; \
} while (/*CONSTCOND*/ 0)

#define	PREPART_REG32_EA(b, s, d, regclk, memclk) \
do { \
		GET_PCBYTE((b)); \
		if (b >= 0xc0) { \
			CPU_CLOCK(regclk); \
			s = *(reg32_b20[(b)]); \
		} else { \
			CPU_CLOCK(memclk); \
			s = cpu_memoryread_d(calc_ea_dst((b))); \
		} \
		d = reg32_b53[(b)]; \
} while (/*CONSTCOND*/ 0)


//
// arith
//
#define	ADDBYTE(r, d, s) \
do { \
	(r) = (s) + (d); \
	CPU_OV = ((r) ^ (s)) & ((r) ^ (d)) & 0x80; \
	CPU_FLAGL = (BYTE)(((r) ^ (d) ^ (s)) & A_FLAG); \
	CPU_FLAGL |= szpcflag[(r)]; \
} while (/*CONSTCOND*/ 0)

#define	ADDWORD(r, d, s) \
do { \
	(r) = (s) + (d); \
	CPU_OV = ((r) ^ (s)) & ((r) ^ (d)) & 0x8000; \
	CPU_FLAGL = (BYTE)(((r) ^ (d) ^ (s)) & A_FLAG); \
	if ((r) & 0xffff0000) { \
		(r) &= 0x0000ffff; \
		CPU_FLAGL |= C_FLAG; \
	} \
	CPU_FLAGL |= szpflag_w[(r)]; \
} while (/*CONSTCOND*/ 0)

#define	ADDDWORD(r, d, s) \
do { \
	(r) = (s) + (d); \
	CPU_OV = ((r) ^ (s)) & ((r) ^ (d)) & 0x80000000; \
	CPU_FLAGL = (BYTE)(((r) ^ (d) ^ (s)) & A_FLAG); \
	if ((r) < (s)) { \
		CPU_FLAGL |= C_FLAG; \
	} \
	if ((r) == 0) { \
		CPU_FLAGL |= Z_FLAG; \
	} \
	if ((r) & 0x80000000) { \
		CPU_FLAGL |= S_FLAG; \
	} \
	CPU_FLAGL |= szpcflag[(BYTE)(r)] & P_FLAG; \
} while (/*CONSTCOND*/ 0)

#define ORBYTE(d, s) \
do { \
	(d) |= (s); \
	CPU_OV = 0; \
	CPU_FLAGL = szpcflag[(d)]; \
} while (/*CONSTCOND*/ 0)

#define ORWORD(d, s) \
do { \
	(d) |= (s); \
	CPU_OV = 0; \
	CPU_FLAGL = szpflag_w[(d)]; \
} while (/*CONSTCOND*/ 0)

#define ORDWORD(d, s) \
do { \
	(d) |= (s); \
	CPU_OV = 0; \
	if ((r) == 0) { \
		CPU_FLAGL |= Z_FLAG; \
	} \
	if ((r) & 0x80000000) { \
		CPU_FLAGL |= S_FLAG; \
	} \
	CPU_FLAGL |= szpcflag[(BYTE)(r)] & P_FLAG; \
} while (/*CONSTCOND*/ 0)

// flag no check
#define ADCBYTE(r, d, s) \
do { \
	(r) = (CPU_FLAGL & 1) + (s) + (d); \
	CPU_OV = ((r) ^ (s)) & ((r) ^ (d)) & 0x80; \
	CPU_FLAGL = (BYTE)(((r) ^ (d) ^ (s)) & A_FLAG); \
	CPU_FLAGL |= szpcflag[(r)]; \
} while (/*CONSTCOND*/ 0)

#define ADCWORD(r, d, s) \
do { \
	(r) = (CPU_FLAGL & 1) + (s) + (d); \
	CPU_OV = ((r) ^ (s)) & ((r) ^ (d)) & 0x8000; \
	CPU_FLAGL = (BYTE)(((r) ^ (d) ^ (s)) & A_FLAG); \
	if ((r) & 0xffff0000) { \
		(r) &= 0x0000ffff; \
		CPU_FLAGL |= C_FLAG; \
	} \
	CPU_FLAGL |= szpflag_w[(r)]; \
} while (/*CONSTCOND*/ 0)

#define ADCDWORD(r, d, s) \
do { \
	(r) = (CPU_FLAGL & 1) + (s) + (d); \
	CPU_OV = ((r) ^ (s)) & ((r) ^ (d)) & 0x80000000; \
	CPU_FLAGL = (BYTE)(((r) ^ (d) ^ (s)) & A_FLAG); \
	if ((r) < (s)) { \
		CPU_FLAGL |= C_FLAG; \
	} \
	if ((r) == 0) { \
		CPU_FLAGL |= Z_FLAG; \
	} \
	if ((r) & 0x80000000) { \
		CPU_FLAGL |= S_FLAG; \
	} \
	CPU_FLAGL |= szpcflag[(BYTE)(r)] & P_FLAG; \
} while (/*CONSTCOND*/ 0)

// flag no check
#define	SBBBYTE(r, d, s) \
do { \
	(r) = (d) - (s) - (CPU_FLAGL & 1); \
	CPU_OV = ((d) ^ (r)) & ((d) ^ (s)) & 0x80; \
	CPU_FLAGL = (BYTE)(((r) ^ (d) ^ (s)) & A_FLAG); \
	CPU_FLAGL |= szpcflag[(r) & 0x1ff]; \
} while (/*CONSTCOND*/ 0)

#define	SBBWORD(r, d, s) \
do { \
	(r) = (d) - (s) - (CPU_FLAGL & 1); \
	CPU_OV = ((d) ^ (r)) & ((d) ^ (s)) & 0x8000; \
	CPU_FLAGL = (BYTE)(((r) ^ (d) ^ (s)) & A_FLAG); \
	if ((r) & 0xffff0000) { \
		(r) &= 0x0000ffff; \
		CPU_FLAGL |= C_FLAG; \
	} \
	CPU_FLAGL |= szpflag_w[(r)]; \
} while (/*CONSTCOND*/ 0)

#define	SBBDWORD(r, d, s) \
do { \
	(r) = (d) - (s) - (CPU_FLAGL & 1); \
	CPU_OV = ((d) ^ (r)) & ((d) ^ (s)) & 0x8000; \
	CPU_FLAGL = (BYTE)(((r) ^ (d) ^ (s)) & A_FLAG); \
	if ((d) < (s)) { \
		CPU_FLAGL |= C_FLAG; \
	} \
	if ((r) == 0) { \
		CPU_FLAGL |= Z_FLAG; \
	} \
	if ((r) & 0x80000000) { \
		CPU_FLAGL |= S_FLAG; \
	} \
	CPU_FLAGL |= szpcflag[(BYTE)(r)] & P_FLAG; \
} while (/*CONSTCOND*/ 0)

#define	ANDBYTE(d, s) \
do { \
	(d) &= (s); \
	CPU_OV = 0; \
	CPU_FLAGL = szpcflag[(d)]; \
} while (/*CONSTCOND*/ 0)

#define	ANDWORD(d, s) \
do { \
	(d) &= s; \
	CPU_OV = 0; \
	CPU_FLAGL = szpflag_w[(d)]; \
} while (/*CONSTCOND*/ 0)

#define	ANDDWORD(d, s) \
do { \
	(d) &= s; \
	CPU_OV = 0; \
	if ((r) == 0) { \
		CPU_FLAGL |= Z_FLAG; \
	} \
	if ((r) & 0x80000000) { \
		CPU_FLAGL |= S_FLAG; \
	} \
	CPU_FLAGL |= szpcflag[(BYTE)(r)] & P_FLAG; \
} while (/*CONSTCOND*/ 0)

#define	BYTE_SUB(r, d, s) \
do { \
	(r) = (d) - (s); \
	CPU_OV = ((d) ^ (r)) & ((d) ^ (s)) & 0x80; \
	CPU_FLAGL = (BYTE)(((r) ^ (d) ^ (s)) & A_FLAG); \
	CPU_FLAGL |= szpcflag[(r) & 0x1ff]; \
} while (/*CONSTCOND*/ 0)

#define	WORD_SUB(r, d, s) \
do { \
	(r) = (d) - (s); \
	CPU_OV = ((d) ^ (r)) & ((d) ^ (s)) & 0x8000; \
	CPU_FLAGL = (BYTE)(((r) ^ (d) ^ (s)) & A_FLAG); \
	if ((r) & 0xffff0000) { \
		(r) &= 0x0000ffff; \
		CPU_FLAGL |= C_FLAG; \
	} \
	CPU_FLAGL |= szpflag_w[(r)]; \
} while (/*CONSTCOND*/ 0)

#define	DWORD_SUB(r, d, s) \
do { \
	(r) = (d) - (s); \
	CPU_OV = ((d) ^ (r)) & ((d) ^ (s)) & 0x8000; \
	CPU_FLAGL = (BYTE)(((r) ^ (d) ^ (s)) & A_FLAG); \
	if ((d) < (s)) { \
		CPU_FLAGL |= C_FLAG; \
	} \
	if ((r) == 0) { \
		CPU_FLAGL |= Z_FLAG; \
	} \
	if ((r) & 0x80000000) { \
		CPU_FLAGL |= S_FLAG; \
	} \
	CPU_FLAGL |= szpcflag[(BYTE)(r)] & P_FLAG; \
} while (/*CONSTCOND*/ 0)

#define	BYTE_XOR(d, s) \
do { \
	(d) ^= s; \
	CPU_OV = 0; \
	CPU_FLAGL = szpcflag[(d)]; \
} while (/*CONSTCOND*/ 0)

#define	WORD_XOR(d, s) \
do { \
	(d) ^= (s); \
	CPU_OV = 0; \
	CPU_FLAGL = szpflag_w[(d)]; \
} while (/*CONSTCOND*/ 0)

#define	DWORD_XOR(d, s) \
do { \
	(d) ^= (s); \
	CPU_OV = 0; \
	if ((r) == 0) { \
		CPU_FLAGL |= Z_FLAG; \
	} \
	if ((r) & 0x80000000) { \
		CPU_FLAGL |= S_FLAG; \
	} \
	CPU_FLAGL |= szpcflag[(BYTE)(r)] & P_FLAG; \
} while (/*CONSTCOND*/ 0)

#define	BYTE_NEG(d, s) \
do { \
	(d) = 0 - (s); \
	CPU_OV = ((d) & (s)) & 0x80; \
	CPU_FLAGL = (BYTE)(((d) ^ (s)) & A_FLAG); \
	CPU_FLAGL |= szpcflag[(d) & 0x1ff]; \
} while (/*CONSTCOND*/ 0)

#define	WORD_NEG(d, s) \
do { \
	(d) = 0 - (s); \
	CPU_OV = ((d) & (s)) & 0x8000; \
	CPU_FLAGL = (BYTE)(((d) ^ (s)) & A_FLAG); \
	if ((d) & 0xffff0000) { \
		(d) &= 0x0000ffff; \
		CPU_FLAGL |= C_FLAG; \
	} \
	CPU_FLAGL |= szpflag_w[(d)]; \
} while (/*CONSTCOND*/ 0)

#define	DWORD_NEG(d, s) \
do { \
	(d) = 0 - (s); \
	CPU_OV = ((d) & (s)) & 0x8000; \
	CPU_FLAGL = (BYTE)(((d) ^ (s)) & A_FLAG); \
	if ((d) < (s)) { \
		CPU_FLAGL |= C_FLAG; \
	} \
	if ((d) == 0) { \
		CPU_FLAGL |= Z_FLAG; \
	} \
	if ((d) & 0x80000000) { \
		CPU_FLAGL |= S_FLAG; \
	} \
	CPU_FLAGL |= szpcflag[(BYTE)(d)] & P_FLAG; \
} while (/*CONSTCOND*/ 0)

#define	BYTE_MUL(r, d, s) \
do { \
	CPU_FLAGL &= (Z_FLAG | S_FLAG | A_FLAG | P_FLAG); \
	(r) = (BYTE)(d) * (BYTE)(s); \
	CPU_OV = (r) >> 8; \
	if (CPU_OV) { \
		CPU_FLAGL |= C_FLAG; \
	} \
} while (/*CONSTCOND*/ 0)

#define	WORD_MUL(r, d, s) \
do { \
	CPU_FLAGL &= (Z_FLAG | S_FLAG | A_FLAG | P_FLAG); \
	(r) = (WORD)(d) * (WORD)(s); \
	CPU_OV = (r) >> 16; \
	if (CPU_OV) { \
		CPU_FLAGL |= C_FLAG; \
	} \
} while (/*CONSTCOND*/ 0)

#define	DWORD_MUL(r, d, s) \
do { \
	unsigned long long __v; \
	CPU_FLAGL &= (Z_FLAG | S_FLAG | A_FLAG | P_FLAG); \
	(r) = (DWORD)(d) * (DWORD)(s); \
	__v = (unsigned long long)(d) * (unsigned long long)(s); \
	(r) = __v & 0xffffffff; \
	CPU_OV = (__v >> 32); \
	if (CPU_OV) { \
		CPU_FLAGL |= C_FLAG; \
	} \
} while (/*CONSTCOND*/ 0)

#define	BYTE_IMUL(r, d, s) \
do { \
	CPU_FLAGL &= (Z_FLAG | S_FLAG | A_FLAG | P_FLAG); \
	(r) = (signed char)(d) * (signed char)(s); \
	CPU_OV = ((r) + 0x80) & 0xffffff00; \
	if (CPU_OV) { \
		CPU_FLAGL |= C_FLAG; \
	} \
} while (/*CONSTCOND*/ 0)

#define	WORD_IMUL(r, d, s) \
do { \
	CPU_FLAGL &= (Z_FLAG | S_FLAG | A_FLAG | P_FLAG); \
	(r) = (short)(d) * (short)(s); \
	CPU_OV = ((r) + 0x8000) & 0xffff00; \
	if (CPU_OV) { \
		CPU_FLAGL |= C_FLAG; \
	} \
} while (/*CONSTCOND*/ 0)

#define DWORD_IMUL(r, d, s) \
do { \
	long long __v; \
	CPU_FLAGL &= (Z_FLAG | S_FLAG | A_FLAG | P_FLAG); \
	__v = (long long)(d) * (long long)(s); \
	(r) = __v & 0xffffffff; \
	CPU_OV = (__v >> 32); \
	if (CPU_OV) { \
		CPU_FLAGL |= C_FLAG; \
	} \
} while (/*CONSTCOND*/ 0)

// flag no check
#define	BYTE_INC(s) \
do { \
	BYTE __b; \
	__b = (s); \
	__b++; \
	CPU_OV = __b & (__b ^ (s)) & 0x80; \
	CPU_FLAGL &= C_FLAG; \
	CPU_FLAGL |= (BYTE)((__b ^ (s)) & A_FLAG); \
	CPU_FLAGL |= szpcflag[__b]; \
	(s) = __b; \
} while (/*CONSTCOND*/ 0)

#define	WORD_INC(s) \
do { \
	WORD __b; \
	__b = (s); \
	__b++; \
	CPU_OV = __b & (__b ^ (s)) & 0x8000; \
	CPU_FLAGL &= C_FLAG; \
	CPU_FLAGL |= (BYTE)((__b ^ (s)) & A_FLAG); \
	CPU_FLAGL |= szpflag_w[__b]; \
	(s) = __b; \
} while (/*CONSTCOND*/ 0)

#define	DWORD_INC(s) \
do { \
	DWORD __b; \
	__b = (s); \
	__b++; \
	CPU_OV = __b & (__b ^ (s)) & 0x80000000; \
	CPU_FLAGL &= C_FLAG; \
	CPU_FLAGL |= (BYTE)((__b ^ (s)) & A_FLAG); \
	if ((__b) == 0) { \
		CPU_FLAGL |= Z_FLAG; \
	} \
	if ((__b) & 0x80000000) { \
		CPU_FLAGL |= S_FLAG; \
	} \
	CPU_FLAGL |= szpcflag[(BYTE)(__b)] & P_FLAG; \
	(s) = __b; \
} while (/*CONSTCOND*/ 0)

// flag no check
#define	BYTE_DEC(s) \
do { \
	BYTE __b = (s); \
	__b--; \
	CPU_OV = (s) & (__b ^ (s)) & 0x80; \
	CPU_FLAGL &= C_FLAG; \
	CPU_FLAGL |= (BYTE)((__b ^ (s)) & A_FLAG); \
	CPU_FLAGL |= szpcflag[__b]; \
	(s) = __b; \
} while (/*CONSTCOND*/ 0)

#define	WORD_DEC(s) \
do { \
	WORD __b = (s); \
	__b--; \
	CPU_OV = (s) & (__b ^ (s)) & 0x8000; \
	CPU_FLAGL &= C_FLAG; \
	CPU_FLAGL |= (BYTE)((__b ^ (s)) & A_FLAG); \
	CPU_FLAGL |= szpflag_w[__b]; \
	(s) = __b; \
} while (/*CONSTCOND*/ 0)

#define	DWORD_DEC(s) \
do { \
	DWORD __b = (s); \
	__b--; \
	CPU_OV = (s) & (__b ^ (s)) & 0x80000000; \
	CPU_FLAGL &= C_FLAG; \
	CPU_FLAGL |= (BYTE)((__b ^ (s)) & A_FLAG); \
	if ((__b) == 0) { \
		CPU_FLAGL |= Z_FLAG; \
	} \
	if ((__b) & 0x80000000) { \
		CPU_FLAGL |= S_FLAG; \
	} \
	CPU_FLAGL |= szpcflag[(BYTE)(__b)] & P_FLAG; \
	(s) = __b; \
} while (/*CONSTCOND*/ 0)


//
// stack
//
#define REGPUSH(reg, clock) \
do { \
	CPU_SP -= 2; \
	cpu_memorywrite_w(CPU_SP + SS_BASE, reg); \
	CPU_CLOCK(clock); \
} while (/*CONSTCOND*/ 0)

#define REGPUSH_32(reg, clock) \
do { \
	CPU_SP -= 4; \
	cpu_memorywrite_d(CPU_ESP + SS_BASE, reg); \
	CPU_CLOCK(clock); \
} while (/*CONSTCOND*/ 0)

#define REGPUSH0(reg) \
do { \
	CPU_SP -= 2; \
	cpu_memorywrite_w(CPU_SP + SS_BASE, reg); \
} while (/*CONSTCOND*/ 0)

#define REGPUSH0_32(reg) \
do { \
	CPU_SP -= 4; \
	cpu_memorywrite_d(CPU_ESP + SS_BASE, reg); \
} while (/*CONSTCOND*/ 0)

#define SP_PUSH(reg, clock) \
do { \
	WORD sp = CPU_SP; \
	CPU_SP -= 2; \
	cpu_memorywrite_w(CPU_SP + SS_BASE, sp); \
	CPU_CLOCK(clock); \
} while (/*CONSTCOND*/ 0)

#define ESP_PUSH(reg, clock) \
do { \
	DWORD esp = CPU_ESP; \
	CPU_SP -= 4; \
	cpu_memorywrite_d(CPU_ESP + SS_BASE, esp); \
	CPU_CLOCK(clock); \
} while (/*CONSTCOND*/ 0)

#define REGPOP(reg, clock) \
do { \
	(reg) = cpu_memoryread_w(CPU_SP + SS_BASE); \
	CPU_SP += 2; \
	CPU_CLOCK(clock); \
} while (/*CONSTCOND*/ 0)

#define REGPOP_32(reg, clock) \
do { \
	(reg) = cpu_memoryread_d(CPU_ESP + SS_BASE); \
	CPU_SP += 4; \
	CPU_CLOCK(clock); \
} while (/*CONSTCOND*/ 0)

#define REGPOP0(reg) \
do { \
	(reg) = cpu_memoryread_w(CPU_SP + SS_BASE); \
	CPU_SP += 2; \
} while (/*CONSTCOND*/ 0)

#define REGPOP0_32(reg) \
do { \
	(reg) = cpu_memoryread_d(CPU_ESP + SS_BASE); \
	CPU_SP += 4; \
} while (/*CONSTCOND*/ 0)


#define JMPSHORT(clock) \
do { \
	CPU_CLOCK(clock); \
	CPU_IP += __CBW(cpu_memoryread(CS_BASE + CPU_IP)); \
	CPU_IP++; \
} while (/*CONSTCOND*/ 0)

#define JMPNOP(clock) \
do { \
	CPU_CLOCK(clock); \
	CPU_IP++; \
} while (/*CONSTCOND*/ 0)


#endif	/* NP2_CPU_IA32_IA32_MCR__ */
