/*	$Id: bin_arith.c,v 1.1 2002/12/15 02:57:06 nonaka Exp $	*/

#include "compiler.h"

#include "i286.h"
#include "ia32.mcr"

#include "bin_arith.h"

#include "memory.h"
#include "nevent.h"


//
// ADD
//
void
ADD_EbGb(void)
{
	BYTE *out;
	DWORD op, src, dst, res, madr;

	PREPART_EA_REG8(op, src);
	if (op >= 0xc0) {
		CPU_CLOCK(2);
		out = reg8_b20[op];
	} else {
		CPU_CLOCK(7);
		madr = calc_ea_dst(op);
		if (madr >= MAINMEM_WRITEMAX) {
			dst = cpu_memoryread(madr);
			ADDBYTE(res, dst, src);
			cpu_memorywrite(madr, (BYTE)res);
			return;
		}
		out = mem + madr;
	}
	dst = *out;
	ADDBYTE(res, dst, src);
	*out = (BYTE)res;
}

void
ADD_EwGw(void)
{
	WORD *out;
	DWORD op, src, dst, res, madr;

	PREPART_EA_REG16(op, src);
	if (op >= 0xc0) {
		CPU_CLOCK(2);
		out = reg16_b20[op];
	} else {
		CPU_CLOCK(7);
		madr = calc_ea_dst(op);
		if (INHIBIT_WORDP(madr)) {
			dst = cpu_memoryread_w(madr);
			ADDWORD(res, dst, src);
			cpu_memorywrite_w(madr, (WORD)res);
			return;
		}
		out = (WORD *)(mem + madr);
	}
	dst = *out;
	ADDWORD(res, dst, src);
	*out = (WORD)res;
}

void
ADD_EdGd(void)
{
	DWORD *out;
	DWORD op, src, dst, res, madr;

	PREPART_EA_REG32(op, src);
	if (op >= 0xc0) {
		CPU_CLOCK(2);
		out = reg32_b20[op];
	} else {
		CPU_CLOCK(7);
		madr = calc_ea_dst(op);
		if (INHIBIT_DWORDP(madr)) {
			dst = cpu_memoryread_d(madr);
			ADDDWORD(res, dst, src);
			cpu_memorywrite_d(madr, res);
			return;
		}
		out = (DWORD *)(mem + madr);
	}
	dst = *out;
	ADDDWORD(res, dst, src);
	*out = res;
}

void
ADD_GbEb(void)
{
	BYTE *out;
	DWORD op, src, dst, res;

	PREPART_REG8_EA(op, src, out, 2, 7);
	dst = *out;
	ADDBYTE(res, dst, src);
	*out = (BYTE)res;
}

void
ADD_GwEw(void)
{
	WORD *out;
	DWORD op, src, dst, res;

	PREPART_REG16_EA(op, src, out, 2, 7);
	dst = *out;
	ADDWORD(res, dst, src);
	*out = (WORD)res;
}

void
ADD_GdEd(void)
{
	DWORD *out;
	DWORD op, src, dst, res;

	PREPART_REG32_EA(op, src, out, 2, 7);
	dst = *out;
	ADDDWORD(res, dst, src);
	*out = (DWORD)res;
}

void
ADD_ALIb(void)
{
	DWORD src, res;

	CPU_CLOCK(3);
	GET_PCBYTE(src);
	ADDBYTE(res, CPU_AL, src);
	CPU_AL = (BYTE)res;
}

void
ADD_AXIw(void)
{
	DWORD src, res;

	CPU_CLOCK(3);
	GET_PCWORD(src);
	ADDWORD(res, CPU_AX, src);
	CPU_AX = (WORD)res;
}

void
ADD_EAXId(void)
{
	DWORD src, res;

	CPU_CLOCK(3);
	GET_PCDWORD(src);
	ADDDWORD(res, CPU_EAX, src);
	CPU_EAX = res;
}

void
ADD_EbIb(BYTE *p)
{
	DWORD src, dst, res;

	GET_PCBYTE(src);
	dst = *p;
	ADDBYTE(res, dst, src);
	*p = (BYTE)res;
}

void
ADD_EbIb_ext(DWORD madr)
{
	DWORD src, dst, res;

	GET_PCBYTE(src);
	dst = cpu_memoryread(madr);
	ADDBYTE(res, dst, src);
	cpu_memorywrite(madr, (BYTE)res);
}

void
ADD_EwIx(WORD *p, DWORD src)
{
	DWORD dst, res;

	dst = *p;
	ADDWORD(res, dst, src);
	*p = (WORD)res;
}

void
ADD_EwIx_ext(DWORD madr, DWORD src)
{
	DWORD dst, res;

	dst = cpu_memoryread_w(madr);
	ADDWORD(res, dst, src);
	cpu_memorywrite_w(madr, (WORD)res);
}

void
ADD_EdIx(DWORD *p, DWORD src)
{
	DWORD dst, res;

	dst = *p;
	ADDDWORD(res, dst, src);
	*p = res;
}

void
ADD_EdIx_ext(DWORD madr, DWORD src)
{
	DWORD dst, res;

	dst = cpu_memoryread_d(madr);
	ADDDWORD(res, dst, src);
	cpu_memorywrite_d(madr, res);
}


//
// ADC
//
void
ADC_EbGb(void)
{
	BYTE *out;
	DWORD op, src, dst, res, madr;

	PREPART_EA_REG8(op, src);
	if (op >= 0xc0) {
		CPU_CLOCK(2);
		out = reg8_b20[op];
	} else {
		CPU_CLOCK(7);
		madr = calc_ea_dst(op);
		if (madr >= MAINMEM_WRITEMAX) {
			dst = cpu_memoryread(madr);
			ADCBYTE(res, dst, src);
			cpu_memorywrite(madr, (BYTE)res);
			return;
		}
		out = mem + madr;
	}
	dst = *out;
	ADCBYTE(res, dst, src);
	*out = (BYTE)res;
}

void
ADC_EwGw(void)
{
	WORD *out;
	DWORD op, src, dst, res, madr;

	PREPART_EA_REG16(op, src);
	if (op >= 0xc0) {
		CPU_CLOCK(2);
		out = reg16_b20[op];
	} else {
		CPU_CLOCK(7);
		madr = calc_ea_dst(op);
		if (INHIBIT_WORDP(madr)) {
			dst = cpu_memoryread_w(madr);
			ADCWORD(res, dst, src);
			cpu_memorywrite_w(madr, (WORD)res);
			return;
		}
		out = (WORD *)(mem + madr);
	}
	dst = *out;
	ADCWORD(res, dst, src);
	*out = (WORD)res;
}

void
ADC_EdGd(void)
{
	DWORD *out;
	DWORD op, src, dst, res, madr;

	PREPART_EA_REG16(op, src);
	if (op >= 0xc0) {
		CPU_CLOCK(2);
		out = reg32_b20[op];
	} else {
		CPU_CLOCK(7);
		madr = calc_ea_dst(op);
		if (INHIBIT_DWORDP(madr)) {
			dst = cpu_memoryread_d(madr);
			ADCDWORD(res, dst, src);
			cpu_memorywrite_d(madr, (WORD)res);
			return;
		}
		out = (DWORD *)(mem + madr);
	}
	dst = *out;
	ADCDWORD(res, dst, src);
	*out = res;
}

void
ADC_GbEb(void)
{
	BYTE *out;
	DWORD op, src, dst, res;

	PREPART_REG8_EA(op, src, out, 2, 7);
	dst = *out;
	ADCBYTE(res, dst, src);
	*out = (BYTE)res;
}

void
ADC_GwEw(void)
{
	WORD *out;
	DWORD op, src, dst, res;

	PREPART_REG16_EA(op, src, out, 2, 7);
	dst = *out;
	ADCWORD(res, dst, src);
	*out = (WORD)res;
}

void
ADC_GdEd(void)
{
	DWORD *out;
	DWORD op, src, dst, res;

	PREPART_REG32_EA(op, src, out, 2, 7);
	dst = *out;
	ADCDWORD(res, dst, src);
	*out = res;
}

void
ADC_ALIb(void)
{
	DWORD src, res;

	CPU_CLOCK(3);
	GET_PCBYTE(src);
	ADCBYTE(res, CPU_AL, src);
	CPU_AL = (BYTE)res;
}

void
ADC_AXIw(void)
{
	DWORD src, res;

	CPU_CLOCK(3);
	GET_PCWORD(src);
	ADCWORD(res, CPU_AX, src);
	CPU_AX = (WORD)res;
}

void
ADC_EAXId(void)
{
	DWORD src, res;

	CPU_CLOCK(3);
	GET_PCDWORD(src);
	ADCDWORD(res, CPU_EAX, src);
	CPU_EAX = res;
}

void
ADC_EbIb(BYTE *p)
{
	DWORD src, dst, res;

	GET_PCBYTE(src);
	dst = *p;
	ADCBYTE(res, dst, src);
	*p = (BYTE)res;
}

void
ADC_EbIb_ext(DWORD madr)
{
	DWORD src, dst, res;

	GET_PCBYTE(src);
	dst = cpu_memoryread(madr);
	ADCBYTE(res, dst, src);
	cpu_memorywrite(madr, (BYTE)res);
}

void
ADC_EwIx(WORD *p, DWORD src)
{
	DWORD dst, res;

	dst = *p;
	ADCWORD(res, dst, src);
	*p = (WORD)res;
}

void
ADC_EwIx_ext(DWORD madr, DWORD src)
{
	DWORD dst, res;

	dst = cpu_memoryread_w(madr);
	ADCWORD(res, dst, src);
	cpu_memorywrite_w(madr, (WORD)res);
}

void
ADC_EdIx(DWORD *p, DWORD src)
{
	DWORD dst, res;

	dst = *p;
	ADCDWORD(res, dst, src);
	*p = res;
}

void
ADC_EdIx_ext(DWORD madr, DWORD src)
{
	DWORD dst, res;

	dst = cpu_memoryread_d(madr);
	ADCDWORD(res, dst, src);
	cpu_memorywrite_d(madr, res);
}


//
// SUB
//
void
SUB_EbGb(void)
{
	BYTE *out;
	DWORD op, src, dst, res, madr;

	PREPART_EA_REG8(op, src);
	if (op >= 0xc0) {
		CPU_CLOCK(2);
		out = reg8_b20[op];
	} else {
		CPU_CLOCK(7);
		madr = calc_ea_dst(op);
		if (madr >= MAINMEM_WRITEMAX) {
			dst = cpu_memoryread(madr);
			BYTE_SUB(res, dst, src);
			cpu_memorywrite(madr, (BYTE)res);
			return;
		}
		out = mem + madr;
	}
	dst = *out;
	BYTE_SUB(res, dst, src);
	*out = (BYTE)res;
}

void
SUB_EwGw(void)
{
	WORD *out;
	DWORD op, src, dst, res, madr;

	PREPART_EA_REG16(op, src);
	if (op >= 0xc0) {
		CPU_CLOCK(2);
		out = reg16_b20[op];
	} else {
		CPU_CLOCK(7);
		madr = calc_ea_dst(op);
		if (INHIBIT_WORDP(madr)) {
			dst = cpu_memoryread_w(madr);
			WORD_SUB(res, dst, src);
			cpu_memorywrite_w(madr, (WORD)res);
			return;
		}
		out = (WORD *)(mem + madr);
	}
	dst = *out;
	WORD_SUB(res, dst, src);
	*out = (WORD)res;
}

void
SUB_EdGd(void)
{
	DWORD *out;
	DWORD op, src, dst, res, madr;

	PREPART_EA_REG32(op, src);
	if (op >= 0xc0) {
		CPU_CLOCK(2);
		out = reg32_b20[op];
	} else {
		CPU_CLOCK(7);
		madr = calc_ea_dst(op);
		if (INHIBIT_DWORDP(madr)) {
			dst = cpu_memoryread_d(madr);
			DWORD_SUB(res, dst, src);
			cpu_memorywrite_d(madr, res);
			return;
		}
		out = (DWORD *)(mem + madr);
	}
	dst = *out;
	DWORD_SUB(res, dst, src);
	*out = res;
}

void
SUB_GbEb(void)
{
	BYTE *out;
	DWORD op, src, dst, res;

	PREPART_REG8_EA(op, src, out, 2, 7);
	dst = *out;
	BYTE_SUB(res, dst, src);
	*out = (BYTE)res;
}

void
SUB_GwEw(void)
{
	WORD *out;
	DWORD op, src, dst, res;

	PREPART_REG16_EA(op, src, out, 2, 7);
	dst = *out;
	WORD_SUB(res, dst, src);
	*out = (WORD)res;
}

void
SUB_GdEd(void)
{
	DWORD *out;
	DWORD op, src, dst, res;

	PREPART_REG32_EA(op, src, out, 2, 7);
	dst = *out;
	DWORD_SUB(res, dst, src);
	*out = res;
}

void
SUB_ALIb(void)
{
	DWORD src, res;

	CPU_CLOCK(3);
	GET_PCBYTE(src);
	BYTE_SUB(res, CPU_AL, src);
	CPU_AL = (BYTE)res;
}

void
SUB_AXIw(void)
{
	DWORD src, res;

	CPU_CLOCK(3);
	GET_PCWORD(src);
	WORD_SUB(res, CPU_AX, src);
	CPU_AX = (WORD)res;
}

void
SUB_EAXId(void)
{
	DWORD src, res;

	CPU_CLOCK(3);
	GET_PCDWORD(src);
	DWORD_SUB(res, CPU_EAX, src);
	CPU_EAX = res;
}

void
SUB_EbIb(BYTE *p)
{
	DWORD src, dst, res;

	GET_PCBYTE(src);
	dst = *p;
	BYTE_SUB(res, dst, src);
	*p = (BYTE)res;
}

void
SUB_EbIb_ext(DWORD madr)
{
	DWORD src, dst, res;

	GET_PCBYTE(src);
	dst = cpu_memoryread(madr);
	BYTE_SUB(res, dst, src);
	cpu_memorywrite(madr, (BYTE)res);
}

void
SUB_EwIx(WORD *p, DWORD src)
{
	DWORD dst, res;

	dst = *p;
	WORD_SUB(res, dst, src);
	*p = (WORD)res;
}

void
SUB_EwIx_ext(DWORD madr, DWORD src)
{
	DWORD dst, res;

	dst = cpu_memoryread_w(madr);
	WORD_SUB(res, dst, src);
	cpu_memorywrite_w(madr, (WORD)res);
}

void
SUB_EdIx(DWORD *p, DWORD src)
{
	DWORD dst, res;

	dst = *p;
	DWORD_SUB(res, dst, src);
	*p = res;
}

void
SUB_EdIx_ext(DWORD madr, DWORD src)
{
	DWORD dst, res;

	dst = cpu_memoryread_d(madr);
	DWORD_SUB(res, dst, src);
	cpu_memorywrite_d(madr, res);
}


//
// SBB
//
void
SBB_EbGb(void)
{
	BYTE *out;
	DWORD op, src, dst, res, madr;

	PREPART_EA_REG8(op, src);
	if (op >= 0xc0) {
		CPU_CLOCK(2);
		out = reg8_b20[op];
	} else {
		CPU_CLOCK(7);
		madr = calc_ea_dst(op);
		if (madr >= MAINMEM_WRITEMAX) {
			dst = cpu_memoryread(madr);
			BYTE_SBB(res, dst, src);
			cpu_memorywrite(madr, (BYTE)res);
			return;
		}
		out = mem + madr;
	}
	dst = *out;
	BYTE_SBB(res, dst, src);
	*out = (BYTE)res;
}

void
SBB_EwGw(void)
{
	WORD *out;
	DWORD op, src, dst, res, madr;

	PREPART_EA_REG16(op, src);
	if (op >= 0xc0) {
		CPU_CLOCK(2);
		out = reg16_b20[op];
	} else {
		CPU_CLOCK(7);
		madr = calc_ea_dst(op);
		if (INHIBIT_WORDP(madr)) {
			dst = cpu_memoryread_w(madr);
			WORD_SBB(res, dst, src);
			cpu_memorywrite_w(madr, (WORD)res);
			return;
		}
		out = (WORD *)(mem + madr);
	}
	dst = *out;
	WORD_SBB(res, dst, src);
	*out = (WORD)res;
}

void
SBB_EdGd(void)
{
	DWORD *out;
	DWORD op, src, dst, res, madr;

	PREPART_EA_REG32(op, src);
	if (op >= 0xc0) {
		CPU_CLOCK(2);
		out = reg32_b20[op];
	} else {
		CPU_CLOCK(7);
		madr = calc_ea_dst(op);
		if (INHIBIT_DWORDP(madr)) {
			dst = cpu_memoryread_d(madr);
			DWORD_SBB(res, dst, src);
			cpu_memorywrite_d(madr, res);
			return;
		}
		out = (DWORD *)(mem + madr);
	}
	dst = *out;
	DWORD_SBB(res, dst, src);
	*out = res;
}

void
SBB_GbEb(void)
{
	BYTE *out;
	DWORD op, src, dst, res;

	PREPART_REG8_EA(op, src, out, 2, 7);
	dst = *out;
	BYTE_SBB(res, dst, src);
	*out = (BYTE)res;
}

void
SBB_GwEw(void)
{
	WORD *out;
	DWORD op, src, dst, res;

	PREPART_REG16_EA(op, src, out, 2, 7);
	dst = *out;
	WORD_SBB(res, dst, src);
	*out = (WORD)res;
}

void
SBB_GdEd(void)
{
	DWORD *out;
	DWORD op, src, dst, res;

	PREPART_REG32_EA(op, src, out, 2, 7);
	dst = *out;
	DWORD_SBB(res, dst, src);
	*out = res;
}

void
SBB_ALIb(void)
{
	DWORD src, res;

	CPU_CLOCK(3);
	GET_PCBYTE(src);
	BYTE_SBB(res, CPU_AL, src);
	CPU_AL = (BYTE)res;
}

void
SBB_AXIw(void)
{
	DWORD src, res;

	CPU_CLOCK(3);
	GET_PCWORD(src);
	WORD_SBB(res, CPU_AX, src);
	CPU_AX = (WORD)res;
}

void
SBB_EAXId(void)
{
	DWORD src, res;

	CPU_CLOCK(3);
	GET_PCDWORD(src);
	DWORD_SBB(res, CPU_EAX, src);
	CPU_EAX = res;
}

void
SBB_EbIb(BYTE *p)
{
	DWORD src, dst, res;

	GET_PCBYTE(src);
	dst = *p;
	BYTE_SBB(res, dst, src);
	*p = (BYTE)res;
}

void
SBB_EbIb_ext(DWORD madr)
{
	DWORD src, dst, res;

	GET_PCBYTE(src);
	dst = cpu_memoryread(madr);
	BYTE_SBB(res, dst, src);
	cpu_memorywrite(madr, (BYTE)res);
}

void
SBB_EwIx(WORD *p, DWORD src)
{
	DWORD dst, res;

	dst = *p;
	WORD_SBB(res, dst, src);
	*p = (WORD)res;
}

void
SBB_EwIx_ext(DWORD madr, DWORD src)
{
	DWORD dst, res;

	dst = cpu_memoryread_w(madr);
	WORD_SBB(res, dst, src);
	cpu_memorywrite_w(madr, (WORD)res);
}

void
SBB_EdIx(DWORD *p, DWORD src)
{
	DWORD dst, res;

	dst = *p;
	DWORD_SBB(res, dst, src);
	*p = res;
}

void
SBB_EdIx_ext(DWORD madr, DWORD src)
{
	DWORD dst, res;

	dst = cpu_memoryread_d(madr);
	DWORD_SBB(res, dst, src);
	cpu_memorywrite_d(madr, res);
}


//
// IMUL
//
void
IMUL_ALEb(DWORD op)
{
	BYTE src;
	long res;

	if (op >= 0xc0) {
		CPU_CLOCK(13);
		src = *(reg8_b20[op]);
	} else {
		CPU_CLOCK(16);
		src = cpu_memoryread(calc_ea_dst(op));
	}
	BYTE_IMUL(res, CPU_AL, src);
	CPU_AX = (WORD)res;
}

void
IMUL_AXEw(DWORD op)
{
	short src;
	long res;

	if (op >= 0xc0) {
		CPU_CLOCK(21);
		src = *(reg16_b20[op]);
	} else {
		CPU_CLOCK(24);
		src = cpu_memoryread_w(calc_ea_dst(op));
	}
	WORD_IMUL(res, CPU_AX, src);
	CPU_AX = (WORD)res;
	CPU_DX = (WORD)(res >> 16);
}

void
IMUL_EAXEd(DWORD op)
{
	long src;
	long res;

	if (op >= 0xc0) {
		CPU_CLOCK(21);
		src = *(reg32_b20[op]);
	} else {
		CPU_CLOCK(24);
		src = cpu_memoryread_d(calc_ea_dst(op));
	}
	WORD_IMUL(res, CPU_EAX, src);
	CPU_EAX = res;
	CPU_EDX = CPU_OV;	// Τʤ
}

void
IMUL_GwEw(void)
{
	WORD *out;
	DWORD op, src, dst, res;

	PREPART_REG16_EA(op, src, out, 21, 27);
	dst = *out;
	WORD_IMUL(res, dst, src);
	*out = (WORD)res;
}

void
IMUL_GdEd(void)
{
	DWORD *out;
	DWORD op, src, dst, res;

	PREPART_REG32_EA(op, src, out, 21, 27);
	dst = *out;
	DWORD_IMUL(res, dst, src);
	*out = res;
}

void
IMUL_GwEwIb(void)
{
	WORD *out;
	DWORD op;
	short src, dst;
	long res;

	PREPART_REG16_EA(op, src, out, 21, 24);
	GET_PCBYTE(dst);
	WORD_IMUL(res, dst, src);
	*out = (WORD)res;
}

void
IMUL_GdEdIb(void)
{
	DWORD *out;
	DWORD op;
	long src, dst;
	long res;

	PREPART_REG32_EA(op, src, out, 21, 24);
	GET_PCBYTE(dst);
	DWORD_IMUL(res, dst, src);
	*out = res;
}

void
IMUL_GwEwIw(void)
{
	WORD *out;
	DWORD op;
	short src, dst;
	long res;

	PREPART_REG16_EA(op, src, out, 21, 24);
	GET_PCWORD(dst);
	WORD_IMUL(res, dst, src);
	*out = (WORD)res;
}

void
IMUL_GdEdId(void)
{
	DWORD *out;
	DWORD op;
	long src, dst;
	long res;

	PREPART_REG32_EA(op, src, out, 21, 24);
	GET_PCDWORD(dst);
	DWORD_IMUL(res, dst, src);
	*out = res;
}


//
// MUL
//
void
MUL_ALEb(DWORD op)
{
	BYTE src;
	DWORD res;

	if (op >= 0xc0) {
		CPU_CLOCK(13);
		src = *(reg8_b20[op]);
	} else {
		CPU_CLOCK(16);
		src = cpu_memoryread(calc_ea_dst(op));
	}
	BYTE_MUL(res, CPU_AL, src);
	CPU_AX = (WORD)res;
}

void
MUL_AXEw(DWORD op)
{
	WORD src;
	DWORD res;

	if (op >= 0xc0) {
		CPU_CLOCK(21);
		src = *(reg16_b20[op]);
	} else {
		CPU_CLOCK(24);
		src = cpu_memoryread_w(calc_ea_dst(op));
	}
	WORD_MUL(res, CPU_AX, src);
	CPU_AX = (WORD)res;
	CPU_DX = (WORD)(res >> 16);
}

void
MUL_EAXEd(DWORD op)
{
	DWORD src;
	DWORD res;

	if (op >= 0xc0) {
		CPU_CLOCK(21);
		src = *(reg32_b20[op]);
	} else {
		CPU_CLOCK(24);
		src = cpu_memoryread_d(calc_ea_dst(op));
	}
	WORD_MUL(res, CPU_EAX, src);
	CPU_EAX = res;
	CPU_EDX = CPU_OV;	// Τʤ
}


//
// IDIV
//
void
IDIV_ALIb(DWORD op)
{
	short tmp, r;
	signed char src;
	WORD ip;

	ip = CPU_IP;

	if (op >= 0xc0) {
		CPU_CLOCK(17);
		src = *(reg8_b20[op]);
	} else {
		CPU_CLOCK(25);
		src = cpu_memoryread(calc_ea_dst(op));
	}
	tmp = (short)CPU_AX;
	if (src != 0) {
		r = tmp / src;
		if (!((r + 0x80) & 0xff00)) {
			CPU_AL = (signed char)r;
			CPU_AH = tmp % src;
			return;
		}
	}

	INT_NUM(0, ip - 2);	// 80x86
}

void
IDIV_AXIw(DWORD op)
{
	long tmp, r;
	short src;
	WORD ip;

	ip = CPU_IP;

	if (op >= 0xc0) {
		CPU_CLOCK(17);
		src = *(reg16_b20[op]);
	} else {
		CPU_CLOCK(25);
		src = cpu_memoryread_w(c_calc_ea_dst(op));
	}
	tmp = (long)(((DWORD)CPU_DX << 16) | CPU_AX);
	if (src != 0) {
		r = tmp / src;
		if (!((r + 0x8000) & 0xffff0000)) {
			CPU_AX = (short)r;
			CPU_DX = tmp % src;
			return;
		}
	}

	INT_NUM(0, ip - 2);	// 80x86
}

void
IDIV_EAXId(DWORD op)
{
	long long tmp, r;
	long src;
	WORD ip;

	ip = CPU_IP;

	if (op >= 0xc0) {
		CPU_CLOCK(17);
		src = *(reg32_b20[op]);
	} else {
		CPU_CLOCK(25);
		src = cpu_memoryread_d(calc_ea_dst(op));
	}
	tmp = (long long)(((unsigned long long)CPU_EDX << 32) | CPU_EAX);
	if (src != 0) {
		r = tmp / src;
		if (!((r + 0x80000000) & 0xffffffff00000000)) {
			CPU_EAX = (long)r;
			CPU_EDX = tmp % src;
			return;
		}
	}

	INT_NUM(0, ip - 2);	// 80x86
}


//
// DIV
//
void
DIV_ALIb(DWORD op)
{
	WORD tmp, r;
	BYTE src;
	WORD ip;

	ip = CPU_IP;

	if (op >= 0xc0) {
		CPU_CLOCK(17);
		src = *(reg8_b20[op]);
	} else {
		CPU_CLOCK(25);
		src = cpu_memoryread(calc_ea_dst(op));
	}
	tmp = CPU_AX;
	if (src != 0) {
		r = tmp / src;
		if (!((r + 0x80) & 0xff00)) {
			CPU_AL = (BYTE)r;
			CPU_AH = tmp % src;
			return;
		}
	}

	INT_NUM(0, ip - 2);	// 80x86
}

void
DIV_AXIw(DWORD op)
{
	DWORD tmp, r;
	WORD src;
	WORD ip;

	ip = CPU_IP;

	if (op >= 0xc0) {
		CPU_CLOCK(17);
		src = *(reg16_b20[op]);
	} else {
		CPU_CLOCK(25);
		src = cpu_memoryread_w(c_calc_ea_dst(op));
	}
	tmp = ((DWORD)CPU_DX << 16) | CPU_AX;
	if (src != 0) {
		r = tmp / src;
		if (!((r + 0x8000) & 0xffff0000)) {
			CPU_AX = (WORD)r;
			CPU_DX = tmp % src;
			return;
		}
	}

	INT_NUM(0, ip - 2);	// 80x86
}

void
DIV_EAXId(DWORD op)
{
	unsigned long long tmp, r;
	DWORD src;
	WORD ip;

	ip = CPU_IP;

	if (op >= 0xc0) {
		CPU_CLOCK(17);
		src = *(reg32_b20[op]);
	} else {
		CPU_CLOCK(25);
		src = cpu_memoryread_d(calc_ea_dst(op));
	}
	tmp = ((unsigned long long)CPU_EDX << 32) | CPU_EAX;
	if (src != 0) {
		r = tmp / src;
		if (!((r + 0x80000000) & 0xffffffff00000000)) {
			CPU_EAX = (DWORD)r;
			CPU_EDX = tmp % src;
			return;
		}
	}

	INT_NUM(0, ip - 2);	// 80x86
}


//
// INC
//
void
INC_Eb(DWORD op)
{
	DWORD madr;
	BYTE *out;

	if (op >= 0xc0) {
		CPU_CLOCK(2);
		out = reg8_b20[op];
	} else {
		CPU_CLOCK(7);
		madr = calc_ea_dst(op);
		if (madr >= MAINMEM_WRITEMAX) {
			BYTE value = cpu_memoryread(madr);
			BYTE_INC(value);
			cpu_memorywrite(madr, value);
			return;
		}
		out = mem + madr;
	}
	BYTE_INC(*out);
}

void
INC_Ew(DWORD op)
{
	DWORD madr;
	WORD *out;

	if (op >= 0xc0) {
		CPU_CLOCK(2);
		out = reg16_b20[op];
	} else {
		CPU_CLOCK(7);
		madr = calc_ea_dst(op);
		if (INHIBIT_WORDP(madr)) {
			WORD value = cpu_memoryread_w(madr);
			WORD_INC(value);
			cpu_memorywrite_w(madr, value);
			return;
		}
		out = (WORD *)(mem + madr);
	}
	WORD_INC(*out);
}

void
INC_Ed(DWORD op)
{
	DWORD madr;
	DWORD *out;

	if (op >= 0xc0) {
		CPU_CLOCK(2);
		out = reg32_b20[op];
	} else {
		CPU_CLOCK(7);
		madr = calc_ea_dst(op);
		if (INHIBIT_DWORDP(madr)) {
			DWORD value = cpu_memoryread_d(madr);
			DWORD_INC(value);
			cpu_memorywrite_d(madr, value);
			return;
		}
		out = (DWORD *)(mem + madr);
	}
	DWORD_INC(*out);
}

#define	INCWORD(w, clock) \
do { \
	WORD __bak = (w); \
	(w)++; \
	CPU_OV = (w) & ((w) ^ __bak) & 0x8000; \
	CPU_FLAGL &= C_FLAG; \
	CPU_FLAGL |= (BYTE)(((w) ^ __bak) & A_FLAG); \
	CPU_FLAGL |= szpflag_w[(w)]; \
	CPU_CLOCK(clock); \
} while (/*CONSTCOND*/ 0)

void INC_AX(void) { INCWORD(CPU_AX, 2); }
void INC_CX(void) { INCWORD(CPU_CX, 2); }
void INC_DX(void) { INCWORD(CPU_DX, 2); }
void INC_BX(void) { INCWORD(CPU_BX, 2); }
void INC_SP(void) { INCWORD(CPU_SP, 2); }
void INC_BP(void) { INCWORD(CPU_BP, 2); }
void INC_SI(void) { INCWORD(CPU_SI, 2); }
void INC_DI(void) { INCWORD(CPU_DI, 2); }

#define	INCDWORD(w, clock) \
do { \
	DWORD __bak = (w); \
	(w)++; \
	CPU_OV = (w) & ((w) ^ __bak) & 0x8000; \
	CPU_FLAGL &= C_FLAG; \
	CPU_FLAGL |= (BYTE)(((w) ^ __bak) & A_FLAG); \
	if ((w) == 0) { \
		CPU_FLAGL |= Z_FLAG; \
	} \
	if ((w) & 0x80000000) { \
		CPU_FLAGL |= S_FLAG; \
	} \
	CPU_FLAGL |= szpcflag[(BYTE)(w)] & P_FLAG; \
	CPU_CLOCK(clock); \
} while (/*CONSTCOND*/ 0)

void INC_EAX(void) { INCDWORD(CPU_EAX, 2); }
void INC_ECX(void) { INCDWORD(CPU_ECX, 2); }
void INC_EDX(void) { INCDWORD(CPU_EDX, 2); }
void INC_EBX(void) { INCDWORD(CPU_EBX, 2); }
void INC_ESP(void) { INCDWORD(CPU_ESP, 2); }
void INC_EBP(void) { INCDWORD(CPU_EBP, 2); }
void INC_ESI(void) { INCDWORD(CPU_ESI, 2); }
void INC_EDI(void) { INCDWORD(CPU_EDI, 2); }


//
// DEC
//
void
DEC_Eb(DWORD op)
{
	DWORD madr;
	BYTE *out;

	if (op >= 0xc0) {
		CPU_CLOCK(2);
		out = reg8_b20[op];
	} else {
		CPU_CLOCK(7);
		madr = calc_ea_dst(op);
		if (madr >= MAINMEM_WRITEMAX) {
			BYTE value = cpu_memoryread(madr);
			BYTE_DEC(value);
			cpu_memorywrite(madr, value);
			return;
		}
		out = mem + madr;
	}
	BYTE_DEC(*out);
}

void
DEC_Ew(DWORD op)
{
	DWORD madr;
	WORD *out;

	if (op >= 0xc0) {
		CPU_CLOCK(2);
		out = reg16_b20[op];
	} else {
		CPU_CLOCK(7);
		madr = calc_ea_dst(op);
		if (INHIBIT_WORDP(madr)) {
			WORD value = cpu_memoryread_w(madr);
			WORD_DEC(value);
			cpu_memorywrite_w(madr, value);
			return;
		}
		out = (WORD *)(mem + madr);
	}
	WORD_DEC(*out);
}

void
DEC_Ed(DWORD op)
{
	DWORD madr;
	DWORD *out;

	if (op >= 0xc0) {
		CPU_CLOCK(2);
		out = reg32_b20[op];
	} else {
		CPU_CLOCK(7);
		madr = calc_ea_dst(op);
		if (INHIBIT_DWORDP(madr)) {
			DWORD value = cpu_memoryread_d(madr);
			DWORD_DEC(value);
			cpu_memorywrite_d(madr, value);
			return;
		}
		out = (DWORD *)(mem + madr);
	}
	DWORD_DEC(*out);
}

#define	DECWORD(w, clock) \
do { \
	DWORD __bak = (w); \
	w--; \
	CPU_OV = __bak & (w ^ __bak) & 0x8000; \
	CPU_FLAGL &= C_FLAG; \
	CPU_FLAGL |= (BYTE)((w ^ __bak) & A_FLAG); \
	CPU_FLAGL |= szpflag_w[w]; \
	CPU_CLOCK(clock); \
} while (/*CONSTCOND*/ 0)

void DEC_AX(void) { DECWORD(CPU_AX, 2); }
void DEC_CX(void) { DECWORD(CPU_CX, 2); }
void DEC_DX(void) { DECWORD(CPU_DX, 2); }
void DEC_BX(void) { DECWORD(CPU_BX, 2); }
void DEC_SP(void) { DECWORD(CPU_SP, 2); }
void DEC_BP(void) { DECWORD(CPU_BP, 2); }
void DEC_SI(void) { DECWORD(CPU_SI, 2); }
void DEC_DI(void) { DECWORD(CPU_DI, 2); }

#define	DECDWORD(w, clock) \
do { \
	DWORD __bak = (w); \
	w--; \
	CPU_OV = __bak & (w ^ __bak) & 0x8000; \
	CPU_FLAGL &= C_FLAG; \
	CPU_FLAGL |= (BYTE)((w ^ __bak) & A_FLAG); \
	if ((w) == 0) { \
		CPU_FLAGL |= Z_FLAG; \
	} \
	if ((w) & 0x80000000) { \
		CPU_FLAGL |= S_FLAG; \
	} \
	CPU_FLAGL |= szpcflag[(BYTE)(w)] & P_FLAG; \
	CPU_CLOCK(clock); \
} while (/*CONSTCOND*/ 0)

void DEC_EAX(void) { DECWORD(CPU_EAX, 2); }
void DEC_ECX(void) { DECWORD(CPU_ECX, 2); }
void DEC_EDX(void) { DECWORD(CPU_EDX, 2); }
void DEC_EBX(void) { DECWORD(CPU_EBX, 2); }
void DEC_ESP(void) { DECWORD(CPU_ESP, 2); }
void DEC_EBP(void) { DECWORD(CPU_EBP, 2); }
void DEC_ESI(void) { DECWORD(CPU_ESI, 2); }
void DEC_EDI(void) { DECWORD(CPU_EDI, 2); }


//
// NEG
//
void
NEG_Eb(DWORD op)
{
	BYTE *out;
	DWORD src, dst, madr;

	if (op >= 0xc0) {
		CPU_CLOCK(2);
		out = reg8_b20[op];
	} else {
		CPU_CLOCK(7);
		madr = calc_ea_dst(op);
		if (madr >= I286_MEMWRITEMAX) {
			src = cpu_memoryread(madr);
			BYTE_NEG(dst, src);
			cpu_memorywrite(madr, (BYTE)dst);
			return;
		}
		out = mem + madr;
	}
	src = *out;
	BYTE_NEG(dst, src);
	*out = (BYTE)dst;
}

void
NEG_Ew(DWORD op)
{
	WORD *out;
	DWORD src, dst, madr;

	if (op >= 0xc0) {
		CPU_CLOCK(2);
		out = reg16_b20[op];
	} else {
		CPU_CLOCK(7);
		madr = calc_ea_dst(op);
		if (INHIBIT_WORDP(madr)) {
			src = cpu_memoryread_w(madr);
			WORD_NEG(dst, src);
			cpu_memorywrite_w(madr, (WORD)dst);
			return;
		}
		out = (WORD *)(mem + madr);
	}
	src = *out;
	WORD_NEG(dst, src);
	*out = (WORD)dst;
}

void
NEG_Ed(DWORD op)
{
	DWORD *out;
	DWORD src, dst, madr;

	if (op >= 0xc0) {
		CPU_CLOCK(2);
		out = reg32_b20[op];
	} else {
		CPU_CLOCK(7);
		madr = calc_ea_dst(op);
		if (INHIBIT_DWORDP(madr)) {
			src = cpu_memoryread_d(madr);
			DWORD_NEG(dst, src);
			cpu_memorywrite_d(madr, dst);
			return;
		}
		out = (DWORD *)(mem + madr);
	}
	src = *out;
	DWORD_NEG(dst, src);
	*out = dst;
}


//
// CMP
//
void
CMP_EbGb(void)
{
	BYTE *out;
	DWORD op, src, dst, res, madr;

	PREPART_EA_REG8(op, src);
	if (op >= 0xc0) {
		CPU_CLOCK(2);
		out = reg8_b20[op];
	} else {
		CPU_CLOCK(7);
		madr = calc_ea_dst(op);
		if (madr >= MAINMEM_WRITEMAX) {
			dst = cpu_memoryread(madr);
			BYTE_CMP(res, dst, src);
			return;
		}
		out = mem + madr;
	}
	dst = *out;
	BYTE_CMP(res, dst, src);
}

void
CMP_EwGw(void)
{
	WORD *out;
	DWORD op, src, dst, res, madr;

	PREPART_EA_REG16(op, src);
	if (op >= 0xc0) {
		CPU_CLOCK(2);
		out = reg16_b20[op];
	} else {
		CPU_CLOCK(7);
		madr = calc_ea_dst(op);
		if (INHIBIT_WORDP(madr)) {
			dst = cpu_memoryread_w(madr);
			WORD_CMP(res, dst, src);
			return;
		}
		out = (WORD *)(mem + madr);
	}
	dst = *out;
	WORD_CMP(res, dst, src);
}

void
CMP_EdGd(void)
{
	DWORD *out;
	DWORD op, src, dst, res, madr;

	PREPART_EA_REG32(op, src);
	if (op >= 0xc0) {
		CPU_CLOCK(2);
		out = reg32_b20[op];
	} else {
		CPU_CLOCK(7);
		madr = calc_ea_dst(op);
		if (INHIBIT_DWORDP(madr)) {
			dst = cpu_memoryread_d(madr);
			DWORD_CMP(res, dst, src);
			return;
		}
		out = (DWORD *)(mem + madr);
	}
	dst = *out;
	DWORD_CMP(res, dst, src);
}

void
CMP_GbEb(void)
{
	BYTE *out;
	DWORD op, src, dst, res;

	PREPART_REG8_EA(op, src, out, 2, 7);
	dst = *out;
	BYTE_CMP(res, dst, src);
}

void
CMP_GwEw(void)
{
	WORD *out;
	DWORD op, src, dst, res;

	PREPART_REG16_EA(op, src, out, 2, 7);
	dst = *out;
	WORD_CMP(res, dst, src);
}

void
CMP_GdEd(void)
{
	DWORD *out;
	DWORD op, src, dst, res;

	PREPART_REG32_EA(op, src, out, 2, 7);
	dst = *out;
	DWORD_CMP(res, dst, src);
}

void
CMP_ALIb(void)
{
	DWORD src, res;

	CPU_CLOCK(3);
	GET_PCBYTE(src);
	BYTE_CMP(res, CPU_AL, src);
}

void
CMP_AXIw(void)
{
	DWORD src, res;

	CPU_CLOCK(3);
	GET_PCWORD(src);
	WORD_CMP(res, CPU_AX, src);
}

void
CMP_EAXId(void)
{
	DWORD src, res;

	CPU_CLOCK(3);
	GET_PCDWORD(src);
	DWORD_CMP(res, CPU_EAX, src);
}

void
CMP_EbIb(BYTE *p)
{
	DWORD src, dst, res;

	GET_PCBYTE(src);
	dst = *p;
	BYTE_CMP(res, dst, src);
}

void
CMP_EbIb_ext(DWORD madr)
{
	DWORD src, dst, res;

	GET_PCBYTE(src);
	dst = cpu_memoryread(madr);
	BYTE_CMP(res, dst, src);
}

void
CMP_EwIx(WORD *p, DWORD src)
{
	DWORD dst, res;

	dst = *p;
	WORD_CMP(res, dst, src);
}

void
CMP_EwIx_ext(DWORD madr, DWORD src)
{
	DWORD dst, res;

	dst = cpu_memoryread_w(madr);
	WORD_CMP(res, dst, src);
}

void
CMP_EdIx(DWORD *p, DWORD src)
{
	DWORD dst, res;

	dst = *p;
	DWORD_CMP(res, dst, src);
}

void
CMP_EdIx_ext(DWORD madr, DWORD src)
{
	DWORD dst, res;

	dst = cpu_memoryread_d(madr);
	DWORD_CMP(res, dst, src);
}
