/*	$Id: ctrl_trans.c,v 1.1 2002/12/15 02:57:06 nonaka Exp $	*/

#include "compiler.h"

#include "i286.h"
#include "ia32.mcr"

#include "ctrl_trans.h"

#include "memory.h"
#include "nevent.h"


void
JMP_Jb(void)
{
	WORD ad;

	CPU_CLOCK(7);
	GET_PCBYTES(ad);
	CPU_IP += ad;
}

void
JMP_Jw(void)
{
	WORD ad;

	CPU_CLOCK(7);
	GET_PCWORD(ad);
	CPU_IP += ad;
}

void
JMP_Jd(void)
{
	DWORD ad;

	CPU_CLOCK(7);
	GET_PCDWORD(ad);
	CPU_IP += ad & 0xffff;
}

void
JMP16_Ap(void)
{
	WORD ad;

	CPU_CLOCK(11);
	GET_PCWORD(ad);
	GET_PCWORD(CPU_CS);
	CS_BASE = (DWORD)CPU_CS << 4;
	CPU_IP = ad;
}

void
JMP32_Ap(void)
{
	DWORD ad;

	CPU_CLOCK(11);
	GET_PCDWORD(ad);
	GET_PCWORD(CPU_CS);
	CS_BASE = (DWORD)CPU_CS << 4;
	CPU_IP = ad & 0xffff;
}

void
JMP_Ew(DWORD op)
{

	if (op >= 0xc0) {
		CPU_CLOCK(7);
		CPU_IP = *(reg16_b20[op]);
	} else {
		CPU_CLOCK(11);
		CPU_IP = cpu_memoryread_w(calc_ea_dst(op));
	}
}

void
JMP_Ed(DWORD op)
{

	if (op >= 0xc0) {
		CPU_CLOCK(7);
		CPU_IP = *(reg32_b20[op]) & 0xffff;
	} else {
		CPU_CLOCK(11);
		CPU_IP = cpu_memoryread_d(calc_ea_dst(op)) & 0xffff;
	}
}

void
JMP16_Ep(DWORD op)
{

	CPU_CLOCK(11);
	if (op < 0xc0) {
		WORD ad = get_ea(op);
		CPU_IP = cpu_memoryread_w(ad + EA_FIX);
		ad += 2;
		CPU_IP = cpu_memoryread_w(ad + EA_FIX);
		CS_BASE = (DWORD)CPU_CS << 4;
	} else {
		INT_NUM(6, CPU_EIP - 2);
	}
}

void
JMP32_Ep(DWORD op)
{

	CPU_CLOCK(11);
	if (op < 0xc0) {
		WORD ad = get_ea(op);
		CPU_IP = cpu_memoryread_d(ad + EA_FIX);
		ad += 2;
		CPU_IP = cpu_memoryread_w(ad + EA_FIX);
		CS_BASE = (DWORD)CPU_CS << 4;
	} else {
		INT_NUM(6, CPU_EIP - 2);
	}
}

// jcc
// jo
void
JO_Jb(void)
{

	if (!CPU_OV) {
		CPU_CLOCK(2);
		CPU_IP++;
	} else {
		CPU_CLOCK(7);
		CPU_IP += __CBW(cpu_memoryread(CS_BASE + CPU_IP));
		CPU_IP++;
	}
}

void
JO_Jw(void)
{

	if (!CPU_OV) {
		CPU_CLOCK(2);
		CPU_IP += 2;
	} else {
		CPU_CLOCK(7);
		CPU_IP += cpu_memoryread_w(CS_BASE + CPU_IP);
		CPU_IP += 2;
	}
}

void
JO_Jd(void)
{

	if (!CPU_OV) {
		CPU_CLOCK(2);
		CPU_IP += 4;
	} else {
		CPU_CLOCK(7);
		CPU_IP += cpu_memoryread_d(CS_BASE + CPU_IP);
		CPU_IP += 4;
	}
}

// jno
void
JNO_Jb(void)
{

	if (CPU_OV) {
		CPU_CLOCK(2);
		CPU_IP++;
	} else {
		CPU_CLOCK(7);
		CPU_IP += __CBW(cpu_memoryread(CS_BASE + CPU_IP));
		CPU_IP++;
	}
}

void
JNO_Jw(void)
{

	if (CPU_OV) {
		CPU_CLOCK(2);
		CPU_IP += 2;
	} else {
		CPU_CLOCK(7);
		CPU_IP += cpu_memoryread_w(CS_BASE + CPU_IP);
		CPU_IP += 2;
	}
}

void
JNO_Jd(void)
{

	if (CPU_OV) {
		CPU_CLOCK(2);
		CPU_IP += 4;
	} else {
		CPU_CLOCK(7);
		CPU_IP += cpu_memoryread_d(CS_BASE + CPU_IP);
		CPU_IP += 4;
	}
}

// jc
void
JC_Jb(void)
{

	if (!(CPU_FLAGL & C_FLAG)) {
		CPU_CLOCK(2);
		CPU_IP++;
	} else {
		CPU_CLOCK(7);
		CPU_IP += __CBW(cpu_memoryread(CS_BASE + CPU_IP));
		CPU_IP++;
	}
}

void
JC_Jw(void)
{

	if (!(CPU_FLAGL & C_FLAG)) {
		CPU_CLOCK(2);
		CPU_IP += 2;
	} else {
		CPU_CLOCK(7);
		CPU_IP += cpu_memoryread_w(CS_BASE + CPU_IP);
		CPU_IP += 2;
	}
}

void
JC_Jd(void)
{

	if (!(CPU_FLAGL & C_FLAG)) {
		CPU_CLOCK(2);
		CPU_IP += 4;
	} else {
		CPU_CLOCK(7);
		CPU_IP += cpu_memoryread_d(CS_BASE + CPU_IP);
		CPU_IP += 4;
	}
}

// jnc
void
JNC_Jb(void)
{

	if (CPU_FLAGL & C_FLAG) {
		CPU_CLOCK(2);
		CPU_IP++;
	} else {
		CPU_CLOCK(7);
		CPU_IP += __CBW(cpu_memoryread(CS_BASE + CPU_IP));
		CPU_IP++;
	}
}

void
JNC_Jw(void)
{

	if (CPU_FLAGL & C_FLAG) {
		CPU_CLOCK(2);
		CPU_IP += 2;
	} else {
		CPU_CLOCK(7);
		CPU_IP += cpu_memoryread_w(CS_BASE + CPU_IP);
		CPU_IP += 2;
	}
}

void
JNC_Jd(void)
{

	if (CPU_FLAGL & C_FLAG) {
		CPU_CLOCK(2);
		CPU_IP += 4;
	} else {
		CPU_CLOCK(7);
		CPU_IP += cpu_memoryread_d(CS_BASE + CPU_IP);
		CPU_IP += 4;
	}
}

// jz
void
JZ_Jb(void)
{

	if (!(CPU_FLAGL & Z_FLAG)) {
		CPU_CLOCK(2);
		CPU_IP++;
	} else {
		CPU_CLOCK(7);
		CPU_IP += __CBW(cpu_memoryread(CS_BASE + CPU_IP));
		CPU_IP++;
	}
}

void
JZ_Jw(void)
{

	if (!(CPU_FLAGL & Z_FLAG)) {
		CPU_CLOCK(2);
		CPU_IP += 2;
	} else {
		CPU_CLOCK(7);
		CPU_IP += cpu_memoryread_w(CS_BASE + CPU_IP);
		CPU_IP += 2;
	}
}

void
JZ_Jd(void)
{

	if (!(CPU_FLAGL & Z_FLAG)) {
		CPU_CLOCK(2);
		CPU_IP += 4;
	} else {
		CPU_CLOCK(7);
		CPU_IP += cpu_memoryread_d(CS_BASE + CPU_IP);
		CPU_IP += 4;
	}
}

// jnz
void
JNZ_Jb(void)
{

	if (CPU_FLAGL & Z_FLAG) {
		CPU_CLOCK(2);
		CPU_IP++;
	} else {
		CPU_CLOCK(7);
		CPU_IP += __CBW(cpu_memoryread(CS_BASE + CPU_IP));
		CPU_IP++;
	}
}

void
JNZ_Jw(void)
{

	if (CPU_FLAGL & Z_FLAG) {
		CPU_CLOCK(2);
		CPU_IP += 2;
	} else {
		CPU_CLOCK(7);
		CPU_IP += cpu_memoryread_w(CS_BASE + CPU_IP);
		CPU_IP += 2;
	}
}

void
JNZ_Jd(void)
{

	if (CPU_FLAGL & Z_FLAG) {
		CPU_CLOCK(2);
		CPU_IP += 4;
	} else {
		CPU_CLOCK(7);
		CPU_IP += cpu_memoryread_d(CS_BASE + CPU_IP);
		CPU_IP += 4;
	}
}

// jna
void
JNA_Jb(void)
{

	if (!(CPU_FLAGL & (Z_FLAG | C_FLAG))) {
		CPU_CLOCK(2);
		CPU_IP++;
	} else {
		CPU_CLOCK(7);
		CPU_IP += __CBW(cpu_memoryread(CS_BASE + CPU_IP));
		CPU_IP++;
	}
}

void
JNA_Jw(void)
{

	if (!(CPU_FLAGL & (Z_FLAG | C_FLAG))) {
		CPU_CLOCK(2);
		CPU_IP += 2;
	} else {
		CPU_CLOCK(7);
		CPU_IP += cpu_memoryread_w(CS_BASE + CPU_IP);
		CPU_IP += 2;
	}
}

void
JNA_Jd(void)
{

	if (!(CPU_FLAGL & (Z_FLAG | C_FLAG))) {
		CPU_CLOCK(2);
		CPU_IP += 4;
	} else {
		CPU_CLOCK(7);
		CPU_IP += cpu_memoryread_d(CS_BASE + CPU_IP);
		CPU_IP += 4;
	}
}

// ja
void
JA_Jb(void)
{

	if (CPU_FLAGL & (Z_FLAG | C_FLAG)) {
		CPU_CLOCK(2);
		CPU_IP++;
	} else {
		CPU_CLOCK(7);
		CPU_IP += __CBW(cpu_memoryread(CS_BASE + CPU_IP));
		CPU_IP++;
	}
}

void
JA_Jw(void)
{

	if (CPU_FLAGL & (Z_FLAG | C_FLAG)) {
		CPU_CLOCK(2);
		CPU_IP += 2;
	} else {
		CPU_CLOCK(7);
		CPU_IP += cpu_memoryread_w(CS_BASE + CPU_IP);
		CPU_IP += 2;
	}
}

void
JA_Jd(void)
{

	if (CPU_FLAGL & (Z_FLAG | C_FLAG)) {
		CPU_CLOCK(2);
		CPU_IP += 4;
	} else {
		CPU_CLOCK(7);
		CPU_IP += cpu_memoryread_d(CS_BASE + CPU_IP);
		CPU_IP += 4;
	}
}

// js
void
JS_Jb(void)
{

	if (!(CPU_FLAGL & S_FLAG)) {
		CPU_CLOCK(2);
		CPU_IP++;
	} else {
		CPU_CLOCK(7);
		CPU_IP += __CBW(cpu_memoryread(CS_BASE + CPU_IP));
		CPU_IP++;
	}
}

void
JS_Jw(void)
{

	if (!(CPU_FLAGL & S_FLAG)) {
		CPU_CLOCK(2);
		CPU_IP += 2;
	} else {
		CPU_CLOCK(7);
		CPU_IP += cpu_memoryread_w(CS_BASE + CPU_IP);
		CPU_IP += 2;
	}
}

void
JS_Jd(void)
{

	if (!(CPU_FLAGL & S_FLAG)) {
		CPU_CLOCK(2);
		CPU_IP += 4;
	} else {
		CPU_CLOCK(7);
		CPU_IP += cpu_memoryread_d(CS_BASE + CPU_IP);
		CPU_IP += 4;
	}
}

// jns
void
JNS_Jb(void)
{

	if (CPU_FLAGL & S_FLAG) {
		CPU_CLOCK(2);
		CPU_IP++;
	} else {
		CPU_CLOCK(7);
		CPU_IP += __CBW(cpu_memoryread(CS_BASE + CPU_IP));
		CPU_IP++;
	}
}

void
JNS_Jw(void)
{

	if (CPU_FLAGL & S_FLAG) {
		CPU_CLOCK(2);
		CPU_IP += 2;
	} else {
		CPU_CLOCK(7);
		CPU_IP += cpu_memoryread_w(CS_BASE + CPU_IP);
		CPU_IP += 2;
	}
}

void
JNS_Jd(void)
{

	if (CPU_FLAGL & S_FLAG) {
		CPU_CLOCK(2);
		CPU_IP += 4;
	} else {
		CPU_CLOCK(7);
		CPU_IP += cpu_memoryread_d(CS_BASE + CPU_IP);
		CPU_IP += 4;
	}
}

// jp
void
JP_Jb(void)
{

	if (!(CPU_FLAGL & P_FLAG)) {
		CPU_CLOCK(2);
		CPU_IP++;
	} else {
		CPU_CLOCK(7);
		CPU_IP += __CBW(cpu_memoryread(CS_BASE + CPU_IP));
		CPU_IP++;
	}
}

void
JP_Jw(void)
{

	if (!(CPU_FLAGL & P_FLAG)) {
		CPU_CLOCK(2);
		CPU_IP += 2;
	} else {
		CPU_CLOCK(7);
		CPU_IP += cpu_memoryread_w(CS_BASE + CPU_IP);
		CPU_IP += 2;
	}
}

void
JP_Jd(void)
{

	if (!(CPU_FLAGL & P_FLAG)) {
		CPU_CLOCK(2);
		CPU_IP += 4;
	} else {
		CPU_CLOCK(7);
		CPU_IP += cpu_memoryread_d(CS_BASE + CPU_IP);
		CPU_IP += 4;
	}
}

// jns
void
JNP_Jb(void)
{

	if (CPU_FLAGL & P_FLAG) {
		CPU_CLOCK(2);
		CPU_IP++;
	} else {
		CPU_CLOCK(7);
		CPU_IP += __CBW(cpu_memoryread(CS_BASE + CPU_IP));
		CPU_IP++;
	}
}

void
JNP_Jw(void)
{

	if (CPU_FLAGL & P_FLAG) {
		CPU_CLOCK(2);
		CPU_IP += 2;
	} else {
		CPU_CLOCK(7);
		CPU_IP += cpu_memoryread_w(CS_BASE + CPU_IP);
		CPU_IP += 2;
	}
}

void
JNP_Jd(void)
{

	if (CPU_FLAGL & P_FLAG) {
		CPU_CLOCK(2);
		CPU_IP += 4;
	} else {
		CPU_CLOCK(7);
		CPU_IP += cpu_memoryread_d(CS_BASE + CPU_IP);
		CPU_IP += 4;
	}
}

// jl
void
JL_Jb(void)
{

	if ((!(CPU_FLAGL & S_FLAG)) == (!CPU_OV)) {
		CPU_CLOCK(2);
		CPU_IP++;
	} else {
		CPU_CLOCK(7);
		CPU_IP += __CBW(cpu_memoryread(CS_BASE + CPU_IP));
		CPU_IP++;
	}
}

void
JL_Jw(void)
{

	if ((!(CPU_FLAGL & S_FLAG)) == (!CPU_OV)) {
		CPU_CLOCK(2);
		CPU_IP += 2;
	} else {
		CPU_CLOCK(7);
		CPU_IP += cpu_memoryread_w(CS_BASE + CPU_IP);
		CPU_IP += 2;
	}
}

void
JL_Jd(void)
{

	if ((!(CPU_FLAGL & S_FLAG)) == (!CPU_OV)) {
		CPU_CLOCK(2);
		CPU_IP += 4;
	} else {
		CPU_CLOCK(7);
		CPU_IP += cpu_memoryread_d(CS_BASE + CPU_IP);
		CPU_IP += 4;
	}
}

// jnl
void
JNL_Jb(void)
{

	if ((!(CPU_FLAGL & S_FLAG)) != (!CPU_OV)) {
		CPU_CLOCK(2);
		CPU_IP++;
	} else {
		CPU_CLOCK(7);
		CPU_IP += __CBW(cpu_memoryread(CS_BASE + CPU_IP));
		CPU_IP++;
	}
}

void
JNL_Jw(void)
{

	if ((!(CPU_FLAGL & S_FLAG)) != (!CPU_OV)) {
		CPU_CLOCK(2);
		CPU_IP += 2;
	} else {
		CPU_CLOCK(7);
		CPU_IP += cpu_memoryread_w(CS_BASE + CPU_IP);
		CPU_IP += 2;
	}
}

void
JNL_Jd(void)
{

	if ((!(CPU_FLAGL & S_FLAG)) != (!CPU_OV)) {
		CPU_CLOCK(2);
		CPU_IP += 4;
	} else {
		CPU_CLOCK(7);
		CPU_IP += cpu_memoryread_d(CS_BASE + CPU_IP);
		CPU_IP += 4;
	}
}

// jle
void
JLE_Jb(void)
{

	if ((!(CPU_FLAGL & Z_FLAG)) && ((!(CPU_FLAGL & S_FLAG)) == (!CPU_OV))) {
		CPU_CLOCK(2);
		CPU_IP++;
	} else {
		CPU_CLOCK(7);
		CPU_IP += __CBW(cpu_memoryread(CS_BASE + CPU_IP));
		CPU_IP++;
	}
}

void
JLE_Jw(void)
{

	if ((!(CPU_FLAGL & Z_FLAG)) && ((!(CPU_FLAGL & S_FLAG)) == (!CPU_OV))) {
		CPU_CLOCK(2);
		CPU_IP += 2;
	} else {
		CPU_CLOCK(7);
		CPU_IP += cpu_memoryread_w(CS_BASE + CPU_IP);
		CPU_IP += 2;
	}
}

void
JLE_Jd(void)
{

	if ((!(CPU_FLAGL & Z_FLAG)) && ((!(CPU_FLAGL & S_FLAG)) == (!CPU_OV))) {
		CPU_CLOCK(2);
		CPU_IP += 4;
	} else {
		CPU_CLOCK(7);
		CPU_IP += cpu_memoryread_d(CS_BASE + CPU_IP);
		CPU_IP += 4;
	}
}

// jnle
void
JNLE_Jb(void)
{

	if ((CPU_FLAGL & Z_FLAG) || ((!(CPU_FLAGL & S_FLAG)) != (!CPU_OV))) {
		CPU_CLOCK(2);
		CPU_IP++;
	} else {
		CPU_CLOCK(7);
		CPU_IP += __CBW(cpu_memoryread(CS_BASE + CPU_IP));
		CPU_IP++;
	}
}

void
JNLE_Jw(void)
{

	if ((CPU_FLAGL & Z_FLAG) || ((!(CPU_FLAGL & S_FLAG)) != (!CPU_OV))) {
		CPU_CLOCK(2);
		CPU_IP += 2;
	} else {
		CPU_CLOCK(7);
		CPU_IP += cpu_memoryread_w(CS_BASE + CPU_IP);
		CPU_IP += 2;
	}
}

void
JNLE_Jd(void)
{

	if ((CPU_FLAGL & Z_FLAG) || ((!(CPU_FLAGL & S_FLAG)) != (!CPU_OV))) {
		CPU_CLOCK(2);
		CPU_IP += 4;
	} else {
		CPU_CLOCK(7);
		CPU_IP += cpu_memoryread_d(CS_BASE + CPU_IP);
		CPU_IP += 4;
	}
}

// jcxz
void
JeCXZ_Jb(void)
{

	if (!CPU_INST_AS32) {
		if (CPU_CX) {
			CPU_CLOCK(4);
			CPU_IP++;
		} else {
			CPU_CLOCK(8);
			CPU_IP += __CBW(cpu_memoryread(CS_BASE + CPU_IP));
			CPU_IP++;
		}
	} else {
		if (CPU_ECX) {
			CPU_CLOCK(4);
			CPU_IP++;
		} else {
			CPU_CLOCK(8);
			CPU_IP += __CBW(cpu_memoryread(CS_BASE + CPU_IP));
			CPU_IP++;
		}
	}
}

// loopne
void
LOOPNE_Jb(void)
{

	if (!CPU_INST_AS32) {
		CPU_CX--;
		if (CPU_CX == 0 || (CPU_FLAGL & Z_FLAG)) {
			CPU_CLOCK(4);
			CPU_IP++;
		} else {
			CPU_CLOCK(8);
			CPU_IP += __CBW(cpu_memoryread(CS_BASE + CPU_IP));
			CPU_IP++;
		}
	} else {
		CPU_ECX--;
		if (CPU_ECX == 0 || (CPU_FLAGL & Z_FLAG)) {
			CPU_CLOCK(4);
			CPU_IP++;
		} else {
			CPU_CLOCK(8);
			CPU_IP += __CBW(cpu_memoryread(CS_BASE + CPU_IP));
			CPU_IP++;
		}
	}
}

// loope
void
LOOPE_Jb(void)
{

	if (!CPU_INST_AS32) {
		CPU_CX--;
		if (CPU_CX == 0 || !(CPU_FLAGL & Z_FLAG)) {
			CPU_CLOCK(4);
			CPU_IP++;
		} else {
			CPU_CLOCK(8);
			CPU_IP += __CBW(cpu_memoryread(CS_BASE + CPU_IP));
			CPU_IP++;
		}
	} else {
		CPU_ECX--;
		if (CPU_ECX == 0 || !(CPU_FLAGL & Z_FLAG)) {
			CPU_CLOCK(4);
			CPU_IP++;
		} else {
			CPU_CLOCK(8);
			CPU_IP += __CBW(cpu_memoryread(CS_BASE + CPU_IP));
			CPU_IP++;
		}
	}
}

// loope
void
LOOPE_Jb(void)
{

	if (!CPU_INST_AS32) {
		CPU_CX--;
		if (CPU_CX) {
			CPU_CLOCK(4);
			CPU_IP++;
		} else {
			CPU_CLOCK(8);
			CPU_IP += __CBW(cpu_memoryread(CS_BASE + CPU_IP));
			CPU_IP++;
		}
	} else {
		CPU_ECX--;
		if (CPU_ECX) {
			CPU_CLOCK(4);
			CPU_IP++;
		} else {
			CPU_CLOCK(8);
			CPU_IP += __CBW(cpu_memoryread(CS_BASE + CPU_IP));
			CPU_IP++;
		}
	}
}

// call
void
CALL_Aw(void)
{
	WORD ad;

	CPU_CLOCK(7);
	GET_PCWORD(ad);
	REGPUSH0(CPU_IP);
	CPU_IP += ad;
}

void
CALL_Ad(void)
{
	DWORD ad;

	CPU_CLOCK(7);
	GET_PCDWORD(ad);
	REGPUSH0_32(CPU_EIP);
	CPU_EIP += ad;
}

void
CALL_Ew(DWORD op)
{
	WORD ad;

	if (op >= 0xc0) {
		CPU_CLOCK(7);
		ad = *(reg16_b20[op]);
		REGPUSH0(CPU_IP);
		CPU_IP = ad;
	} else {
		CPU_CLOCK(11);
		ad = cpu_memoryread_w(calc_ea_dst(op));
		REGPUSH0(CPU_IP);
		CPU_IP = ad;
	}
}

void
CALL_Ed(DWORD op)
{
	DWORD ad;

	if (op >= 0xc0) {
		CPU_CLOCK(7);
		ad = *(reg32_b20[op]);
		REGPUSH0_32(CPU_EIP);
		CPU_EIP = ad;
	} else {
		CPU_CLOCK(11);
		ad = cpu_memoryread_d(calc_ea_dst(op));
		REGPUSH0_32(CPU_EIP);
		CPU_EIP = ad;
	}
}

void
CALL16_Ap(void)
{
	WORD new_ip;

	CPU_CLOCK(13);
	REGPUSH0(CPU_CS);
	GET_PCWORD(new_ip);
	GET_PCWORD(CPU_CS);
	CS_BASE = (DWORD)CPU_CS << 4;
	REGPUSH0(CPU_IP);
	CPU_IP = new_ip;
}

void
CALL32_Ap(void)
{
	DWORD new_ip;

	CPU_CLOCK(13);
	REGPUSH0_32(CPU_CS);
	GET_PCDWORD(new_ip);
	GET_PCWORD(CPU_CS);
	CS_BASE = (DWORD)CPU_CS << 4;
	REGPUSH0_32(CPU_EIP);
	CPU_EIP = new_ip;
}

void
CALL16_Ep(DWORD op)
{

	if (op < 0xc0) {
		WORD ad;

		CPU_CLOCK(16);
		ad = get_ea(op);
		REGPUSH0(CPU_CS);
		REGPUSH0(CPU_IP);
		CPU_IP = cpu_memoryread_w(ad + EA_FIX);
		ad += 2;
		CPU_CS = cpu_memoryread_w(ad + EA_FIX);
		CS_BASE = (DWORD)CPU_CS << 4;
	} else {
		INT_NUM(6, CPU_EIP - 2);
	}
}

void
CALL32_Ep(DWORD op)
{

	if (op < 0xc0) {
		DWORD ad;

		CPU_CLOCK(16);
		ad = get_ea(op);
		REGPUSH0_32(CPU_CS);
		REGPUSH0_32(CPU_EIP);
		CPU_IP = cpu_memoryread_d(ad + EA_FIX);
		ad += 4;
		CPU_CS = cpu_memoryread_w(ad + EA_FIX);
		CS_BASE = (DWORD)CPU_CS << 4;
	} else {
		INT_NUM(6, CPU_EIP - 2);
	}
}

// ret
void
RETnear16(void)
{

	CPU_CLOCK(11);
	REGPOP0(CPU_IP);
}

void
RETnear32(void)
{

	CPU_CLOCK(11);
	REGPOP0_32(CPU_EIP);
}

void
RETnear16_Iw(void)
{

	WORD ad;

	CPU_CLOCK(11);
	GET_PCWORD(ad);
	REGPOP0(CPU_IP);
	CPU_SP += ad;
}

void
RETnear32_Iw(void)
{

	WORD ad;

	CPU_CLOCK(11);
	GET_PCDWORD(ad);
	REGPOP0_32(CPU_EIP);
	CPU_ESP += ad;
}

void
RETfar16(void)
{

	CPU_CLOCK(15);
	REGPOP0(CPU_IP);
	REGPOP0(CPU_CS);
	CS_BASE = (DWORD)CPU_CS << 4;
}

void
RETfar32(void)
{

	CPU_CLOCK(15);
	REGPOP0_32(CPU_EIP);
	REGPOP0_32(CPU_CS);
	CS_BASE = (DWORD)CPU_CS << 4;
}

void
RETfar16_Iw(void)
{
	WORD ad;

	CPU_CLOCK(15);
	GET_PCWORD(ad);
	REGPOP0(CPU_IP);
	REGPOP0(CPU_CS);
	CS_BASE = (DWORD)CPU_CS << 4;
	CPU_SP += ad;
}

void
RETfar32_Iw(void)
{
	DWORD ad;

	CPU_CLOCK(15);
	GET_PCDWORD(ad);
	REGPOP0_32(CPU_EIP);
	REGPOP0_32(CPU_CS);
	CS_BASE = (DWORD)CPU_CS << 4;
	CPU_ESP += ad;
}

void
IRET(void)
{

	CPU_CLOCK(31);
	REGPOP0(CPU_IP);
	REGPOP0(CPU_CS);
	REGPOP0(CPU_FLAG);
	CPU_OV = CPU_FLAG & O_FLAG;
	CPU_FLAG &= 0x7fd7;
	CPU_TRAP = (CPU & 0x300) == 0x300;
	CS_BASE = (DWORD)CPU_CS << 4;

	IRQCHECKTERM();
}

void
IRETD(void)
{

	CPU_CLOCK(31);
	REGPOP0_32(CPU_EIP);
	REGPOP0_32(CPU_CS);
	REGPOP0_32(CPU_EFLAG);
	CPU_OV = CPU_FLAG & O_FLAG;
	CPU_EFLAG &= 0x00277fd7;
	CPU_TRAP = (CPU & 0x300) == 0x300;
	CS_BASE = (DWORD)CPU_CS << 4;

	IRQCHECKTERM();
}

void
INT1(void)
{

	CPU_CLOCK(23);
	INT_NUM(1, CPU_EIP);
}

void
INT3(void)
{

	CPU_CLOCK(23);
	INT_NUM(3, CPU_EIP);
}

void
INTO(void)
{

	if (CPU_OV) {
		CPU_CLOCK(24);
		INT_NUM(4, CPU_EIP);
	} else {
		CPU_CLOCK(4);
	}
}

void
INT_Ib(void)
{
	BYTE vect;

	CPU_CLOCK(23);
	GET_PCBYTE(vect);
	INT_NUM(vect, CPU_EIP);
}

void
BOUND_GwMa(void)
{
	DWORD vect = 0;
	DWORD op;
	DWORD madr;
	WORD reg;

	CPU_CLOCK(13);
	GET_PCBYTE(op);
	if (op < 0xc0) {
		reg = *(reg16_b53[op]);
		madr = calc_ea_dst(op);
		if (reg >= cpu_memoryread_w(madr)) {
			madr += 2;
			if (reg <= cpu_memoryread_w(madr)) {
				return;
			}
		}
		vect = 5;
	} else {
		vect = 6;
	}
	INT_NUM(vect, CPU_EIP);
}

void
BOUND_GwMa(void)
{
	DWORD vect = 0;
	DWORD op;
	DWORD madr;
	DWORD reg;

	CPU_CLOCK(13);
	GET_PCBYTE(op);
	if (op < 0xc0) {
		reg = *(reg32_b53[op]);
		madr = calc_ea_dst(op);
		if (reg >= cpu_memoryread_d(madr)) {
			madr += 4;
			if (reg <= cpu_memoryread_d(madr)) {
				return;
			}
		}
		vect = 5;
	} else {
		vect = 6;
	}
	INT_NUM(vect, CPU_EIP);
}

void
ENTER_IwIb(void)
{
	WORD dimsize;
	BYTE level;

	GET_PCWORD(dimsize);
	GET_PCBYTE(level);
	REGPUSH0(CPU_BP);

	level &= 0x1f;
	if (!level) {				// enter level=0
		CPU_CLOCK(11);
		CPU_BP = CPU_SP;
		CPU_SP -= dimsize;
	} else {
		level--;
		if (!level) {			// enter level=1
			WORD tmp;

			CPU_CLOCK(15);
			tmp = CPU_SP;
			REGPUSH0(tmp);
			CPU_BP = tmp;
			CPU_SP -= dimsize;
		} else {			// enter level=2-31
			WORD bp;

			CPU_CLOCK(12 + level * 4);
			bp = CPU_BP;
			CPU_BP = CPU_SP;
			while(level--) {
				WORD val = cpu_memoryread_w(bp + SS_BASE);
				cpu_memorywrite_w(CPU_SP + SS_BASE, val);
				bp -= 2;
				CPU_SP -= 2;
			}
			REGPUSH0(CPU_BP);
			CPU_SP -= dimsize;
		}
	}
}

void
LEAVE16(void)
{

	CPU_CLOCK(5);
	CPU_SP = CPU_BP;
	REGPOP0(CPU_BP);
}

void
LEAVE32(void)
{

	CPU_CLOCK(5);
	CPU_ESP = CPU_EBP;
	REGPOP0_32(CPU_EBP);
}
