/*	$Id: interface.c,v 1.1 2002/12/15 02:57:59 nonaka Exp $	*/

#include "compiler.h"

#include "cpu.h"
#include "ia32.mcr"
#include "iobridge.h"
#include "dmac.h"
#include "nevent.h"


void
ia32reset(void)
{

	cpu_init();
#ifdef USE_FPU
	fpu_init();
#endif

	CPU_CS = 0x1fc0;
	CS_BASE = 0x1fc00;
}

void
ia32(void)
{

	do {
		exec_1step();
	} while (nevent.remainclock > 0);
}

void
ia32withtrap(void)
{

	do {
		exec_1step();
		if (CPU_TRAP) {
			ia32_interrupt(1);
		}
	} while (nevent.remainclock > 0);
}

void
ia32withdma(void)
{

	do {
		exec_1step();
		dma_proc();
	} while (nevent.remainclock > 0);
}

void
ia32_step(void)
{

	do {
		exec_1step();
		if (CPU_TRAP) {
			ia32_interrupt(1);
		}
		dma_proc();
	} while (nevent.remainclock > 0);
}
