/*	$Id: resolve.c,v 1.1 2002/12/15 02:57:59 nonaka Exp $	*/

#include "compiler.h"

#include "cpu.h"
#include "ia32.mcr"
#include "resolve.h"


static DWORD (*calc_ea_dst_tbl[0x100])(void);
static WORD (*calc_lea_tbl[0xc0])(void);
static WORD (*get_ea_tbl[0xc0])(void);
static DWORD (*calc_ea32_dst_tbl[0x100])(void);
static DWORD (*calc_lea32_tbl[0xc0])(void);
static DWORD (*get_ea32_tbl[0xc0])(void);

DWORD EA_FIX;


DWORD
calc_ea_dst(DWORD op)
{

	if (!CPU_INST_AS32)
		return (*calc_ea_dst_tbl[op])();
	return (*calc_ea32_dst_tbl[op])();
}

DWORD
calc_lea(DWORD op)
{

	if (!CPU_INST_AS32)
		return (*calc_lea_tbl[op])();
	return (*calc_lea32_tbl[op])();
}

DWORD
get_ea(DWORD op)
{

	if (!CPU_INST_AS32)
		return (*get_ea_tbl[op])();
	return (*get_ea32_tbl[op])();
}


//
// common
//

DWORD
ea_nop(void)
{

	return 0;
}

#define	DS_FIX	((CPU_INST_SEGUSE) ? (DS_BASE) : (CPU_INST_SEGBASE))
#define	SS_FIX	((CPU_INST_SEGUSE) ? (SS_BASE) : (CPU_INST_SEGBASE))


//
// 16bit
//

//
// ea_dest
//
static DWORD
ea_bx_si(void)
{

	return ((CPU_BX + CPU_SI) & 0x0000ffff) + DS_FIX;
}

static DWORD
ea_bx_si_disp8(void)
{
	long adrs;

	GET_PCBYTESD(adrs);
	return ((adrs + CPU_BX + CPU_SI) & 0x0000ffff) + DS_FIX;
}

static DWORD
ea_bx_si_disp16(void)
{
	DWORD adrs;

	GET_PCWORD(adrs);
	return (((adrs + CPU_BX + CPU_SI) & 0x0000ffff) + DS_FIX);
}

static DWORD
ea_bx_di(void)
{

	return (((CPU_BX + CPU_DI) & 0x0000ffff) + DS_FIX);
}

static DWORD
ea_bx_di_disp8(void)
{
	long adrs;

	GET_PCBYTESD(adrs);
	return (((adrs + CPU_BX + CPU_DI) & 0x0000ffff) + DS_FIX);
}

static DWORD
ea_bx_di_disp16(void)
{
	DWORD adrs;

	GET_PCWORD(adrs);
	return (((adrs + CPU_BX + CPU_DI) & 0x0000ffff) + DS_FIX);
}

static DWORD
ea_bp_si(void)
{

	return (((CPU_BP + CPU_SI) & 0x0000ffff) + SS_FIX);
}

static DWORD
ea_bp_si_disp8(void)
{
	long adrs;

	GET_PCBYTESD(adrs);
	return (((adrs + CPU_BP + CPU_SI) & 0x0000ffff) + SS_FIX);
}

static DWORD
ea_bp_si_disp16(void)
{
	DWORD adrs;

	GET_PCWORD(adrs);
	return (((adrs + CPU_BP + CPU_SI) & 0x0000ffff) + SS_FIX);
}

static DWORD
ea_bp_di(void)
{

	return (((CPU_BP + CPU_DI) & 0x0000ffff) + SS_FIX);
}

static DWORD
ea_bp_di_disp8(void)
{
	long adrs;

	GET_PCBYTESD(adrs);
	return (((adrs + CPU_BP + CPU_DI) & 0x0000ffff) + SS_FIX);
}

static DWORD
ea_bp_di_disp16(void)
{
	DWORD adrs;

	GET_PCWORD(adrs);
	return (((adrs + CPU_BP + CPU_DI) & 0x0000ffff) + SS_FIX);
}

static DWORD
ea_si(void)
{

	return (CPU_SI + DS_FIX);
}

static DWORD
ea_si_disp8(void)
{
	long adrs;

	GET_PCBYTESD(adrs);
	return (((adrs + CPU_SI) & 0x0000ffff) + DS_FIX);
}

static DWORD
ea_si_disp16(void)
{
	DWORD adrs;

	GET_PCWORD(adrs);
	return (((adrs + CPU_SI) & 0x0000ffff) + DS_FIX);
}

static DWORD
ea_di(void)
{

	return (CPU_DI + DS_FIX);
}

static DWORD
ea_di_disp8(void)
{
	long adrs;

	GET_PCBYTESD(adrs);
	return (((adrs + CPU_DI) & 0x0000ffff) + DS_FIX);
}

static DWORD
ea_di_disp16(void)
{
	DWORD adrs;

	GET_PCWORD(adrs);
	return (((adrs + CPU_DI) & 0x0000ffff) + DS_FIX);
}

static DWORD
ea_disp16(void)
{
	DWORD adrs;

	GET_PCWORD(adrs);
	return ((adrs & 0x0000ffff) + DS_FIX);
}

static DWORD
ea_bp_disp8(void)
{
	long adrs;

	GET_PCBYTESD(adrs);
	return (((adrs + CPU_BP) & 0x0000ffff) + SS_FIX);
}

static DWORD
ea_bp_disp16(void)
{
	DWORD adrs;

	GET_PCWORD(adrs);
	return (((adrs + CPU_BP) & 0x0000ffff) + SS_FIX);
}

static DWORD
ea_bx(void)
{

	return (CPU_BX + DS_FIX);
}

static DWORD
ea_bx_disp8(void)
{
	long adrs;

	GET_PCBYTESD(adrs);
	return (((adrs + CPU_BX) & 0x0000ffff) + DS_FIX);
}

static DWORD
ea_bx_disp16(void)
{
	DWORD adrs;

	GET_PCWORD(adrs);
	return (((adrs + CPU_BX) & 0x0000ffff) + DS_FIX);
}

static DWORD (*c_ea_dst_tbl[])(void) = {
	ea_bx_si,		ea_bx_di,
	ea_bp_si,		ea_bp_di,
	ea_si,			ea_di,
	ea_disp16,		ea_bx,
	ea_bx_si_disp8,		ea_bx_di_disp8,
	ea_bp_si_disp8,		ea_bp_di_disp8,
	ea_si_disp8,		ea_di_disp8,
	ea_bp_disp8,		ea_bx_disp8,
	ea_bx_si_disp16,	ea_bx_di_disp16,
	ea_bp_si_disp16,	ea_bp_di_disp16,
	ea_si_disp16,		ea_di_disp16,
	ea_bp_disp16,		ea_bx_disp16,
};

//
// lea
//
static WORD 
lea_bx_si(void)
{

	return (CPU_BX + CPU_SI);
}

static WORD 
lea_bx_si_disp8(void)
{
	WORD adrs;

	GET_PCBYTES(adrs);
	return (adrs + CPU_BX + CPU_SI);
}

static WORD 
lea_bx_si_disp16(void)
{
	WORD adrs;

	GET_PCWORD(adrs);
	return (adrs + CPU_BX + CPU_SI);
}

static WORD 
lea_bx_di(void)
{

	return (CPU_BX + CPU_DI);
}

static WORD 
lea_bx_di_disp8(void)
{
	WORD adrs;

	GET_PCBYTES(adrs);
	return (adrs + CPU_BX + CPU_DI);
}

static WORD 
lea_bx_di_disp16(void)
{
	WORD adrs;

	GET_PCWORD(adrs);
	return (adrs + CPU_BX + CPU_DI);
}

static WORD 
lea_bp_si(void)
{

	return (CPU_BP + CPU_SI);
}

static WORD 
lea_bp_si_disp8(void)
{

	WORD	adrs;

	GET_PCBYTES(adrs);
	return (adrs + CPU_BP + CPU_SI);
}

static WORD 
lea_bp_si_disp16(void)
{
	WORD adrs;

	GET_PCWORD(adrs);
	return (adrs + CPU_BP + CPU_SI);
}

static WORD 
lea_bp_di(void)
{

	return (CPU_BP + CPU_DI);
}

static WORD 
lea_bp_di_disp8(void)
{
	WORD adrs;

	GET_PCBYTES(adrs);
	return (adrs + CPU_BP + CPU_DI);
}

static WORD 
lea_bp_di_disp16(void)
{
	WORD adrs;

	GET_PCWORD(adrs);
	return (adrs + CPU_BP + CPU_DI);
}

static WORD 
lea_si(void)
{

	return (CPU_SI);
}

static WORD 
lea_si_disp8(void)
{
	WORD adrs;

	GET_PCBYTES(adrs);
	return (adrs + CPU_SI);
}

static WORD 
lea_si_disp16(void)
{
	WORD adrs;

	GET_PCWORD(adrs);
	return (adrs + CPU_SI);
}

static WORD 
lea_di(void)
{

	return (CPU_DI);
}

static WORD 
lea_di_disp8(void)
{
	WORD adrs;

	GET_PCBYTES(adrs);
	return (adrs + CPU_DI);
}

static WORD 
lea_di_disp16(void)
{
	WORD adrs;

	GET_PCWORD(adrs);
	return (adrs + CPU_DI);
}

static WORD 
lea_disp16(void)
{
	WORD adrs;

	GET_PCWORD(adrs);
	return (adrs);
}

static WORD 
lea_bp_disp8(void)
{
	WORD adrs;

	GET_PCBYTES(adrs);
	return (adrs + CPU_BP);
}

static WORD 
lea_bp_disp16(void)
{
	WORD adrs;

	GET_PCWORD(adrs);
	return (adrs + CPU_BP);
}

static WORD 
lea_bx(void)
{

	return (CPU_BX);
}

static WORD 
lea_bx_disp8(void)
{
	WORD adrs;

	GET_PCBYTES(adrs);
	return (adrs + CPU_BX);
}

static WORD 
lea_bx_disp16(void)
{
	WORD adrs;

	GET_PCWORD(adrs);
	return (adrs + CPU_BX);
}

static WORD (*c_lea_tbl[])(void) = {
	lea_bx_si,		lea_bx_di,
	lea_bp_si,		lea_bp_di,
	lea_si,			lea_di,
	lea_disp16,		lea_bx,
	lea_bx_si_disp8,	lea_bx_di_disp8,
	lea_bp_si_disp8,	lea_bp_di_disp8,
	lea_si_disp8,		lea_di_disp8,
	lea_bp_disp8,		lea_bx_disp8,
	lea_bx_si_disp16,	lea_bx_di_disp16,
	lea_bp_si_disp16,	lea_bp_di_disp16,
	lea_si_disp16,		lea_di_disp16,
	lea_bp_disp16,		lea_bx_disp16
};

//
// ea
//
static WORD 
a_bx_si(void)
{

	EA_FIX = DS_FIX;
	return (CPU_BX + CPU_SI);
}

static WORD 
a_bx_si_disp8(void)
{
	WORD adrs;

	EA_FIX = DS_FIX;
	GET_PCBYTES(adrs);
	return (adrs + CPU_BX + CPU_SI);
}

static WORD 
a_bx_si_disp16(void)
{
	WORD adrs;

	EA_FIX = DS_FIX;
	GET_PCWORD(adrs);
	return (adrs + CPU_BX + CPU_SI);
}

static WORD 
a_bx_di(void)
{

	EA_FIX = DS_FIX;
	return (CPU_BX + CPU_DI);
}

static WORD 
a_bx_di_disp8(void)
{
	WORD adrs;

	EA_FIX = DS_FIX;
	GET_PCBYTES(adrs);
	return (adrs + CPU_BX + CPU_DI);
}

static WORD 
a_bx_di_disp16(void)
{
	WORD adrs;

	EA_FIX = DS_FIX;
	GET_PCWORD(adrs);
	return (adrs + CPU_BX + CPU_DI);
}

static WORD 
a_bp_si(void)
{

	EA_FIX = SS_FIX;
	return (CPU_BP + CPU_SI);
}

static WORD 
a_bp_si_disp8(void)
{
	WORD adrs;

	EA_FIX = SS_FIX;
	GET_PCBYTES(adrs);
	return (adrs + CPU_BP + CPU_SI);
}

static WORD 
a_bp_si_disp16(void)
{
	WORD adrs;

	EA_FIX = SS_FIX;
	GET_PCWORD(adrs);
	return (adrs + CPU_BP + CPU_SI);
}

static WORD 
a_bp_di(void)
{

	EA_FIX = SS_FIX;
	return (CPU_BP + CPU_DI);
}

static WORD 
a_bp_di_disp8(void)
{
	WORD adrs;

	EA_FIX = SS_FIX;
	GET_PCBYTES(adrs);
	return (adrs + CPU_BP + CPU_DI);
}

static WORD 
a_bp_di_disp16(void)
{
	WORD adrs;

	EA_FIX = SS_FIX;
	GET_PCWORD(adrs);
	return (adrs + CPU_BP + CPU_DI);
}

static WORD 
a_si(void)
{

	EA_FIX = DS_FIX;
	return (CPU_SI);
}

static WORD 
a_si_disp8(void)
{
	WORD adrs;

	EA_FIX = DS_FIX;
	GET_PCBYTES(adrs);
	return (adrs + CPU_SI);
}

static WORD 
a_si_disp16(void)
{
	WORD adrs;

	EA_FIX = DS_FIX;
	GET_PCWORD(adrs);
	return (adrs + CPU_SI);
}

static WORD 
a_di(void)
{

	EA_FIX = DS_FIX;
	return (CPU_DI);
}

static WORD 
a_di_disp8(void)
{
	WORD adrs;

	EA_FIX = DS_FIX;
	GET_PCBYTES(adrs);
	return (adrs + CPU_DI);
}

static WORD 
a_di_disp16(void)
{
	WORD adrs;

	EA_FIX = DS_FIX;
	GET_PCWORD(adrs);
	return (adrs + CPU_DI);
}

static WORD 
a_disp16(void)
{
	WORD adrs;

	EA_FIX = DS_FIX;
	GET_PCWORD(adrs);
	return (adrs);
}

static WORD 
a_bp_disp8(void)
{
	WORD adrs;

	EA_FIX = SS_FIX;
	GET_PCBYTESD(adrs);
	return (adrs + CPU_BP);
}

static WORD 
a_bp_disp16(void)
{
	WORD adrs;

	EA_FIX = SS_FIX;
	GET_PCWORD(adrs);
	return (adrs + CPU_BP);
}

static WORD 
a_bx(void)
{

	EA_FIX = DS_FIX;
	return (CPU_BX);
}

static WORD 
a_bx_disp8(void)
{
	WORD adrs;

	EA_FIX = DS_FIX;
	GET_PCBYTES(adrs);
	return (adrs + CPU_BX);
}

static WORD 
a_bx_disp16(void)
{
	WORD adrs;

	EA_FIX = DS_FIX;
	GET_PCWORD(adrs);
	return (adrs + CPU_BX);
}

static WORD (*c_ea_tbl[])(void) = {
	a_bx_si,		a_bx_di,
	a_bp_si,		a_bp_di,
	a_si,			a_di,
	a_disp16,		a_bx,
	a_bx_si_disp8,		a_bx_di_disp8,
	a_bp_si_disp8,		a_bp_di_disp8,
	a_si_disp8,		a_di_disp8,
	a_bp_disp8,		a_bx_disp8,
	a_bx_si_disp16,		a_bx_di_disp16,
	a_bp_si_disp16,		a_bp_di_disp16,
	a_si_disp16,		a_di_disp16,
	a_bp_disp16,		a_bx_disp16
};


//
// 32bit
//

// ea_dest sib
static DWORD
sib_eax(DWORD base, DWORD scale)
{

	return (CPU_EAX << scale) + base;
}

static DWORD
sib_ecx(DWORD base, DWORD scale)
{

	return (CPU_ECX << scale) + base;
}

static DWORD
sib_edx(DWORD base, DWORD scale)
{

	return (CPU_EDX << scale) + base;
}

static DWORD
sib_ebx(DWORD base, DWORD scale)
{

	return (CPU_EBX << scale) + base;
}

static DWORD
sib_none(DWORD base, DWORD scale)
{

	return 0;
}

static DWORD
sib_ebp(DWORD base, DWORD scale)
{

	return (CPU_EBP << scale) + base;
}

static DWORD
sib_esi(DWORD base, DWORD scale)
{

	return (CPU_ESI << scale) + base;
}

static DWORD
sib_edi(DWORD base, DWORD scale)
{

	return (CPU_EDI << scale) + base;
}

static DWORD (*sib_table[])(DWORD, DWORD) = {
	sib_eax,	sib_ecx,
	sib_edx,	sib_ebx,
	sib_none,	sib_ebp,
	sib_esi,	sib_edi,
};

//
// ea_dest 32
//
static DWORD
ea32_eax(void)
{

	return CPU_EAX + DS_FIX;
}

static DWORD
ea32_ecx(void)
{

	return CPU_ECX + DS_FIX;
}

static DWORD
ea32_edx(void)
{

	return CPU_EDX + DS_FIX;
}

static DWORD
ea32_ebx(void)
{

	return CPU_EBX + DS_FIX;
}

static DWORD
ea32_sib(void)
{
	DWORD op, base;

	GET_PCBYTE(op);
	switch (op & 7) {
	case 4:
		return (*sib_table[(op >> 3) & 7])(CPU_ESP, op >> 6) + SS_FIX;

	case 5:
		GET_DWORD(base);
		break;

	default:
		base = cpu_regs.u.reg[op & 7].d;
		break;
	}
	return (*sib_table[(op >> 3) & 7])(base, op >> 6) + DS_FIX;
}

static DWORD
ea32_disp32(void)
{
	DWORD adrs;

	GET_PCDWORD(adrs);
	return adrs + DS_FIX;
}

static DWORD
ea32_esi(void)
{

	return CPU_ESI + DS_FIX;
}

static DWORD
ea32_edi(void)
{

	return CPU_EDI + DS_FIX;
}

static DWORD
ea32_eax_disp8(void)
{
	long adrs;

	GET_PCBYTESD(adrs);
	return adrs + CPU_EAX + DS_FIX;
}

static DWORD
ea32_ecx_disp8(void)
{
	long adrs;

	GET_PCBYTESD(adrs);
	return adrs + CPU_ECX + DS_FIX;
}

static DWORD
ea32_edx_disp8(void)
{
	long adrs;

	GET_PCBYTESD(adrs);
	return adrs + CPU_EDX + DS_FIX;
}

static DWORD
ea32_ebx_disp8(void)
{
	long adrs;

	GET_PCBYTESD(adrs);
	return adrs + CPU_EBX + DS_FIX;
}

static DWORD
ea32_sib_disp8(void)
{
	DWORD op, base;
	long adrs;

	GET_PCBYTE(op);
	GET_PCBYTESD(adrs);
	switch (op & 7) {
	case 4:
		return (*sib_table[(op >> 3) & 7])(CPU_ESP, op >> 6) + adrs + SS_FIX;

	case 5:
		return (*sib_table[(op >> 3) & 7])(CPU_EBP, op >> 6) + adrs + SS_FIX;
		break;

	default:
		base = cpu_regs.u.reg[op & 7].d;
		break;
	}
	return (*sib_table[(op >> 3) & 7])(base, op >> 6) + adrs + DS_FIX;
}

static DWORD
ea32_ebp_disp8(void)
{
	long adrs;

	GET_PCBYTESD(adrs);
	return adrs + CPU_EBP + SS_FIX;
}

static DWORD
ea32_esi_disp8(void)
{
	long adrs;

	GET_PCBYTESD(adrs);
	return adrs + CPU_ESI + DS_FIX;
}

static DWORD
ea32_edi_disp8(void)
{
	long adrs;

	GET_PCBYTESD(adrs);
	return adrs + CPU_EDI + DS_FIX;
}

static DWORD
ea32_eax_disp32(void)
{
	DWORD adrs;

	GET_PCDWORD(adrs);
	return adrs + CPU_EAX + DS_FIX;
}

static DWORD
ea32_ecx_disp32(void)
{
	DWORD adrs;

	GET_PCDWORD(adrs);
	return adrs + CPU_ECX + DS_FIX;
}

static DWORD
ea32_edx_disp32(void)
{
	DWORD adrs;

	GET_PCDWORD(adrs);
	return adrs + CPU_EDX + DS_FIX;
}

static DWORD
ea32_ebx_disp32(void)
{
	DWORD adrs;

	GET_PCDWORD(adrs);
	return adrs + CPU_EBX + DS_FIX;
}

static DWORD
ea32_sib_disp32(void)
{
	DWORD op, base;
	DWORD adrs;

	GET_PCBYTE(op);
	GET_PCDWORD(adrs);
	switch (op & 7) {
	case 4:
		return (*sib_table[(op >> 3) & 7])(CPU_ESP, op >> 6) + adrs + SS_FIX;

	case 5:
		return (*sib_table[(op >> 3) & 7])(CPU_EBP, op >> 6) + adrs + SS_FIX;
		break;

	default:
		base = cpu_regs.u.reg[op & 7].d;
		break;
	}
	return (*sib_table[(op >> 3) & 7])(base, op >> 6) + adrs + DS_FIX;
}

static DWORD
ea32_ebp_disp32(void)
{
	DWORD adrs;

	GET_PCDWORD(adrs);
	return adrs + CPU_EBP + SS_FIX;
}

static DWORD
ea32_esi_disp32(void)
{
	DWORD adrs;

	GET_PCDWORD(adrs);
	return adrs + CPU_ESI + DS_FIX;
}

static DWORD
ea32_edi_disp32(void)
{
	DWORD adrs;

	GET_PCDWORD(adrs);
	return adrs + CPU_EDI + DS_FIX;
}

static DWORD (*c_ea32_dst_tbl[])(void) = {
	ea32_eax,		ea32_ecx, 
	ea32_edx,		ea32_ebx,
	ea32_sib,		ea32_disp32,
	ea32_esi,		ea32_edi,
	ea32_eax_disp8,		ea32_ecx_disp8, 
	ea32_edx_disp8,		ea32_ebx_disp8,
	ea32_sib_disp8,		ea32_ebp_disp8,
	ea32_esi_disp8,		ea32_edi_disp8,
	ea32_eax_disp32,	ea32_ecx_disp32, 
	ea32_edx_disp32,	ea32_ebx_disp32,
	ea32_sib_disp32,	ea32_ebp_disp32,
	ea32_esi_disp32,	ea32_edi_disp32,
};

//
// lea 32
//
static DWORD
lea32_eax(void)
{

	return CPU_EAX;
}

static DWORD
lea32_ecx(void)
{

	return CPU_ECX;
}

static DWORD
lea32_edx(void)
{

	return CPU_EDX;
}

static DWORD
lea32_ebx(void)
{

	return CPU_EBX;
}

static DWORD
lea32_sib(void)
{
	DWORD op, base;

	GET_PCBYTE(op);
	switch (op & 7) {
	case 4:
		return (*sib_table[(op >> 3) & 7])(CPU_ESP, op >> 6);

	case 5:
		GET_DWORD(base);
		break;

	default:
		base = cpu_regs.u.reg[op & 7].d;
		break;
	}
	return (*sib_table[(op >> 3) & 7])(base, op >> 6);
}

static DWORD
lea32_disp32(void)
{
	DWORD adrs;

	GET_PCDWORD(adrs);
	return adrs;
}

static DWORD
lea32_esi(void)
{

	return CPU_ESI;
}

static DWORD
lea32_edi(void)
{

	return CPU_EDI;
}

static DWORD
lea32_eax_disp8(void)
{
	long adrs;

	GET_PCBYTESD(adrs);
	return adrs + CPU_EAX;
}

static DWORD
lea32_ecx_disp8(void)
{
	long adrs;

	GET_PCBYTESD(adrs);
	return adrs + CPU_ECX;
}

static DWORD
lea32_edx_disp8(void)
{
	long adrs;

	GET_PCBYTESD(adrs);
	return adrs + CPU_EDX;
}

static DWORD
lea32_ebx_disp8(void)
{
	long adrs;

	GET_PCBYTESD(adrs);
	return adrs + CPU_EBX;
}

static DWORD
lea32_sib_disp8(void)
{
	DWORD op;
	long adrs;

	GET_PCBYTE(op);
	GET_PCBYTESD(adrs);
	return (*sib_table[(op >> 3) & 7])(cpu_regs.u.reg[op & 7].d, op >> 6) + adrs;
}

static DWORD
lea32_ebp_disp8(void)
{
	long adrs;

	GET_PCBYTESD(adrs);
	return adrs + CPU_EBP;
}

static DWORD
lea32_esi_disp8(void)
{
	long adrs;

	GET_PCBYTESD(adrs);
	return adrs + CPU_ESI;
}

static DWORD
lea32_edi_disp8(void)
{
	long adrs;

	GET_PCBYTESD(adrs);
	return adrs + CPU_EDI;
}

static DWORD
lea32_eax_disp32(void)
{
	DWORD adrs;

	GET_PCDWORD(adrs);
	return adrs + CPU_EAX;
}

static DWORD
lea32_ecx_disp32(void)
{
	DWORD adrs;

	GET_PCDWORD(adrs);
	return adrs + CPU_ECX;
}

static DWORD
lea32_edx_disp32(void)
{
	DWORD adrs;

	GET_PCDWORD(adrs);
	return adrs + CPU_EDX;
}

static DWORD
lea32_ebx_disp32(void)
{
	DWORD adrs;

	GET_PCDWORD(adrs);
	return adrs + CPU_EBX;
}

static DWORD
lea32_sib_disp32(void)
{
	DWORD op;
	DWORD adrs;

	GET_PCBYTE(op);
	GET_PCDWORD(adrs);
	return (*sib_table[(op >> 3) & 7])(cpu_regs.u.reg[op & 7].d, op >> 6) + adrs;
}

static DWORD
lea32_ebp_disp32(void)
{
	DWORD adrs;

	GET_PCDWORD(adrs);
	return adrs + CPU_EBP;
}

static DWORD
lea32_esi_disp32(void)
{
	DWORD adrs;

	GET_PCDWORD(adrs);
	return adrs + CPU_ESI;
}

static DWORD
lea32_edi_disp32(void)
{
	DWORD adrs;

	GET_PCDWORD(adrs);
	return adrs + CPU_EDI;
}

static DWORD (*c_lea32_tbl[])(void) = {
	lea32_eax,		lea32_ecx, 
	lea32_edx,		lea32_ebx,
	lea32_sib,		lea32_disp32,
	lea32_esi,		lea32_edi,
	lea32_eax_disp8,	lea32_ecx_disp8, 
	lea32_edx_disp8,	lea32_ebx_disp8,
	lea32_sib_disp8,	lea32_ebp_disp8,
	lea32_esi_disp8,	lea32_edi_disp8,
	lea32_eax_disp32,	lea32_ecx_disp32, 
	lea32_edx_disp32,	lea32_ebx_disp32,
	lea32_sib_disp32,	lea32_ebp_disp32,
	lea32_esi_disp32,	lea32_edi_disp32,
};

//
// ea 32
//
static DWORD
a32_eax(void)
{

	EA_FIX = DS_FIX;
	return CPU_EAX;
}

static DWORD
a32_ecx(void)
{

	EA_FIX = DS_FIX;
	return CPU_ECX;
}

static DWORD
a32_edx(void)
{

	EA_FIX = DS_FIX;
	return CPU_EDX;
}

static DWORD
a32_ebx(void)
{

	EA_FIX = DS_FIX;
	return CPU_EBX;
}

static DWORD
a32_sib(void)
{
	DWORD op, base;

	GET_PCBYTE(op);
	switch (op & 7) {
	case 4:
		EA_FIX = SS_FIX;
		return (*sib_table[(op >> 3) & 7])(CPU_ESP, op >> 6);

	case 5:
		EA_FIX = DS_FIX;
		GET_DWORD(base);
		break;

	default:
		EA_FIX = DS_FIX;
		base = cpu_regs.u.reg[op & 7].d;
		break;
	}
	return (*sib_table[(op >> 3) & 7])(base, op >> 6);
}

static DWORD
a32_disp32(void)
{
	DWORD adrs;

	EA_FIX = DS_FIX;
	GET_PCDWORD(adrs);
	return adrs;
}

static DWORD
a32_esi(void)
{

	EA_FIX = DS_FIX;
	return CPU_ESI;
}

static DWORD
a32_edi(void)
{

	EA_FIX = DS_FIX;
	return CPU_EDI;
}

static DWORD
a32_eax_disp8(void)
{
	long adrs;

	EA_FIX = DS_FIX;
	GET_PCBYTESD(adrs);
	return adrs + CPU_EAX;
}

static DWORD
a32_ecx_disp8(void)
{
	long adrs;

	EA_FIX = DS_FIX;
	GET_PCBYTESD(adrs);
	return adrs + CPU_ECX;
}

static DWORD
a32_edx_disp8(void)
{
	long adrs;

	EA_FIX = DS_FIX;
	GET_PCBYTESD(adrs);
	return adrs + CPU_EDX;
}

static DWORD
a32_ebx_disp8(void)
{
	long adrs;

	EA_FIX = DS_FIX;
	GET_PCBYTESD(adrs);
	return adrs + CPU_EBX;
}

static DWORD
a32_sib_disp8(void)
{
	DWORD op;
	long adrs;

	GET_PCBYTE(op);
	GET_PCBYTESD(adrs);
	switch (op & 7) {
	case 4:
	case 5:
		EA_FIX = SS_FIX;
		return (*sib_table[(op >> 3) & 7])(cpu_regs.u.reg[op & 7].d, op >> 6) + adrs;

	default:
		EA_FIX = DS_FIX;
		return (*sib_table[(op >> 3) & 7])(cpu_regs.u.reg[op & 7].d, op >> 6) + adrs;
	}
}

static DWORD
a32_ebp_disp8(void)
{
	long adrs;

	EA_FIX = SS_FIX;
	GET_PCBYTESD(adrs);
	return adrs + CPU_EBP;
}

static DWORD
a32_esi_disp8(void)
{
	long adrs;

	EA_FIX = DS_FIX;
	GET_PCBYTESD(adrs);
	return adrs + CPU_ESI;
}

static DWORD
a32_edi_disp8(void)
{
	long adrs;

	EA_FIX = DS_FIX;
	GET_PCBYTESD(adrs);
	return adrs + CPU_EDI;
}

static DWORD
a32_eax_disp32(void)
{
	DWORD adrs;

	EA_FIX = DS_FIX;
	GET_PCDWORD(adrs);
	return adrs + CPU_EAX;
}

static DWORD
a32_ecx_disp32(void)
{
	DWORD adrs;

	EA_FIX = DS_FIX;
	GET_PCDWORD(adrs);
	return adrs + CPU_ECX;
}

static DWORD
a32_edx_disp32(void)
{
	DWORD adrs;

	EA_FIX = DS_FIX;
	GET_PCDWORD(adrs);
	return adrs + CPU_EDX;
}

static DWORD
a32_ebx_disp32(void)
{
	DWORD adrs;

	EA_FIX = DS_FIX;
	GET_PCDWORD(adrs);
	return adrs + CPU_EBX;
}

static DWORD
a32_sib_disp32(void)
{
	DWORD op;
	DWORD adrs;

	GET_PCBYTE(op);
	GET_PCDWORD(adrs);
	switch (op & 7) {
	case 4:
	case 5:
		EA_FIX = SS_FIX;
		return (*sib_table[(op >> 3) & 7])(cpu_regs.u.reg[op & 7].d, op >> 6) + adrs;

	default:
		EA_FIX = DS_FIX;
		return (*sib_table[(op >> 3) & 7])(cpu_regs.u.reg[op & 7].d, op >> 6) + adrs;
	}
}

static DWORD
a32_ebp_disp32(void)
{
	DWORD adrs;

	EA_FIX = SS_FIX;
	GET_PCDWORD(adrs);
	return adrs + CPU_EBP;
}

static DWORD
a32_esi_disp32(void)
{
	DWORD adrs;

	EA_FIX = DS_FIX;
	GET_PCDWORD(adrs);
	return adrs + CPU_ESI;
}

static DWORD
a32_edi_disp32(void)
{
	DWORD adrs;

	EA_FIX = DS_FIX;
	GET_PCDWORD(adrs);
	return adrs + CPU_EDI;
}

static DWORD (*c_ea32_tbl[])(void) = {
	a32_eax,	a32_ecx, 
	a32_edx,	a32_ebx,
	a32_sib,	a32_disp32,
	a32_esi,	a32_edi,
	a32_eax_disp8,	a32_ecx_disp8, 
	a32_edx_disp8,	a32_ebx_disp8,
	a32_sib_disp8,	a32_ebp_disp8,
	a32_esi_disp8,	a32_edi_disp8,
	a32_eax_disp32,	a32_ecx_disp32, 
	a32_edx_disp32,	a32_ebx_disp32,
	a32_sib_disp32,	a32_ebp_disp32,
	a32_esi_disp32,	a32_edi_disp32,
};


//
// init table
//
void
resolve_init(void)
{
	int i, pos;

	for (i = 0; i < 0xc0; ++i) {
		pos = ((i >> 3) & 0x18) + (i & 0x07);
		calc_ea_dst_tbl[i] = c_ea_dst_tbl[pos];
		calc_ea32_dst_tbl[i] = c_ea32_dst_tbl[pos];
		calc_lea_tbl[i] = c_lea_tbl[pos];
		calc_lea32_tbl[i] = c_lea32_tbl[pos];
		get_ea_tbl[i] = c_ea_tbl[pos];
		get_ea32_tbl[i] = c_ea32_tbl[pos];
	}
	for (; i < 0x100; ++i) {
		calc_ea_dst_tbl[i] = ea_nop;
		calc_ea32_dst_tbl[i] = ea_nop;
	}
}
