#include	"compiler.h"

#ifndef NP2_MEMORY_ASM

#include	"memory.h"
#include	"i286.h"
#include	"np2pc98.h"
#include	"iobridge.h"
#include	"gdc.h"
#include	"vram.h"
#include	"font.h"
#include	"cgrom.h"
#include	"extmem.h"
#include	"nevent.h"
#include	"egc.h"
#include	"egcwork.h"
#include	"crtc.h"


#ifdef __cplusplus
extern "C" {
#endif
extern	BYTE	itf_bank;
#ifdef __cplusplus
}
#endif


// ---------------------------------------------------------------- write byte

static void MEM_CALL i286_wt(DWORD address, BYTE value) {

	MEM_SETB((address & extmem.adrsmask), value);
}

static void MEM_CALL tram_wt(DWORD address, BYTE value) {

	nevent.remainclock -= vramop.tramwait;
	if (address < 0xa2000) {
		MEM_SETB(address, value);
		tramupdate[(address >> 1) & 0x0fff] = 1;
		gdcs.textdisp |= 1;
	}
	else if (address < 0xa3fe0) {
		if (!(address & 1)) {
			MEM_SETB(address, value);
			tramupdate[(address >> 1) & 0x0fff] = 1;
			gdcs.textdisp |= 1;
		}
	}
	else if (address < 0xa4000) {
		if (!(address & 1)) {
			if ((!(address & 2)) || (gdcs.msw_accessable)) {
				MEM_SETB(address, value);
				tramupdate[(address >> 1) & 0x0fff] = 1;
				gdcs.textdisp |= 1;
			}
		}
	}
	else if (address < 0xa5000) {
		if ((address & 1) && (cgwindow.writable & 1)) {
			cgwindow.writable |= 0x80;
			font[cgwindow.high + ((address >> 1) & 0x0f)] = value;
		}
	}
}

static void MEM_CALL vram_w0(DWORD address, BYTE value) {

	nevent.remainclock -= vramop.vramwait;
	MEM_SETB(address, value);
	vramupdate[address & 0x7fff] |= 1;
	gdcs.grphdisp |= 1;
}

static void MEM_CALL vram_w1(DWORD address, BYTE value) {

	nevent.remainclock -= vramop.vramwait;
	MEM_SETB(address + VRAM_STEP, value);
	vramupdate[address & 0x7fff] |= 2;
	gdcs.grphdisp |= 2;
}

static void MEM_CALL grcg_rmw0(DWORD address, BYTE value) {

	BYTE	mask;

	nevent.remainclock -= vramop.grcgwait;
	mask = ~value;
	address &= 0x7fff;
	vramupdate[address] |= 1;
	gdcs.grphdisp |= 1;

	if (!(grcg.modereg & 1)) {
		mem[address + VRAM0_B] &= mask;
		mem[address + VRAM0_B] |= (value & grcg.tile[0].b[0]);
	}
	if (!(grcg.modereg & 2)) {
		mem[address + VRAM0_R] &= mask;
		mem[address + VRAM0_R] |= (value & grcg.tile[1].b[0]);
	}
	if (!(grcg.modereg & 4)) {
		mem[address + VRAM0_G] &= mask;
		mem[address + VRAM0_G] |= (value & grcg.tile[2].b[0]);
	}
	if (!(grcg.modereg & 8)) {
		mem[address + VRAM0_E] &= mask;
		mem[address + VRAM0_E] |= (value & grcg.tile[3].b[0]);
	}
}

static void MEM_CALL grcg_rmw1(DWORD address, BYTE value) {

	BYTE	mask;

	nevent.remainclock -= vramop.grcgwait;
	mask = ~value;
	address &= 0x7fff;
	vramupdate[address] |= 2;
	gdcs.grphdisp |= 2;

	if (!(grcg.modereg & 1)) {
		mem[address + VRAM1_B] &= mask;
		mem[address + VRAM1_B] |= (value & grcg.tile[0].b[0]);
	}
	if (!(grcg.modereg & 2)) {
		mem[address + VRAM1_R] &= mask;
		mem[address + VRAM1_R] |= (value & grcg.tile[1].b[0]);
	}
	if (!(grcg.modereg & 4)) {
		mem[address + VRAM1_G] &= mask;
		mem[address + VRAM1_G] |= (value & grcg.tile[2].b[0]);
	}
	if (!(grcg.modereg & 8)) {
		mem[address + VRAM1_E] &= mask;
		mem[address + VRAM1_E] |= (value & grcg.tile[3].b[0]);
	}
}

static void MEM_CALL grcg_tdw0(DWORD address, BYTE value) {

	nevent.remainclock -= vramop.grcgwait;
	address &= 0x7fff;
	vramupdate[address] |= 1;
	gdcs.grphdisp |= 1;
	if (!(grcg.modereg & 1)) {
		mem[address + VRAM0_B] = grcg.tile[0].b[0];
	}
	if (!(grcg.modereg & 2)) {
		mem[address + VRAM0_R] = grcg.tile[1].b[0];
	}
	if (!(grcg.modereg & 4)) {
		mem[address + VRAM0_G] = grcg.tile[2].b[0];
	}
	if (!(grcg.modereg & 8)) {
		mem[address + VRAM0_E] = grcg.tile[3].b[0];
	}
}

static void MEM_CALL grcg_tdw1(DWORD address, BYTE value) {

	nevent.remainclock -= vramop.grcgwait;
	address &= 0x7fff;
	vramupdate[address] |= 2;
	gdcs.grphdisp |= 2;
	if (!(grcg.modereg & 1)) {
		mem[address + VRAM1_B] = grcg.tile[0].b[0];
	}
	if (!(grcg.modereg & 2)) {
		mem[address + VRAM1_R] = grcg.tile[1].b[0];
	}
	if (!(grcg.modereg & 4)) {
		mem[address + VRAM1_G] = grcg.tile[2].b[0];
	}
	if (!(grcg.modereg & 8)) {
		mem[address + VRAM1_E] = grcg.tile[3].b[0];
	}
}

static void MEM_CALL egc_wt(DWORD address, BYTE value) {

	egc_write(address, value);
}

static void MEM_CALL emmc_wt(DWORD address, BYTE value) {

	extmem.pageptr[(address >> 14) & 3][address & 0x3fff] = value;
}

static void MEM_CALL i286_wn(DWORD address, BYTE value) { }


// ----------------------------------------------------------------- read byte

static BYTE MEM_CALL i286_rd(DWORD address) {

	return(MEM_GETB(address & extmem.adrsmask));
}

static BYTE MEM_CALL tram_rd(DWORD address) {

	nevent.remainclock -= vramop.tramwait;
	if (address < 0xa4000) {
		return(MEM_GETB(address));
	}
	else if (address < 0xa5000) {
		if (address & 1) {
			return(font[cgwindow.high + ((address >> 1) & 0x0f)]);
		}
		else {
			return(font[cgwindow.low + ((address >> 1) & 0x0f)]);
		}
	}
	return(MEM_GETB(address));
}

static BYTE MEM_CALL vram_r0(DWORD address) {

	nevent.remainclock -= vramop.vramwait;
	return(MEM_GETB(address));
}

static BYTE MEM_CALL vram_r1(DWORD address) {

	nevent.remainclock -= vramop.vramwait;
	return(MEM_GETB(address + VRAM_STEP));
}

static BYTE MEM_CALL grcg_tcr0(DWORD address) {

	BYTE	ret;

	nevent.remainclock -= vramop.grcgwait;
	ret = 0;
	address &= 0x7fff;
	if (!(grcg.modereg & 1)) {
		ret |= mem[address + VRAM0_B] ^ grcg.tile[0].b[0];
	}
	if (!(grcg.modereg & 2)) {
		ret |= mem[address + VRAM0_R] ^ grcg.tile[1].b[0];
	}
	if (!(grcg.modereg & 4)) {
		ret |= mem[address + VRAM0_G] ^ grcg.tile[2].b[0];
	}
	if (!(grcg.modereg & 8)) {
		ret |= mem[address + VRAM0_E] ^ grcg.tile[3].b[0];
	}
	return(~ret);
}

static BYTE MEM_CALL grcg_tcr1(DWORD address) {

	BYTE	ret;

	nevent.remainclock -= vramop.grcgwait;
	ret = 0;
	address &= 0x7fff;
	if (!(grcg.modereg & 1)) {
		ret |= mem[address + VRAM1_B] ^ grcg.tile[0].b[0];
	}
	if (!(grcg.modereg & 2)) {
		ret |= mem[address + VRAM1_R] ^ grcg.tile[1].b[0];
	}
	if (!(grcg.modereg & 4)) {
		ret |= mem[address + VRAM1_G] ^ grcg.tile[2].b[0];
	}
	if (!(grcg.modereg & 8)) {
		ret |= mem[address + VRAM1_E] ^ grcg.tile[3].b[0];
	}
	return(~ret);
}

static BYTE MEM_CALL egc_rd(DWORD address) {

	return(egc_read(address));
}

static BYTE MEM_CALL emmc_rd(DWORD address) {

	return(extmem.pageptr[(address >> 14) & 3][address & 0x3fff]);
}

static BYTE MEM_CALL i286_itf(DWORD address) {

	if (itf_bank) {
		address = ITF_ADRS + (address & 0x7fff);
	}
	return(MEM_GETB(address));
}


// ---------------------------------------------------------------- write word

static void MEM_CALL i286w_wt(DWORD address, WORD value) {

	MEM_SETW((address & extmem.adrsmask), value);
}

static void MEM_CALL tramw_wt(DWORD address, WORD value) {

	if (address < 0xa1fff) {
		MEM_SETW(address, value);
		SETWORD(tramupdate + ((address >> 1) & 0x0fff), 0x0101);
		gdcs.textdisp |= 1;
	}
	else if (address == 0xa1fff) {
		MEM_SETW(0xa1fff, value);
		tramupdate[0] = 1;
		tramupdate[0xfff] = 1;
		gdcs.textdisp |= 1;
	}
	else if (address < 0xa3fe0) {
		if (address & 1) {
			address++;
			value >>= 8;
		}
		MEM_SETB(address, (BYTE)value);
		tramupdate[(address >> 1) & 0x0fff] = 1;
		gdcs.textdisp |= 1;
	}
	else if (address < 0xa3fff) {
		if (address & 1) {
			address++;
			value >>= 8;
		}
		if ((!(address & 2)) || (gdcs.msw_accessable)) {
			MEM_SETB(address, (BYTE)value);
			tramupdate[(address >> 1) & 0x0fff] = 1;
			gdcs.textdisp |= 1;
		}
	}
	else if (address < 0xa5000) {
		if (address & 1) {
			value >>= 8;
		}
		if (cgwindow.writable & 1) {
			cgwindow.writable |= 0x80;
			font[cgwindow.high + ((address >> 1) & 0x0f)] = (BYTE)value;
		}
	}
}



#ifdef NP2_LITTLEENDIAN
#define GRCGW_NON(page) {											\
	nevent.remainclock -= vramop.vramwait;							\
	MEM_SETW(address + VRAM_STEP*(page), value);					\
	*(WORD *)(vramupdate + (address & 0x7fff)) |= (0x0101 << page);	\
	gdcs.grphdisp |= (1 << page);									\
}
#endif
#ifdef NP2_BIGENDIAN
#define GRCGW_NON(page) {											\
	nevent.remainclock -= vramop.vramwait;							\
	MEM_SETW(address + VRAM_STEP*(page), value);					\
	vramupdate[address & 0x7fff] |= (1 << page);					\
	vramupdate[(address + 1) & 0x7fff] |= (1 << page);				\
	gdcs.grphdisp |= (1 << page);									\
}
#endif


#ifdef NP2_LITTLEENDIAN
#define GRCGW_RMW(page) {											\
	WORD	mask;													\
	nevent.remainclock -= vramop.grcgwait;							\
	mask = ~value;													\
	address &= 0x7fff;												\
	*(WORD *)(vramupdate + address) |= (0x0101 << page);			\
	gdcs.grphdisp |= (1 << page);									\
	if (!(grcg.modereg & 1)) {										\
		*(WORD *)(mem + address + (VRAM_STEP*(page)) + VRAM0_B)		\
									&= mask;						\
		*(WORD *)(mem + address + (VRAM_STEP*(page)) + VRAM0_B)		\
									|= (value & grcg.tile[0].w);	\
	}																\
	if (!(grcg.modereg & 2)) {										\
		*(WORD *)(mem + address + (VRAM_STEP*(page)) + VRAM0_R)		\
									&= mask;						\
		*(WORD *)(mem + address + (VRAM_STEP*(page)) + VRAM0_R)		\
									|= (value & grcg.tile[1].w);	\
	}																\
	if (!(grcg.modereg & 4)) {										\
		*(WORD *)(mem + address + (VRAM_STEP*(page)) + VRAM0_G)		\
									&= mask;						\
		*(WORD *)(mem + address + (VRAM_STEP*(page)) + VRAM0_G)		\
									|= (value & grcg.tile[2].w);	\
	}																\
	if (!(grcg.modereg & 8)) {										\
		*(WORD *)(mem + address + (VRAM_STEP*(page)) + VRAM0_E)		\
									&= mask;						\
		*(WORD *)(mem + address + (VRAM_STEP*(page)) + VRAM0_E)		\
									|= (value & grcg.tile[3].w);	\
	}																\
}
#endif
#ifdef NP2_BIGENDIAN
#define GRCGW_RMW(page) {											\
	nevent.remainclock -= vramop.grcgwait;							\
	address &= 0x7fff;												\
	vramupdate[address] |= (1 << page);								\
	vramupdate[address + 1] |= (1 << page);							\
	gdcs.grphdisp |= (1 << page);									\
	if (!(grcg.modereg & 1)) {										\
		BYTE tmp;													\
		tmp = (BYTE)value;											\
		mem[address + (VRAM_STEP*(page)) + VRAM0_B]					\
								&= (~tmp);							\
		mem[address + (VRAM_STEP*(page)) + VRAM0_B]					\
								|= (tmp & grcg.tile[0].b[0]);		\
		tmp = (BYTE)(value >> 8);									\
		mem[address + (VRAM_STEP*(page)) + VRAM0_B + 1]				\
								&= (~tmp);							\
		mem[address + (VRAM_STEP*(page)) + VRAM0_B + 1]				\
								|= (tmp & grcg.tile[0].b[0]);		\
	}																\
	if (!(grcg.modereg & 2)) {										\
		BYTE tmp;													\
		tmp = (BYTE)value;											\
		mem[address + (VRAM_STEP*(page)) + VRAM0_R]					\
								&= (~tmp);							\
		mem[address + (VRAM_STEP*(page)) + VRAM0_R]					\
								|= (tmp & grcg.tile[1].b[0]);		\
		tmp = (BYTE)(value >> 8);									\
		mem[address + (VRAM_STEP*(page)) + VRAM0_R + 1]				\
								&= (~tmp);							\
		mem[address + (VRAM_STEP*(page)) + VRAM0_R + 1]				\
								|= (tmp & grcg.tile[1].b[0]);		\
	}																\
	if (!(grcg.modereg & 4)) {										\
		BYTE tmp;													\
		tmp = (BYTE)value;											\
		mem[address + (VRAM_STEP*(page)) + VRAM0_G]					\
								&= (~tmp);							\
		mem[address + (VRAM_STEP*(page)) + VRAM0_G]					\
								|= (tmp & grcg.tile[2].b[0]);		\
		tmp = (BYTE)(value >> 8);									\
		mem[address + (VRAM_STEP*(page)) + VRAM0_G + 1]				\
								&= (~tmp);							\
		mem[address + (VRAM_STEP*(page)) + VRAM0_G + 1]				\
								|= (tmp & grcg.tile[2].b[0]);		\
	}																\
	if (!(grcg.modereg & 8)) {										\
		BYTE tmp;													\
		tmp = (BYTE)value;											\
		mem[address + (VRAM_STEP*(page)) + VRAM0_E]					\
								&= (~tmp);							\
		mem[address + (VRAM_STEP*(page)) + VRAM0_E]					\
								|= (tmp & grcg.tile[3].b[0]);		\
		tmp = (BYTE)(value >> 8);									\
		mem[address + (VRAM_STEP*(page)) + VRAM0_E + 1]				\
								&= (~tmp);							\
		mem[address + (VRAM_STEP*(page)) + VRAM0_E + 1]				\
								|= (tmp & grcg.tile[3].b[0]);		\
	}																\
}
#endif


#ifdef NP2_LITTLEENDIAN
#define GRCGW_TDW(page) {											\
	nevent.remainclock -= vramop.grcgwait;							\
	address &= 0x7fff;												\
	*(WORD *)(vramupdate + address) |= (0x0101 << page);			\
	gdcs.grphdisp |= (1 << page);									\
	if (!(grcg.modereg & 1)) {										\
		*(WORD *)(mem + address + (VRAM_STEP*(page)) + VRAM0_B)		\
												= grcg.tile[0].w;	\
	}																\
	if (!(grcg.modereg & 2)) {										\
		*(WORD *)(mem + address + (VRAM_STEP*(page)) + VRAM0_R)		\
												= grcg.tile[1].w;	\
	}																\
	if (!(grcg.modereg & 4)) {										\
		*(WORD *)(mem + address + (VRAM_STEP*(page)) + VRAM0_G)		\
												= grcg.tile[2].w;	\
	}																\
	if (!(grcg.modereg & 8)) {										\
		*(WORD *)(mem + address + (VRAM_STEP*(page)) + VRAM0_E)		\
												= grcg.tile[3].w;	\
	}																\
}
#endif
#ifdef NP2_BIGENDIAN
#define GRCGW_TDW(page) {											\
	nevent.remainclock -= vramop.grcgwait;							\
	address &= 0x7fff;												\
	vramupdate[address] |= (1 << page);								\
	vramupdate[address + 1] |= (1 << page);							\
	gdcs.grphdisp |= (1 << page);									\
	if (!(grcg.modereg & 1)) {										\
		mem[address + (VRAM_STEP*(page)) + VRAM0_B]					\
											= grcg.tile[0].b[0];	\
		mem[address + (VRAM_STEP*(page)) + VRAM0_B + 1]				\
											= grcg.tile[0].b[0];	\
	}																\
	if (!(grcg.modereg & 2)) {										\
		mem[address + (VRAM_STEP*(page)) + VRAM0_R]					\
											= grcg.tile[1].b[0];	\
		mem[address + (VRAM_STEP*(page)) + VRAM0_R + 1]				\
											= grcg.tile[1].b[0];	\
	}																\
	if (!(grcg.modereg & 4)) {										\
		mem[address + (VRAM_STEP*(page)) + VRAM0_G]					\
											= grcg.tile[2].b[0];	\
		mem[address + (VRAM_STEP*(page)) + VRAM0_G + 1]				\
											= grcg.tile[2].b[0];	\
	}																\
	if (!(grcg.modereg & 8)) {										\
		mem[address + (VRAM_STEP*(page)) + VRAM0_E]					\
											= grcg.tile[3].b[0];	\
		mem[address + (VRAM_STEP*(page)) + VRAM0_E + 1]				\
											= grcg.tile[3].b[0];	\
	}																\
}
#endif

static void MEM_CALL vramw_w0(DWORD address, WORD value) GRCGW_NON(0)
static void MEM_CALL vramw_w1(DWORD address, WORD value) GRCGW_NON(1)
static void MEM_CALL grcgw_rmw0(DWORD address, WORD value) GRCGW_RMW(0)
static void MEM_CALL grcgw_rmw1(DWORD address, WORD value) GRCGW_RMW(1)
static void MEM_CALL grcgw_tdw0(DWORD address, WORD value) GRCGW_TDW(0)
static void MEM_CALL grcgw_tdw1(DWORD address, WORD value) GRCGW_TDW(1)

static void MEM_CALL egcw_wt(DWORD address, WORD value) {

	if (!(address & 1)) {
		egc_write_w(address, value);
	}
	else {
		if (!(egc.sft & 0x1000)) {
			egc_write(address, (BYTE)value);
			egc_write(address + 1, (BYTE)(value >> 8));
		}
		else {
			egc_write(address + 1, (BYTE)(value >> 8));
			egc_write(address, (BYTE)value);
		}
	}
}

static void MEM_CALL emmcw_wt(DWORD address, WORD value) {

	if ((address & 0x3fff) != 0x3fff) {
		SETWORD(extmem.pageptr[(address >> 14) & 3] + (address & 0x3fff)
																, value);
	}
	else {
		extmem.pageptr[(address >> 14) & 3][0x3fff] = (BYTE)value;
		extmem.pageptr[((address +1 )>> 14) & 3][0] = (BYTE)(value >> 8);
	}
}

static void MEM_CALL i286w_wn(DWORD address, WORD value) { }

// ----------------------------------------------------------------- read word

static WORD MEM_CALL i286w_rd(DWORD address) {

	return(MEM_GETW(address & extmem.adrsmask));
}

static WORD MEM_CALL tramw_rd(DWORD address) {

	nevent.remainclock -= vramop.tramwait;
	if (address < (0xa4000 - 1)) {
		return(MEM_GETW(address));
	}
	else if (address == 0xa3fff) {
		return(MEM_GETB(0xa3fff) | ((WORD)font[cgwindow.low] << 8));
	}
	else if (address < 0xa4fff) {
		if (address & 1) {
			WORD ret;
			ret = font[cgwindow.high + ((address >> 1) & 0x0f)];
			ret |= (WORD)font[cgwindow.low + (((address+1)>>1) & 0x0f)] << 8;
			return(ret);
		}
		else {
			WORD ret;
			ret = font[cgwindow.low + ((address >> 1) & 0x0f)];
			ret |= (WORD)font[cgwindow.high + ((address >> 1) & 0x0f)] << 8;
			return(ret);
		}
	}
	else if (address == 0xa4fff) {
		return(((WORD)MEM_GETB(0xa5000) << 8) | font[cgwindow.high + 15]);
	}
	return(MEM_GETW(address));
}

static WORD MEM_CALL vramw_r0(DWORD address) {

	nevent.remainclock -= vramop.vramwait;
	return(MEM_GETW(address));
}

static WORD MEM_CALL vramw_r1(DWORD address) {

	nevent.remainclock -= vramop.vramwait;
	return(MEM_GETW(address + VRAM_STEP));
}

static WORD MEM_CALL grcgw_tcr0(DWORD address) {

	WORD	ret;

	nevent.remainclock -= vramop.grcgwait;
	ret = 0;
	address &= 0x7fff;
	if (!(grcg.modereg & 1)) {
		ret |= MEM_GETW(address + VRAM0_B) ^ grcg.tile[0].w;
	}
	if (!(grcg.modereg & 2)) {
		ret |= MEM_GETW(address + VRAM0_R) ^ grcg.tile[1].w;
	}
	if (!(grcg.modereg & 4)) {
		ret |= MEM_GETW(address + VRAM0_G) ^ grcg.tile[2].w;
	}
	if (!(grcg.modereg & 8)) {
		ret |= MEM_GETW(address + VRAM0_E) ^ grcg.tile[3].w;
	}
	return(~ret);
}

static WORD MEM_CALL grcgw_tcr1(DWORD address) {

	WORD	ret;

	nevent.remainclock -= vramop.grcgwait;
	ret = 0;
	address &= 0x7fff;
	if (!(grcg.modereg & 1)) {
		ret |= MEM_GETW(address + VRAM1_B) ^ grcg.tile[0].w;
	}
	if (!(grcg.modereg & 2)) {
		ret |= MEM_GETW(address + VRAM1_R) ^ grcg.tile[1].w;
	}
	if (!(grcg.modereg & 4)) {
		ret |= MEM_GETW(address + VRAM1_G) ^ grcg.tile[2].w;
	}
	if (!(grcg.modereg & 8)) {
		ret |= MEM_GETW(address + VRAM1_E) ^ grcg.tile[3].w;
	}
	return(~ret);
}

static WORD MEM_CALL egcw_rd(DWORD address) {

	if (!(address & 1)) {
		return(egc_read_w(address));
	}
	else {
		if (!(egc.sft & 0x1000)) {
			WORD ret;
			ret = egc_read(address);
			ret |= (WORD)egc_read(address + 1) << 8;
			return(ret);
		}
		else {
			WORD ret;
			ret = (WORD)egc_read(address + 1) << 8;
			ret |= egc_read(address);
			return(ret);
		}
	}
}

static WORD MEM_CALL emmcw_rd(DWORD address) {

	return(GETWORD(extmem.pageptr[(address >> 14) & 3] + (address & 0x3fff)));
}

static WORD MEM_CALL i286w_itf(DWORD address) {

	if (itf_bank) {
		address = ITF_ADRS + (address & 0x7fff);
	}
	return(MEM_GETW(address));
}

// --------------------------------------------------------------------- table

static void (MEM_CALL * memory_write[])(DWORD address, BYTE value) = {
			i286_wt,	i286_wt,	i286_wt,	i286_wt,		// 00
			i286_wt,	i286_wt,	i286_wt,	i286_wt,		// 20
			i286_wt,	i286_wt,	i286_wt,	i286_wt,		// 40
			i286_wt,	i286_wt,	i286_wt,	i286_wt,		// 60
			i286_wt,	i286_wt,	i286_wt,	i286_wt,		// 80
			tram_wt,	vram_w0,	vram_w0,	vram_w0,		// a0
			emmc_wt,	emmc_wt,	i286_wn,	i286_wn,		// c0
			vram_w0,	i286_wn,	i286_wn,	i286_wn};		// e0

static BYTE (MEM_CALL * memory_read[])(DWORD address) = {
			i286_rd,	i286_rd,	i286_rd,	i286_rd,		// 00
			i286_rd,	i286_rd,	i286_rd,	i286_rd,		// 20
			i286_rd,	i286_rd,	i286_rd,	i286_rd,		// 40
			i286_rd,	i286_rd,	i286_rd,	i286_rd,		// 60
			i286_rd,	i286_rd,	i286_rd,	i286_rd,		// 80
			tram_rd,	vram_r0,	vram_r0,	vram_r0,		// a0
			emmc_rd,	emmc_rd,	i286_rd,	i286_rd,		// c0
			vram_r0,	i286_rd,	i286_rd,	i286_itf};		// f0

static void (MEM_CALL * memword_write[])(DWORD address, WORD value) = {
			i286w_wt,	i286w_wt,	i286w_wt,	i286w_wt,		// 00
			i286w_wt,	i286w_wt,	i286w_wt,	i286w_wt,		// 20
			i286w_wt,	i286w_wt,	i286w_wt,	i286w_wt,		// 40
			i286w_wt,	i286w_wt,	i286w_wt,	i286w_wt,		// 60
			i286w_wt,	i286w_wt,	i286w_wt,	i286w_wt,		// 80
			tramw_wt,	vramw_w0,	vramw_w0,	vramw_w0,		// a0
			emmcw_wt,	emmcw_wt,	i286w_wn,	i286w_wn,		// c0
			vramw_w0,	i286w_wn,	i286w_wn,	i286w_wn};		// e0

static WORD (MEM_CALL * memword_read[])(DWORD address) = {
			i286w_rd,	i286w_rd,	i286w_rd,	i286w_rd,		// 00
			i286w_rd,	i286w_rd,	i286w_rd,	i286w_rd,		// 20
			i286w_rd,	i286w_rd,	i286w_rd,	i286w_rd,		// 40
			i286w_rd,	i286w_rd,	i286w_rd,	i286w_rd,		// 60
			i286w_rd,	i286w_rd,	i286w_rd,	i286w_rd,		// 80
			tramw_rd,	vramw_r0,	vramw_r0,	vramw_r0,		// a0
			emmcw_rd,	emmcw_rd,	i286w_rd,	i286w_rd,		// c0
			vramw_r0,	i286w_rd,	i286w_rd,	i286w_itf};		// e0


static void (MEM_CALL * vram_write[])(DWORD address, BYTE value) = {
			vram_w0,	vram_w1,	vram_w0,	vram_w1,		// 00
			vram_w0,	vram_w1,	vram_w0,	vram_w1,		// 40
			grcg_tdw0,	grcg_tdw1,	egc_wt,		egc_wt,			// 80 tdw/tcr
			grcg_rmw0,	grcg_rmw1,	egc_wt,		egc_wt};		// c0 rmw

static BYTE (MEM_CALL * vram_read[])(DWORD address) = {
			vram_r0,	vram_r1,	vram_r0,	vram_r1,		// 00
			vram_r0,	vram_r1,	vram_r0,	vram_r1,		// 40
			grcg_tcr0,	grcg_tcr1,	egc_rd,		egc_rd,			// 80 tdw/tcr
			vram_r0,	vram_r1,	egc_rd,		egc_rd};		// c0 rmw

static void (MEM_CALL * vramw_write[])(DWORD address, WORD value) = {
			vramw_w0,	vramw_w1,	vramw_w0,	vramw_w1,		// 00
			vramw_w0,	vramw_w1,	vramw_w0,	vramw_w1,		// 40
			grcgw_tdw0,	grcgw_tdw1,	egcw_wt,	egcw_wt,		// 80 tdw/tcr
			grcgw_rmw0,	grcgw_rmw1,	egcw_wt,	egcw_wt};		// c0 rmw

static WORD (MEM_CALL * vramw_read[])(DWORD address) = {
			vramw_r0,	vramw_r1,	vramw_r0,	vramw_r1,		// 00
			vramw_r0,	vramw_r1,	vramw_r0,	vramw_r1,		// 40
			grcgw_tcr0,	grcgw_tcr1,	egcw_rd,	egcw_rd,		// 80 tdw/tcr
			vramw_r0,	vramw_r1,	egcw_rd,	egcw_rd};		// c0 rmw





void MEM_CALL __i286_memorywrite_d(DWORD address, DWORD value) {

	__i286_memorywrite_w(address, value & 0xffff);
	__i286_memorywrite_w(address + 2, (WORD)(value >> 16));
}

void MEM_CALL __i286_memorywrite_w(DWORD address, WORD value) {

	if (address < (I286_MEMWRITEMAX - 1)) {
		MEM_SETW(address, value);
	}
	else if ((address & 0x7fff) != 0x7fff) {
		memword_write[(address >> 15) & 0x1f](address, value);
	}
	else {
		memory_write[(address >> 15) & 0x1f](address, (BYTE)value);
		address++;
		memory_write[(address >> 15) & 0x1f](address, (BYTE)(value >> 8));
	}
}

void MEM_CALL __i286_memorywrite(DWORD address, BYTE value) {

	if (address < I286_MEMWRITEMAX) {
		MEM_SETB(address, value);
	}
	else {
		memory_write[(address >> 15) & 0x1f](address, value);
	}
}

DWORD MEM_CALL __i286_memoryread_d(DWORD address) {

	DWORD ret;

	ret = __i286_memoryread_w(address);
	ret |= (DWORD)__i286_memoryread_w(address + 2) << 16;

	return ret;
}

WORD MEM_CALL __i286_memoryread_w(DWORD address) {

	if (address < (I286_MEMREADMAX - 1)) {
		return(MEM_GETW(address));
	}
	else if ((address & 0x7fff) != 0x7fff) {
		return(memword_read[(address >> 15) & 0x1f](address));
	}
	else {
		WORD ret;
		ret = memory_read[(address >> 15) & 0x1f](address);
		address++;
		ret |= (WORD)memory_read[(address >> 15) & 0x1f](address) << 8;
		return(ret);
	}
}

BYTE MEM_CALL __i286_memoryread(DWORD address) {

	if (address < I286_MEMREADMAX) {
		return(MEM_GETB(address));
	}
	else {
		return(memory_read[(address >> 15) & 0x1f](address));
	}
}

static BYTE MEM_CALL i286_nonram_r(DWORD adrs) { return(0xff); }
static WORD MEM_CALL i286_nonram_rw(DWORD adrs) { return(0xffff); }

void MEM_CALL i286_vram_dispatch(DWORD func) {

	DWORD	proc = func & 0x0f;

	memory_write[0xa8000 >> 15] = vram_write[proc];
	memory_write[0xb0000 >> 15] = vram_write[proc];
	memory_write[0xb8000 >> 15] = vram_write[proc];
	memory_write[0xe0000 >> 15] = vram_write[proc];

	memory_read[0xa8000 >> 15] = vram_read[proc];
	memory_read[0xb0000 >> 15] = vram_read[proc];
	memory_read[0xb8000 >> 15] = vram_read[proc];
	memory_read[0xe0000 >> 15] = vram_read[proc];

	memword_write[0xa8000 >> 15] = vramw_write[proc];
	memword_write[0xb0000 >> 15] = vramw_write[proc];
	memword_write[0xb8000 >> 15] = vramw_write[proc];
	memword_write[0xe0000 >> 15] = vramw_write[proc];

	memword_read[0xa8000 >> 15] = vramw_read[proc];
	memword_read[0xb0000 >> 15] = vramw_read[proc];
	memword_read[0xb8000 >> 15] = vramw_read[proc];
	memword_read[0xe0000 >> 15] = vramw_read[proc];

	if (!(func & 0x10)) {							// digital
		memory_write[0xe0000 >> 15] = i286_wn;
		memword_write[0xe0000 >> 15] = i286w_wn;
		memory_read[0xe0000 >> 15] = i286_nonram_r;
		memword_read[0xe0000 >> 15] = i286_nonram_rw;
	}

#if defined(USE_ASM)
	i286a_vram_dispatch(func);
#endif
}

// ---------------------------------------------------------------------------

void MEM_CALL i286_memstr_read(WORD seg, WORD off, void *dat, DWORD leng) {

	BYTE	*out;
	DWORD	adrs;

	out = (BYTE *)dat;
	adrs = (DWORD)seg << 4;
	if ((I286_MEMREADMAX >= 0x10000) &&
		(adrs < (I286_MEMREADMAX - 0x10000))) {
		if (leng) {
			DWORD	size;
			size = 0x10000 - off;
			if (size >= leng) {
				CopyMemory(out, mem + adrs + off, leng);
				return;
			}
			CopyMemory(out, mem + adrs + off, size);
			out += size;
			leng -= size;
		}
		while(leng >= 0x10000) {
			CopyMemory(out, mem + adrs, 0x10000);
			out += 0x10000;
			leng -= 0x10000;
		}
		if (leng) {
			CopyMemory(out, mem + adrs, leng);
		}
	}
	else {
		while(leng--) {
			*out++ = i286_memoryread(adrs + off);
			off++;
		}
	}
}


void MEM_CALL i286_memstr_write(WORD seg, WORD off, void *dat, DWORD leng) {

	BYTE	*out;
	DWORD	adrs;

	out = (BYTE *)dat;
	adrs = (DWORD)seg << 4;
	if ((I286_MEMWRITEMAX >= 0x10000) &&
		(adrs < (I286_MEMWRITEMAX - 0x10000))) {
		if (leng) {
			DWORD	size;
			size = 0x10000 - off;
			if (size >= leng) {
				CopyMemory(mem + adrs + off, out, leng);
				return;
			}
			CopyMemory(mem + adrs + off, out, size);
			out += size;
			leng -= size;
		}
		while(leng >= 0x10000) {
			CopyMemory(mem + adrs, out, 0x10000);
			out += 0x10000;
			leng -= 0x10000;
		}
		if (leng) {
			CopyMemory(mem + adrs, out, leng);
		}
	}
	else {
		while(leng--) {
			i286_memorywrite(adrs + off, *out++);
			off++;
		}
	}
}


void MEM_CALL i286_memx_read(DWORD address, void *dat, DWORD leng) {

	if ((address + leng) < I286_MEMREADMAX) {
		CopyMemory(dat, mem + address, leng);
	}
	else {
		BYTE *out = (BYTE *)dat;
		if (address < I286_MEMREADMAX) {
			CopyMemory(out, mem + address, I286_MEMREADMAX - address);
			out += I286_MEMREADMAX - address;
			leng -= I286_MEMREADMAX - address;
			address = I286_MEMREADMAX;
		}
		while(leng--) {
			*out++ = i286_memoryread(address++);
		}
	}
}


void MEM_CALL i286_memx_write(DWORD address, void *dat, DWORD leng) {

	if ((address + leng) < I286_MEMWRITEMAX) {
		CopyMemory(mem + address, dat, leng);
	}
	else {
		BYTE *out = (BYTE *)dat;
		if (address < I286_MEMWRITEMAX) {
			CopyMemory(mem + address, out, I286_MEMWRITEMAX - address);
			out += I286_MEMWRITEMAX - address;
			leng -= I286_MEMWRITEMAX - address;
			address = I286_MEMWRITEMAX;
		}
		while(leng--) {
			i286_memorywrite(address++, *out++);
		}
	}
}

#if defined(CPU386)

#include	"cpuio.h"
#include	"cpu_mem.h"

void MEM_CALL
cpu_memorywrite_d(DWORD address, DWORD value)
{
	DWORD adr = address & cpumem_addrmask;

	if (adr < LOWMEM - 3) {
		__i286_memorywrite_d(adr, value);
	} else if (adr < LOWMEM) {
		cpu_memorywrite_w(adr, value & 0xffff);
		cpu_memorywrite_w(adr + 2, (value >> 16) & 0xffff);
	} else {
		adr -= LOWMEM;
		if (adr < extmem_size) {
			SETDWORD(cpumem + adr, value);
		}
	}
}

void MEM_CALL
cpu_memorywrite_w(DWORD address, WORD value)
{
	DWORD adr = address & cpumem_addrmask;

	if (adr < LOWMEM - 1) {
		__i286_memorywrite_w(adr, value);
	} else if (adr < LOWMEM) {
		__i286_memorywrite(adr, value & 0xff);
		cpumem[adr - (LOWMEM - 1)] = (value >> 8) & 0xff;
	} else {
		adr -= LOWMEM;
		if (adr < extmem_size) {
			SETWORD(cpumem + adr, value);
		}
	}
}

void MEM_CALL
cpu_memorywrite(DWORD address, BYTE value)
{
	DWORD adr = address & cpumem_addrmask;

	if (adr < LOWMEM) {
		__i286_memorywrite(adr, value);
	} else {
		adr -= LOWMEM;
		if (adr < extmem_size) {
			cpumem[adr] = value;
		}
	}
}

DWORD MEM_CALL
cpu_memoryread_d(DWORD address)
{
	DWORD adr = address & cpumem_addrmask;
	DWORD val;

	if (adr < LOWMEM - 3) {
		val = __i286_memoryread_d(adr);
	} else if (adr < LOWMEM) {
		val = cpu_memoryread_w(adr);
		val |= (DWORD)cpu_memoryread_w(adr + 2) << 16;
	} else {
		adr -= LOWMEM;
		if (adr < extmem_size) {
			val = GETDWORD(cpumem + adr);
		} else {
			val = (DWORD)-1;
		}
	}

	return val;
}

WORD MEM_CALL
cpu_memoryread_w(DWORD address)
{
	DWORD adr = address & cpumem_addrmask;
	WORD val;

	if (adr < LOWMEM - 1) {
		val = __i286_memoryread_w(adr);
	} else if (adr < LOWMEM) {
		val = cpu_memoryread(adr);
		val |= (WORD)cpumem[adr - (LOWMEM - 1)] << 8;
	} else {
		adr -= LOWMEM;
		if (adr < extmem_size) {
			val = GETWORD(cpumem + adr);
		} else {
			val = (WORD)-1;
		}
	}

	return val;
}

BYTE MEM_CALL
cpu_memoryread(DWORD address)
{
	DWORD adr = address & cpumem_addrmask;
	BYTE val;

	if (adr < LOWMEM) {
		val = __i286_memoryread(adr);
	} else {
		adr -= LOWMEM;
		if (adr < extmem_size) {
			val = cpumem[adr];
		} else {
			val = (BYTE)-1;
		}
	}

	return val;
}

#endif	/* CPU386 */

#endif
