/*	$Id: dosio.c,v 1.6 2002/06/02 15:04:19 nonaka Exp $	*/

#include "compiler.h"

#include <sys/param.h>
#include <time.h>

#include "dosio.h"
#include "milstr.h"

static char	curpath[MAX_PATH+32] = "";
static LPSTR	curfilep = curpath;

void
dosio_init(void)
{

	/* Nothing to do. */
}

void
dosio_term(void)
{

	/* Nothing to do. */
}

/* ե */
FILEH
file_open(LPSTR filename)
{
	FILEH	ret;

	ret = CreateFile(filename, GENERIC_READ | GENERIC_WRITE,
	    0, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if (ret == (FILEH)INVALID_HANDLE_VALUE) {
		ret = CreateFile(filename, GENERIC_READ,
		    0, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
		if (ret == (FILEH)INVALID_HANDLE_VALUE)
			return (FILEH)-1;
	}
	return ret ;
}

FILEH
file_create(LPSTR filename, int ftype)
{
	FILEH	ret;

	UNUSED(ftype);

	ret = CreateFile(filename, GENERIC_READ | GENERIC_WRITE,
	    0, 0, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	if (ret == (FILEH)INVALID_HANDLE_VALUE)
		return (FILEH)-1;
	return ret;
}

DWORD
file_seek(FILEH handle, long pointer, short mode)
{

	return SetFilePointer(handle, pointer, 0, mode);
}

DWORD
file_lread(FILEH handle, void *data, DWORD length)
{
	DWORD	readsize;

	if (ReadFile(handle, data, length, &readsize, NULL) == 0)
		return 0;
	return readsize;
}

DWORD
file_lwrite(FILEH handle, void *data, DWORD length)
{
	DWORD	writesize;

	if (WriteFile(handle, data, length, &writesize, NULL) == 0)
		return 0;
	return writesize;
}

WORD
file_read(FILEH handle, void *data, WORD length)
{
	DWORD	readsize;

	if (ReadFile(handle, data, length, &readsize, NULL) == 0)
		return 0;
	return (WORD)readsize;
}

DWORD
file_zeroclr(FILEH handle, DWORD length)
{
	char	buf[256];
	DWORD	size;
	DWORD	wsize;
	DWORD	ret = 0;

	memset(buf, 0, sizeof(buf));
	while (length > 0) {
		wsize = (length >= sizeof(buf)) ? sizeof(buf) : length;

		size = file_lwrite(handle, buf, wsize);
		if (size == (DWORD)-1)
			return -1;

		ret += size;
		if (size != wsize)
			break;
		length -= wsize;
	}
	return ret;
}


WORD
file_write(FILEH handle, void *data, WORD length)
{
	DWORD	writesize;

	if (WriteFile(handle, data, length, &writesize, NULL) == 0)
		return 0;
	return (WORD)writesize;
}

WORD
file_lineread(FILEH handle, void *data, WORD length)
{
	LPSTR	p = (LPSTR)data;
	DWORD	readsize;
	DWORD	pos;
	WORD	ret = 0;

	if ((length == 0) || ((pos = file_seek(handle, 0, 1)) == (DWORD)-1))
		return 0;

	ZeroMemory(data, length);
	if (ReadFile(handle, data, length-1, &readsize, NULL) == 0)
		return 0;

	while (*p) {
		ret++;
		pos++;
		if ((*p == 0x0d) || (*p == 0x0a)) {
			break;
		}
		p++;
	}
	*p = '\0';

	file_seek(handle, pos, 0);

	return ret;
}

short
file_close(FILEH handle)
{

	CloseHandle(handle);
	return 0;
}

short
file_attr(LPSTR filename)
{

	return (short)GetFileAttributes(filename);
}


							// ȥե
void
file_setcd(LPSTR exename)
{

	strncpy(curpath, exename, sizeof(curpath));
	plusyen(curpath, sizeof(curpath));
	curfilep = curpath + strlen(exename) + 1;
	*curfilep = '\0';
}

LPSTR
file_getcd(LPSTR filename)
{

	strncpy(curfilep, filename, curfilep - curpath);
	return curpath;
}

FILEH
file_open_c(LPSTR filename)
{

	strncpy(curfilep, filename, curfilep - curpath);
	return file_open(curpath);
}

FILEH
file_create_c(LPSTR filename, int ftype)
{

	strncpy(curfilep, filename, curfilep - curpath);
	return file_create(curpath, ftype);
}

short
file_attr_c(LPSTR filename)
{

	strncpy(curfilep, filename, curfilep - curpath);
	return file_attr(curpath);
}

int
file_getftype(LPSTR filename)
{

	UNUSED(filename);

	return FTYPE_NONE;
}


LPSTR
getFileName(LPSTR filename)
{
	LPSTR p, q;

	for (p = q = filename; *p != '\0'; p++)
		if (*p == '/')
			q = p + 1;
	return q;
}

void
cutFileName(LPSTR filename)
{
	LPSTR p, q;

	for (p = filename, q = NULL; *p != '\0'; p++)
		if (*p == '/')
			q = p + 1;
	if (q != NULL)
		*q = '\0';
}

LPSTR
getExtName(LPSTR filename)
{
	LPSTR	p;
	LPSTR	q;

	p = getFileName(filename);
	q = NULL;

	while (*p != '\0') {
		if (*p == '.')
			q = p + 1;
		p++;
	}
	if (q == NULL)
		q = p;
	return q;
}

void
cutExtName(LPSTR filename)
{
	LPSTR	p;
	LPSTR	q;

	p = getFileName(filename);
	q = NULL;

	while (*p != '\0') {
		if (*p == '.')
			q = p;
		p++;
	}
	if (q != NULL)
		*q = '\0';
}

int
kanji1st(LPSTR str, int pos)
{
	int	ret = 0;
	BYTE	c;

	for (; pos > 0; pos--) {
		c = (BYTE)str[pos];
		if (!((0x81 <= c && c <= 0x9f) || (0xe0 <= c && c <= 0xfc)))
			break;
		ret ^= 1;
	}
	return ret;
}

int
kanji2nd(LPSTR str, int pos)
{
	int	ret = 0;
	BYTE	c;

	while (pos-- > 0) {
		c = (BYTE)str[pos];
		if (!((0x81 <= c && c <= 0x9f) || (0xe0 <= c && c <= 0xfc)))
			break;
		ret ^= 1;
	}
	return ret;
}


int
ex_a2i(LPSTR str, int min, int max)
{
	int	ret = 0;
	char	c;

	if (str == NULL)
		return(min);

	for (;;) {
		c = *str++;
		if (c == ' ')
			continue;
		if ((c < '0') || (c > '9'))
			break;
		ret = ret * 10 + (c - '0');
	}

	if (ret < min)
		return min;
	else if (ret > max)
		return max;
	return ret;
}

void
cutyen(LPSTR str)
{
	int pos = strlen(str) - 1;

	if ((pos > 0) && (str[pos] == '/'))
		str[pos] = '\0';
}

void
plusyen(LPSTR str, int len)
{
	int	pos = strlen(str);

	if (pos) {
		if (str[pos-1] == '/')
			return;
	}
	if ((pos + 2) >= len)
		return;
	str[pos++] = '/';
	str[pos] = '\0';
}


void
fname_mix(LPSTR str, LPSTR mix, int size)
{
	LPSTR p;
	int len;
	char c;
	char check;

	cutFileName(str);
	if (mix[0] == '/')
		str[0] = '\0';

	len = strlen(str);
	p = str + len;
	check = '.';
	while (len < size) {
		c = *mix++;
		if (c == '\0')
			break;

		if (c == check) {
			/* current dir */
			if (mix[0] == '/') {
				mix++;
				continue;
			}
			/* parent dir */
			if (mix[0] == '.' && mix[1] == '/') {
				mix += 2;
				cutyen(str);
				cutFileName(str);
				len = strlen(str);
				p = str + len;
				continue;
			}
		}
		if (c == '/')
			check = '.';
		else
			check = 0;
		*p++ = c;
		len++;
	}
	if (p < str + len)
		*p = '\0';
	else
		str[len - 1] = '\0';
}
