/*	$Id: draw.c,v 1.4 2002/06/03 15:46:50 nonaka Exp $	*/

#include "compiler.h"

#include <stdio.h>
#include <string.h>

#include "np2.h"
#include "np2pc98.h"
#include "iobridge.h"
#include "pc_core.h"
#include "gdc.h"
#include "memory.h"
#include "parts.h"
#include "palettes.h"

#include "xnp2.h"
#include "xdraw.h"

void
draws_init(void)
{

	bzero(np2_tram, sizeof(np2_tram));
	bzero(np2_vram, sizeof(np2_vram));
	allflash = 1;
	fillrenewalline(0x80);
}

void
fillrenewalline(BYTE value)
{
        int cnt = SCREEN_HEIGHT;
        BYTE *p = renewal_line;

        while (cnt--)
                *p++ |= value;
}

BYTE
xdraws_setdisplaymode(void)
{
	int disp = 0;

	if ((displaymodel != 0) && (nordisplay != 0)) {
		disp = 1;
	}
	if (displaymoder != disp) {
		displaymoder = disp;
		allflash = 1;
		return 1;
	}
	return 0;
}

void
xdraws_adjustleft(void)
{

	if (((setscmd & SCMD_SETTURN) != 0)
	    || (np2cfg.paddingx == 0)
	    || ((SCREENMODE & SCMD_COLORMASK) == SCMD_COLOR8)) {
		displaymodel = 0;
	} else {
		displaymodel = 1;
	}
	xdraws_setdisplaymode();
}

BYTE
xdraws_setscreenmode(BYTE mode)
{
	BYTE ret = FALSE;

	if (mode & SCMD_SETWINDOWED) {
		if ((SCREENMODE & SCMD_WINDOWED) == 0) {
			setscmd |= SCMD_SETWINDOWED;
			ret = TRUE;
		}
	} else if (mode & SCMD_SETFULLSCREEN) {
		if ((SCREENMODE & SCMD_FULLSCRN) == 0) {
			setscmd &= (~SCMD_SETWINDOWED);
			ret = TRUE;
		}
	}

	if ((mode & (SCMD_SETNORMAL | SCMD_SETTURN))
	    && ((setscmd ^ mode) & (SCMD_SETNORMAL | SCMD_SETTURN))) {
		setscmd &= ~(SCMD_SETNORMAL | SCMD_SETTURN);
		setscmd |= mode & (SCMD_SETNORMAL | SCMD_SETTURN);
		if (setscmd & SCMD_SETWINDOWED) {
			ret = TRUE;
		}
	}

	return ret;
}

void
xdraws_setwindowsize(void)
{
	DWORD x, y;

	if (realdisp.w >= minisize2.x) {
		x = realdisp.w;
		vir.x1 = 0;
		vir.x2 = 0;
		vir.w = realdisp.w;
	} else {
		x = minisize2.x;
		vir.x1 = (minisize2.x - realdisp.x) / 2;
		vir.x2 = vir.x1;
		vir.w = realdisp.w;
	}
	if (realdisp.h >= minisize2.y) {
		y = realdisp.h;
		vir.y1 = 0;
		vir.y2 = 0;
		vir.h = realdisp.h;
	} else {
		y = minisize2.y;
		vir.y1 = (minisize2.y - realdisp.y) / 2;
		vir.y2 = vir.x1;
		vir.h = realdisp.h;
	}

	if ((x != vir.sx) || (y != vir.sy)) {
		vir.sx = x;
		vir.sy = y;
		xdraws_setdisplaymode();
	}
}

BOOL
np2os_setsize(NP2RECT *r)
{
	BOOL ret = FALSE;

	if ((r->y) & 7) {
		(r->y) = ((r->y) + 7) & (~7);
		ret = TRUE;
	}
	memcpy(&realdisp, r, sizeof(NP2RECT));
	xdraws_setwindowsize();
	allflash = 1;
	return ret;
}

void
np2os_changepalettes(void)
{
	if (SCREENMODE & SCMD_USEPAL) 
                palchanged = 1;
	else
		fillrenewalline(0x80);
}

BYTE
np2os_setextflag(BYTE flag)
{
	BYTE ret;

	nordisplay = (flag & 1) ? 1 : 0;
	ret = xdraws_setdisplaymode();

	return ret;
}
