typedef struct {				// Header Part (size:2B0h)
	BYTE	fd_name[17];		// Disk Name
	BYTE	reserved1[9]; 		// Reserved
	BYTE	protect;			// Write Protect bit:4
	BYTE	fd_type;			// Disk Format
	BYTE	fd_size[4];			// Disk Size			little endian
	BYTE	trackp[164][4];		// Track_pointer		little endian
} D88_HEADER;

//  (16 Bytes)
typedef struct {
	BYTE	c;
	BYTE	h;
	BYTE	r;
	BYTE	n;
	BYTE	sectors[2];			// Sector Count			little endian
	BYTE	mfm_flg;			// sides
	BYTE	del_flg;			// DELETED DATA
	BYTE	stat;				// STATUS (FDC ret)
	BYTE	reserved2[5];		// Reserved
	BYTE	size[2];			// Sector Size			little endian
} D88_SECTOR;


BOOL fdd_set_d88(BYTE drv, LPSTR fname);
BOOL fdd_eject_d88(BYTE drv);

BOOL fdd_diskaccess_d88(void);
BOOL fdd_seek_d88(void);
BOOL fdd_seeksector_d88(void);
BOOL fdd_read_d88(void);
BOOL fdd_write_d88(void);
BOOL fdd_diagread_d88(void);
BOOL fdd_readid_d88(void);
BOOL fdd_writeid_d88(void);

BOOL fdd_formatinit_d88(void);
BOOL fdd_formating_d88(BYTE *ID);
BOOL fdd_isformating_d88(void);
