#include	"compiler.h"

#include	"dosio.h"
#include	"memory.h"
#include	"font.h"
#include	"bitmap.h"

#define	FONTYSIZE		16

#define	BMPWIDTH		2048L
#define	BMPHEIGHT		2048L

#define	BMPLINESIZE		(BMPWIDTH / 8)			// ڤ^^;

#define	BMPDATASIZE		(BMPLINESIZE * BMPHEIGHT)

											// ץȥ
static void pc98ankcpy(BYTE *dst, BYTE *src, int from, int to);
static void pc98knjcpy(BYTE *dst, BYTE *src, int from, int to);


BYTE pc98fontread(char *filename, BYTE loading) {

	FILEH	fh;
	BMP_T	bmp;
	MEM_HDL	hbmpdata;
	BYTE	*bmpdata;
	DWORD	pos;

	if (!(loading & LOADFONT_16)) {
		return(loading);
	}

	// ե뤬¸ߤ뤫
	if (file_attr(filename) == -1) {
		return(loading);					// ե뤬¸ߤʤä
	}

	// ꥢ
	if ((hbmpdata = np2os_malloc(BMPDATASIZE)) == NULL) {
		return(loading);					// Ȥ˼
	}
	bmpdata = (BYTE *)MEM_PTR(hbmpdata);

	// ե򥪡ץ
	if ((fh = file_open(filename)) == (FILEH)-1) {
		np2os_free(hbmpdata);				// ץ˼
		return(loading);
	}

	for (;;) {								// gotoȤʤ ޤʤ
		// BITMAPHEADER ɤ߹
		if (file_read(fh, &bmp, sizeof(BMP_T)) != sizeof(BMP_T)) {
			break;							// ɤ߹߼
		}

		// פ BM
		if (GETWORD(bmp.bfType) != 0x4d42) {
			break;							// "BM" ǤϤʤä
		}

		// ¤Υ
		if (GETDWORD(bmp.biSize) != BMPINFO_SIZE) {
			break;							// 
		}
		// ץ졼ϣ礫
		if (GETWORD(bmp.biPlanes) != 1) {
			break;							// 
		}
		// ñǤ뤫
		if (GETWORD(bmp.biBitCount) != 1) {
			break;							// 
		}
		// 
		if (GETDWORD(bmp.biWidth) != BMPWIDTH) {
			break;							// 
		}
		// ĥ
		if (GETDWORD(bmp.biHeight) != BMPHEIGHT) {
			break;							// 
		}
		// ᡼ϤäƤ뤫
		if (GETDWORD(bmp.biSizeImage) != BMPDATASIZE) {
			break;							// 
		}
		// ̵̤
		if (GETDWORD(bmp.biCompression) != 0) {
			break;							// 
		}

		// BITMAPǡƬ
		pos = GETDWORD(bmp.bfOffBits);
		if (file_seek(fh, pos, FSEEK_SET) != pos) {
			break;							// ˼
		}

		// BITMAPǡɤߤ
		if (file_lread(fh, bmpdata, BMPDATASIZE) != BMPDATASIZE) {
			break;							// ɤߤʤä
		}

		// 8x16 ե(0x7f)ɤɬפ롩
		if (loading & FONT_ANK16a) {
			loading &= ~FONT_ANK16a;
			pc98ankcpy(font + 0x80000, bmpdata, 0x000, 0x080);
		}
		// 8x16 ե(0x80)ɤɬפ롩
		if (loading & FONT_ANK16b) {
			loading &= ~FONT_ANK16b;
			pc98ankcpy(font + 0x80800, bmpdata, 0x080, 0x100);
		}

		// ɤɬפ롩
		if (loading & FONT_KNJ1) {
			loading &= ~FONT_KNJ1;
			pc98knjcpy(font, bmpdata, 0x01, 0x30);
		}
		// ɤɬפ롩
		if (loading & FONT_KNJ2) {
			loading &= ~FONT_KNJ2;
			pc98knjcpy(font, bmpdata, 0x30, 0x56);
		}
		// ĥɤɬפ롩
		if (loading & FONT_KNJ3) {
			loading &= ~FONT_KNJ3;
			pc98knjcpy(font, bmpdata, 0x58, 0x60);
		}
		break;
	}
	file_close(fh);							// 
	np2os_free(hbmpdata);

	return(loading);
}


// ANKλϰϤΥɤ ԡ
static void pc98ankcpy(BYTE *dst, BYTE *src, int from, int to) {

	int		y;
	BYTE	*p;
	int		ank;

	for (ank=from; ank<to; ank++) {

		// ANKեȤΥȰ
		p = src + BMPDATASIZE + ank + (0 * FONTYSIZE * BMPLINESIZE);
		for (y=0; y<FONTYSIZE; y++) {
			p -= BMPLINESIZE;				// BMPʤΤǥݥ󥿤ϰ
			*dst++ = ~(*p);
		}
	}
}


// λϰϤΥɤ ԡ
static void pc98knjcpy(BYTE *dst, BYTE *src, int from, int to) {

	int		i, j, k;
	BYTE	*p, *q;

	for (i=from; i<to; i++) {
		p = src + BMPDATASIZE + (i << 1) - (FONTYSIZE * BMPLINESIZE);
		q = dst + 0x1000 + (i << 4);
		for (j=1; j<0x80; j++) {
			for (k=0; k<16; k++) {
				p -= BMPLINESIZE;
				*(q + 0x800) = ~(*(p+1));
				*q++ = ~(*p);
			}
			q += 0x1000 - 16;
		}
	}
}

