/*	$Id: xmouse.h,v 1.6 2001/10/09 16:09:42 nonaka Exp $	*/

/*
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgment:
 *      This product includes software developed by NONAKA Kimihiro.
 * 4. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef	__NP2_XMOUSE_H__
#define	__NP2_XMOUSE_H__

#define	MOUSE_MASK	7

#define	M_RES		0x00
#define	M_XOR		0x40
#define	M_SET		0x80

#define	MOUSE_OFF	(M_RES | 0)
#define	MOUSE_ON	(M_SET | 0)
#define	MOUSE_XOR	(M_XOR | 0)
#define	MOUSE_CONT	(M_RES | 1)
#define	MOUSE_STOP	(M_SET | 1)
#define	MOUSE_CONT_M	(M_RES | 2)
#define	MOUSE_STOP_M	(M_SET | 2)

#define	MOUSE_HIDE	0
#define	MOUSE_SHOW	1
#define	MOUSE_TOGGLE	2

#define	MOUSE_LEFTDOWN	0
#define	MOUSE_LEFTUP	1
#define	MOUSE_RIGHTDOWN	2
#define	MOUSE_RIGHTUP	3

int xmouse_init(GtkWidget *);
void xmouse_term(GtkWidget *);
void xmouse_show(GtkWidget *, int);
void mouse_running(GtkWidget *, BYTE);
void mouse_callback(GtkWidget *);
int xmouse_button(int);

extern BYTE mouse_move_mul;
extern BYTE mouse_move_div;
extern BYTE mouse_move_ratio;
enum {
	MOUSE_RATIO_050 = 0x12,
	MOUSE_RATIO_075 = 0x34,
	MOUSE_RATIO_150 = 0x32,
	MOUSE_RATIO_200 = 0x21,
	MOUSE_RATIO_400 = 0x41,
	MOUSE_RATIO_800 = 0x81,
	MOUSE_RATIO_100 = 0
};

#endif	/* __NP2_XMOUSE_H__ */
