#include	"compiler.h"

#include	"i286.h"
#include	"iobridge.h"
#include	"memory.h"
#include	"cpuio.h"
#include	"nmiio.h"
#include	"extmem.h"
#include	"nevent.h"

	CPUIO_TABLE		cpuio;
	DWORD			cpumem_addrmask = 0x000fffff;

static enable_a20(void) {

	extmem.adrsmask = 0x001fffff;
	cpumem_addrmask = 0xffffffff;
}

static disable_a20(void) {

	extmem.adrsmask = 0x000fffff;
	cpumem_addrmask = 0x000fffff;
}

#ifdef __cplusplus
extern "C" {
#endif
BOOL is_a20(void) {

	return extmem.adrsmask != 0x0fffff;
}
#ifdef __cplusplus
}
#endif

void cpuio_init(void) {

	ZeroMemory(&cpuio, sizeof(cpuio));
}

I286_OUT cpuio_w(WORD port, BYTE value) {

	switch(port & 0x07) {
		case 0x00:
			cpuio.reset_req = 1;
			disable_a20();
			//i286_interrupt(0x02); // XXX
			nevent_forceexit();										// ver0.29
			break;

		case 0x02:
			enable_a20();
			break;

		case 0x04:
			break;

#ifdef CPU386											// defineѤƤ
		case 0x06:
			switch(value) {
				case 0x02:
					enable_a20();
					break;
				case 0x03:
					disable_a20();
					break;
			}
			break;
#endif
	}
}


I286_INB cpuio_r(WORD port) {

	BYTE	ret;

	switch(port & 0x07) {
		case 0x00:
			ret = 0x00;
			return(ret);

		case 0x02:
			ret = 0xfe;
			if (!is_a20()) {
				ret++;
			}
			return(ret);

		case 0x04:
			break;

#ifdef CPU386											// defineѤƤ
		case 0x06:
			ret = 0x00;
			if (!is_a20()) {
				ret |= 0x01;
			}
			if (nmiio.enable) {
				ret |= 0x02;
			}
			return(ret);
#endif
	}
	return(0xff);
}

