#include	"compiler.h"

#include	"np2.h"
#include	"np2pc98.h"
#include	"memory.h"
#include	"iobridge.h"
#include	"gdc.h"
#include	"gdc_cmd.h"
#include	"dispsync.h"

		DSYNC_T	dsync;
static	DSYNC_T	dsync_org = {0, 80, 0, 400, 0, 400, {0, 0, 640, 400}, 0, 0};

void dispsync_reset(void) {

	dsync = dsync_org;
	np2os_setsize(&dsync.scrn);
}


BOOL dispsync_set(void) {

	DSYNC_T	ds;

	ZeroMemory(&ds, sizeof(ds));

	// xSYNC
	ds.hbp = gdc.m.para[GDC_SYNC + 4] & 0x1f;
	if (ds.hbp >= 7) {
		ds.hbp -= 7;
	}
	else {
		ds.hbp = 0;
	}
	ds.xmax = (DWORD)gdc.m.para[GDC_SYNC + 1] + 2;
	if ((ds.hbp + ds.xmax) > 80) {
		ds.xmax = 80 - ds.hbp;
	}

	// YSYNC
	ds.text_vbp = gdc.m.para[GDC_SYNC + 7] >> 2;
	ds.grph_vbp = gdc.s.para[GDC_SYNC + 7] >> 2;
	if (ds.text_vbp >= ds.grph_vbp) {
		ds.text_vbp -= ds.grph_vbp;
		ds.grph_vbp = 0;
	}
	else {
		ds.grph_vbp -= ds.text_vbp;
		ds.text_vbp = 0;
	}

	ds.textymax = GETWORD(gdc.m.para + GDC_SYNC + 6) & 0x3ff;
	if (ds.textymax) {
		ds.textymax += ds.text_vbp;
		if (ds.textymax > SURFACE_HEIGHT) {
			ds.textymax = SURFACE_HEIGHT;
		}
	}
	else {
		ds.textymax = SURFACE_HEIGHT;
	}

	ds.grphymax = GETWORD(gdc.s.para + GDC_SYNC + 6) & 0x3ff;
	if (ds.grphymax) {
		ds.grphymax += ds.grph_vbp;
		if (ds.grphymax > SURFACE_HEIGHT) {
			ds.grphymax = SURFACE_HEIGHT;
		}
	}
	else {
		ds.grphymax = SURFACE_HEIGHT;
	}

	// textvadľޤ
	if (!memcmp(&dsync, &ds, (int)(&(((DSYNC_T *)NULL)->scrn)))) {
		return(FALSE);
	}

	// 㤦Τǥԡ
	memcpy(&dsync, &ds, (int)(&(((DSYNC_T *)NULL)->scrn)));

	dsync.scrn.x = dsync.hbp * 8;
	dsync.scrn.w = dsync.xmax * 8;

	dsync.scrn.y = 0;
	// max Win32ޥ	#define max(a,b) (((a)>(b))?(a):(b))
	dsync.scrn.h = max(dsync.grphymax, dsync.textymax);

	np2os_setsize(&dsync.scrn);

	dsync.textvad = dsync.text_vbp * 640;
	dsync.grphvad = dsync.grph_vbp * 640;

	if (dsync.text_vbp) {
		ZeroMemory(np2_tram, dsync.text_vbp * 640);
	}
	if (dsync.scrn.h - dsync.textymax) {
		ZeroMemory(np2_tram + dsync.textymax * 640,
								(dsync.scrn.h - dsync.textymax) * 640);
	}
	if (dsync.grph_vbp) {
		ZeroMemory(np2_vram[0], dsync.grph_vbp * 640);
		ZeroMemory(np2_vram[1], dsync.grph_vbp * 640);
	}
	if (dsync.scrn.h - dsync.grphymax) {
		ZeroMemory(np2_vram[0] + dsync.grphymax * 640,
								(dsync.scrn.h - dsync.grphymax) * 640);
		ZeroMemory(np2_vram[1] + dsync.grphymax * 640,
								(dsync.scrn.h - dsync.grphymax) * 640);
	}
	return(TRUE);
}


