#include	"compiler.h"

#include	"np2pc98.h"
#include	"memory.h"
#include	"iobridge.h"
#include	"egc.h"
#include	"egcwork.h"
#include	"vram.h"
#include	"trace.h"

#ifdef __cplusplus
extern "C" {
#endif
		EGC_T		egc;
#ifdef __cplusplus
}
#endif


#if (defined(NP2_LITTLEENDIAN) || defined(NP2_TESTBIGENDIAN))

static	DWORD	maskword[16][2] = {
						{0x00000000, 0x00000000}, {0x0000ffff, 0x00000000},
						{0xffff0000, 0x00000000}, {0xffffffff, 0x00000000},
						{0x00000000, 0x0000ffff}, {0x0000ffff, 0x0000ffff},
						{0xffff0000, 0x0000ffff}, {0xffffffff, 0x0000ffff},
						{0x00000000, 0xffff0000}, {0x0000ffff, 0xffff0000},
						{0xffff0000, 0xffff0000}, {0xffffffff, 0xffff0000},
						{0x00000000, 0xffffffff}, {0x0000ffff, 0xffffffff},
						{0xffff0000, 0xffffffff}, {0xffffffff, 0xffffffff}};

#else

static	DWORD	maskword[16][2] = {
						{0x00000000, 0x00000000}, {0xffff0000, 0x00000000},
						{0x0000ffff, 0x00000000}, {0xffffffff, 0x00000000},
						{0x00000000, 0xffff0000}, {0xffff0000, 0xffff0000},
						{0x0000ffff, 0xffff0000}, {0xffffffff, 0xffff0000},
						{0x00000000, 0x0000ffff}, {0xffff0000, 0x0000ffff},
						{0x0000ffff, 0x0000ffff}, {0xffffffff, 0x0000ffff},
						{0x00000000, 0xffffffff}, {0xffff0000, 0xffffffff},
						{0x0000ffff, 0xffffffff}, {0xffffffff, 0xffffffff}};

#endif

void egc_init(void) {

	ZeroMemory(&egc, sizeof(egc));
	egc.access = 0xfff0;
	egc.fgbg = 0x00ff;
	egc.mask.w = 0xffff;
	egc.leng = 0x000f;
	egcshift();
}

I286_OUT egc_w(WORD port, WORD value) {

	if (!(vramop.operate & VOP_EGCBIT)) {
		return;
	}
	TRACEOUTW(port, value);

	switch(port & 0x000f) {
		case 0x00:
			egc.access = value;
			break;
		case 0x02:
			egc.fgbg = value;
			break;
		case 0x04:
			egc.ope = value;
			break;
		case 0x06:
			egc.fg = value;
			egc.fgc.d[0] = maskword[value & 15][0];
			egc.fgc.d[1] = maskword[value & 15][1];
			break;
		case 0x08:
			if (!(egc.fgbg & 0x6000)) {
				egc.mask.w = value;
			}
			break;
		case 0x0a:
			egc.bg = value;
			egc.bgc.d[0] = maskword[value & 15][0];
			egc.bgc.d[1] = maskword[value & 15][1];
			break;
		case 0x0c:
			egc.sft = value;
			egcshift();
			break;
		case 0x0e:
			egc.leng = value;
			egcshift();
			break;
	}
}

