#include	"compiler.h"

#include	"np2.h"
#include	"np2pc98.h"
#include	"memory.h"
#include	"iobridge.h"
#include	"crtc.h"
#include	"gdc.h"
#include	"gdc_cmd.h"
#include	"maketext.h"
#include	"font.h"
#include	"dispsync.h"

	TRAM_T	tramflag;

static	DWORD	text_table[512];
static	DWORD	text_tblx2[512][2];

void maketext_reset(void) {

	ZeroMemory(&tramflag, sizeof(tramflag));
}

void maketext_init(void) {

	int		i, j;
	BYTE	bit;

	ZeroMemory(text_table, sizeof(text_table));
	for (i=0; i<8; i++) {
		for (j=0; j<16; j++) {
#if (defined(NP2_LITTLEENDIAN) || defined(NP2_TESTBIGENDIAN))
			for (bit=1; bit<0x10; bit<<=1)
#else
			for (bit=8; bit; bit>>=1)
#endif
			{
				text_table[i*16+j] <<= 8;
				text_table[i*16+j+128] <<= 8;
				if (j & bit) {
					text_table[i*16+j] |= (i+1) << 4;
				}
				else {
					text_table[i*16+j+128] |= (i+1) << 4;
				}
			}
		}
	}
	for (i=0; i<256; i++) {
		text_table[i+256] = text_table[i ^ 0x80];
	}
	for (i=0; i<512; i++) {
#if (defined(NP2_LITTLEENDIAN) || defined(NP2_TESTBIGENDIAN))
		text_tblx2[i][0]  = (text_table[i] & 0x000000ff);
		text_tblx2[i][0] |= (text_table[i] & 0x0000ffff) << 8;
		text_tblx2[i][0] |= (text_table[i] & 0x0000ff00) << 16;
		text_tblx2[i][1]  = (text_table[i] & 0x00ff0000) >> 16;
		text_tblx2[i][1] |= (text_table[i] & 0xffff0000) >> 8;
		text_tblx2[i][1] |= (text_table[i] & 0xff000000);
#else
		text_tblx2[i][0]  = (text_table[i] & 0xff000000);
		text_tblx2[i][0] |= (text_table[i] & 0xffff0000) >> 8;
		text_tblx2[i][0] |= (text_table[i] & 0x00ff0000) >> 16;
		text_tblx2[i][1]  = (text_table[i] & 0x0000ff00) << 16;
		text_tblx2[i][1] |= (text_table[i] & 0x0000ffff) << 8;
		text_tblx2[i][1] |= (text_table[i] & 0x000000ff);
#endif
	}
}

#ifdef NP2_MAKETEXT_ASM

LABEL static BYTE dirtyonblink(void) {

	__asm {
				xor		edx, edx
				xor		eax, eax
blinkdirtylp:	test	byte ptr (mem[0a2000h + edx*2]), TXTATR_BL
				je		short nonblink
				mov		al, 1
				or		tramupdate[edx], al
nonblink:		inc		edx
				cmp		edx, 1000h
				jc		blinkdirtylp
				ret
	}
}
#else
static BYTE dirtyonblink(void) {

	int		i;
	BYTE	ret = 0;

	for (i=0; i<0x1000; i++) {
		if (mem[0xa2000 + i*2] & TXTATR_BL) {
			ret = 1;
			tramupdate[i] |= 1;
		}
	}
	return(ret);
}
#endif


BYTE maketext_curblink(void) {

	BYTE	ret = 0;

	if (tramflag.renewal & 1) {
		tramflag.curdisp = tramflag.count & 1;
		if (!(gdc.m.para[GDC_CSRFORM] & 0x80)) {
			tramflag.curdisp = 0;
		}
		else if (gdc.m.para[GDC_CSRFORM+1] & 0x20) {
			tramflag.curdisp = 1;
		}
		if ((tramflag.curdisp != tramflag.curdisplast) ||
			(tramflag.curpos != GETWORD(gdc.m.para + GDC_CSRW))) {
			if ((tramflag.curdisplast) && (tramflag.curpos < 0x1000)) {
				tramupdate[tramflag.curpos] = 1;
			}
			tramflag.curdisplast = tramflag.curdisp;
			tramflag.curpos = GETWORD(gdc.m.para + GDC_CSRW);
			if ((tramflag.curdisplast) && (tramflag.curpos < 0x1000)) {
				tramupdate[tramflag.curpos] = 1;
			}
			ret = GDCSCRN_REDRAW;
		}
	}
	if (tramflag.renewal & 2) {
		tramflag.blinkdisp = ((tramflag.count & 3)?1:0);
		if (tramflag.blink) {
			tramflag.blink = dirtyonblink();
			if (tramflag.blink) {
				ret = GDCSCRN_REDRAW;
			}
		}
	}
	tramflag.renewal = 0;
	return(ret);
}


void MAKESCRN_CALL maketext(int text_renewal) {

	BYTE	TEXT_LR = gdc.m.para[GDC_CSRFORM] & 0x1f;
	short	TEXT_PL = crtc.reg.pl;
	short	TEXT_BL = crtc.reg.bl + 1;
	short	TEXT_CL = crtc.reg.cl;
	short	TEXT_SUR = crtc.reg.sur;
	short	TEXT_SDR = -1;
	WORD	esi;
	WORD	edi;
	WORD	scroll;
	int		scrp = 0;
	short	lines;
	short 	topline;
	BYTE	LRcnt = 0;
	DWORD	bitmap[TEXTXMAX];
	WORD	color[TEXTXMAX];
	BYTE	curx[TEXTXMAX+1];
	DWORD	gaiji1st;												// ver0.28
	BYTE	kanji2nd;
	int		x;
	DWORD	y;
	short	nowline = 0;
	BYTE	fbwork;
	int		new_flag = 0;
	int		cur_line = -1;
	BYTE	kc;
	int		linecnt = 0;
	short	wait1 = 0;
	short	wait2 = 0;
	BYTE	*q = np2_tram + dsync.textvad;							// ver0.26
	BYTE	line_effect;
	int		reloadline = 0;
	WORD	pitch;													// ver0.26
	DWORD	lastbitp;												// ver0.28

	if (text_renewal) {
		tramflag.gaiji = 0;
	}
	if (TEXT_CL > 16) {
		TEXT_CL = 16;
	}
	if (TEXT_PL >= 16) {
		topline = TEXT_PL - 32;
		lines = TEXT_BL;
	}
	else {
		topline = TEXT_PL;
		if ((lines = TEXT_BL - topline) <= 0) {
			lines += 32;											// 
		}
	}
	nowline = topline;

	if (!TEXT_SUR) {
		wait2 = crtc.reg.ssl;
		TEXT_SDR = crtc.reg.sdr + 1;
	}
	else {
		TEXT_SUR = 32 - TEXT_SUR;
	}

	esi = GETWORD(gdc.m.para + GDC_SCROLL) & 0xfff;
	scroll = ((GETWORD(gdc.m.para + GDC_SCROLL + 2)) >> 4) & 0x3ff;

	pitch = gdc.m.para[GDC_PITCH] & 0xfe;							// ver0.26

	for (y=dsync.text_vbp; y<dsync.textymax;) {						// ver0.26
		if (!wait1) {
			if (LRcnt-- == 0) {
				LRcnt = TEXT_LR;
				reloadline = 1;
			}
		}
		else {
			wait1--;
		}
		if (reloadline) {
			reloadline = 0;
			new_flag = text_renewal;
			cur_line = -1;
			line_effect = 0;
			if (!new_flag) {
				edi = esi;
				for (x=0; x<TEXTXMAX; x++) {
					if (tramupdate[edi]) {
						new_flag = 1;
						break;
					}
					edi = (edi + 1) & 0xfff;
				}
			}
			if (new_flag) {
				edi = esi;
				gaiji1st = 0;
				kanji2nd = 0;
				lastbitp = 0;										// ver0.28
				for (x=0; x<TEXTXMAX; x++) {						// width80
					if (edi == GETWORD(gdc.m.para + GDC_CSRW)) {
						cur_line = x;
					}
					curx[x] = mem[0xa2000 + edi*2] & (~TEXTATR_RGB);
					line_effect |= curx[x];
					color[x] = (mem[0xa2000 + edi*2] & (TEXTATR_RGB)) >> 1;
					if (curx[x] & TXTATR_RV) {				// text reverse
						color[x] |= 0x80;
					}
					if (kanji2nd) {
						kanji2nd = 0;
						bitmap[x] = lastbitp + 0x800;				// ver0.28
						curx[x-1] |= 0x80;
						curx[x] |= curx[x-1] & 0x20;				// ver0.28
					}
					else if (!(mem[0xa0001 + edi*2] & gdc.bitac)) {
						gaiji1st = 0;
						if (gdc.mode1 & 8) {
							bitmap[x] = 0x80000 +
										(mem[0xa0000 + edi*2] << 4);
							if ((curx[x] & TXTATR_BG) && (gdc.mode1 & 1)) {
//								curx[x] &= ~(TXTATR_BG);			// ver0.27
								bitmap[x] += 0x1000;
							}
						}
						else {
							bitmap[x] = 0x82000 + 
										(mem[0xa0000 + edi*2] << 3);
							curx[x] |= 0x20;						// ver0.28
							if ((curx[x] & TXTATR_BG) && (gdc.mode1 & 1)) {
//								curx[x] &= ~(TXTATR_BG);			// ver0.27
								bitmap[x] += 0x800;
							}
						}
					}
					else {											// ver0.27
						bitmap[x] = (MEM_GETW(0xa0000 + edi*2) & 0x7f7f) << 4;
						kc = mem[0xa0000 + edi*2] & 0x7e;
						if (kc == 0x56) {							// ver0.28
							tramflag.gaiji = 1;
							if ((gaiji1st) &&
								(bitmap[x] == (lastbitp & (~15)))) {
								curx[x-1] |= 0x80;
							}
							bitmap[x] += gaiji1st;
							gaiji1st ^= 0x800;
						}
						else {
							gaiji1st = 0;
							if ((kc < 0x08) || (kc >= 0x0c)) {
								kanji2nd = 1;
							}
						}
																	// ver0.28
						if ((curx[x] & TXTATR_BG) && (gdc.mode1 & 1)) {
							curx[x] |= 0x20;
							bitmap[x] += 8;
						}
						else if (!(gdc.mode1 & 8)) {
							curx[x] |= 0x20;
						}
					}
					lastbitp = bitmap[x];
					if (!(curx[x] & TXTATR_ST)) {		// ͥ褬	// ver0.27
						bitmap[x] = 0;
					}
					else if (curx[x] & TXTATR_BL) {
						tramflag.blink = 1;
						if (!tramflag.blinkdisp) {
							bitmap[x] = 0;
						}
					}
					edi = (edi+1) & 0x0fff;							// width80
				}
				if (!tramflag.curdisp) {
					cur_line = -1;
				}
			}
			esi = (esi + pitch) & 0x0fff;							// ver0.26
		}

		if ((!TEXT_SDR) && (nowline >= topline + crtc.reg.ssl)) {
			nowline = topline;
			TEXT_SDR--;
			wait1 = crtc.reg.ssl;
		}

		if (!wait2) {
			if (new_flag) {
				renewal_line[y] |= 4;
				if (cur_line >= 0) {
					if ((nowline >= (gdc.m.para[GDC_CSRFORM+1] & 0x1f)) &&
						(nowline <= (gdc.m.para[GDC_CSRFORM+2] >> 3))) {
						color[cur_line] |= 256;
						if (curx[cur_line] & 0x80) {				// ver0.28
							color[cur_line+1] |= 256;
						}
					}
					else {
						color[cur_line] &= ~(256);
						if (curx[cur_line] & 0x80) {				// ver0.28
							color[cur_line+1] &= ~(256);
						}
					}
				}
				if ((nowline >= 0) && (nowline < TEXT_CL)) {
					// width80
					for (x=0; x<TEXTXMAX; x++) {
						DWORD fntline;							// ver0.28
						fntline = nowline & 0x0f;
						if (curx[x] & 0x20) {
							fntline >>= 1;
						}
						fbwork = font[bitmap[x] + fntline];
						*(DWORD *)q = text_table[color[x]+(fbwork>>4)];
						*(DWORD *)(q+4) = text_table[color[x]+(fbwork&0xf)];
						q += 8;
					}
				}
				else {
					// width80
					for (x=0; x<(TEXTXMAX); x++) {
						*(DWORD *)q = text_table[color[x]];
						*(DWORD *)(q+4) = text_table[color[x]];
						q += 8;
					}
				}
				if ((line_effect & TXTATR_UL) &&
					((nowline + 1) == lines)) {			// 饤
					// width80
					q -= TEXTXMAX * 8;
					q += 4;
					for (x=0; x<(TEXTXMAX-1); x++) {
						if (curx[x] & TXTATR_UL) {
							*(DWORD *)q = text_table[(color[x] & 0x70) | 0x0f];
							*(DWORD *)(q+4) = text_table[(color[x+1] & 0x70)
																	| 0x0f];
						}
						q += 8;
					}
					if (curx[TEXTXMAX-1] & TXTATR_UL) {
						*(DWORD *)q = text_table[(color[TEXTXMAX-1] & 0x70)
																	| 0x0f];
					}
					q += 4;
				}
#if 1												// virtical line ver0.27
				if ((line_effect & TXTATR_VL) && (!(gdc.mode1 & 1))) {
					// width80
					q -= TEXTXMAX * 8;
					for (x=0; x<TEXTXMAX; x++) {
						if (curx[x] & TXTATR_VL) {
							// text_table[]  ȤäƤʤΤ
							*(q+4) |= (color[x] & 0x70) + 0x10;
						}
						q += 8;
					}
				}

// *(q+4) |= (color[x] & 0x70) + 0x10; ϡ
// *(DWORD *)(q+4) = text_table[(color[x] & 0x70) + 8];
// ˤʤȦ

#endif
			}
			else {
				q += TEXTXMAX * 8;
			}
			y++;
			if (!(--scroll)) {
				scrp = (scrp + 4) & 0x0c;
				esi = GETWORD(gdc.m.para + GDC_SCROLL + scrp) & 0xfff;
				scroll = (GETWORD(gdc.m.para + GDC_SCROLL + scrp + 2)
														>> 4) & 0x3ff;
				reloadline = 1;
			}
		}
		else {
			wait2--;
		}

		nowline++;
		if ((TEXT_SDR) && (nowline >= lines)) {
			nowline = topline;
			TEXT_SDR--;
			if (++linecnt == TEXT_SUR) {
				wait2 = crtc.reg.ssl;
				TEXT_SDR = crtc.reg.sdr + 1;
			}
		}
	}
	ZeroMemory(tramupdate, sizeof(tramupdate));
}


void MAKESCRN_CALL maketext40(int text_renewal) {

	BYTE	TEXT_LR = gdc.m.para[GDC_CSRFORM] & 0x1f;
	short	TEXT_PL = crtc.reg.pl;
	short	TEXT_BL = crtc.reg.bl + 1;
	short	TEXT_CL = crtc.reg.cl;
	short	TEXT_SUR = crtc.reg.sur;
	short	TEXT_SDR = -1;
	WORD	esi;
	WORD	edi;
	WORD	scroll;
	int		scrp = 0;
	short	lines;
	short 	topline;
	BYTE	LRcnt = 0;
	DWORD	bitmap[TEXTXMAX];
	WORD	color[TEXTXMAX];
	BYTE	curx[TEXTXMAX+1];
	DWORD	gaiji1st;												// ver0.28
	BYTE	kanji2nd;
	int		x;
	DWORD	y;
	short	nowline = 0;
	BYTE	fbwork;
	int		new_flag = 0;
	int		cur_line = -1;
	BYTE	kc;
	int		linecnt = 0;
	short	wait1 = 0;
	short	wait2 = 0;
	BYTE	*q = np2_tram + dsync.textvad;							// ver0.26
	BYTE	line_effect;
	int		reloadline = 0;
	WORD	pitch;													// ver0.26
	DWORD	lastbitp;

	if (text_renewal) {
		tramflag.gaiji = 0;
	}
	if (TEXT_CL > 16) {
		TEXT_CL = 16;
	}
	if (TEXT_PL >= 16) {
		topline = TEXT_PL - 32;
		lines = TEXT_BL;
	}
	else {
		topline = TEXT_PL;
		if ((lines = TEXT_BL - topline) <= 0) {
			lines += 32;											// 
		}
	}
	nowline = topline;

	if (!TEXT_SUR) {
		wait2 = crtc.reg.ssl;
		TEXT_SDR = crtc.reg.sdr + 1;
	}
	else {
		TEXT_SUR = 32 - TEXT_SUR;
	}

	esi = GETWORD(gdc.m.para + GDC_SCROLL) & 0xfff;
	scroll = ((GETWORD(gdc.m.para + GDC_SCROLL + 2)) >> 4) & 0x3ff;

	pitch = gdc.m.para[GDC_PITCH] & 0xfe;							// ver0.26

	for (y=dsync.text_vbp; y<dsync.textymax;) {						// ver0.26
		if (!wait1) {
			if (LRcnt-- == 0) {
				LRcnt = TEXT_LR;
				reloadline = 1;
			}
		}
		else {
			wait1--;
		}
		if (reloadline) {
			reloadline = 0;
			new_flag = text_renewal;
			cur_line = -1;
			line_effect = 0;
			if (!new_flag) {
				edi = esi;
				for (x=0; x<TEXTXMAX; x++) {
					if (tramupdate[edi]) {
						new_flag = 1;
						break;
					}
					edi = (edi + 1) & 0xfff;
				}
			}
			if (new_flag) {
				edi = esi;
				gaiji1st = 0;
				kanji2nd = 0;
				lastbitp = 0;										// ver0.28
				for (x=0; x<(TEXTXMAX/2); x++) {					// width40
					if (edi == GETWORD(gdc.m.para + GDC_CSRW)) {
						cur_line = x;
					}
					curx[x] = mem[0xa2000 + edi*2] & (~TEXTATR_RGB);
					line_effect |= curx[x];
					color[x] = (mem[0xa2000 + edi*2] & (TEXTATR_RGB)) >> 1;
					if (curx[x] & TXTATR_RV) {			// text reverse
						color[x] |= 0x80;
					}
					if (kanji2nd) {
						kanji2nd = 0;
						bitmap[x] = lastbitp + 0x800;				// ver0.28
						curx[x-1] |= 0x80;
						curx[x] |= curx[x-1] & 0x20;				// ver0.28
					}
					else if (!(mem[0xa0001 + edi*2] & gdc.bitac)) {
						gaiji1st = 0;
						if (gdc.mode1 & 8) {
							bitmap[x] = 0x80000 +
										(mem[0xa0000 + edi*2] << 4);
							if ((curx[x] & TXTATR_BG) && (gdc.mode1 & 1)) {
//								curx[x] &= ~(TXTATR_BG);			// ver0.27
								bitmap[x] += 0x1000;
							}
						}
						else {
							bitmap[x] = 0x82000 + 
										(mem[0xa0000 + edi*2] << 3);
							curx[x] |= 0x20;						// ver0.28
							if ((curx[x] & TXTATR_BG) && (gdc.mode1 & 1)) {
//								curx[x] &= ~(TXTATR_BG);			// ver0.27
								bitmap[x] += 0x800;
							}
						}
					}
					else {											// ver0.27
						bitmap[x] = (MEM_GETW(0xa0000 + edi*2) & 0x7f7f) << 4;
						kc = mem[0xa0000 + edi*2] & 0x7e;
						if (kc == 0x56) {							// 
							tramflag.gaiji = 1;
							if ((gaiji1st) &&
								(bitmap[x] == (lastbitp & (~15)))) {
								curx[x-1] |= 0x80;
							}
							bitmap[x] += gaiji1st;
							gaiji1st ^= 0x800;
						}
						else {
							gaiji1st = 0;
							if ((kc < 0x08) || (kc >= 0x0c)) {
								kanji2nd = 1;
							}
						}
																	// ver0.28
						if ((curx[x] & TXTATR_BG) && (gdc.mode1 & 1)) {
							curx[x] |= 0x20;
							bitmap[x] += 8;
						}
						else if (!(gdc.mode1 & 8)) {
							curx[x] |= 0x20;
						}
					}
					lastbitp = bitmap[x];							// ver0.28
					if (!(curx[x] & TXTATR_ST)) {		// ͥ褬	// ver0.27
						bitmap[x] = 0;
					}
					else if (curx[x] & TXTATR_BL) {
						tramflag.blink = 1;
						if (!tramflag.blinkdisp) {
							bitmap[x] = 0;
						}
					}
					edi = (edi+2) & 0x0fff;							// width40
				}
				if (!tramflag.curdisp) {
					cur_line = -1;
				}
			}
			esi = (esi + pitch) & 0x0fff;							// ver0.26
		}

		if ((!TEXT_SDR) && (nowline >= topline + crtc.reg.ssl)) {
			nowline = topline;
			TEXT_SDR--;
			wait1 = crtc.reg.ssl;
		}

		if (!wait2) {
			if (new_flag) {
				renewal_line[y] |= 4;
				if (cur_line >= 0) {
					if ((nowline >= (gdc.m.para[GDC_CSRFORM+1] & 0x1f)) &&
						(nowline <= (gdc.m.para[GDC_CSRFORM+2] >> 3))) {
						color[cur_line] |= 256;
						if (curx[cur_line] & 0x80) {			// ver0.28
							color[cur_line+1] |= 256;
						}
					}
					else {
						color[cur_line] &= ~(256);
						if (curx[cur_line] & 0x80) {				// ver0.28
							color[cur_line+1] &= ~(256);
						}
					}
				}
				if ((nowline >= 0) && (nowline < TEXT_CL)) {
					// width40
					for (x=0; x<(TEXTXMAX/2); x++) {
						DWORD fntline;								// ver0.28
						fntline = nowline & 0x0f;
						if (curx[x] & 0x20) {
							fntline >>= 1;
						}
						fbwork = font[bitmap[x] + fntline];
						*(DWORD *)(q+ 0) = text_tblx2[color[x] +
															(fbwork>>4)][0];
						*(DWORD *)(q+ 4) = text_tblx2[color[x] +
															(fbwork>>4)][1];
						*(DWORD *)(q+ 8) = text_tblx2[color[x] +
															(fbwork&0xf)][0];
						*(DWORD *)(q+12) = text_tblx2[color[x] +
															(fbwork&0xf)][1];
						q += 16;
					}
				}
				else {
					// width40
					for (x=0; x<(TEXTXMAX/2); x++) {
						*(DWORD *)q = text_table[color[x]];
						*(DWORD *)(q+4) = text_table[color[x]];
						*(DWORD *)(q+8) = text_table[color[x]];
						*(DWORD *)(q+12) = text_table[color[x]];
						q += 16;
					}
				}
				if ((line_effect & TXTATR_UL) &&
					((nowline + 1) == lines)) {			// 饤
					// width40
					q -= TEXTXMAX * 8;
					q += 4;
					for (x=0; x<((TEXTXMAX/2)-1); x++) {
						if (curx[x] & 8) {
							*(DWORD *)q = text_table[(color[x] & 0x70)
																	+ 0x0f];
							*(DWORD *)(q+4) = text_table[(color[x] & 0x70)
																	+ 0x0f];
							*(DWORD *)(q+8) = text_table[(color[x] & 0x70)
																	+ 0x0f];
							*(DWORD *)(q+12) = text_table[(color[x+1] & 0x70)
																	+ 0x0f];
						}
						q += 16;
					}
					if (curx[(TEXTXMAX/2)-1] & TXTATR_UL) {
						*(DWORD *)q = text_table[(color[TEXTXMAX-1] & 0x70)
																	+ 0x0f];
						*(DWORD *)(q+4) = text_table[(color[TEXTXMAX-1] & 0x70)
																	+ 0x0f];
						*(DWORD *)(q+8) = text_table[(color[TEXTXMAX-1] & 0x70)
																	+ 0x0f];
					}
					q += 12;
				}
#if 1												// virtical line ver0.27
				if ((line_effect & TXTATR_VL) && (!(gdc.mode1 & 1))) {
					// width40
					q -= TEXTXMAX * 8;
					for (x=0; x<(TEXTXMAX/2); x++) {
						if (curx[x] & TXTATR_VL) {
							// text_table[]  ȤäƤʤΤ
							*(q+4) |= (color[x] & 0x70) + 0x10;
							*(q+12) |= (color[x] & 0x70) + 0x10;
						}
						q += 16;
					}
				}
#endif
			}
			else {
				q += TEXTXMAX * 8;
			}
			y++;
			if (!(--scroll)) {
				scrp = (scrp + 4) & 0x0c;
				esi = GETWORD(gdc.m.para + GDC_SCROLL + scrp) & 0xfff;
				scroll = (GETWORD(gdc.m.para + GDC_SCROLL + scrp + 2)
														>> 4) & 0x3ff;
				reloadline = 1;
			}
		}
		else {
			wait2--;
		}

		nowline++;
		if ((TEXT_SDR) && (nowline >= lines)) {
			nowline = topline;
			TEXT_SDR--;
			if (++linecnt == TEXT_SUR) {
				wait2 = crtc.reg.ssl;
				TEXT_SDR = crtc.reg.sdr + 1;
			}
		}
	}
	ZeroMemory(tramupdate, sizeof(tramupdate));
}

