#include	"compiler.h"

#include	"np2.h"
#include	"iobridge.h"
#include	"nevent.h"
#include	"mouseif.h"
#include	"pc_core.h"
#include	"pic.h"
#include	"serial.h"

	MOUSE_TABLE		mouseif;


// ޥ ver0.28
// ΥǥޥǡڤΤƤΤưʤʤ
// ߤ٤ ˰ưǡ褦ˤʤФʤʤ


void mouseif_sync(void) {

	// ʬ
	mouseif.x += mouseif.rx;
	mouseif.y += mouseif.ry;

	// ΰư̤
	mouseif.b = np2os_getmousestat(&mouseif.sx, &mouseif.sy, 1);
	mouseif.b &= mousekey(&mouseif.sx, &mouseif.sy);
	mouseif.rx = mouseif.sx;
	mouseif.ry = mouseif.sy;

	mouseif.lastc = nevent.clock + nevent.baseclock
											- nevent.remainclock;
}

static void calc_mousexy(void) {

	DWORD	clock;
	long	diff;

	clock = nevent.clock + nevent.baseclock - nevent.remainclock;
	diff = clock - mouseif.lastc;
	if (diff >= 2000) {
		short dx, dy;
		mouseif.rapid ^= 0xa0;
		diff /= 1000;
		dx = (short)((long)mouseif.sx * diff / (long)pc.frame1000);
		if (dx >= 0) {											// 
			if (dx > mouseif.rx) {
				dx = mouseif.rx;
			}
		}
		else {													// 
			if (dx < mouseif.rx) {
				dx = mouseif.rx;
			}
		}
		mouseif.x += dx;
		mouseif.rx -= dx;
		dy = (short)((long)mouseif.sy * diff / (long)pc.frame1000);
		if (dy >= 0) {											// 
			if (dy > mouseif.ry) {
				dy = mouseif.ry;
			}
		}
		else {													// 
			if (dy < mouseif.ry) {
				dy = mouseif.ry;
			}
		}
		mouseif.y += dy;
		mouseif.ry -= dy;
		mouseif.lastc += diff * 1000;
	}
}




NEVENT_PROC mouseint(NEVENT_ITEM *item) {

	if (item->flag & NEVENT_SETEVENT) {
		pic_setirq(0x0d);
		nevent_set(NEVENT_MOUSE, pc.mouseclock << mouseif.timing,
												mouseint, NEVENT_RELATIVE);
	}
}

static void setportc(BYTE value) {

	if ((value & 0x80) && (!(mouseif.portc & 0x80))) {
		calc_mousexy();
		mouseif.latch_x = mouseif.x;
		mouseif.x = 0;
		mouseif.latch_y = mouseif.y;
		mouseif.y = 0;
		if (mouseif.latch_x > 127) {
			mouseif.latch_x = 127;
		}
		else if (mouseif.latch_x < -128) {
			mouseif.latch_x = -128;
		}
		if (mouseif.latch_y > 127) {
			mouseif.latch_y = 127;
		}
		else if (mouseif.latch_y < -128) {
			mouseif.latch_y = -128;
		}
	}
	if ((value ^ mouseif.portc) & 0x10) {
		if (!(value & 0x10)) {
			if (!nevent_iswork(NEVENT_MOUSE)) {
				nevent_set(NEVENT_MOUSE, pc.mouseclock << mouseif.timing,
												mouseint, NEVENT_ABSOLUTE);
			}
		}
	}
	mouseif.portc = value;
}



// ---------------------------------------------------------------------------

void mouseif_init(void) {

	ZeroMemory(&mouseif, sizeof(mouseif));
	mouseif.mode = 0x93;
	mouseif.portc = 0x10;											// ver0.28
}


I286_OUT mouseif_w(WORD port, BYTE value) {

	switch(port & 0x7) {
		case 0x05:
			setportc(value);
			break;

		case 0x07:													// 07/19
			if (value & 0xf0) {
				mouseif.mode = value;
				if (value == 0x93) {								// ver0.28
					setportc(0);
				}
			}
			else {
				if (value & 1) {
					setportc(mouseif.portc | (1 << (value >> 1)));
				}
				else {
					setportc(mouseif.portc & (~(1 << (value >> 1))));
				}
			}
			break;
	}
}

I286_INB mouseif_r(WORD port) {

	short	x, y;
	BYTE	ret;

	switch(port & 0x7) {
		case 0x01:
			calc_mousexy();
			ret = mouseif.b & 0xf0;
			if (np2cfg.MOUSERAPID) {
				ret |= mouseif.rapid;
			}
			ret |= 0x40;
			if (mouseif.portc & 0x80) {
				x = mouseif.latch_x;
				y = mouseif.latch_y;
			}
			else {
				x = mouseif.x;
				y = mouseif.y;
			}
			if (mouseif.portc & 0x40) {
				x = y;
			}
			if (!(mouseif.portc & 0x20)) {
				ret |= x & 0x0f;
			}
			else {
				ret |= (x >> 4) & 0x0f;
			}
			return(ret);

		case 0x03:
			return(0x40);				// RAMKL bit6褦		// ver0.29

		case 0x05:													// 06/04
			ret = mouseif.portc;
			if (mouseif.mode & 8) {
				ret &= 0x1f;										// 06/08
			}
			if (mouseif.mode & 1) {
				ret &= 0xf0;
				ret |= 0x08;
				ret |= (np2cfg.dipsw[2] >> 5) & 0x04;
				ret |= ((~np2cfg.dipsw[0]) >> 4) & 0x03;
			}
			return(ret);
	}
	return(0xff);
}

I286_OUT mousetiming_w(WORD port, BYTE value) {

	mouseif.timing = value & 3;
}
