#include	"compiler.h"

#include	"pc_core.h"
#include	"i286.h"
#include	"iobridge.h"
#include	"np2sysp.h"

#define		NP2SYSP_VER			"B"
#define		NP2SYSP_CREDIT		""					// פʤ顦

#define		OPEN_HOSTDRV		0
#define		INTR_HOSTDRV		1
#define		CLOSE_HOSTDRV		2

// NP2¸ݡ
// port:07edh	reserved
// port:07efh	np2 string comm

// Ū STRINGǤꤹ
// ݡ 7efh  'NP2' ȽϤ "NP2"֤äƤ NP2Ǥ

// verA
//		out->str: 'ver'				in->str:	verֹ A
//		out->str: 'poweroff'		NP2λ

// verB
//		out->str: 'cpu'				in->str:	CPU
//		out->str: 'clock'			in->str:	ưå


// --------------------------------------------------------------------------

	NP2_SYSPT	np2sysp;


typedef struct {
	char	*key;
	void	(*func)(void *arg1, void *arg2);
	void	*arg1;
	void	*arg2;
} NP2SYSP_CMD;


static void np2sysp_outstr(void *arg1, void * arg2) {

	strcpy(np2sysp.outstr, (char *)arg1);
	np2sysp.outpos = 0;
}

static void np2sysp_pwroff(void * arg1, void * arg2) {

	np2os_exit();
}

static void np2sysp_cpu(void * arg1, void * arg2) {

	// CPU֤
#if 1											// 80286 or V30
	if (!(CPUTYPE & CPUTYPE_V30)) {
		np2sysp_outstr("80286", NULL);
	}
	else {
		np2sysp_outstr("V30", NULL);
	}
#else
	// 386ʹߤξ V30⡼ɤϥߥ졼(?)
	np2sysp_outstr("PENTIUM", NULL);
#endif
}

static void np2sysp_clock(void * arg1, void * arg2) {

	snprintf(np2sysp.outstr, sizeof(np2sysp.outstr), "%uMHz", (pc.realclock + 500000) / 1000000);
	np2sysp.outpos = 0;
}

static void np2sysp_mul(void * arg1, void * arg2) {

	snprintf(np2sysp.outstr, sizeof(np2sysp.outstr), "%u", pc.multiple);
	np2sysp.outpos = 0;
}

static	NP2SYSP_CMD	np2spcmd[] = {
			{"NP2",			np2sysp_outstr, "NP2",			NULL},
			{"ver",			np2sysp_outstr,	NP2SYSP_VER,	NULL},

// version:A
			{"poweroff",	np2sysp_pwroff,	NULL,			NULL},

// version:B
			{"credit",		np2sysp_outstr,	NP2SYSP_CREDIT,	NULL},
			{"cpu",			np2sysp_cpu,	NULL,			NULL},
			{"clock",		np2sysp_clock,	NULL,			NULL},
			{"multiple",	np2sysp_mul,	NULL,			NULL},
};


static BOOL np2syspcmp(char *p) {

	int		len;
	int		pos;

	len = strlen(p);
	if (!len) {
		return(TRUE);
	}
	pos = np2sysp.strpos;
	while(len--) {
		if (p[len] != np2sysp.substr[pos]) {
			return(TRUE);
		}
		pos--;
		pos &= NP2SYSP_MASK;
	}
	return(FALSE);
}


void np2sysp_init(void) {

	ZeroMemory(&np2sysp, sizeof(np2sysp));
}

I286_OUT np2sysp_w(WORD port, BYTE value) {

	int		i;

	switch(port & 3) {
		case 0x01:
			break;

		case 0x03:
			np2sysp.substr[np2sysp.strpos] = value;
			for (i=0; i<(sizeof(np2spcmd) / sizeof(NP2SYSP_CMD)); i++) {
				if (!np2syspcmp(np2spcmd[i].key)) {
					np2spcmd[i].func(np2spcmd[i].arg1, np2spcmd[i].arg2);
					break;
				}
			}
			np2sysp.strpos++;
			np2sysp.strpos &= NP2SYSP_MASK;
			break;
	}
}

I286_INB np2sysp_r(WORD port) {

	BYTE	ret = 0xff;

	switch(port & 3) {
		case 0x01:
			break;

		case 0x03:
			ret = np2sysp.outstr[np2sysp.outpos];
			if (ret) {
				np2sysp.outpos++;
				np2sysp.outpos &= NP2SYSP_MASK;
			}
			break;
	}
	return(ret);
}

