#include	"compiler.h"

#include	"pc_core.h"												// ver0.28
#include	"i286.h"
#include	"iobridge.h"
#include	"pic.h"
#include	"itimer.h"
#include	"nevent.h"
#include	"gdc.h"
#include	"memory.h"

#include	"trace.h"

	PIC_TABLE	pic[2];


static	PIC_TABLE	defaultpic[2] = {
							{0, {0, 0, 0, 0, 0, 0, 0, 0},
								{7, 6, 5, 4, 3, 2, 1, 0},
								{0, 0x08, 0x00, 0},
								0x7d,	//(BYTE)~(PIC_KEYBOARD | PIC_SLAVE)
								0, 0, 0, 0},
							{0, {0, 0, 0, 0, 0, 0, 0, 0},
								{7, 6, 5, 4, 3, 2, 1, 0},
								{0, 0x10, 0x07, 0},
								0x70,	//(BYTE)~(PIC_INT41 | PIC_INT42)
								0, 0, 0, 0}};

static void pic_rolpry(PIC_TABLE *picp) {

	// Ϥϡá󤤤͡Ĥ
	*(DWORD *)(&picp->pry[0]) =
			(*(DWORD *)(&picp->pry[0]) + 0x01010101) & 0x07070707;
	*(DWORD *)(&picp->pry[4]) =
			(*(DWORD *)(&picp->pry[4]) + 0x01010101) & 0x07070707;
}


static void pic_downbylevel(PIC_TABLE *picp, BYTE level) {

	int		i;

	for (i=0; i<8; i++) {
		if (picp->pry[i] < picp->pry[level]) {
			(picp->pry[i])++;
		}
	}
	picp->pry[level] = 0;
}


// eoi
static void pic_forceeoibylevel(PIC_TABLE *picp, BYTE level) {

	int		i;

	if (picp->isr & (1 << level)) {
		picp->isr &= ~(1 << level);
		(picp->levels)--;
		for (i=0; (i<picp->levels) && (picp->level[i] != level); i++) { }
		for (; i<picp->levels; i++) {
			picp->level[i] = picp->level[i+1];
		}
	}
}


void pic_init(void) {

	CopyMemory(pic, defaultpic, sizeof(pic));
}


void pic_irq(void) {

	// ߵĤǡ׵ᤢꡩ
	if ((isI286EI) &&
		((pic[0].irr & (~pic[0].imr)) ||
		(pic[1].irr & (~pic[1].imr)))) {

		int		i;
		BYTE	bit;
		char	pry;
		BYTE	irq;
		BYTE	sirq;
		BYTE	targetbit;

		// ޥν
		if (!pic[0].levels) {
			pry = -1;
		}
		else {
			pry = (char)pic[0].pry[pic[0].level[pic[0].levels - 1]];
		}
		targetbit = 0;
		for (bit=1, i=0; bit; bit<<=1, i++) {
			if ((pic[0].irr & bit) &&
				(!((pic[0].imr | pic[0].isr) & bit))) {
				if ((char)pic[0].pry[i] > pry) {
					pry = pic[0].pry[i];
					irq = (BYTE)i;
					targetbit = bit;
				}
			}
		}
		// 졼׵Ϥ롩
		if (!(pic[1].irr & (~pic[1].imr))) {
			sirq = 0xff;
		}
		else {
			sirq = pic[1].icw[2] & 7;
			bit = 1 << sirq;
			if (!((pic[0].imr | pic[0].isr) & bit)) {
				if ((char)pic[0].pry[sirq] > pry) {
					irq = sirq;
					targetbit = bit;
				}
			}
		}
		// ޥγ
		if (targetbit) {
			pic[0].isr |= targetbit;
			pic[0].irr &= ~targetbit;
			pic[0].level[pic[0].levels++] = irq;
#if 1
			if (irq == 0) {											// ver0.28
				nevent_reset(NEVENT_PICMASK);
			}
#endif
			if (irq != sirq) {
				CPU_INTERRUPT((pic[0].icw[1] & 0xf8) | irq);
				return;
			}
		}
		if ((!pic[0].levels) || (pic[0].level[pic[0].levels - 1] != sirq)) {
			return;
		}
		// 졼ν
		if (!pic[1].levels) {
			pry = -1;
		}
		else {
			pry = (char)pic[1].pry[pic[1].level[pic[1].levels - 1]];
		}
		targetbit = 0;
		for (bit=1, i=0; bit; bit<<=1, i++) {
			if ((pic[1].irr & bit) &&
				(!((pic[1].imr | pic[1].isr) & bit))) {
				if ((char)pic[1].pry[i] > pry) {
					pry = pic[1].pry[i];
					irq = (BYTE)i;
					targetbit = bit;
				}
			}
		}
		// 졼γ
		if (targetbit) {
			if (!(pic[0].icw[2] & targetbit)) {
				pic[1].isr |= targetbit;
				pic[1].irr &= ~targetbit;
				pic[1].level[pic[1].levels++] = irq;
				CPU_INTERRUPT((pic[1].icw[1] & 0xf8) | irq);
			}
		}
	}
}


// ʰץ⡼(SYSTEM TIMER)
NEVENT_PROC picmask(NEVENT_ITEM *item) {

	if (item->flag & NEVENT_SETEVENT) {
		// ĤΤޤˤȥȤƤ					// ver0.28
		pic[0].irr &= ~(pic[0].imr & PIC_SYSTEMTIMER);
	}
}

void pic_setirq(BYTE irq) {

	BYTE	bit = 1 << (irq & 7);

	irq &= 0x0f;
	if (irq < 8) {
		pic[0].irr |= bit;
		if (pic[0].imr & bit) {
			if (bit & PIC_SYSTEMTIMER) {
				if ((itimer.mode[0] & 0x0c) == 0x04) {
					DWORD	cnt;									// ver0.29
					if (itimer.value[0].w > 8) {
						cnt = pc.multiple * itimer.value[0].w;
						cnt >>= 2;
					}
					else {
						cnt = pc.multiple << (16 - 2);
					}
					nevent_set(NEVENT_PICMASK, cnt, picmask, NEVENT_ABSOLUTE);
				}
			}
		}
		if (pic[0].isr & bit) {
			if (bit & PIC_CRTV) {
				pic[0].irr &= ~PIC_CRTV;
				gdc.vsyncint = 1;
			}
		}
	}
	else {
		pic[1].irr |= bit;
	}
}

I286_OUT pic_w(WORD port, BYTE value) {

	PIC_TABLE	*picp = &pic[(port >> 3) & 1];
	BYTE		level;

	if (!(port & 2)) {						// port 00:
		picp->writeicw = 0;
		switch(value & 0x18) {
			case 0x00:						// eoi
				if (value & 0x40) {
					level = value & 7;
				}
				else {
					if (picp->levels == 0) {
						break;
					}
					level = picp->level[picp->levels - 1];
				}
				if (value & 0x80) {
					if (!(value & 0x40)) {
						pic_rolpry(picp);
					}
					else {
						pic_downbylevel(picp, level);
					}
				}
				if (value & 0x20) {
					pic_forceeoibylevel(picp, level);
				}
				nevent_forceexit();				// mainloop exit
				break;
			case 0x08:							// ocw3
				picp->ocw3 = value;
				break;
			default:
				picp->icw[0] = value;
				picp->imr = 0;
				picp->irr = 0;										// ver0.28
				picp->ocw3 = 0;										// ver0.25
#if 0
				picp->levels = 0;
				picp->isr = 0;
#endif
				picp->writeicw = 1;
				break;
		}
	}
	else {									// port 02:
		if (!picp->writeicw) {
			picp->imr = value;
		}
		else {
			picp->icw[picp->writeicw] = value;
			picp->writeicw++;
			if (picp->writeicw >= (3 + (picp->icw[0] & 1))) {
				picp->writeicw = 0;
			}
		}
		nevent_forceexit();											// ver0.28
	}
}


I286_INB pic_r(WORD port) {

	PIC_TABLE	*picp = &pic[(port >> 3) & 1];

	if (!(port & 2)) {						// port 00:
		switch(picp->ocw3 & 0x03) {
			case 0x02:						// read irr
				return(picp->irr);
			case 0x03:						// read isr
				return(picp->isr);
			default:
				return(0x00);				// can can bunny
		}
	}
	return(picp->imr);						// port 02:
}

