#include	"compiler.h"

#include	"np2.h"
#include	"iobridge.h"
#include	"pic.h"
#include	"memory.h"
#include	"pc_core.h"
#include	"serial.h"
#include	"nevent.h"
#include	"dosio.h"
#include	"trace.h"

static BYTE joykeytable[12] = {
				0x2a,	0x34,
				0x29,	0x1c,
				0x3c,	0x48,
				0x3b,	0x46,
				0x3d,	0x4b,
				0x3a,	0x43};

static BYTE kbexflag[0x80] = {

		//	 ESC,  ,  ,  ,  ,  ,  ,  		; 00h
			   0,   0,   0,   0,   0,   0,   0,   0,
		//	  ,  ,  ,  ,  ,  ,  BS, TAB		; 08h
			   0,   0,   0,   0,   0,   0,   0,   0,
		//	  ,  ,  ,  ,  ,  ,  ,  		; 10h
			   0,   0,   0,   0,   0,   0,   0,   0,
		//	  ,  ,  ,  , Ret,  ,  ,  		; 18h
			   0,   0,   0,   0,   1,   0,   0,   0,
		//	  ,  ,  ,  ,  ,  ,  ,  		; 20h
			   0,   0,   0,   0,   0,   0,   0,   0,
		//    ,  ,  ,  ,  ,  ,  ,  		; 28h
			   0,   1,   1,   0,   0,   0,   0,   0,
		//    ,  ,  ,  , SPC,XFER,RLUP,RLDN		; 30h
			   0,   0,   0,   0,   1,   0,   0,   0,
		//	 INS, DEL,  ,  ,  ,  ,HMCR,HELP		; 38h
			   2,   0,   1,   1,   1,   1,   0,   0,
		//	<>,<>,<>,<>,<>,<>,<>,<>		; 40h
			   0,   0,   0,   1,   0,   0,   1,   0,
		//	<>,<>,<>,<>,<>,<>,<>,<>		; 48h
			   1,   0,   0,   1,   0,   0,   0,   0,
		//	<>,NFER,vf.1,vf.2,vf.3,vf.4,vf.5,   		; 50h
			   0,   0,   2,   2,   2,   2,   2,   0,
		//	    ,    ,    ,    ,    ,    ,HOME,   		; 58h
			   0,   0,   0,   0,   0,   0,   0,   0,
		//	STOP,COPY, f.1, f.2, f.3, f.4, f.5, f.6		; 60h
			   0,   0,   2,   2,   2,   2,   2,   2,
		//	 f.7, f.8, f.9, f10,    ,    ,    ,   		; 68h
			   2,   2,   2,   2,   0,   0,   0,   0,
		//	 SFT,CAPS,KANA,GRPH,CTRL,    ,    ,   		; 70h
			   2,   2,   2,   2,   2,   0,   0,   0,
		//	    ,    ,    ,    ,    ,    ,    ,   		; 78h
			   0,   0,   0,   0,   0,   0,   0,   0};


	WINKEY_TABLE	winkeyb;
	KEYBOARD_TABLE	keyb;

NEVENT_PROC keyb_callback(NEVENT_ITEM *item);


void winkeyinit106(void) {

	ZeroMemory(&winkeyb, sizeof(winkeyb));
}


void keyb_int(BOOL absolute) {

	if (keyb.buffers) {
		if (!((pic[0].irr | pic[0].isr) & PIC_KEYBOARD)) {
			keyb.status |= 2;
			keyb.data = keyb.buf[keyb.pos];
			keyb.pos = (keyb.pos + 1) & KB_BUFMASK;
			keyb.buffers--;
			pic_setirq(1);
		}
		nevent_set(NEVENT_KEYBOARD, pc.keyboardclock,
											keyb_callback, absolute);
	}
	else {
		keyb.status &= ~2;
	}
}


NEVENT_PROC keyb_callback(NEVENT_ITEM *item) {

	if (item->flag & NEVENT_SETEVENT) {
		keyb_int(NEVENT_RELATIVE);
	}
}


static void keyb_out(BYTE data) {

	if (keyb.buffers < KB_BUF) {
		keyb.buf[(keyb.pos + keyb.buffers) & KB_BUFMASK] = data;
		keyb.buffers++;
		if (!nevent_iswork(NEVENT_KEYBOARD)) {
			keyb_int(NEVENT_ABSOLUTE);
		}
	}
	else {
		keyb.status |= 0x10;
	}
}

#if 0
static void keyb_delete(BYTE data) {

	if (keyb.buffers) {
		int		i;
		// 鸡...
		for (i=keyb.buffers; i--;) {
			if (keyb.buf[(keyb.pos + i) & KB_BUFMASK] == data) {
				break;
			}
		}
		if (i >= 0) {								// ҥåȤ
			keyb.buffers--;
			for (; i<keyb.buffers; i++) {
				keyb.buf[(keyb.pos + i) & KB_BUFMASK] =
							keyb.buf[(keyb.pos + i + 1) & KB_BUFMASK];
			}
		}
	}
}
#endif


void np2serial_keyout(BYTE data) {

	BYTE	key = data & 0x7f;
	BOOL	keynochange = FALSE;

	if ((key == 0x71) || (key == 0x72)) {
		if (data & 0x80) {
			return;
		}
		data = key | (winkeyb.stat[key] & 0x80);
		winkeyb.stat[key] ^= 0x80;
	}
	else {
		if ((np2cfg.XSHIFT) &&
			(((key == 0x70) && (np2cfg.XSHIFT & 1)) ||
			((key == 0x74) && (np2cfg.XSHIFT & 2)) ||
			((key == 0x73) && (np2cfg.XSHIFT & 4)))) {
			if (data & 0x80) {
				return;
			}
			data = key | (winkeyb.stat[key] & 0x80);
			winkeyb.stat[key] ^= 0x80;
		}
		else {
			if ((key == 0x78) || (key == 0x79)) {
				// Macξ capsξ֤뤫ɲá
				key -= 0x08;
				data -= 0x08;
			}
			if (!((winkeyb.stat[key] ^ data) & 0x80)) {
				winkeyb.stat[key] ^= 0x80;
			}
			else if (!(data & 0x80)) {
				keynochange = TRUE;
				if (kbexflag[key] & 2) {			// ԡ̵
					return;
				}
			}
		}
	}
	if ((!np2cfg.KEY_MODE) || (!(kbexflag[key] & 1))) {
		if (keynochange) {
			keyb_out(data ^ 0x80);
		}
		keyb_out(data);
	}
}

// --------------------------------------------------------------------------

BYTE joykey(void) {

	BYTE	ret = 0xff;
	BYTE	*p = (BYTE *)joykeytable;
	BYTE	bit;

	for (bit=0x20; bit; bit>>=1, p+=2) {
		if ((winkeyb.stat[*p] & 0x80) || (winkeyb.stat[*(p+1)] & 0x80)) {
			ret &= ~bit;
		}
	}
	return(ret);
}

// --------------------------------------------------------------------------

struct {
	BYTE	b;
	BYTE	lastpad;
	short	x;
	short	y;
	int		up;
	int		dn;
	int		lt;
	int		rt;
} mkey = {0xff, 0xff, 0, 0, 0, 0, 0, 0};

static short moving[] = {	1, 1, 1, 1,
							2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 3, 3, 4};

#define	MOVESTEPMAX		((sizeof(moving)/sizeof(short)) - 1)

void mousekey_make(void) {

	if (np2cfg.KEY_MODE == 3) {
		BYTE btn, acc;
		btn = joykey();
		acc = btn | mkey.lastpad;
		mkey.lastpad = btn;
		if (!(btn & 1)) {
			mkey.y -= moving[mkey.up];
		}
		if (!(acc & 1)) {
			if (mkey.up < MOVESTEPMAX) {
				mkey.up++;
			}
		}
		else {
			mkey.up = 0;
		}
		if (!(btn & 2)) {
			mkey.y += moving[mkey.dn];
		}
		if (!(acc & 2)) {
			if (mkey.dn < MOVESTEPMAX) {
				mkey.dn++;
			}
		}
		else {
			mkey.dn = 0;
		}
		if (!(btn & 4)) {
			mkey.x -= moving[mkey.lt];
		}
		if (!(acc & 4)) {
			if (mkey.lt < MOVESTEPMAX) {
				mkey.lt++;
			}
		}
		else {
			mkey.lt = 0;
		}
		if (!(btn & 8)) {
			mkey.x += moving[mkey.rt];
		}
		if (!(acc & 8)) {
			if (mkey.rt < MOVESTEPMAX) {
				mkey.rt++;
			}
		}
		else {
			mkey.rt = 0;
		}
		mkey.b = ((btn & 0x10)?0x80:0x00) | ((btn & 0x20)?0x20:0x00) | 0x5f;
	}
}

BYTE mousekey(short *x, short *y) {

	if (np2cfg.KEY_MODE == 3) {
		(*x) += mkey.x;
		mkey.x = 0;
		(*y) += mkey.y;
		mkey.y = 0;
		return(mkey.b);
	}
	return(0xff);
}

// --------------------------------------------------------------------------

void keyboard_init(void) {

	ZeroMemory(&keyb, sizeof(keyb));
	keyb.data = 0xff;
	keyb.mode = 0x5e;
}

void keyboard_reset(void) {

	int		i;

	keyboard_init();
	for (i=0; i<0x80; i++) {
		if (winkeyb.stat[i]) {
			keyb_out((BYTE)i);
		}
	}
}

I286_OUT keyboard_w(WORD port, BYTE value) {

	switch(port & 0x03) {
		case 0x01:					// mode regs
			keyb.mode = value;
			break;

		case 0x03:
			if ((!(value & 0x08)) && (keyb.cmd & 0x08)) {
				keyboard_reset();
			}
			if (value & 0x10) {
				keyb.status &= ~(0x38);
			}
			keyb.cmd = value;
			break;
	}
}

I286_INB keyboard_r(WORD port) {

	switch(port & 0x03) {
		case 0x01:
			return(keyb.data);

		case 0x03:
			return(keyb.status);
	}
	return(0xff);
}

// -------------------------------------------------------------------------

void np2key_resetjoykey(void) {

	int		i;
	BYTE	key;

	for (i=0; i<12; i++) {
		key = joykeytable[i];
		if (winkeyb.stat[key] & 0x80) {
			winkeyb.stat[key] &= 0x7f;
			keyb_out(key | 0x80);
		}
	}
	ZeroMemory(&mkey, sizeof(mkey));
}

void np2key_resetcopyhelp(void) {

	BYTE	i;

	for (i=0x60; i<0x62; i++) {
		if (winkeyb.stat[i] & 0x80) {
			winkeyb.stat[i] &= 0x7f;
			keyb_out(i | 0x80);
		}
	}
}

void np2key_forcerelease(BYTE value) {

	if (winkeyb.stat[value & 0x7f] & 0x80) {
		winkeyb.stat[value & 0x7f] &= ~0x80;
		keyb_out(value | 0x80);
	}
}


// -----------------------------------------------------------------------

	RS232C_TABLE	rs232c;

void rs232c_init(void) {

	rs232c.result = 0x05;
	rs232c.data = 0xff;
}

void rs232c_callback(void) {

	if (np2os_comm_read(&rs232c.data)) {
		rs232c.result |= 2;
	}
	else {
		rs232c.result &= (BYTE)~2;
	}
}

I286_OUT rs232c_w(WORD port, BYTE value) {

	switch(port & 0x3) {
		case 0x00:
			np2os_comm_write(value);
			break;
		case 0x02:
			break;
	}
}

I286_INB rs232c_r(WORD port) {

	switch(port & 0x3) {
		case 0x00:
			return(rs232c.data);
		case 0x02:
			if (np2os_comm_cd()) {
				return(rs232c.result | 0x80);
			}
			return(rs232c.result);
	}
	return(0xff);
}

