// -------------------------------------------------------------------- CS4231

typedef struct {
	BYTE	adc_l;				// 0
	BYTE	adc_r;				// 1
	BYTE	aux1_l;				// 2
	BYTE	aux1_r;				// 3
	BYTE	aux2_l;				// 4
	BYTE	aux2_r;				// 5
	BYTE	dac_l;				// 6
	BYTE	dac_r;				// 7
	BYTE	datafmt;			// 8
	BYTE	intconfig;			// 9
	BYTE	pinctrl;			// a
	BYTE	errorstatus;
	BYTE	mode_id;
	BYTE	loopctrl;
	WORD	playcount;

	WORD	featurefunc;
	BYTE	line_l;
	BYTE	line_r;
	WORD	timer;
	BYTE	reserved1;
	BYTE	reserved2;
	BYTE	featurestatus;
	BYTE	chipid;
	BYTE	monoinput;
	BYTE	reserved3;
	BYTE	cap_datafmt;
	BYTE	reserved4;
	WORD	cap_basecount;
} CS4231_REG;

typedef struct {
	BYTE		buffer[256];
	DWORD		bufsize;
	DWORD		readpos;
	DWORD		writepos;
	DWORD		curtime;
	DWORD		step;
	DWORD		pcmdata;
	BYTE		(SOUND_CALL * proc)(void);

	CS4231_REG	reg;
	BYTE		enable;
	BYTE		portctrl;
	WORD		port;
	BYTE		dmairq;
	BYTE		dmach;
	BYTE		adrs;
	BYTE		index;
	BYTE		intflag;
	BYTE		outenable;
} CS4231_TABLE;



extern CS4231_TABLE cs4231;

void cs4231_disable(void);
void cs4231_reset(void);
I286_OUT cs4231p_w(WORD port, BYTE value);
I286_INB cs4231p_r(WORD port);
I286_OUT cs4231_w(WORD port, BYTE value);
I286_INB cs4231_r(WORD port);
void SOUND_CALL cs4231_update(void *buf, int buflength);
