// ----------------------------------------------------------------- opn, opna

#define OPNA_CLOCK	3993600L

#define	MAXCHANNEL		12

#define	FM_CHMASK		0x8000
#define	FM_STEREO		0x8000
#define	FM_MONORAL		0x0000


#ifdef SOUND_FM_ASM										// ver0.27
#define	FMDIV_BITS		9
#define	FMDIV_ENT		(1 << FMDIV_BITS)
#define	FMVOL_SFTBIT	5

#define	SIN_BITS		11
#define	EVC_BITS		11
#define	ENV_BITS		16
#define	KF_BITS			6
#define	FREQ_BITS		21
#define	ENVTBL_BIT		24
#define	SINTBL_BIT		24

#else

#define	FMDIV_BITS		8
#define	FMDIV_ENT		(1 << FMDIV_BITS)
#define	FMVOL_SFTBIT	5

#define	SIN_BITS		10
#define	EVC_BITS		10
#define	ENV_BITS		16
#define	KF_BITS			6
#define	FREQ_BITS		21
#define	ENVTBL_BIT		14
#define	SINTBL_BIT		15							// env+sin 30bit max
#endif

#define	TL_BITS			(FREQ_BITS+2)
#define	OPM_OUTSB		(TL_BITS + 2 - 16)			// OPM output 16bit

#define	SIN_ENT			(1L << SIN_BITS)
#define	EVC_ENT			(1L << EVC_BITS)

#define	EC_ATTACK		0								// ATTACK start
#define	EC_DECAY		(EVC_ENT << ENV_BITS)			// DECAY start
#define	EC_OFF			((2L * EVC_ENT) << ENV_BITS)	// OFF

#define	EG_STEP			(96.0/EVC_ENT)					// dB step
#define	TL_MAX			(EVC_ENT * 2)

#define	SLOT1			0				// slot number
#define	SLOT2			2
#define	SLOT3			1
#define	SLOT4			3

#define EM_ATTACK		4
#define EM_DECAY1		3
#define EM_DECAY2		2
#define EM_RELEASE		1
#define EM_OFF			0


typedef struct {
	long	*detune1;			// detune1
	long	totallevel;			// total level
	long	decaylevel;			// decay level
	long	*attack;			// attack raito
	long	*decay1;			// decay1 raito
	long	*decay2;			// decay2 raito
	long	*release;			// release raito
	long 	freq_cnt;			// frequency count
	long	freq_inc;			// frequency step
	long	multiple;			// multiple
	BYTE	keyscale;			// key scale
	BYTE	env_mode;			// envelope mode
	BYTE	envraito;			// envelope raito
	BYTE	ssgeg1;				// SSG-EG

	long	env_cnt;			// envelope count
	long	env_end;			// envelope end count
	long	env_inc;			// envelope step
	long	env_inc_attack;		// envelope attack step
	long	env_inc_decay1;		// envelope decay1 step
	long	env_inc_decay2;		// envelope decay2 step
	long	env_inc_release;	// envelope release step

} FM_SLOT;

typedef struct {
	FM_SLOT		SLOT[4];
	BYTE		algorhythm;			// algorythm
	BYTE		feedback;			// self feedback
	long		op1fb;				// operator1 feedback
	long		*connect1;			// operator1 connect
	long		*connect3;			// operator3 connect
	long		*connect2;			// operator2 connect
	long		*connect4;			// operator4 connect
	DWORD		keynote[4];			// key note				// ver0.27

	BYTE		keyfunc[4];			// key function
	BYTE		kcode[4];			// key code
	BYTE		pan;				// pan
	BYTE		extop;				// extendopelator-enable
	BYTE		stereo;				// stereo-enable
	BYTE		padding;
} FM_CH;



extern	FM_CH	FMCH[MAXCHANNEL];
extern	BYTE	playchannels;

void fm_tableinit(void);
void fm_reset(void);
void fm_volume(void);											// ver0.28
void fm_setreg(BYTE reg, BYTE value, BYTE ch);
void fm_keyon(int ch, BYTE value);
void fm_channel(BYTE maxchannels, int flg);
void fm_extchannel(int channel, BYTE data);
void SOUND_CALL fm_update(void *buf, int length);
