#include	"compiler.h"

#include	"fm.h"
#include	"np2sound.h"

extern	FM_CH	FMCH[];

extern	long	env_curve[];				// ver0.27
extern	long	envtable[];
extern	long	sintable[];					// ver0.27

extern	long	feedback2;
extern	long	feedback3;
extern	long	feedback4;

extern	long	outdl;
extern	long	outdc;
extern	long	outdr;

extern	long	calc1024;
		long	calcremain;

extern	DWORD	fmvolforasm;								// ver0.28
extern	long	fmvolforc;

#ifdef SOUND_FM_ASM									// äϥ֥

#define	OP_OUT																\
			__asm {	add		eax, [edi]FM_SLOT.freq_cnt					}	\
			__asm {	shr		eax, (FREQ_BITS - SIN_BITS - 2)				}	\
			__asm {	and		eax, (SIN_ENT - 1) * 4						}	\
			__asm {	mov		eax, sintable[eax]							}	\
			__asm {	imul	envtable[edx*4]								}	\
			__asm {	shrd	eax, edx, (ENVTBL_BIT+SINTBL_BIT-TL_BITS)	}

#define	calc_envlope(n)													\
			__asm {	mov		eax, [edi]FM_SLOT.freq_inc				}	\
			__asm {	add		[edi]FM_SLOT.freq_cnt, eax				}	\
			__asm {	mov		eax, [edi]FM_SLOT.env_cnt				}	\
			__asm {	add		eax, [edi]FM_SLOT.env_inc				}	\
			__asm {	cmp		eax, [edi]FM_SLOT.env_end				}	\
			__asm {	jae		calc_newenv##n##						}	\
envret##n##:															\
			__asm {	mov		[edi]FM_SLOT.env_cnt, eax				}	\
			__asm {	shr		eax, ENV_BITS							}	\
			__asm {	mov		edx, [edi]FM_SLOT.totallevel			}	\
			__asm {	sub		edx, env_curve[eax*4]					}


#define	setenvlopmode(n)												\
			__asm {	mov		dl, [edi]FM_SLOT.env_mode				}	\
			__asm {	dec		dl										}	\
			__asm {	je		SETRR_##n##								}	\
			__asm {	dec		dl										}	\
			__asm {	je		SETD2_##n##								}	\
			__asm {	dec		dl										}	\
			__asm {	je		SETD1_##n##								}	\
			__asm {	dec		dl										}	\
			__asm {	jne		envret##n##								}	\
			__asm {	mov		[edi]FM_SLOT.env_mode, EM_DECAY1		}	\
			__asm {	mov		eax, [edi]FM_SLOT.decaylevel			}	\
			__asm {	mov		[edi]FM_SLOT.env_end, eax				}	\
			__asm {	mov		eax, [edi]FM_SLOT.env_inc_decay1		}	\
			__asm {	mov		[edi]FM_SLOT.env_inc, eax				}	\
			__asm {	mov		eax, EC_DECAY							}	\
			__asm {	jmp		envret##n##								}	\
SETD1_##n##:															\
			__asm {	mov		[edi]FM_SLOT.env_mode, EM_DECAY2		}	\
			__asm {	mov		[edi]FM_SLOT.env_end, EC_OFF			}	\
			__asm {	mov		eax, [edi]FM_SLOT.env_inc_decay2		}	\
			__asm {	mov		[edi]FM_SLOT.env_inc, eax				}	\
			__asm {	mov		eax, [edi]FM_SLOT.decaylevel			}	\
			__asm {	jmp		envret##n##								}	\
SETRR_##n##:															\
			__asm {	mov		[edi]FM_SLOT.env_mode, EM_OFF			}	\
SETD2_##n##:															\
			__asm {	mov		[edi]FM_SLOT.env_end, EC_OFF + 1		}	\
			__asm {	mov		[edi]FM_SLOT.env_inc, 0					}	\
			__asm {	mov		eax, EC_OFF								}	\
			__asm {	jmp		envret##n##								}


// make stereo 16bit
LABEL void __fastcall fm_update(void *buf, int buflength) {

	__asm {
				cmp		edx, 0
				je		opnanoupdate

				pushad
				mov		ebp, ecx

				mov		ebx, calcremain
				align	4
fmout_st:
				mov		eax, ebx
				imul	ebx, outdl
				mov		[ebp], ebx
				mov		ebx, FMDIV_ENT
				sub		ebx, eax
				imul	eax, outdr
				mov		[ebp+4], eax

fmout_loop:		mov		calcremain, ebx

				xor		eax, eax
				mov		outdl, eax
				mov		outdc, eax
				mov		outdr, eax

				mov		ch, playchannels
				mov		edi, offset FMCH
calc_channel_lp:
				xor		eax, eax
				mov		feedback2, eax
				mov		feedback3, eax
				mov		feedback4, eax
				mov		esi, edi
				calc_envlope(1)						// slot1 calculate
				jl		calc_slot3
				mov		cl, [esi]FM_CH.feedback
				or		cl, cl
				je		notcalc_feed
				mov		eax, [esi]FM_CH.op1fb		// with feedback
				mov		ebx, eax
				shr		eax, cl
				OP_OUT
				mov		[esi]FM_CH.op1fb, eax
				add		eax, ebx
				sar		eax, 1
				jmp		ch_algchk
notcalc_feed:	xor		eax, eax					// without feedback
				OP_OUT
ch_algchk:		cmp		[esi]FM_CH.algorhythm, 5
				jne		calcch_an5
				mov		feedback2, eax				// case ALG == 5
				mov		feedback3, eax
				mov		feedback4, eax
				jmp		calc_slot3
calcch_an5:		mov		ebx, [esi]FM_CH.connect1	// case ALG != 5
				add		[ebx], eax
calc_slot3:		add		edi, (type FM_SLOT)			// slot3 calculate
				calc_envlope(2)
				jl		calc_slot2
				mov		eax, feedback2
				OP_OUT
				mov		ebx, [esi]FM_CH.connect2
				add		[ebx], eax
calc_slot2:		add		edi, (type FM_SLOT)			// slot2 calculate
				calc_envlope(3)
				jl		calc_slot4
				mov		eax, feedback3
				OP_OUT
				mov		ebx, [esi]FM_CH.connect3
				add		[ebx], eax
calc_slot4:		add		edi, (type FM_SLOT)			// slot4 calculate
				calc_envlope(4)
				jl		calc_slot_end
				mov		eax, feedback4
				OP_OUT
				mov		ebx, [esi]FM_CH.connect4
				add		[ebx], eax

calc_slot_end:	add		edi, (type FM_CH) - (type FM_SLOT)*3
				dec		ch
				jne		calc_channel_lp

				mov		eax, outdc
				add		outdl, eax
				sar		outdl, FMVOL_SFTBIT
				add		outdr, eax
				sar		outdr, FMVOL_SFTBIT

				mov		edx, calc1024
				mov		ebx, calcremain
				mov		eax, ebx
				sub		ebx, edx
				jbe		short calc1smpend

				mov		calcremain, ebx
				mov		eax, edx
				imul	eax, outdl
				add		[ebp], eax
				imul	edx, outdr
				add		[ebp+4], edx
				jmp		fmout_loop

				align	4
calc1smpend:	neg		ebx
				mov		calcremain, ebx

				mov		ecx, eax						// ver0.28
				imul	eax, outdl
				add		eax, [ebp]
				imul	fmvolforasm
				mov		[ebp], edx

				mov		eax, outdr
				imul	ecx
				add		eax, [ebp+4]
				imul	fmvolforasm
				mov		[ebp+4], edx

				add		ebp, 8

				dec		dword ptr [esp + 20]			// edx
				jne		fmout_st

				popad
opnanoupdate:
				ret

calc_newenv1:	setenvlopmode(1)
calc_newenv3:	setenvlopmode(3)
calc_newenv2:	setenvlopmode(2)
calc_newenv4:	setenvlopmode(4)
	}
}

#else										// ä

static long calcrate_envlope(FM_SLOT *SLOT) {

	/* calcrate phage generator */
	SLOT->freq_cnt += SLOT->freq_inc;
	/* calcrate envelope generator */
	if ((SLOT->env_cnt += SLOT->env_inc) >= SLOT->env_end) {
		switch(SLOT->env_mode) {
			case EM_ATTACK:						// DECAY1 start
				SLOT->env_mode = EM_DECAY1;
				SLOT->env_cnt = EC_DECAY;
				SLOT->env_end = SLOT->decaylevel;
				SLOT->env_inc = SLOT->env_inc_decay1;
				break;
			case EM_DECAY1:						// DECAY2 start
				SLOT->env_mode = EM_DECAY2;
				SLOT->env_cnt = SLOT->decaylevel;
				SLOT->env_end = EC_OFF;
				SLOT->env_inc = SLOT->env_inc_decay2;
				break;
			case EM_RELEASE:					// OFF timing
				SLOT->env_mode = EM_OFF;
			case EM_DECAY2: 					// DECAY end
				SLOT->env_cnt = EC_OFF;
				SLOT->env_end = EC_OFF + 1;
				SLOT->env_inc = 0;
				break;
		}
	}
	return(SLOT->totallevel - env_curve[SLOT->env_cnt >> ENV_BITS]);
}


#define OP_OUT(slot,env,con)   												\
		((sintable[((slot.freq_cnt+con)>>(FREQ_BITS-SIN_BITS)) &			\
			(SIN_ENT-1)] * envtable[env]) >> (ENVTBL_BIT+SINTBL_BIT-TL_BITS))


static void create_channel(FM_CH *CH) {

	long	op_out;
	long	env_out;

	feedback2 = feedback3 = feedback4 = 0;

	/* SLOT 1 */
	env_out = calcrate_envlope(&CH->SLOT[0]);
	if (env_out > 0) {
		if (CH->feedback) {
			/* with self feed back */
			op_out = CH->op1fb;
			CH->op1fb = OP_OUT(CH->SLOT[0], env_out,
											(CH->op1fb >> CH->feedback));
			op_out = (op_out + CH->op1fb) / 2;
		}
		else {
			/* without self feed back */
			op_out = OP_OUT(CH->SLOT[0], env_out, 0);
		}
		/* output slot1 */
		if (!CH->connect1) {
			feedback2 = feedback3 = feedback4 = op_out;
		}
		else {
			*CH->connect1 += op_out;
		}
	}
	/* SLOT 2 */
	env_out = calcrate_envlope(&CH->SLOT[1]);
	if (env_out > 0) {
		*CH->connect2 += OP_OUT(CH->SLOT[1], env_out, feedback2);
	}
	/* SLOT 3 */
	env_out = calcrate_envlope(&CH->SLOT[2]);
	if (env_out > 0) {
		*CH->connect3 += OP_OUT(CH->SLOT[2], env_out, feedback3);
	}
	/* SLOT 4 */
	env_out = calcrate_envlope(&CH->SLOT[3]);
	if (env_out > 0) {
		*CH->connect4 += OP_OUT(CH->SLOT[3], env_out, feedback4);
	}
}


void SOUND_CALL fm_update(void *buf, int buflength) {

	int		ch;
	long	*ptr = (long *)buf;

	while(buflength--) {
		ptr[0] = outdl * (calcremain * -1);
		ptr[1] = outdr * (calcremain * -1);
		calcremain += FMDIV_ENT;
		while(1) {
			outdc = 0;
			outdl = 0;
			outdr = 0;
			for (ch=0; ch<playchannels; ch++) {
				create_channel(&FMCH[ch]);
			}
			outdl += outdc;
			outdr += outdc;
			outdl >>= FMVOL_SFTBIT;
			outdr >>= FMVOL_SFTBIT;
			if (calcremain > calc1024) {
				ptr[0] += outdl * calc1024;
				ptr[1] += outdr * calc1024;
				calcremain -= calc1024;
			}
			else {
				break;
			}
		}
		ptr[0] += outdl * calcremain;
		ptr[0] >>= 8;
		ptr[0] *= fmvolforc;
		ptr[0] >>= (OPM_OUTSB + FMDIV_BITS + 1 + 6 - FMVOL_SFTBIT - 8);
		ptr[1] += outdr * calcremain;
		ptr[1] >>= FMDIV_BITS;
		ptr[1] *= fmvolforc;
		ptr[1] >>= (OPM_OUTSB + FMDIV_BITS + 1 + 6 - FMVOL_SFTBIT - 8);
		calcremain -= calc1024;
		ptr += 2;
	}
}

#endif

