#include	"compiler.h"

#include	"np2.h"
#include	"psg.h"
#include	"np2sound.h"

static	DWORD	psgnoise_vol;

#ifdef SOUND_PSG_ASM

LABEL void __fastcall psg_update(void *buf, int psgnum, int buflength) {

	__asm {
				cmp		dword ptr [esp+4], 0
				je		psgnoupdate

				pushad
				imul	esi, edx, type PSG_T
				add		esi, offset psgreg
				mov		edi, ecx

psgmake_loop:	xor		eax, eax
				mov		psgnoise_vol, eax

				cmp		[esi]PSG_T.psgenv_cnt, ax
				je		short psgenv_calcend
				dec		[esi]PSG_T.psgenv_cnt
				jne		short psgenv_calcend
				dec		[esi]PSG_T.psgenv_volcnt
				jns		short psgenv_cont2
				test	[esi]PSG_T.psgenv_mod, PSGENV_ONESHOT
				je		short psgenv_cont1
				mov		dl, al
				test	[esi]PSG_T.psgenv_mod, PSGENV_LASTON
				je		short psgenv_volset
				mov		dl, 15
				jmp		short psgenv_volset
psgenv_cont1:	mov		[esi]PSG_T.psgenv_volcnt, 15
				test	[esi]PSG_T.psgenv_mod, PSGENV_ONECYCLE
				jne		short psgenv_cont2
				xor		[esi]PSG_T.psgenv_mod, PSGENV_INC
psgenv_cont2:	mov		dx, [esi]PSG_T.psgenv_max		; Counter Reset
				mov		[esi]PSG_T.psgenv_cnt, dx
				mov		dl, [esi]PSG_T.psgenv_volcnt
				xor		dl, [esi]PSG_T.psgenv_mod
				and		dl, 15
psgenv_volset:	mov		[esi]PSG_T.psgenv_vol, dl
psgenv_calcend:
				mov		ch, [esi]PSG_T.psg_mixer
				mov		dl, 3
psgtone_lp:
				mov		ebx, [esi]PSGTONE_T.psgtone_volp
				movzx	ebx, byte ptr [ebx]
				and		ebx, 15
				je		short psgtone_end
				mov		ebx, psg_voltbl[ebx*4]				// ver0.28
				test	ch, 8
				je		short psgtone_chk
				add		psgnoise_vol, ebx					// ver0.27b
psgtone_chk:
				test	ch, 1
				jne		short makepsgtone
				cmp		[esi]PSGTONE_T.psgtone_puchi, 0
				je		short psgtone_end
				dec		[esi]PSGTONE_T.psgtone_puchi
				shl		ebx, 2
				add		eax, ebx
				jmp		short psgtone_end

makepsgtone:
				mov		ebp, [esi]PSGTONE_T.psgtone_freq
				mov		cl, (1 << PSGADDEDBIT)					// ver0.28
psgtone_mlp:	add		[esi]PSGTONE_T.psgtone_cnt, ebp
				js		short psgtone_ms
				add		eax, ebx
				jmp		short psgtone_mkd
psgtone_ms:		sub		eax, ebx
psgtone_mkd:	dec		cl
				jne		short psgtone_mlp
psgtone_end:	add		esi, (type PSGTONE_T)
				shr		ch, 1
				dec		dl
				jne		short psgtone_lp

				test	ch, 7
				je		psgnoise_end
				mov		ecx, psgnoise_vol
				shl		ecx, (PSGADDEDBIT - 2)				// ver0.28
				mov		dx, [esi]PSGNOISE_T.psgnoise_freq
				sub		[esi]PSGNOISE_T.psgnoise_cnt, dx
				jc		short psgnoise_make
				js		short psgnoise_ms
psgnoise_pl:	add		eax, ecx
				jmp		short psgnoise_end
psgnoise_make:	mov		bx, [esi]PSGNOISE_T.psgnoise_rand0
				ror		bx, 5
				add		bx, 60043
				sbb		[esi]PSGNOISE_T.psgnoise_rand1, 4953
				rol		[esi]PSGNOISE_T.psgnoise_rand1, 1
				adc		bx, [esi]PSGNOISE_T.psgnoise_rand1
				mov		[esi]PSGNOISE_T.psgnoise_rand0, bx
				and		ebx, 15*2
				mov		bx, [esi+ebx]PSGNOISE_T.psgnoise_table
				mov		[esi]PSGNOISE_T.psgnoise_freq, bx
				cmp		[esi]PSGNOISE_T.psgnoise_cnt, 0
				jns		short psgnoise_pl
psgnoise_ms:	sub		eax, ecx
psgnoise_end:
				sub		esi, (type PSGTONE_T) * 3
				add		[edi], eax
				add		[edi+4], eax
				add		edi, 8
				dec		dword ptr [esp+36]
				jne		psgmake_loop

				popad
psgnoupdate:
				ret		4
	}
}

#else

void SOUND_CALL psg_update(void *buf, int psgnum, int buflength) {

	long		*p;
	PSGTONE_T	*tonep;
	int			mixer;
	int			i, j;
	DWORD		vol;
	DWORD		psgvol;
	long		samp;
	long		psgnoise_vol;
	PSG_T		*psg;
	int			noisetbl;

	if (!buflength) {
		return;	
	}
	psg = &psgreg[psgnum];
	p = (long *)buf;
	while(buflength--) {
		samp = 0;
		psgnoise_vol = 0;
		if (psg->psgenv_cnt) {
			(psg->psgenv_cnt)--;
			if (!(psg->psgenv_cnt)) {
				(psg->psgenv_volcnt)--;
				if ((psg->psgenv_volcnt) < 0) {
					if (psg->psgenv_mod & PSGENV_ONESHOT) {
						psg->psgenv_vol =
							((psg->psgenv_mod & PSGENV_LASTON)?15:0);
					}
					else {
						psg->psgenv_volcnt = 15;
						if (!(psg->psgenv_mod & PSGENV_ONECYCLE)) {
							(psg->psgenv_mod) ^= PSGENV_INC;
						}
						psg->psgenv_cnt = psg->psgenv_max;
						psg->psgenv_vol = 
							(psg->psgenv_volcnt ^ psg->psgenv_mod) & 0x0f;
					}
				}
				else {
					psg->psgenv_cnt = psg->psgenv_max;
					psg->psgenv_vol = 
							(psg->psgenv_volcnt ^ psg->psgenv_mod) & 0x0f;
				}
			}
		}
		tonep = psg->psgtone;
		mixer = psg->psg_mixer;
		if (mixer & 0x38) {							// noise
			noisetbl = 0;
			for (i=0; i<(1 << PSGADDEDBIT); i++) {
				if (psg->psgnoise.cnt < psg->psgnoise.freq) {
					psg->psgnoise.base = rand() & (1 << (1 << PSGADDEDBIT));
				}
				psg->psgnoise.cnt -= psg->psgnoise.freq;
				noisetbl += psg->psgnoise.base;
				noisetbl >>= 1;
			}
		}
		for (i=0; i<3; i++, mixer>>=1, tonep++) {
			psgvol = (*(tonep->psgtone_volp)) & 0x0f;
			if (psgvol) {
				vol = psg_voltbl[psgvol];
				switch(mixer & 9) {
					case 0:							// no mix
						if (tonep->psgtone_puchi) {
							tonep->psgtone_puchi--;
							samp += vol;
						}
						break;
					case 1:							// tone only
						for (j=0; j<(1 << PSGADDEDBIT); j++) {
							tonep->psgtone_cnt += tonep->psgtone_freq;
							samp += vol * ((tonep->psgtone_cnt>=0)?1:-1);
						}
						break;
					case 8:							// noise only
						{
							int ns = noisetbl;
							for (j=0; j<(1 << PSGADDEDBIT); j++) {
								samp += vol * ((ns & 1)?1:-1);
								ns >>= 1;
							}
						}
						break;
					case 9:
						{
							int ns = noisetbl;
							for (j=0; j<(1 << PSGADDEDBIT); j++) {
								tonep->psgtone_cnt += tonep->psgtone_freq;
								samp += vol *
									(((tonep->psgtone_cnt>=0)||(ns&1))?1:-1);
								ns >>= 1;
							}
						}
						break;
				}
			}
		}
		(*p++) += samp;
		(*p++) += samp;
	}
}

#endif
