#include	"compiler.h"

#include	"np2.h"
#include	"iobridge.h"
#include	"sndboard.h"
#include	"np2sound.h"
#include	"fmtimer.h"
#include	"beep.h"
#include	"fm.h"
#include	"psg.h"
#include	"rhythm.h"
#include	"pcm86.h"
#include	"s98.h"

static void SOUND_CALL makesounds(void *buf, int length) {

	fm_update(buf, length);
	psg_update(buf, 0, length);
	beep_update(buf, length);
}

void sndb26_init(void) {

	fmtimer_reset(np2cfg.snd26opt & 0xc0);
	fm_reset();
	psg_reset(0);
	fm_channel(3, FM_MONORAL | 0x07);
	sndbios_loadex(np2cfg.snd26opt & 7, "26");
	sndreg.base = ((np2cfg.snd26opt & 0x10)?0x000:0x100);
}

static I286_OUT sndb26_w(WORD port, BYTE value) {

	port += sndreg.base;
	switch(port & 0x707) {
		case 0x100:
			sndreg.opnreg = value;
			break;

		case 0x102:
			S98_put(NORMAL2608, sndreg.opnreg, value);
			sndreg.reg[sndreg.opnreg] = value;
			if (sndreg.opnreg < 0x10) {
				if (sndreg.opnreg != 0x0e) {
					sound_make();							// ver0.28
					psg_setreg(0, sndreg.opnreg, value);
				}
			}
			else {
				if (sndreg.opnreg < 0x30) {
					if (sndreg.opnreg == 0x28) {
						if ((value & 0x0f) < 3) {
							sound_make();
							fm_keyon(value & 0x0f, value);
						}
					}
					else {
						fmtimer_setreg(sndreg.opnreg, value);
						if (sndreg.opnreg == 0x27) {
							fm_extchannel(2, value & 0xc0);
						}
					}
				}
				else if (sndreg.opnreg < 0xc0) {
					sound_make();
					fm_setreg(sndreg.opnreg, value, 0);
				}
			}
			break;
	}
}

static I286_INB sndb26_r(WORD port) {

	port += sndreg.base;
	switch(port & 0x707) {
		case 0x100:
			return(fmtimer.status);

		case 0x102:
			if (sndreg.opnreg == 0x0e) {
				return(psg_getjoyport(0));
			}
			if (sndreg.opnreg < 0x10) {
				return(sndreg.reg[sndreg.opnreg]);
			}
			break;
	}
	return(0xff);
}

SNDPROC_T sndproc_b26 = {
				sndb26_w,
				sndb26_r,
				sound_dummyout,
				sound_dummyin,
				makesounds,
				NULL};

