#include	"compiler.h"

#include	"memory.h"
#include	"dosio.h"

	char	sndbiosname[24] = "";
	DWORD	sndbiospos = 0;

static BOOL loadbiosfile(void) {

	FILEH	fh;
	short	readlen;

	if ((fh = file_open_c(sndbiosname)) != (FILEH)-1) {
		readlen = file_read(fh, mem + sndbiospos, 0x4000);
		file_close(fh);
		return(readlen == 0x4000);
	}
	return(FALSE);
}

void sndbios_reset(void) {

	sndbiospos = 0;
	strcpy(sndbiosname, "");
}

void sndbios_load(DWORD address, char *primary) {

	sndbiospos = address;

	if (primary) {
		snprintf(sndbiosname, sizeof(sndbiosname), "sound%s.rom", primary);
		if (loadbiosfile()) {
			return;
		}
	}

	strcpy(sndbiosname, "sound.rom");
	if (loadbiosfile()) {
		return;
	}

	strcpy(sndbiosname, "");
	mem[sndbiospos + 0x2e00] = 1;
	mem[sndbiospos + 0x2e04] = 0xd2;
	MEM_SETW(sndbiospos + 0x2e06, 0x0008);
	mem[sndbiospos + 0x2e08] = 0xcb;
}

void sndbios_loadex(BYTE sw, char *primary) {

	if (sw >= 4) {
		sndbiospos = 0;
		return;
	}
	sndbios_load((0xc8000 + ((DWORD)sw << 14)), primary);
}

