#include	"compiler.h"

#include	"np2.h"
#include	"np2pc98.h"
#include	"pc_core.h"
#include	"iobridge.h"
#include	"sndboard.h"
#include	"np2sound.h"
#include	"beep.h"
#include	"cs4231.h"

	SNDREG_T	sndreg;


I286_OUT sound_dummyout(WORD port, BYTE value) { }

I286_INB sound_dummyin(WORD port) {

	return(0xff);
}

static void SOUND_CALL makebeeponly(void *buf, int length) {

	if (length) {
		ZeroMemory(buf, length * 8);
		beep_update(buf, length);
	}
}

// --------------------------------------------------------------------------

		SNDPROC_T	sndproc = {
						sound_dummyout,
						sound_dummyin,
						sound_dummyout,
						sound_dummyin,
						makebeeponly,
						NULL};

static	SNDPROC_T	sndproc_beep = {
						sound_dummyout,
						sound_dummyin,
						sound_dummyout,
						sound_dummyin,
						makebeeponly,
						NULL};


void sndboard_init(void) {
}

void sndboard_trash(void) {
}

void sndboard_reset(BYTE num) {

	int		i;

	ZeroMemory(&sndreg, sizeof(sndreg));
	sndreg.adpcmmask = (BYTE)~(0x1c);
	sndreg.reg[0xff] = 0x01;
	for (i=0x30; i<0xc0; i++) {
		sndreg.reg[i+0x000] = 0xff;
		sndreg.reg[i+0x100] = 0xff;
		sndreg.reg[i+0x200] = 0xff;
		sndreg.reg[i+0x300] = 0xff;
	}

	sndbios_reset();
	beep_reset();											// ver0.27a
	cs4231_disable();
	switch(num) {
#if 0
		case 0x01:
			sndboard = BOARD14;
			musicgen_reset();
			break;
#endif
		case 0x02:
			sndproc = sndproc_b26;
			sndb26_init();
			break;
		case 0x04:
			sndproc = sndproc_b86;
			sndb86_init();
			break;
		case 0x06:
			sndproc = sndproc_bx2;
			sndbx2_init();
			break;
#if 0
		case 0x08:
			sndboard = BOARD118;
			ymf_init();
			break;
		case 0x14:
			sndproc = sndproc_c86;
			sndbc86_init();
			break;
		case 0x20:
			sndboard = BOARDSPB;
			spb_init();
			break;

		case 0x40:
			sndboard = BOARDSPR;
			spark_init();
			break;
#endif
		default:
			sndproc = sndproc_beep;
			break;
	}
	np2sound_volume();
}


