#include	"compiler.h"

#include	"pc_core.h"
#include	"i286.h"
#include	"memory.h"
#include	"iobridge.h"
#include	"gdc.h"
#include	"gdc_cmd.h"
#include	"gdc_sub.h"
#include	"crtc.h"
#include	"makegrph.h"
#include	"lio.h"
#include	"trace.h"

static void nor_linebox(short x1, short y1, short x2, short y2, BYTE pal) {

	lio_line(x1, x2, y1, pal);
	for (; y1<y2; y1++) {
		lio_pset(x1, y1, pal);
		lio_pset(x2, y1, pal);
	}
	if (y1 != y2) {
		lio_line(x1, x2, y2, pal);
	}
}

static void nor_lineboxfill(short x1, short y1, short x2, short y2, BYTE pal) {

	for (; y1<=y2; y1++) {
		lio_line(x1, x2, y1, pal);
	}
}



BYTE lio_gline(void) {

	GLINE_MEMTBL	dat;
	short			x1, y1, x2, y2;

	i286_memstr_read(I286_DS, I286_BX, &dat, sizeof(dat));
	x1 = (short)GETWORD(dat.x1);
	y1 = (short)GETWORD(dat.y1);
	x2 = (short)GETWORD(dat.x2);
	y2 = (short)GETWORD(dat.y2);

	if (dat.pal == 0xff) {
		dat.pal = lio.gcolor1.fgcolor;
	}
	else if (dat.pal >= lio.gcolor1.palmax) {
		return(5);
	}
	switch(dat.type) {
		case 0:
			break;
		case 1:
			nor_linebox(x1, y1, x2, y2, dat.pal);
			break;
		case 2:
			nor_lineboxfill(x1, y1, x2, y2, dat.pal);
			break;
		default:
			return(5);
	}
	return(0);
}
