/*	$Id: np2osdep.c,v 1.12 2002/06/03 15:46:50 nonaka Exp $	*/

#include "compiler.h"

#include <time.h>

#include "np2.h"
#include "audio.h"
#include "dosio.h"
#include "midi.h"
#include "timing.h"

#include "xnp2.h"
#include "xkeyboard.h"
#include "xmouse.h"

static void
sound_init(void)
{

	audio_setup();
	audio_init(np2cfg.samplingrate, np2cfg.delayms);
	audio_play();
}

static void
sound_term(void)
{

	audio_stop();
	audio_term();
}

void
np2os_init(void)
{

	xkeyboard_init(window);
	xmouse_init(window);
	audio_setup();
	MIDI_Init();
}

void
np2os_reset(void)
{

	MIDI_Cleanup();
	sound_term();
	sound_init();
	MIDI_Init();

	timing_init();
}

void
np2os_term(void)
{

	sound_term();
	xmouse_term(window);
}


void
np2os_getcalender(CALENDER_T *c)
{
	time_t ltime;
	struct tm *nt;

	time(&ltime);
	nt = localtime(&ltime);

	c->year = nt->tm_year;
	c->month = nt->tm_mon + 1;
	c->day = nt->tm_mday;
	c->hour = nt->tm_hour;
	c->minute = nt->tm_min;
	c->second = nt->tm_sec;
	c->weekday = nt->tm_wday;
}
